/*
 * pyhddm_s.cpy - DO NOT EDIT THIS FILE
 *
 * This file was generated automatically by hddm-py from the file
 * event.xml

 * This source file contains the Python/C++ API wrappers that
 * provide a python interface to the hddm classes and methods
 * generated by hddm-cpp from event.xml.
 *
 * The hddm data model tool set was written by
 * Richard Jones, University of Connecticut.
 *
 * For more information see the documentation at
 * http://github.com/rjones30/HDDM
 *
 */

#include <Python.h>
#include <structmember.h>

#include <hddm_s.hpp>
#include <fstream>
#include <iostream>
#include <exception>
#include <particleType.h>
#ifdef ISTREAM_OVER_HTTP
#include <httpstream.hpp>
#endif
#ifdef ISTREAM_OVER_XROOTD
#include <xrootdstream.hpp>
#endif

using namespace hddm_s;

#if PY_MAJOR_VERSION >= 3
   #define PyInt_FromLong PyLong_FromLong
   #define PyInt_AsLong PyLong_AsLong
#endif


inline void LOG_NEW(PyTypeObject *t, PyTypeObject *subt=0, int own=0) {
#if 0
   if (subt == 0)
      std::cout << "creating a new element of " << t->tp_name
                << " " << ((own == 0)? "(borrowed)" : "(owned)")
                << std::endl;
   else
      std::cout << "creating a new list of " << subt->tp_name
                << " " << ((own == 0)? "(borrowed)" : "(owned)")
                << std::endl;
#endif
}

inline void LOG_DEALLOC(PyTypeObject *t, PyTypeObject *subt=0, int own=0) {
#if 0
   if (subt == 0)
      std::cout << "destroying an element of " << t->tp_name
                << " " << ((own == 0)? "(borrowed)" : "(owned)")
                << std::endl;
   else
      std::cout << "destroying a list of " << subt->tp_name
                << " " << ((own == 0)? "(borrowed)" : "(owned)")
                << std::endl;
#endif
}

inline void My_INCREF(PyObject *o) {
   //std::cout << "incrementing reference at " << o << std::endl;
   Py_INCREF(o);
}

inline void My_DECREF(PyObject *o) {
   //std::cout << "decrementing reference at " << o << std::endl;
   Py_DECREF(o);
}

// wrap base class hddm_s::HDDM_Element as hddm_s.HDDM_Element

typedef struct {
   PyObject_HEAD
   HDDM_Element *elem;
   PyObject *host;
} _HDDM_Element;

static void
_HDDM_Element_dealloc(_HDDM_Element* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_HDDM_Element_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _HDDM_Element *self;
   self = (_HDDM_Element*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_HDDM_Element_init(_HDDM_Element *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_HDDM_Element_getAttribute(PyObject *self, PyObject *args)
{
   char *attr;
   if (! PyArg_ParseTuple(args, "s", &attr)) {
      return NULL;
   }
   _HDDM_Element *me = (_HDDM_Element*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid element");
      return NULL;
   }
   hddm_type atype;
   void *val((int*)me->elem->getAttribute(std::string(attr),&atype));
   if (val == 0) {
      Py_INCREF(Py_None);
      return Py_None;
   }
   else if (atype == k_hddm_int) {
      return PyLong_FromLong(*(int*)val);
   }
   else if (atype == k_hddm_long) {
      return PyLong_FromLongLong(*(long long*)val);
   }
   else if (atype == k_hddm_float) {
      return PyFloat_FromDouble(double(*(float*)val));
   }
   else if (atype == k_hddm_double) {
      return PyFloat_FromDouble(*(double*)val);
   }
   else if (atype == k_hddm_boolean) {
      if (*(bool*)val == 0) {
         Py_INCREF(Py_False);
         return Py_False;
      }
      else {
         Py_INCREF(Py_True);
         return Py_True;
      }
   }
   else if (atype == k_hddm_string) {
      return PyUnicode_FromString(((std::string*)val)->c_str());
   }
   else if (atype == k_hddm_anyURI) {
      return PyUnicode_FromString(((std::string*)val)->c_str());
   }
   else if (atype == k_hddm_Particle_t) {
      return PyUnicode_FromString(ParticleType(*(Particle_t*)val));
   }
   return PyUnicode_FromString(((std::string*)val)->c_str());
}

static PyMemberDef _HDDM_Element_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _HDDM_Element_methods[] = {
   {"getAttribute", _HDDM_Element_getAttribute, METH_VARARGS,
    "look up named attribute in this element"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _HDDM_Element_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.HDDM_Element",     /*tp_name*/
    sizeof(_HDDM_Element),     /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_HDDM_Element_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    0,                         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s basic element",    /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _HDDM_Element_methods,     /* tp_methods */
    _HDDM_Element_members,     /* tp_members */
    0,                         /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_HDDM_Element_init, /* tp_init */
    0,                         /* tp_alloc */
    _HDDM_Element_new,         /* tp_new */
};


// wrap base class hddm_s::HDDM_ElementList as hddm_s.HDDM_ElementList

typedef struct {
   PyObject_HEAD
   PyTypeObject *subtype; // type of wrapper derived from _HDDM_Element
   HDDM_ElementList<HDDM_Element> *list;
   PyObject *host;
   int borrowed;
} _HDDM_ElementList;

static void
_HDDM_ElementList_dealloc(_HDDM_ElementList* self)
{
   if (self->list != 0) {
      LOG_DEALLOC(Py_TYPE(self), self->subtype, self->borrowed == 0);
      if (self->borrowed == 0)
         delete self->list;
      My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_HDDM_ElementList_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _HDDM_ElementList *self;
   self = (_HDDM_ElementList*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->subtype = 0;
      self->borrowed = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_HDDM_ElementList_init(_HDDM_ElementList *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static Py_ssize_t
_HDDM_ElementList_size(_HDDM_ElementList *self, void *closure)
{
   if (self->list == 0) {
      PyErr_SetString(PyExc_RuntimeError, "size attempted on invalid list");
      return -1;
   }
   return self->list->size();
}

static PyObject*
_HDDM_ElementList_item(_HDDM_ElementList *self, Py_ssize_t i)
{
   if (self->list == 0)
      return NULL;
   int len = self->list->size();
   if (i < 0 || i >= len) {
      PyErr_Format(PyExc_IndexError, "index %ld out of bounds.", i);
      return NULL;
   }
   PyObject *elem_obj = _HDDM_Element_new(self->subtype, 0, 0);
   ((_HDDM_Element*)elem_obj)->elem = &(HDDM_Element&)(*self->list)((int)i);
   ((_HDDM_Element*)elem_obj)->host = self->host;
   My_INCREF(self->host);
   LOG_NEW(self->subtype);
   return elem_obj;
}

extern PyTypeObject _HDDM_ElementList_type;

static PyObject *
_HDDM_ElementList_add(PyObject *self, PyObject *args)
{
   int count=0;
   int start=-1;
   if (! PyArg_ParseTuple(args, "i|i", &count, &start)) {
      return NULL;
   }
   _HDDM_ElementList *me = (_HDDM_ElementList*)self;
   if (me->list == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid list");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = me->subtype;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new HDDM_ElementList<HDDM_Element>(me->list->add(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(self), me->subtype, 1);
   return list;
}

static PyObject *
_HDDM_ElementList_del(PyObject *self, PyObject *args)
{
   int start=0;
   int count=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HDDM_ElementList *list_obj;
   list_obj = (_HDDM_ElementList*)self;
   if (list_obj->list == 0) {
      PyErr_SetString(PyExc_RuntimeError, "del attempted on invalid list");
      return NULL;
   }
   list_obj->list->del(count, start);
   Py_INCREF(self);
   return self;
}

static PyObject *
_HDDM_ElementList_clear(PyObject *self, PyObject *args)
{
   _HDDM_ElementList *list_obj;
   list_obj = (_HDDM_ElementList*)self;
   if (list_obj->list == 0) {
      PyErr_SetString(PyExc_RuntimeError, "clear attempted on invalid list");
      return NULL;
   }
   list_obj->list->clear();
   Py_INCREF(self);
   return self;
}

static PyMemberDef _HDDM_ElementList_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _HDDM_ElementList_methods[] = {
   {"add",  _HDDM_ElementList_add, METH_VARARGS,
    "add (or insert) a new element to the list."},
   {"del",  _HDDM_ElementList_del, METH_VARARGS,
    "delete an existing element from the list."},
   {"clear",  _HDDM_ElementList_clear, METH_NOARGS,
    "reset the list to zero elements."},
   {NULL}  /* Sentinel */
};

static PySequenceMethods _HDDM_ElementList_as_sequence = {
    (lenfunc)_HDDM_ElementList_size,            /* sq_length */
    0,                                          /* sq_concat */
    0,                                          /* sq_repeat */
    (ssizeargfunc)_HDDM_ElementList_item,       /* sq_item */
    0,                                          /* sq_slice */
    0,                                          /* sq_ass_item */
    0,                                          /* sq_ass_slice */
    0,                                          /* sq_contains */
    0,                                          /* sq_inplace_concat */
    0,                                          /* sq_inplace_repeat */
};

PyTypeObject _HDDM_ElementList_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.HDDM_ElementList", /*tp_name*/
    sizeof(_HDDM_ElementList), /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_HDDM_ElementList_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    &_HDDM_ElementList_as_sequence, /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    0,                         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s element list",    /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _HDDM_ElementList_methods, /* tp_methods */
    _HDDM_ElementList_members, /* tp_members */
    0,                         /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_HDDM_ElementList_init,   /* tp_init */
    0,                         /* tp_alloc */
    _HDDM_ElementList_new,     /* tp_new */
};


// wrap element class hddm_s::Geometry as hddm_s.Geometry

typedef struct {
   PyObject_HEAD
   Geometry *elem;
   PyObject *host;
} _Geometry;

static void
_Geometry_dealloc(_Geometry* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Geometry_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Geometry *self;
   self = (_Geometry*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Geometry_init(_Geometry *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Geometry_getClass(_Geometry *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Geometry_getVersion(_Geometry *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Geometry_getXmlns(_Geometry *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Geometry_getMaxOccurs(_Geometry *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMaxOccurs());
}

static PyObject*
_Geometry_getMd5reconstruction(_Geometry *self, void *closure)
{
   std::string val(self->elem->getMd5reconstruction());
   return PyUnicode_FromString(val.c_str());
}

static int
_Geometry_setMd5reconstruction(_Geometry *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setMd5reconstruction(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_Geometry_getMd5simulation(_Geometry *self, void *closure)
{
   std::string val(self->elem->getMd5simulation());
   return PyUnicode_FromString(val.c_str());
}

static int
_Geometry_setMd5simulation(_Geometry *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setMd5simulation(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_Geometry_getMd5smear(_Geometry *self, void *closure)
{
   std::string val(self->elem->getMd5smear());
   return PyUnicode_FromString(val.c_str());
}

static int
_Geometry_setMd5smear(_Geometry *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setMd5smear(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_Geometry_getMinOccurs(_Geometry *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Geometry_toString(PyObject *self, PyObject *args=0)
{
   _Geometry *me = (_Geometry*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid geometry element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Geometry_toXML(PyObject *self, PyObject *args=0)
{
   _Geometry *me = (_Geometry*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid geometry element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Geometry_getsetters[] = {
   {(char*)"class",
    (getter)_Geometry_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Geometry_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"md5reconstruction",
    (getter)_Geometry_getMd5reconstruction, (setter)_Geometry_setMd5reconstruction,
    (char*)"md5reconstruction string",
    NULL},
   {(char*)"md5simulation",
    (getter)_Geometry_getMd5simulation, (setter)_Geometry_setMd5simulation,
    (char*)"md5simulation string",
    NULL},
   {(char*)"md5smear",
    (getter)_Geometry_getMd5smear, (setter)_Geometry_setMd5smear,
    (char*)"md5smear string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Geometry_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"version",
    (getter)_Geometry_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_Geometry_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Geometry_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Geometry_methods[] = {
   {"toString", _Geometry_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Geometry_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Geometry_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Geometry",         /*tp_name*/
    sizeof(_Geometry),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Geometry_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Geometry_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s geometry element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Geometry_methods,          /* tp_methods */
    _Geometry_members,          /* tp_members */
    _Geometry_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Geometry_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Geometry_new,              /* tp_new */
};



// wrap element class hddm_s::DataVersionString as hddm_s.DataVersionString

typedef struct {
   PyObject_HEAD
   DataVersionString *elem;
   PyObject *host;
} _DataVersionString;

static void
_DataVersionString_dealloc(_DataVersionString* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DataVersionString_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DataVersionString *self;
   self = (_DataVersionString*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DataVersionString_init(_DataVersionString *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DataVersionString_getClass(_DataVersionString *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DataVersionString_getVersion(_DataVersionString *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DataVersionString_getXmlns(_DataVersionString *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DataVersionString_getEventNo(_DataVersionString *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DataVersionString_getRunNo(_DataVersionString *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DataVersionString_getMaxOccurs(_DataVersionString *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DataVersionString_getMinOccurs(_DataVersionString *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DataVersionString_getText(_DataVersionString *self, void *closure)
{
   std::string val(self->elem->getText());
   return PyUnicode_FromString(val.c_str());
}

static int
_DataVersionString_setText(_DataVersionString *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setText(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_DataVersionString_toString(PyObject *self, PyObject *args=0)
{
   _DataVersionString *me = (_DataVersionString*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dataVersionString element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DataVersionString_toXML(PyObject *self, PyObject *args=0)
{
   _DataVersionString *me = (_DataVersionString*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dataVersionString element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DataVersionString_getsetters[] = {
   {(char*)"class",
    (getter)_DataVersionString_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DataVersionString_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DataVersionString_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_DataVersionString_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_DataVersionString_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"text",
    (getter)_DataVersionString_getText, (setter)_DataVersionString_setText,
    (char*)"text string",
    NULL},
   {(char*)"version",
    (getter)_DataVersionString_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_DataVersionString_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DataVersionString_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DataVersionString_methods[] = {
   {"toString", _DataVersionString_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DataVersionString_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DataVersionString_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DataVersionString",         /*tp_name*/
    sizeof(_DataVersionString),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DataVersionString_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DataVersionString_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s dataVersionString element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DataVersionString_methods,          /* tp_methods */
    _DataVersionString_members,          /* tp_members */
    _DataVersionString_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DataVersionString_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DataVersionString_new,              /* tp_new */
};



// wrap element class hddm_s::CcdbContext as hddm_s.CcdbContext

typedef struct {
   PyObject_HEAD
   CcdbContext *elem;
   PyObject *host;
} _CcdbContext;

static void
_CcdbContext_dealloc(_CcdbContext* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CcdbContext_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CcdbContext *self;
   self = (_CcdbContext*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CcdbContext_init(_CcdbContext *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CcdbContext_getClass(_CcdbContext *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcdbContext_getVersion(_CcdbContext *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CcdbContext_getXmlns(_CcdbContext *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcdbContext_getEventNo(_CcdbContext *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CcdbContext_getRunNo(_CcdbContext *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CcdbContext_getMaxOccurs(_CcdbContext *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcdbContext_getMinOccurs(_CcdbContext *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CcdbContext_getText(_CcdbContext *self, void *closure)
{
   std::string val(self->elem->getText());
   return PyUnicode_FromString(val.c_str());
}

static int
_CcdbContext_setText(_CcdbContext *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setText(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_CcdbContext_toString(PyObject *self, PyObject *args=0)
{
   _CcdbContext *me = (_CcdbContext*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccdbContext element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CcdbContext_toXML(PyObject *self, PyObject *args=0)
{
   _CcdbContext *me = (_CcdbContext*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccdbContext element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CcdbContext_getsetters[] = {
   {(char*)"class",
    (getter)_CcdbContext_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CcdbContext_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CcdbContext_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CcdbContext_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CcdbContext_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"text",
    (getter)_CcdbContext_getText, (setter)_CcdbContext_setText,
    (char*)"text string",
    NULL},
   {(char*)"version",
    (getter)_CcdbContext_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CcdbContext_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CcdbContext_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CcdbContext_methods[] = {
   {"toString", _CcdbContext_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CcdbContext_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CcdbContext_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CcdbContext",         /*tp_name*/
    sizeof(_CcdbContext),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CcdbContext_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CcdbContext_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ccdbContext element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CcdbContext_methods,          /* tp_methods */
    _CcdbContext_members,          /* tp_members */
    _CcdbContext_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CcdbContext_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CcdbContext_new,              /* tp_new */
};



// wrap element class hddm_s::Momentum as hddm_s.Momentum

typedef struct {
   PyObject_HEAD
   Momentum *elem;
   PyObject *host;
} _Momentum;

static void
_Momentum_dealloc(_Momentum* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Momentum_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Momentum *self;
   self = (_Momentum*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Momentum_init(_Momentum *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Momentum_getClass(_Momentum *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Momentum_getVersion(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Momentum_getXmlns(_Momentum *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Momentum_getEventNo(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Momentum_getMaxOccurs(_Momentum *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Momentum_getRunNo(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Momentum_getMinOccurs(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Momentum_getFOM(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static PyObject*
_Momentum_getNdof(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static PyObject*
_Momentum_getCandidateid(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static PyObject*
_Momentum_getChisq(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static PyObject*
_Momentum_getId(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_Momentum_getTrackid(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static PyObject*
_Momentum_getType(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Momentum_getWeight(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Momentum_getDecayVertex(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getDecayVertex());
}

static PyObject*
_Momentum_getMech(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMech());
}

static PyObject*
_Momentum_getParentid(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getParentid());
}

static PyObject*
_Momentum_getPdgtype(_Momentum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPdgtype());
}

static PyObject*
_Momentum_getE(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_Momentum_setE(_Momentum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_Momentum_getPx(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_Momentum_setPx(_Momentum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_Momentum_getPy(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_Momentum_setPy(_Momentum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_Momentum_getPz(_Momentum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_Momentum_setPz(_Momentum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_Momentum_toString(PyObject *self, PyObject *args=0)
{
   _Momentum *me = (_Momentum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid momentum element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Momentum_toXML(PyObject *self, PyObject *args=0)
{
   _Momentum *me = (_Momentum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid momentum element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Momentum_getsetters[] = {
   {(char*)"E",
    (getter)_Momentum_getE, (setter)_Momentum_setE,
    (char*)"E value",
    NULL},
   {(char*)"FOM",
    (getter)_Momentum_getFOM, 0,
    (char*)"FOM value",
    NULL},
   {(char*)"Ndof",
    (getter)_Momentum_getNdof, 0,
    (char*)"Ndof value",
    NULL},
   {(char*)"candidateid",
    (getter)_Momentum_getCandidateid, 0,
    (char*)"candidateid value",
    NULL},
   {(char*)"chisq",
    (getter)_Momentum_getChisq, 0,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_Momentum_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"decayVertex",
    (getter)_Momentum_getDecayVertex, 0,
    (char*)"decayVertex value",
    NULL},
   {(char*)"eventNo",
    (getter)_Momentum_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Momentum_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Momentum_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"mech",
    (getter)_Momentum_getMech, 0,
    (char*)"mech value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Momentum_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"parentid",
    (getter)_Momentum_getParentid, 0,
    (char*)"parentid value",
    NULL},
   {(char*)"pdgtype",
    (getter)_Momentum_getPdgtype, 0,
    (char*)"pdgtype value",
    NULL},
   {(char*)"px",
    (getter)_Momentum_getPx, (setter)_Momentum_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_Momentum_getPy, (setter)_Momentum_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_Momentum_getPz, (setter)_Momentum_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_Momentum_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"trackid",
    (getter)_Momentum_getTrackid, 0,
    (char*)"trackid value",
    NULL},
   {(char*)"type",
    (getter)_Momentum_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Momentum_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Momentum_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Momentum_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Momentum_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Momentum_methods[] = {
   {"toString", _Momentum_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Momentum_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Momentum_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Momentum",         /*tp_name*/
    sizeof(_Momentum),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Momentum_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Momentum_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s momentum element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Momentum_methods,          /* tp_methods */
    _Momentum_members,          /* tp_members */
    _Momentum_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Momentum_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Momentum_new,              /* tp_new */
};



// wrap element class hddm_s::Polarization as hddm_s.Polarization

typedef struct {
   PyObject_HEAD
   Polarization *elem;
   PyObject *host;
} _Polarization;

static void
_Polarization_dealloc(_Polarization* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Polarization_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Polarization *self;
   self = (_Polarization*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Polarization_init(_Polarization *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Polarization_getClass(_Polarization *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Polarization_getVersion(_Polarization *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Polarization_getXmlns(_Polarization *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Polarization_getEventNo(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Polarization_getMaxOccurs(_Polarization *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Polarization_getRunNo(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Polarization_getType(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Polarization_getWeight(_Polarization *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Polarization_getDecayVertex(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getDecayVertex());
}

static PyObject*
_Polarization_getId(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_Polarization_getMech(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMech());
}

static PyObject*
_Polarization_getParentid(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getParentid());
}

static PyObject*
_Polarization_getPdgtype(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPdgtype());
}

static PyObject*
_Polarization_getPx(_Polarization *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_Polarization_setPx(_Polarization *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_Polarization_getPy(_Polarization *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_Polarization_setPy(_Polarization *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_Polarization_getPz(_Polarization *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_Polarization_setPz(_Polarization *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_Polarization_getMinOccurs(_Polarization *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Polarization_toString(PyObject *self, PyObject *args=0)
{
   _Polarization *me = (_Polarization*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid polarization element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Polarization_toXML(PyObject *self, PyObject *args=0)
{
   _Polarization *me = (_Polarization*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid polarization element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Polarization_getsetters[] = {
   {(char*)"Px",
    (getter)_Polarization_getPx, (setter)_Polarization_setPx,
    (char*)"Px value",
    NULL},
   {(char*)"Py",
    (getter)_Polarization_getPy, (setter)_Polarization_setPy,
    (char*)"Py value",
    NULL},
   {(char*)"Pz",
    (getter)_Polarization_getPz, (setter)_Polarization_setPz,
    (char*)"Pz value",
    NULL},
   {(char*)"class",
    (getter)_Polarization_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"decayVertex",
    (getter)_Polarization_getDecayVertex, 0,
    (char*)"decayVertex value",
    NULL},
   {(char*)"eventNo",
    (getter)_Polarization_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Polarization_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Polarization_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"mech",
    (getter)_Polarization_getMech, 0,
    (char*)"mech value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Polarization_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"parentid",
    (getter)_Polarization_getParentid, 0,
    (char*)"parentid value",
    NULL},
   {(char*)"pdgtype",
    (getter)_Polarization_getPdgtype, 0,
    (char*)"pdgtype value",
    NULL},
   {(char*)"runNo",
    (getter)_Polarization_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Polarization_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Polarization_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Polarization_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Polarization_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Polarization_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Polarization_methods[] = {
   {"toString", _Polarization_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Polarization_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Polarization_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Polarization",         /*tp_name*/
    sizeof(_Polarization),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Polarization_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Polarization_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s polarization element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Polarization_methods,          /* tp_methods */
    _Polarization_members,          /* tp_members */
    _Polarization_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Polarization_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Polarization_new,              /* tp_new */
};



// wrap element class hddm_s::Properties as hddm_s.Properties

typedef struct {
   PyObject_HEAD
   Properties *elem;
   PyObject *host;
} _Properties;

static void
_Properties_dealloc(_Properties* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Properties_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Properties *self;
   self = (_Properties*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Properties_init(_Properties *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Properties_getClass(_Properties *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Properties_getVersion(_Properties *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Properties_getXmlns(_Properties *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Properties_getEventNo(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Properties_getMaxOccurs(_Properties *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Properties_getRunNo(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Properties_getMinOccurs(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Properties_getFOM(_Properties *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static PyObject*
_Properties_getNdof(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static PyObject*
_Properties_getCandidateid(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static PyObject*
_Properties_getChisq(_Properties *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static PyObject*
_Properties_getId(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_Properties_getTrackid(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static PyObject*
_Properties_getType(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Properties_getWeight(_Properties *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Properties_getDecayVertex(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getDecayVertex());
}

static PyObject*
_Properties_getMech(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMech());
}

static PyObject*
_Properties_getParentid(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getParentid());
}

static PyObject*
_Properties_getPdgtype(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPdgtype());
}

static PyObject*
_Properties_getCharge(_Properties *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCharge());
}

static int
_Properties_setCharge(_Properties *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setCharge(var);
   return 0;
}

static PyObject*
_Properties_getMass(_Properties *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getMass());
}

static int
_Properties_setMass(_Properties *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setMass((float)var);
   return 0;
}

static PyObject*
_Properties_toString(PyObject *self, PyObject *args=0)
{
   _Properties *me = (_Properties*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid properties element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Properties_toXML(PyObject *self, PyObject *args=0)
{
   _Properties *me = (_Properties*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid properties element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Properties_getsetters[] = {
   {(char*)"FOM",
    (getter)_Properties_getFOM, 0,
    (char*)"FOM value",
    NULL},
   {(char*)"Ndof",
    (getter)_Properties_getNdof, 0,
    (char*)"Ndof value",
    NULL},
   {(char*)"candidateid",
    (getter)_Properties_getCandidateid, 0,
    (char*)"candidateid value",
    NULL},
   {(char*)"charge",
    (getter)_Properties_getCharge, (setter)_Properties_setCharge,
    (char*)"charge value",
    NULL},
   {(char*)"chisq",
    (getter)_Properties_getChisq, 0,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_Properties_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"decayVertex",
    (getter)_Properties_getDecayVertex, 0,
    (char*)"decayVertex value",
    NULL},
   {(char*)"eventNo",
    (getter)_Properties_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Properties_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"mass",
    (getter)_Properties_getMass, (setter)_Properties_setMass,
    (char*)"mass value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Properties_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"mech",
    (getter)_Properties_getMech, 0,
    (char*)"mech value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Properties_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"parentid",
    (getter)_Properties_getParentid, 0,
    (char*)"parentid value",
    NULL},
   {(char*)"pdgtype",
    (getter)_Properties_getPdgtype, 0,
    (char*)"pdgtype value",
    NULL},
   {(char*)"runNo",
    (getter)_Properties_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"trackid",
    (getter)_Properties_getTrackid, 0,
    (char*)"trackid value",
    NULL},
   {(char*)"type",
    (getter)_Properties_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Properties_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Properties_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Properties_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Properties_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Properties_methods[] = {
   {"toString", _Properties_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Properties_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Properties_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Properties",         /*tp_name*/
    sizeof(_Properties),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Properties_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Properties_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s properties element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Properties_methods,          /* tp_methods */
    _Properties_members,          /* tp_members */
    _Properties_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Properties_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Properties_new,              /* tp_new */
};



// wrap element class hddm_s::Beam as hddm_s.Beam

typedef struct {
   PyObject_HEAD
   Beam *elem;
   PyObject *host;
} _Beam;

static void
_Beam_dealloc(_Beam* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Beam_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Beam *self;
   self = (_Beam*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Beam_init(_Beam *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Beam_getClass(_Beam *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Beam_getVersion(_Beam *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Beam_getXmlns(_Beam *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Beam_getEventNo(_Beam *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Beam_getMaxOccurs(_Beam *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Beam_getRunNo(_Beam *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Beam_getWeight(_Beam *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Beam_getMinOccurs(_Beam *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Beam_getType(_Beam *self, void *closure)
{
   Particle_t p(self->elem->getType());
   std::string val(ParticleType(p));
   return PyUnicode_FromString(val.c_str());
}

static int
_Beam_setType(_Beam *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setType((Particle_t)var);
   return 0;
}

static PyObject*
_Beam_getMomentum(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *obj = _Momentum_new(&_Momentum_type, 0, 0);
   ((_Momentum*)obj)->elem = &me->elem->getMomentum();
   ((_Momentum*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Beam_getMomenta(PyObject *self, PyObject *args)
{
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMomenta();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Beam_addMomenta(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MomentumList(me->elem->addMomenta(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Beam_deleteMomenta(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid beam element");
      return NULL;
   }
   me->elem->deleteMomenta(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Beam_getPolarization(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *obj = _Polarization_new(&_Polarization_type, 0, 0);
   ((_Polarization*)obj)->elem = &me->elem->getPolarization();
   ((_Polarization*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Beam_getPolarizations(PyObject *self, PyObject *args)
{
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPolarizations();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Beam_addPolarizations(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PolarizationList(me->elem->addPolarizations(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Beam_deletePolarizations(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid beam element");
      return NULL;
   }
   me->elem->deletePolarizations(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Beam_getProperties(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *obj = _Properties_new(&_Properties_type, 0, 0);
   ((_Properties*)obj)->elem = &me->elem->getProperties();
   ((_Properties*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Beam_getPropertiesList(PyObject *self, PyObject *args)
{
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPropertiesList();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Beam_addPropertiesList(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid beam element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PropertiesList(me->elem->addPropertiesList(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Beam_deletePropertiesList(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid beam element");
      return NULL;
   }
   me->elem->deletePropertiesList(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Beam_toString(PyObject *self, PyObject *args=0)
{
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Beam_toXML(PyObject *self, PyObject *args=0)
{
   _Beam *me = (_Beam*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid beam element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Beam_getsetters[] = {
   {(char*)"class",
    (getter)_Beam_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Beam_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Beam_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Beam_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Beam_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Beam_getType, (setter)_Beam_setType,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Beam_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Beam_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Beam_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Beam_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Beam_methods[] = {
   {"addMomenta", _Beam_addMomenta, METH_VARARGS,
    "extend (or insert into) the list of momentum objects for this beam"},
   {"addPolarizations", _Beam_addPolarizations, METH_VARARGS,
    "extend (or insert into) the list of polarization objects for this beam"},
   {"addPropertiesList", _Beam_addPropertiesList, METH_VARARGS,
    "extend (or insert into) the list of properties objects for this beam"},
   {"deleteMomenta", _Beam_deleteMomenta, METH_VARARGS,
    "delete momentum objects for this beam"},
   {"deletePolarizations", _Beam_deletePolarizations, METH_VARARGS,
    "delete polarization objects for this beam"},
   {"deletePropertiesList", _Beam_deletePropertiesList, METH_VARARGS,
    "delete properties objects for this beam"},
   {"getMomenta", _Beam_getMomenta, METH_NOARGS,
    "get list of momentum objects for this beam"},
   {"getMomentum", _Beam_getMomentum, METH_VARARGS,
    "get an individual momentum object from this beam"},
   {"getPolarization", _Beam_getPolarization, METH_VARARGS,
    "get an individual polarization object from this beam"},
   {"getPolarizations", _Beam_getPolarizations, METH_NOARGS,
    "get list of polarization objects for this beam"},
   {"getProperties", _Beam_getProperties, METH_VARARGS,
    "get an individual properties object from this beam"},
   {"getPropertiesList", _Beam_getPropertiesList, METH_NOARGS,
    "get list of properties objects for this beam"},
   {"toString", _Beam_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Beam_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Beam_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Beam",         /*tp_name*/
    sizeof(_Beam),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Beam_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Beam_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s beam element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Beam_methods,          /* tp_methods */
    _Beam_members,          /* tp_members */
    _Beam_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Beam_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Beam_new,              /* tp_new */
};



// wrap element class hddm_s::Target as hddm_s.Target

typedef struct {
   PyObject_HEAD
   Target *elem;
   PyObject *host;
} _Target;

static void
_Target_dealloc(_Target* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Target_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Target *self;
   self = (_Target*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Target_init(_Target *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Target_getClass(_Target *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Target_getVersion(_Target *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Target_getXmlns(_Target *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Target_getEventNo(_Target *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Target_getMaxOccurs(_Target *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Target_getRunNo(_Target *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Target_getWeight(_Target *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Target_getMinOccurs(_Target *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Target_getType(_Target *self, void *closure)
{
   Particle_t p(self->elem->getType());
   std::string val(ParticleType(p));
   return PyUnicode_FromString(val.c_str());
}

static int
_Target_setType(_Target *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setType((Particle_t)var);
   return 0;
}

static PyObject*
_Target_getMomentum(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *obj = _Momentum_new(&_Momentum_type, 0, 0);
   ((_Momentum*)obj)->elem = &me->elem->getMomentum();
   ((_Momentum*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Target_getMomenta(PyObject *self, PyObject *args)
{
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMomenta();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Target_addMomenta(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MomentumList(me->elem->addMomenta(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Target_deleteMomenta(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid target element");
      return NULL;
   }
   me->elem->deleteMomenta(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Target_getPolarization(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *obj = _Polarization_new(&_Polarization_type, 0, 0);
   ((_Polarization*)obj)->elem = &me->elem->getPolarization();
   ((_Polarization*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Target_getPolarizations(PyObject *self, PyObject *args)
{
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPolarizations();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Target_addPolarizations(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PolarizationList(me->elem->addPolarizations(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Target_deletePolarizations(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid target element");
      return NULL;
   }
   me->elem->deletePolarizations(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Target_getProperties(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *obj = _Properties_new(&_Properties_type, 0, 0);
   ((_Properties*)obj)->elem = &me->elem->getProperties();
   ((_Properties*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Target_getPropertiesList(PyObject *self, PyObject *args)
{
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPropertiesList();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Target_addPropertiesList(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid target element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PropertiesList(me->elem->addPropertiesList(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Target_deletePropertiesList(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid target element");
      return NULL;
   }
   me->elem->deletePropertiesList(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Target_toString(PyObject *self, PyObject *args=0)
{
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Target_toXML(PyObject *self, PyObject *args=0)
{
   _Target *me = (_Target*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid target element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Target_getsetters[] = {
   {(char*)"class",
    (getter)_Target_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Target_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Target_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Target_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Target_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Target_getType, (setter)_Target_setType,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Target_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Target_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Target_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Target_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Target_methods[] = {
   {"addMomenta", _Target_addMomenta, METH_VARARGS,
    "extend (or insert into) the list of momentum objects for this target"},
   {"addPolarizations", _Target_addPolarizations, METH_VARARGS,
    "extend (or insert into) the list of polarization objects for this target"},
   {"addPropertiesList", _Target_addPropertiesList, METH_VARARGS,
    "extend (or insert into) the list of properties objects for this target"},
   {"deleteMomenta", _Target_deleteMomenta, METH_VARARGS,
    "delete momentum objects for this target"},
   {"deletePolarizations", _Target_deletePolarizations, METH_VARARGS,
    "delete polarization objects for this target"},
   {"deletePropertiesList", _Target_deletePropertiesList, METH_VARARGS,
    "delete properties objects for this target"},
   {"getMomenta", _Target_getMomenta, METH_NOARGS,
    "get list of momentum objects for this target"},
   {"getMomentum", _Target_getMomentum, METH_VARARGS,
    "get an individual momentum object from this target"},
   {"getPolarization", _Target_getPolarization, METH_VARARGS,
    "get an individual polarization object from this target"},
   {"getPolarizations", _Target_getPolarizations, METH_NOARGS,
    "get list of polarization objects for this target"},
   {"getProperties", _Target_getProperties, METH_VARARGS,
    "get an individual properties object from this target"},
   {"getPropertiesList", _Target_getPropertiesList, METH_NOARGS,
    "get list of properties objects for this target"},
   {"toString", _Target_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Target_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Target_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Target",         /*tp_name*/
    sizeof(_Target),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Target_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Target_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s target element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Target_methods,          /* tp_methods */
    _Target_members,          /* tp_members */
    _Target_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Target_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Target_new,              /* tp_new */
};



// wrap element class hddm_s::Product as hddm_s.Product

typedef struct {
   PyObject_HEAD
   Product *elem;
   PyObject *host;
} _Product;

static void
_Product_dealloc(_Product* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Product_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Product *self;
   self = (_Product*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Product_init(_Product *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Product_getClass(_Product *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Product_getVersion(_Product *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Product_getXmlns(_Product *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Product_getEventNo(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Product_getRunNo(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Product_getMinOccurs(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Product_getWeight(_Product *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Product_getDecayVertex(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getDecayVertex());
}

static int
_Product_setDecayVertex(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setDecayVertex(var);
   return 0;
}

static PyObject*
_Product_getId(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static int
_Product_setId(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setId(var);
   return 0;
}

static PyObject*
_Product_getMaxOccurs(_Product *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Product_getMech(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMech());
}

static int
_Product_setMech(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setMech(var);
   return 0;
}

static PyObject*
_Product_getParentid(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getParentid());
}

static int
_Product_setParentid(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setParentid(var);
   return 0;
}

static PyObject*
_Product_getPdgtype(_Product *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPdgtype());
}

static int
_Product_setPdgtype(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPdgtype(var);
   return 0;
}

static PyObject*
_Product_getType(_Product *self, void *closure)
{
   Particle_t p(self->elem->getType());
   std::string val(ParticleType(p));
   return PyUnicode_FromString(val.c_str());
}

static int
_Product_setType(_Product *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setType((Particle_t)var);
   return 0;
}

static PyObject*
_Product_getMomentum(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *obj = _Momentum_new(&_Momentum_type, 0, 0);
   ((_Momentum*)obj)->elem = &me->elem->getMomentum();
   ((_Momentum*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Product_getMomenta(PyObject *self, PyObject *args)
{
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMomenta();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Product_addMomenta(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MomentumList(me->elem->addMomenta(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Product_deleteMomenta(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid product element");
      return NULL;
   }
   me->elem->deleteMomenta(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Product_getPolarization(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *obj = _Polarization_new(&_Polarization_type, 0, 0);
   ((_Polarization*)obj)->elem = &me->elem->getPolarization();
   ((_Polarization*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Product_getPolarizations(PyObject *self, PyObject *args)
{
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPolarizations();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Product_addPolarizations(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PolarizationList(me->elem->addPolarizations(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Product_deletePolarizations(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid product element");
      return NULL;
   }
   me->elem->deletePolarizations(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Product_getProperties(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *obj = _Properties_new(&_Properties_type, 0, 0);
   ((_Properties*)obj)->elem = &me->elem->getProperties();
   ((_Properties*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Product_getPropertiesList(PyObject *self, PyObject *args)
{
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPropertiesList();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Product_addPropertiesList(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid product element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PropertiesList(me->elem->addPropertiesList(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Product_deletePropertiesList(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid product element");
      return NULL;
   }
   me->elem->deletePropertiesList(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Product_toString(PyObject *self, PyObject *args=0)
{
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Product_toXML(PyObject *self, PyObject *args=0)
{
   _Product *me = (_Product*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid product element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Product_getsetters[] = {
   {(char*)"class",
    (getter)_Product_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"decayVertex",
    (getter)_Product_getDecayVertex, (setter)_Product_setDecayVertex,
    (char*)"decayVertex value",
    NULL},
   {(char*)"eventNo",
    (getter)_Product_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Product_getId, (setter)_Product_setId,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Product_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"mech",
    (getter)_Product_getMech, (setter)_Product_setMech,
    (char*)"mech value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Product_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"parentid",
    (getter)_Product_getParentid, (setter)_Product_setParentid,
    (char*)"parentid value",
    NULL},
   {(char*)"pdgtype",
    (getter)_Product_getPdgtype, (setter)_Product_setPdgtype,
    (char*)"pdgtype value",
    NULL},
   {(char*)"runNo",
    (getter)_Product_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Product_getType, (setter)_Product_setType,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Product_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Product_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Product_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Product_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Product_methods[] = {
   {"addMomenta", _Product_addMomenta, METH_VARARGS,
    "extend (or insert into) the list of momentum objects for this product"},
   {"addPolarizations", _Product_addPolarizations, METH_VARARGS,
    "extend (or insert into) the list of polarization objects for this product"},
   {"addPropertiesList", _Product_addPropertiesList, METH_VARARGS,
    "extend (or insert into) the list of properties objects for this product"},
   {"deleteMomenta", _Product_deleteMomenta, METH_VARARGS,
    "delete momentum objects for this product"},
   {"deletePolarizations", _Product_deletePolarizations, METH_VARARGS,
    "delete polarization objects for this product"},
   {"deletePropertiesList", _Product_deletePropertiesList, METH_VARARGS,
    "delete properties objects for this product"},
   {"getMomenta", _Product_getMomenta, METH_NOARGS,
    "get list of momentum objects for this product"},
   {"getMomentum", _Product_getMomentum, METH_VARARGS,
    "get an individual momentum object from this product"},
   {"getPolarization", _Product_getPolarization, METH_VARARGS,
    "get an individual polarization object from this product"},
   {"getPolarizations", _Product_getPolarizations, METH_NOARGS,
    "get list of polarization objects for this product"},
   {"getProperties", _Product_getProperties, METH_VARARGS,
    "get an individual properties object from this product"},
   {"getPropertiesList", _Product_getPropertiesList, METH_NOARGS,
    "get list of properties objects for this product"},
   {"toString", _Product_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Product_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Product_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Product",         /*tp_name*/
    sizeof(_Product),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Product_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Product_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s product element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Product_methods,          /* tp_methods */
    _Product_members,          /* tp_members */
    _Product_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Product_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Product_new,              /* tp_new */
};



// wrap element class hddm_s::Origin as hddm_s.Origin

typedef struct {
   PyObject_HEAD
   Origin *elem;
   PyObject *host;
} _Origin;

static void
_Origin_dealloc(_Origin* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Origin_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Origin *self;
   self = (_Origin*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Origin_init(_Origin *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Origin_getClass(_Origin *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Origin_getVersion(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Origin_getXmlns(_Origin *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Origin_getEventNo(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Origin_getMaxOccurs(_Origin *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Origin_getRunNo(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Origin_getMinOccurs(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Origin_getFOM(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static PyObject*
_Origin_getNdof(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static PyObject*
_Origin_getCandidateid(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static PyObject*
_Origin_getChisq(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static PyObject*
_Origin_getId(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_Origin_getTrackid(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static PyObject*
_Origin_getType(_Origin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Origin_getWeight(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Origin_getT(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_Origin_setT(_Origin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_Origin_getVx(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVx());
}

static int
_Origin_setVx(_Origin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setVx((float)var);
   return 0;
}

static PyObject*
_Origin_getVy(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVy());
}

static int
_Origin_setVy(_Origin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setVy((float)var);
   return 0;
}

static PyObject*
_Origin_getVz(_Origin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVz());
}

static int
_Origin_setVz(_Origin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setVz((float)var);
   return 0;
}

static PyObject*
_Origin_toString(PyObject *self, PyObject *args=0)
{
   _Origin *me = (_Origin*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid origin element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Origin_toXML(PyObject *self, PyObject *args=0)
{
   _Origin *me = (_Origin*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid origin element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Origin_getsetters[] = {
   {(char*)"FOM",
    (getter)_Origin_getFOM, 0,
    (char*)"FOM value",
    NULL},
   {(char*)"Ndof",
    (getter)_Origin_getNdof, 0,
    (char*)"Ndof value",
    NULL},
   {(char*)"candidateid",
    (getter)_Origin_getCandidateid, 0,
    (char*)"candidateid value",
    NULL},
   {(char*)"chisq",
    (getter)_Origin_getChisq, 0,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_Origin_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Origin_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Origin_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Origin_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Origin_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Origin_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_Origin_getT, (setter)_Origin_setT,
    (char*)"t value",
    NULL},
   {(char*)"trackid",
    (getter)_Origin_getTrackid, 0,
    (char*)"trackid value",
    NULL},
   {(char*)"type",
    (getter)_Origin_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Origin_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"vx",
    (getter)_Origin_getVx, (setter)_Origin_setVx,
    (char*)"vx value",
    NULL},
   {(char*)"vy",
    (getter)_Origin_getVy, (setter)_Origin_setVy,
    (char*)"vy value",
    NULL},
   {(char*)"vz",
    (getter)_Origin_getVz, (setter)_Origin_setVz,
    (char*)"vz value",
    NULL},
   {(char*)"weight",
    (getter)_Origin_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Origin_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Origin_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Origin_methods[] = {
   {"toString", _Origin_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Origin_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Origin_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Origin",         /*tp_name*/
    sizeof(_Origin),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Origin_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Origin_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s origin element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Origin_methods,          /* tp_methods */
    _Origin_members,          /* tp_members */
    _Origin_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Origin_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Origin_new,              /* tp_new */
};



// wrap element class hddm_s::Vertex as hddm_s.Vertex

typedef struct {
   PyObject_HEAD
   Vertex *elem;
   PyObject *host;
} _Vertex;

static void
_Vertex_dealloc(_Vertex* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Vertex_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Vertex *self;
   self = (_Vertex*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Vertex_init(_Vertex *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Vertex_getClass(_Vertex *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Vertex_getVersion(_Vertex *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Vertex_getXmlns(_Vertex *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Vertex_getEventNo(_Vertex *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Vertex_getRunNo(_Vertex *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Vertex_getMinOccurs(_Vertex *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Vertex_getType(_Vertex *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Vertex_getWeight(_Vertex *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Vertex_getMaxOccurs(_Vertex *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Vertex_getProduct(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   PyObject *obj = _Product_new(&_Product_type, 0, 0);
   ((_Product*)obj)->elem = &me->elem->getProduct(index);
   ((_Product*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Vertex_getProducts(PyObject *self, PyObject *args)
{
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Product_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getProducts();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Vertex_addProducts(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid vertex element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Product_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ProductList(me->elem->addProducts(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Vertex_deleteProducts(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid vertex element");
      return NULL;
   }
   me->elem->deleteProducts(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Vertex_getOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   PyObject *obj = _Origin_new(&_Origin_type, 0, 0);
   ((_Origin*)obj)->elem = &me->elem->getOrigin();
   ((_Origin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Vertex_getOrigins(PyObject *self, PyObject *args)
{
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Origin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Vertex_addOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid vertex element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Origin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new OriginList(me->elem->addOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Vertex_deleteOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid vertex element");
      return NULL;
   }
   me->elem->deleteOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Vertex_toString(PyObject *self, PyObject *args=0)
{
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Vertex_toXML(PyObject *self, PyObject *args=0)
{
   _Vertex *me = (_Vertex*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid vertex element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Vertex_getsetters[] = {
   {(char*)"class",
    (getter)_Vertex_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Vertex_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Vertex_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Vertex_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Vertex_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Vertex_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Vertex_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Vertex_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Vertex_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Vertex_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Vertex_methods[] = {
   {"addOrigins", _Vertex_addOrigins, METH_VARARGS,
    "extend (or insert into) the list of origin objects for this vertex"},
   {"addProducts", _Vertex_addProducts, METH_VARARGS,
    "extend (or insert into) the list of product objects for this vertex"},
   {"deleteOrigins", _Vertex_deleteOrigins, METH_VARARGS,
    "delete origin objects for this vertex"},
   {"deleteProducts", _Vertex_deleteProducts, METH_VARARGS,
    "delete product objects for this vertex"},
   {"getOrigin", _Vertex_getOrigin, METH_VARARGS,
    "get an individual origin object from this vertex"},
   {"getOrigins", _Vertex_getOrigins, METH_NOARGS,
    "get list of origin objects for this vertex"},
   {"getProduct", _Vertex_getProduct, METH_VARARGS,
    "get an individual product object from this vertex"},
   {"getProducts", _Vertex_getProducts, METH_NOARGS,
    "get list of product objects for this vertex"},
   {"toString", _Vertex_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Vertex_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Vertex_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Vertex",         /*tp_name*/
    sizeof(_Vertex),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Vertex_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Vertex_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s vertex element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Vertex_methods,          /* tp_methods */
    _Vertex_members,          /* tp_members */
    _Vertex_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Vertex_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Vertex_new,              /* tp_new */
};



// wrap element class hddm_s::Random as hddm_s.Random

typedef struct {
   PyObject_HEAD
   Random *elem;
   PyObject *host;
} _Random;

static void
_Random_dealloc(_Random* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Random_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Random *self;
   self = (_Random*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Random_init(_Random *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Random_getClass(_Random *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Random_getVersion(_Random *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Random_getXmlns(_Random *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Random_getEventNo(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Random_getRunNo(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Random_getType(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_Random_getWeight(_Random *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_Random_getMaxOccurs(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMaxOccurs());
}

static PyObject*
_Random_getMinOccurs(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Random_getSeed1(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSeed1());
}

static int
_Random_setSeed1(_Random *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSeed1(var);
   return 0;
}

static PyObject*
_Random_getSeed2(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSeed2());
}

static int
_Random_setSeed2(_Random *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSeed2(var);
   return 0;
}

static PyObject*
_Random_getSeed3(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSeed3());
}

static int
_Random_setSeed3(_Random *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSeed3(var);
   return 0;
}

static PyObject*
_Random_getSeed4(_Random *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSeed4());
}

static int
_Random_setSeed4(_Random *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSeed4(var);
   return 0;
}

static PyObject*
_Random_toString(PyObject *self, PyObject *args=0)
{
   _Random *me = (_Random*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid random element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Random_toXML(PyObject *self, PyObject *args=0)
{
   _Random *me = (_Random*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid random element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Random_getsetters[] = {
   {(char*)"class",
    (getter)_Random_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Random_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Random_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Random_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Random_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"seed1",
    (getter)_Random_getSeed1, (setter)_Random_setSeed1,
    (char*)"seed1 value",
    NULL},
   {(char*)"seed2",
    (getter)_Random_getSeed2, (setter)_Random_setSeed2,
    (char*)"seed2 value",
    NULL},
   {(char*)"seed3",
    (getter)_Random_getSeed3, (setter)_Random_setSeed3,
    (char*)"seed3 value",
    NULL},
   {(char*)"seed4",
    (getter)_Random_getSeed4, (setter)_Random_setSeed4,
    (char*)"seed4 value",
    NULL},
   {(char*)"type",
    (getter)_Random_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Random_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Random_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Random_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Random_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Random_methods[] = {
   {"toString", _Random_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Random_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Random_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Random",         /*tp_name*/
    sizeof(_Random),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Random_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Random_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s random element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Random_methods,          /* tp_methods */
    _Random_members,          /* tp_members */
    _Random_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Random_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Random_new,              /* tp_new */
};



// wrap element class hddm_s::UserDataFloat as hddm_s.UserDataFloat

typedef struct {
   PyObject_HEAD
   UserDataFloat *elem;
   PyObject *host;
} _UserDataFloat;

static void
_UserDataFloat_dealloc(_UserDataFloat* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UserDataFloat_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UserDataFloat *self;
   self = (_UserDataFloat*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UserDataFloat_init(_UserDataFloat *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UserDataFloat_getClass(_UserDataFloat *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataFloat_getVersion(_UserDataFloat *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UserDataFloat_getXmlns(_UserDataFloat *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataFloat_getEventNo(_UserDataFloat *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UserDataFloat_getRunNo(_UserDataFloat *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UserDataFloat_getType(_UserDataFloat *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_UserDataFloat_getWeight(_UserDataFloat *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_UserDataFloat_getDescription(_UserDataFloat *self, void *closure)
{
   std::string val(self->elem->getDescription());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataFloat_getData(_UserDataFloat *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getData());
}

static int
_UserDataFloat_setData(_UserDataFloat *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setData((float)var);
   return 0;
}

static PyObject*
_UserDataFloat_getMaxOccurs(_UserDataFloat *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataFloat_getMeaning(_UserDataFloat *self, void *closure)
{
   std::string val(self->elem->getMeaning());
   return PyUnicode_FromString(val.c_str());
}

static int
_UserDataFloat_setMeaning(_UserDataFloat *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setMeaning(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_UserDataFloat_getMinOccurs(_UserDataFloat *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UserDataFloat_toString(PyObject *self, PyObject *args=0)
{
   _UserDataFloat *me = (_UserDataFloat*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userDataFloat element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UserDataFloat_toXML(PyObject *self, PyObject *args=0)
{
   _UserDataFloat *me = (_UserDataFloat*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userDataFloat element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UserDataFloat_getsetters[] = {
   {(char*)"class",
    (getter)_UserDataFloat_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"data",
    (getter)_UserDataFloat_getData, (setter)_UserDataFloat_setData,
    (char*)"data value",
    NULL},
   {(char*)"description",
    (getter)_UserDataFloat_getDescription, 0,
    (char*)"description string",
    NULL},
   {(char*)"eventNo",
    (getter)_UserDataFloat_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UserDataFloat_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"meaning",
    (getter)_UserDataFloat_getMeaning, (setter)_UserDataFloat_setMeaning,
    (char*)"meaning string",
    NULL},
   {(char*)"minOccurs",
    (getter)_UserDataFloat_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_UserDataFloat_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_UserDataFloat_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_UserDataFloat_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_UserDataFloat_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_UserDataFloat_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UserDataFloat_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UserDataFloat_methods[] = {
   {"toString", _UserDataFloat_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UserDataFloat_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UserDataFloat_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UserDataFloat",         /*tp_name*/
    sizeof(_UserDataFloat),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UserDataFloat_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UserDataFloat_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s userDataFloat element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UserDataFloat_methods,          /* tp_methods */
    _UserDataFloat_members,          /* tp_members */
    _UserDataFloat_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UserDataFloat_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UserDataFloat_new,              /* tp_new */
};



// wrap element class hddm_s::UserDataInt as hddm_s.UserDataInt

typedef struct {
   PyObject_HEAD
   UserDataInt *elem;
   PyObject *host;
} _UserDataInt;

static void
_UserDataInt_dealloc(_UserDataInt* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UserDataInt_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UserDataInt *self;
   self = (_UserDataInt*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UserDataInt_init(_UserDataInt *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UserDataInt_getClass(_UserDataInt *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataInt_getVersion(_UserDataInt *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UserDataInt_getXmlns(_UserDataInt *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataInt_getEventNo(_UserDataInt *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UserDataInt_getRunNo(_UserDataInt *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UserDataInt_getType(_UserDataInt *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_UserDataInt_getWeight(_UserDataInt *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_UserDataInt_getDescription(_UserDataInt *self, void *closure)
{
   std::string val(self->elem->getDescription());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataInt_getData(_UserDataInt *self, void *closure)
{
   return PyLong_FromLong(self->elem->getData());
}

static int
_UserDataInt_setData(_UserDataInt *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setData(var);
   return 0;
}

static PyObject*
_UserDataInt_getMaxOccurs(_UserDataInt *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserDataInt_getMeaning(_UserDataInt *self, void *closure)
{
   std::string val(self->elem->getMeaning());
   return PyUnicode_FromString(val.c_str());
}

static int
_UserDataInt_setMeaning(_UserDataInt *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setMeaning(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_UserDataInt_getMinOccurs(_UserDataInt *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UserDataInt_toString(PyObject *self, PyObject *args=0)
{
   _UserDataInt *me = (_UserDataInt*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userDataInt element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UserDataInt_toXML(PyObject *self, PyObject *args=0)
{
   _UserDataInt *me = (_UserDataInt*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userDataInt element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UserDataInt_getsetters[] = {
   {(char*)"class",
    (getter)_UserDataInt_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"data",
    (getter)_UserDataInt_getData, (setter)_UserDataInt_setData,
    (char*)"data value",
    NULL},
   {(char*)"description",
    (getter)_UserDataInt_getDescription, 0,
    (char*)"description string",
    NULL},
   {(char*)"eventNo",
    (getter)_UserDataInt_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UserDataInt_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"meaning",
    (getter)_UserDataInt_getMeaning, (setter)_UserDataInt_setMeaning,
    (char*)"meaning string",
    NULL},
   {(char*)"minOccurs",
    (getter)_UserDataInt_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_UserDataInt_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_UserDataInt_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_UserDataInt_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_UserDataInt_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_UserDataInt_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UserDataInt_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UserDataInt_methods[] = {
   {"toString", _UserDataInt_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UserDataInt_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UserDataInt_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UserDataInt",         /*tp_name*/
    sizeof(_UserDataInt),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UserDataInt_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UserDataInt_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s userDataInt element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UserDataInt_methods,          /* tp_methods */
    _UserDataInt_members,          /* tp_members */
    _UserDataInt_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UserDataInt_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UserDataInt_new,              /* tp_new */
};



// wrap element class hddm_s::UserData as hddm_s.UserData

typedef struct {
   PyObject_HEAD
   UserData *elem;
   PyObject *host;
} _UserData;

static void
_UserData_dealloc(_UserData* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UserData_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UserData *self;
   self = (_UserData*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UserData_init(_UserData *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UserData_getClass(_UserData *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserData_getVersion(_UserData *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UserData_getXmlns(_UserData *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserData_getEventNo(_UserData *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UserData_getRunNo(_UserData *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UserData_getType(_UserData *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static PyObject*
_UserData_getWeight(_UserData *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static PyObject*
_UserData_getDescription(_UserData *self, void *closure)
{
   std::string val(self->elem->getDescription());
   return PyUnicode_FromString(val.c_str());
}

static int
_UserData_setDescription(_UserData *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setDescription(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_UserData_getMaxOccurs(_UserData *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UserData_getMinOccurs(_UserData *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UserData_getUserDataFloat(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   PyObject *obj = _UserDataFloat_new(&_UserDataFloat_type, 0, 0);
   ((_UserDataFloat*)obj)->elem = &me->elem->getUserDataFloat(index);
   ((_UserDataFloat*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UserData_getUserDataFloats(PyObject *self, PyObject *args)
{
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataFloat_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUserDataFloats();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UserData_addUserDataFloats(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid userData element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataFloat_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataFloatList(me->elem->addUserDataFloats(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UserData_deleteUserDataFloats(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid userData element");
      return NULL;
   }
   me->elem->deleteUserDataFloats(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UserData_getUserDataInt(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   PyObject *obj = _UserDataInt_new(&_UserDataInt_type, 0, 0);
   ((_UserDataInt*)obj)->elem = &me->elem->getUserDataInt(index);
   ((_UserDataInt*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UserData_getUserDataInts(PyObject *self, PyObject *args)
{
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataInt_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUserDataInts();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UserData_addUserDataInts(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid userData element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataInt_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataIntList(me->elem->addUserDataInts(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UserData_deleteUserDataInts(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid userData element");
      return NULL;
   }
   me->elem->deleteUserDataInts(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UserData_toString(PyObject *self, PyObject *args=0)
{
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UserData_toXML(PyObject *self, PyObject *args=0)
{
   _UserData *me = (_UserData*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid userData element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UserData_getsetters[] = {
   {(char*)"class",
    (getter)_UserData_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"description",
    (getter)_UserData_getDescription, (setter)_UserData_setDescription,
    (char*)"description string",
    NULL},
   {(char*)"eventNo",
    (getter)_UserData_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UserData_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_UserData_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_UserData_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_UserData_getType, 0,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_UserData_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_UserData_getWeight, 0,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_UserData_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UserData_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UserData_methods[] = {
   {"addUserDataFloats", _UserData_addUserDataFloats, METH_VARARGS,
    "extend (or insert into) the list of userDataFloat objects for this userData"},
   {"addUserDataInts", _UserData_addUserDataInts, METH_VARARGS,
    "extend (or insert into) the list of userDataInt objects for this userData"},
   {"deleteUserDataFloats", _UserData_deleteUserDataFloats, METH_VARARGS,
    "delete userDataFloat objects for this userData"},
   {"deleteUserDataInts", _UserData_deleteUserDataInts, METH_VARARGS,
    "delete userDataInt objects for this userData"},
   {"getUserDataFloat", _UserData_getUserDataFloat, METH_VARARGS,
    "get an individual userDataFloat object from this userData"},
   {"getUserDataFloats", _UserData_getUserDataFloats, METH_NOARGS,
    "get list of userDataFloat objects for this userData"},
   {"getUserDataInt", _UserData_getUserDataInt, METH_VARARGS,
    "get an individual userDataInt object from this userData"},
   {"getUserDataInts", _UserData_getUserDataInts, METH_NOARGS,
    "get list of userDataInt objects for this userData"},
   {"toString", _UserData_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UserData_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UserData_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UserData",         /*tp_name*/
    sizeof(_UserData),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UserData_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UserData_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s userData element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UserData_methods,          /* tp_methods */
    _UserData_members,          /* tp_members */
    _UserData_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UserData_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UserData_new,              /* tp_new */
};



// wrap element class hddm_s::Reaction as hddm_s.Reaction

typedef struct {
   PyObject_HEAD
   Reaction *elem;
   PyObject *host;
} _Reaction;

static void
_Reaction_dealloc(_Reaction* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Reaction_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Reaction *self;
   self = (_Reaction*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Reaction_init(_Reaction *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Reaction_getClass(_Reaction *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Reaction_getVersion(_Reaction *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Reaction_getXmlns(_Reaction *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Reaction_getEventNo(_Reaction *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Reaction_getRunNo(_Reaction *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Reaction_getMaxOccurs(_Reaction *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Reaction_getMinOccurs(_Reaction *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Reaction_getType(_Reaction *self, void *closure)
{
   return PyLong_FromLong(self->elem->getType());
}

static int
_Reaction_setType(_Reaction *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setType(var);
   return 0;
}

static PyObject*
_Reaction_getWeight(_Reaction *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getWeight());
}

static int
_Reaction_setWeight(_Reaction *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setWeight((float)var);
   return 0;
}

static PyObject*
_Reaction_getBeam(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *obj = _Beam_new(&_Beam_type, 0, 0);
   ((_Beam*)obj)->elem = &me->elem->getBeam();
   ((_Beam*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Reaction_getBeams(PyObject *self, PyObject *args)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Beam_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBeams();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Reaction_addBeams(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Beam_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BeamList(me->elem->addBeams(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Reaction_deleteBeams(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reaction element");
      return NULL;
   }
   me->elem->deleteBeams(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Reaction_getTarget(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *obj = _Target_new(&_Target_type, 0, 0);
   ((_Target*)obj)->elem = &me->elem->getTarget();
   ((_Target*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Reaction_getTargets(PyObject *self, PyObject *args)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Target_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTargets();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Reaction_addTargets(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Target_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TargetList(me->elem->addTargets(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Reaction_deleteTargets(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reaction element");
      return NULL;
   }
   me->elem->deleteTargets(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Reaction_getVertex(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *obj = _Vertex_new(&_Vertex_type, 0, 0);
   ((_Vertex*)obj)->elem = &me->elem->getVertex(index);
   ((_Vertex*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Reaction_getVertices(PyObject *self, PyObject *args)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Vertex_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getVertices();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Reaction_addVertices(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Vertex_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new VertexList(me->elem->addVertices(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Reaction_deleteVertices(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reaction element");
      return NULL;
   }
   me->elem->deleteVertices(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Reaction_getRandom(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *obj = _Random_new(&_Random_type, 0, 0);
   ((_Random*)obj)->elem = &me->elem->getRandom();
   ((_Random*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Reaction_getRandoms(PyObject *self, PyObject *args)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Random_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRandoms();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Reaction_addRandoms(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Random_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RandomList(me->elem->addRandoms(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Reaction_deleteRandoms(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reaction element");
      return NULL;
   }
   me->elem->deleteRandoms(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Reaction_getUserData(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *obj = _UserData_new(&_UserData_type, 0, 0);
   ((_UserData*)obj)->elem = &me->elem->getUserData(index);
   ((_UserData*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Reaction_getUserDatas(PyObject *self, PyObject *args)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserData_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUserDatas();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Reaction_addUserDatas(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reaction element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserData_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataList(me->elem->addUserDatas(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Reaction_deleteUserDatas(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reaction element");
      return NULL;
   }
   me->elem->deleteUserDatas(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Reaction_toString(PyObject *self, PyObject *args=0)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Reaction_toXML(PyObject *self, PyObject *args=0)
{
   _Reaction *me = (_Reaction*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reaction element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Reaction_getsetters[] = {
   {(char*)"class",
    (getter)_Reaction_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Reaction_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Reaction_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Reaction_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Reaction_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"type",
    (getter)_Reaction_getType, (setter)_Reaction_setType,
    (char*)"type value",
    NULL},
   {(char*)"version",
    (getter)_Reaction_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"weight",
    (getter)_Reaction_getWeight, (setter)_Reaction_setWeight,
    (char*)"weight value",
    NULL},
   {(char*)"xmlns",
    (getter)_Reaction_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Reaction_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Reaction_methods[] = {
   {"addBeams", _Reaction_addBeams, METH_VARARGS,
    "extend (or insert into) the list of beam objects for this reaction"},
   {"addRandoms", _Reaction_addRandoms, METH_VARARGS,
    "extend (or insert into) the list of random objects for this reaction"},
   {"addTargets", _Reaction_addTargets, METH_VARARGS,
    "extend (or insert into) the list of target objects for this reaction"},
   {"addUserDatas", _Reaction_addUserDatas, METH_VARARGS,
    "extend (or insert into) the list of userData objects for this reaction"},
   {"addVertices", _Reaction_addVertices, METH_VARARGS,
    "extend (or insert into) the list of vertex objects for this reaction"},
   {"deleteBeams", _Reaction_deleteBeams, METH_VARARGS,
    "delete beam objects for this reaction"},
   {"deleteRandoms", _Reaction_deleteRandoms, METH_VARARGS,
    "delete random objects for this reaction"},
   {"deleteTargets", _Reaction_deleteTargets, METH_VARARGS,
    "delete target objects for this reaction"},
   {"deleteUserDatas", _Reaction_deleteUserDatas, METH_VARARGS,
    "delete userData objects for this reaction"},
   {"deleteVertices", _Reaction_deleteVertices, METH_VARARGS,
    "delete vertex objects for this reaction"},
   {"getBeam", _Reaction_getBeam, METH_VARARGS,
    "get an individual beam object from this reaction"},
   {"getBeams", _Reaction_getBeams, METH_NOARGS,
    "get list of beam objects for this reaction"},
   {"getRandom", _Reaction_getRandom, METH_VARARGS,
    "get an individual random object from this reaction"},
   {"getRandoms", _Reaction_getRandoms, METH_NOARGS,
    "get list of random objects for this reaction"},
   {"getTarget", _Reaction_getTarget, METH_VARARGS,
    "get an individual target object from this reaction"},
   {"getTargets", _Reaction_getTargets, METH_NOARGS,
    "get list of target objects for this reaction"},
   {"getUserData", _Reaction_getUserData, METH_VARARGS,
    "get an individual userData object from this reaction"},
   {"getUserDatas", _Reaction_getUserDatas, METH_NOARGS,
    "get list of userData objects for this reaction"},
   {"getVertex", _Reaction_getVertex, METH_VARARGS,
    "get an individual vertex object from this reaction"},
   {"getVertices", _Reaction_getVertices, METH_NOARGS,
    "get list of vertex objects for this reaction"},
   {"toString", _Reaction_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Reaction_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Reaction_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Reaction",         /*tp_name*/
    sizeof(_Reaction),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Reaction_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Reaction_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s reaction element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Reaction_methods,          /* tp_methods */
    _Reaction_members,          /* tp_members */
    _Reaction_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Reaction_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Reaction_new,              /* tp_new */
};



// wrap element class hddm_s::CdcDigihit as hddm_s.CdcDigihit

typedef struct {
   PyObject_HEAD
   CdcDigihit *elem;
   PyObject *host;
} _CdcDigihit;

static void
_CdcDigihit_dealloc(_CdcDigihit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcDigihit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcDigihit *self;
   self = (_CdcDigihit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcDigihit_init(_CdcDigihit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcDigihit_getClass(_CdcDigihit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcDigihit_getVersion(_CdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcDigihit_getXmlns(_CdcDigihit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcDigihit_getEventNo(_CdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcDigihit_getMaxOccurs(_CdcDigihit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcDigihit_getRunNo(_CdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcDigihit_getRing(_CdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_CdcDigihit_getStraw(_CdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStraw());
}

static PyObject*
_CdcDigihit_getQ(_CdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static PyObject*
_CdcDigihit_getT(_CdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_CdcDigihit_getMinOccurs(_CdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcDigihit_getPeakAmp(_CdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPeakAmp());
}

static int
_CdcDigihit_setPeakAmp(_CdcDigihit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPeakAmp((float)var);
   return 0;
}

static PyObject*
_CdcDigihit_toString(PyObject *self, PyObject *args=0)
{
   _CdcDigihit *me = (_CdcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcDigihit_toXML(PyObject *self, PyObject *args=0)
{
   _CdcDigihit *me = (_CdcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcDigihit_getsetters[] = {
   {(char*)"class",
    (getter)_CdcDigihit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcDigihit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcDigihit_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcDigihit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"peakAmp",
    (getter)_CdcDigihit_getPeakAmp, (setter)_CdcDigihit_setPeakAmp,
    (char*)"peakAmp value",
    NULL},
   {(char*)"q",
    (getter)_CdcDigihit_getQ, 0,
    (char*)"q value",
    NULL},
   {(char*)"ring",
    (getter)_CdcDigihit_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcDigihit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"straw",
    (getter)_CdcDigihit_getStraw, 0,
    (char*)"straw value",
    NULL},
   {(char*)"t",
    (getter)_CdcDigihit_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CdcDigihit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcDigihit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcDigihit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcDigihit_methods[] = {
   {"toString", _CdcDigihit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcDigihit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcDigihit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcDigihit",         /*tp_name*/
    sizeof(_CdcDigihit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcDigihit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcDigihit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcDigihit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcDigihit_methods,          /* tp_methods */
    _CdcDigihit_members,          /* tp_members */
    _CdcDigihit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcDigihit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcDigihit_new,              /* tp_new */
};



// wrap element class hddm_s::CdcHitQF as hddm_s.CdcHitQF

typedef struct {
   PyObject_HEAD
   CdcHitQF *elem;
   PyObject *host;
} _CdcHitQF;

static void
_CdcHitQF_dealloc(_CdcHitQF* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcHitQF_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcHitQF *self;
   self = (_CdcHitQF*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcHitQF_init(_CdcHitQF *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcHitQF_getClass(_CdcHitQF *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcHitQF_getVersion(_CdcHitQF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcHitQF_getXmlns(_CdcHitQF *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcHitQF_getEventNo(_CdcHitQF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcHitQF_getMaxOccurs(_CdcHitQF *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcHitQF_getRunNo(_CdcHitQF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcHitQF_getRing(_CdcHitQF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_CdcHitQF_getStraw(_CdcHitQF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStraw());
}

static PyObject*
_CdcHitQF_getQ(_CdcHitQF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static PyObject*
_CdcHitQF_getT(_CdcHitQF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_CdcHitQF_getQF(_CdcHitQF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQF());
}

static int
_CdcHitQF_setQF(_CdcHitQF *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQF((float)var);
   return 0;
}

static PyObject*
_CdcHitQF_getMinOccurs(_CdcHitQF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcHitQF_toString(PyObject *self, PyObject *args=0)
{
   _CdcHitQF *me = (_CdcHitQF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcHitQF element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcHitQF_toXML(PyObject *self, PyObject *args=0)
{
   _CdcHitQF *me = (_CdcHitQF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcHitQF element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcHitQF_getsetters[] = {
   {(char*)"QF",
    (getter)_CdcHitQF_getQF, (setter)_CdcHitQF_setQF,
    (char*)"QF value",
    NULL},
   {(char*)"class",
    (getter)_CdcHitQF_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcHitQF_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcHitQF_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcHitQF_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"q",
    (getter)_CdcHitQF_getQ, 0,
    (char*)"q value",
    NULL},
   {(char*)"ring",
    (getter)_CdcHitQF_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcHitQF_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"straw",
    (getter)_CdcHitQF_getStraw, 0,
    (char*)"straw value",
    NULL},
   {(char*)"t",
    (getter)_CdcHitQF_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CdcHitQF_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcHitQF_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcHitQF_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcHitQF_methods[] = {
   {"toString", _CdcHitQF_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcHitQF_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcHitQF_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcHitQF",         /*tp_name*/
    sizeof(_CdcHitQF),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcHitQF_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcHitQF_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcHitQF element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcHitQF_methods,          /* tp_methods */
    _CdcHitQF_members,          /* tp_members */
    _CdcHitQF_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcHitQF_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcHitQF_new,              /* tp_new */
};



// wrap element class hddm_s::CdcStrawHit as hddm_s.CdcStrawHit

typedef struct {
   PyObject_HEAD
   CdcStrawHit *elem;
   PyObject *host;
} _CdcStrawHit;

static void
_CdcStrawHit_dealloc(_CdcStrawHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcStrawHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcStrawHit *self;
   self = (_CdcStrawHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcStrawHit_init(_CdcStrawHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcStrawHit_getClass(_CdcStrawHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawHit_getVersion(_CdcStrawHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcStrawHit_getXmlns(_CdcStrawHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawHit_getEventNo(_CdcStrawHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcStrawHit_getRunNo(_CdcStrawHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcStrawHit_getMinOccurs(_CdcStrawHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcStrawHit_getRing(_CdcStrawHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_CdcStrawHit_getStraw(_CdcStrawHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStraw());
}

static PyObject*
_CdcStrawHit_getMaxOccurs(_CdcStrawHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawHit_getQ(_CdcStrawHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_CdcStrawHit_setQ(_CdcStrawHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_CdcStrawHit_getT(_CdcStrawHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CdcStrawHit_setT(_CdcStrawHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CdcStrawHit_getCdcDigihit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *obj = _CdcDigihit_new(&_CdcDigihit_type, 0, 0);
   ((_CdcDigihit*)obj)->elem = &me->elem->getCdcDigihit();
   ((_CdcDigihit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcStrawHit_getCdcDigihits(PyObject *self, PyObject *args)
{
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcDigihits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcStrawHit_addCdcDigihits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcDigihitList(me->elem->addCdcDigihits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcStrawHit_deleteCdcDigihits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcStrawHit element");
      return NULL;
   }
   me->elem->deleteCdcDigihits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcStrawHit_getCdcHitQF(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *obj = _CdcHitQF_new(&_CdcHitQF_type, 0, 0);
   ((_CdcHitQF*)obj)->elem = &me->elem->getCdcHitQF();
   ((_CdcHitQF*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcStrawHit_getCdcHitQFs(PyObject *self, PyObject *args)
{
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcHitQF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcHitQFs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcStrawHit_addCdcHitQFs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcStrawHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcHitQF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcHitQFList(me->elem->addCdcHitQFs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcStrawHit_deleteCdcHitQFs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcStrawHit element");
      return NULL;
   }
   me->elem->deleteCdcHitQFs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcStrawHit_toString(PyObject *self, PyObject *args=0)
{
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcStrawHit_toXML(PyObject *self, PyObject *args=0)
{
   _CdcStrawHit *me = (_CdcStrawHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcStrawHit_getsetters[] = {
   {(char*)"class",
    (getter)_CdcStrawHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcStrawHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcStrawHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcStrawHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"q",
    (getter)_CdcStrawHit_getQ, (setter)_CdcStrawHit_setQ,
    (char*)"q value",
    NULL},
   {(char*)"ring",
    (getter)_CdcStrawHit_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcStrawHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"straw",
    (getter)_CdcStrawHit_getStraw, 0,
    (char*)"straw value",
    NULL},
   {(char*)"t",
    (getter)_CdcStrawHit_getT, (setter)_CdcStrawHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CdcStrawHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcStrawHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcStrawHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcStrawHit_methods[] = {
   {"addCdcDigihits", _CdcStrawHit_addCdcDigihits, METH_VARARGS,
    "extend (or insert into) the list of cdcDigihit objects for this cdcStrawHit"},
   {"addCdcHitQFs", _CdcStrawHit_addCdcHitQFs, METH_VARARGS,
    "extend (or insert into) the list of cdcHitQF objects for this cdcStrawHit"},
   {"deleteCdcDigihits", _CdcStrawHit_deleteCdcDigihits, METH_VARARGS,
    "delete cdcDigihit objects for this cdcStrawHit"},
   {"deleteCdcHitQFs", _CdcStrawHit_deleteCdcHitQFs, METH_VARARGS,
    "delete cdcHitQF objects for this cdcStrawHit"},
   {"getCdcDigihit", _CdcStrawHit_getCdcDigihit, METH_VARARGS,
    "get an individual cdcDigihit object from this cdcStrawHit"},
   {"getCdcDigihits", _CdcStrawHit_getCdcDigihits, METH_NOARGS,
    "get list of cdcDigihit objects for this cdcStrawHit"},
   {"getCdcHitQF", _CdcStrawHit_getCdcHitQF, METH_VARARGS,
    "get an individual cdcHitQF object from this cdcStrawHit"},
   {"getCdcHitQFs", _CdcStrawHit_getCdcHitQFs, METH_NOARGS,
    "get list of cdcHitQF objects for this cdcStrawHit"},
   {"toString", _CdcStrawHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcStrawHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcStrawHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcStrawHit",         /*tp_name*/
    sizeof(_CdcStrawHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcStrawHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcStrawHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcStrawHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcStrawHit_methods,          /* tp_methods */
    _CdcStrawHit_members,          /* tp_members */
    _CdcStrawHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcStrawHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcStrawHit_new,              /* tp_new */
};



// wrap element class hddm_s::CdcStrawTruthHit as hddm_s.CdcStrawTruthHit

typedef struct {
   PyObject_HEAD
   CdcStrawTruthHit *elem;
   PyObject *host;
} _CdcStrawTruthHit;

static void
_CdcStrawTruthHit_dealloc(_CdcStrawTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcStrawTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcStrawTruthHit *self;
   self = (_CdcStrawTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcStrawTruthHit_init(_CdcStrawTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcStrawTruthHit_getClass(_CdcStrawTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawTruthHit_getVersion(_CdcStrawTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcStrawTruthHit_getXmlns(_CdcStrawTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawTruthHit_getEventNo(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcStrawTruthHit_getRunNo(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcStrawTruthHit_getMinOccurs(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcStrawTruthHit_getRing(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_CdcStrawTruthHit_getStraw(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStraw());
}

static PyObject*
_CdcStrawTruthHit_getD(_CdcStrawTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getD());
}

static int
_CdcStrawTruthHit_setD(_CdcStrawTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setD((float)var);
   return 0;
}

static PyObject*
_CdcStrawTruthHit_getItrack(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_CdcStrawTruthHit_setItrack(_CdcStrawTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_CdcStrawTruthHit_getMaxOccurs(_CdcStrawTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStrawTruthHit_getPtype(_CdcStrawTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_CdcStrawTruthHit_setPtype(_CdcStrawTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_CdcStrawTruthHit_getQ(_CdcStrawTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_CdcStrawTruthHit_setQ(_CdcStrawTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_CdcStrawTruthHit_getT(_CdcStrawTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CdcStrawTruthHit_setT(_CdcStrawTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CdcStrawTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _CdcStrawTruthHit *me = (_CdcStrawTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcStrawTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _CdcStrawTruthHit *me = (_CdcStrawTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStrawTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcStrawTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_CdcStrawTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"d",
    (getter)_CdcStrawTruthHit_getD, (setter)_CdcStrawTruthHit_setD,
    (char*)"d value",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcStrawTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_CdcStrawTruthHit_getItrack, (setter)_CdcStrawTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcStrawTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcStrawTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ptype",
    (getter)_CdcStrawTruthHit_getPtype, (setter)_CdcStrawTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"q",
    (getter)_CdcStrawTruthHit_getQ, (setter)_CdcStrawTruthHit_setQ,
    (char*)"q value",
    NULL},
   {(char*)"ring",
    (getter)_CdcStrawTruthHit_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcStrawTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"straw",
    (getter)_CdcStrawTruthHit_getStraw, 0,
    (char*)"straw value",
    NULL},
   {(char*)"t",
    (getter)_CdcStrawTruthHit_getT, (setter)_CdcStrawTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CdcStrawTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcStrawTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcStrawTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcStrawTruthHit_methods[] = {
   {"toString", _CdcStrawTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcStrawTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcStrawTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcStrawTruthHit",         /*tp_name*/
    sizeof(_CdcStrawTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcStrawTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcStrawTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcStrawTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcStrawTruthHit_methods,          /* tp_methods */
    _CdcStrawTruthHit_members,          /* tp_members */
    _CdcStrawTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcStrawTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcStrawTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::CdcStraw as hddm_s.CdcStraw

typedef struct {
   PyObject_HEAD
   CdcStraw *elem;
   PyObject *host;
} _CdcStraw;

static void
_CdcStraw_dealloc(_CdcStraw* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcStraw_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcStraw *self;
   self = (_CdcStraw*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcStraw_init(_CdcStraw *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcStraw_getClass(_CdcStraw *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStraw_getVersion(_CdcStraw *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcStraw_getXmlns(_CdcStraw *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStraw_getEventNo(_CdcStraw *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcStraw_getRunNo(_CdcStraw *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcStraw_getMaxOccurs(_CdcStraw *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcStraw_getMinOccurs(_CdcStraw *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcStraw_getRing(_CdcStraw *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static int
_CdcStraw_setRing(_CdcStraw *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRing(var);
   return 0;
}

static PyObject*
_CdcStraw_getStraw(_CdcStraw *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStraw());
}

static int
_CdcStraw_setStraw(_CdcStraw *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setStraw(var);
   return 0;
}

static PyObject*
_CdcStraw_getCdcStrawHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *obj = _CdcStrawHit_new(&_CdcStrawHit_type, 0, 0);
   ((_CdcStrawHit*)obj)->elem = &me->elem->getCdcStrawHit(index);
   ((_CdcStrawHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcStraw_getCdcStrawHits(PyObject *self, PyObject *args)
{
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcStrawHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcStraw_addCdcStrawHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawHitList(me->elem->addCdcStrawHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcStraw_deleteCdcStrawHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcStraw element");
      return NULL;
   }
   me->elem->deleteCdcStrawHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcStraw_getCdcStrawTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *obj = _CdcStrawTruthHit_new(&_CdcStrawTruthHit_type, 0, 0);
   ((_CdcStrawTruthHit*)obj)->elem = &me->elem->getCdcStrawTruthHit(index);
   ((_CdcStrawTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcStraw_getCdcStrawTruthHits(PyObject *self, PyObject *args)
{
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcStrawTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcStraw_addCdcStrawTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcStraw element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawTruthHitList(me->elem->addCdcStrawTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcStraw_deleteCdcStrawTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcStraw element");
      return NULL;
   }
   me->elem->deleteCdcStrawTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcStraw_toString(PyObject *self, PyObject *args=0)
{
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcStraw_toXML(PyObject *self, PyObject *args=0)
{
   _CdcStraw *me = (_CdcStraw*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcStraw element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcStraw_getsetters[] = {
   {(char*)"class",
    (getter)_CdcStraw_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcStraw_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcStraw_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcStraw_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ring",
    (getter)_CdcStraw_getRing, (setter)_CdcStraw_setRing,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcStraw_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"straw",
    (getter)_CdcStraw_getStraw, (setter)_CdcStraw_setStraw,
    (char*)"straw value",
    NULL},
   {(char*)"version",
    (getter)_CdcStraw_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcStraw_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcStraw_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcStraw_methods[] = {
   {"addCdcStrawHits", _CdcStraw_addCdcStrawHits, METH_VARARGS,
    "extend (or insert into) the list of cdcStrawHit objects for this cdcStraw"},
   {"addCdcStrawTruthHits", _CdcStraw_addCdcStrawTruthHits, METH_VARARGS,
    "extend (or insert into) the list of cdcStrawTruthHit objects for this cdcStraw"},
   {"deleteCdcStrawHits", _CdcStraw_deleteCdcStrawHits, METH_VARARGS,
    "delete cdcStrawHit objects for this cdcStraw"},
   {"deleteCdcStrawTruthHits", _CdcStraw_deleteCdcStrawTruthHits, METH_VARARGS,
    "delete cdcStrawTruthHit objects for this cdcStraw"},
   {"getCdcStrawHit", _CdcStraw_getCdcStrawHit, METH_VARARGS,
    "get an individual cdcStrawHit object from this cdcStraw"},
   {"getCdcStrawHits", _CdcStraw_getCdcStrawHits, METH_NOARGS,
    "get list of cdcStrawHit objects for this cdcStraw"},
   {"getCdcStrawTruthHit", _CdcStraw_getCdcStrawTruthHit, METH_VARARGS,
    "get an individual cdcStrawTruthHit object from this cdcStraw"},
   {"getCdcStrawTruthHits", _CdcStraw_getCdcStrawTruthHits, METH_NOARGS,
    "get list of cdcStrawTruthHit objects for this cdcStraw"},
   {"toString", _CdcStraw_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcStraw_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcStraw_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcStraw",         /*tp_name*/
    sizeof(_CdcStraw),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcStraw_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcStraw_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcStraw element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcStraw_methods,          /* tp_methods */
    _CdcStraw_members,          /* tp_members */
    _CdcStraw_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcStraw_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcStraw_new,              /* tp_new */
};



// wrap element class hddm_s::TrackID as hddm_s.TrackID

typedef struct {
   PyObject_HEAD
   TrackID *elem;
   PyObject *host;
} _TrackID;

static void
_TrackID_dealloc(_TrackID* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TrackID_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TrackID *self;
   self = (_TrackID*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TrackID_init(_TrackID *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TrackID_getClass(_TrackID *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackID_getVersion(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TrackID_getXmlns(_TrackID *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackID_getEventNo(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TrackID_getMaxOccurs(_TrackID *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackID_getRunNo(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TrackID_getE(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_TrackID_getPrimary(_TrackID *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static PyObject*
_TrackID_getPtype(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static PyObject*
_TrackID_getPx(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static PyObject*
_TrackID_getPy(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static PyObject*
_TrackID_getPz(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static PyObject*
_TrackID_getT(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_TrackID_getTrack(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static PyObject*
_TrackID_getX(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static PyObject*
_TrackID_getY(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static PyObject*
_TrackID_getZ(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static PyObject*
_TrackID_getDEdx(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static PyObject*
_TrackID_getPhi(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static PyObject*
_TrackID_getR(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static PyObject*
_TrackID_getArm(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_TrackID_getModule(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_TrackID_getColumn(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_TrackID_getSector(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_TrackID_getLayer(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_TrackID_getDradius(_TrackID *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDradius());
}

static PyObject*
_TrackID_getItrack(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_TrackID_setItrack(_TrackID *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_TrackID_getMinOccurs(_TrackID *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TrackID_toString(PyObject *self, PyObject *args=0)
{
   _TrackID *me = (_TrackID*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid trackID element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TrackID_toXML(PyObject *self, PyObject *args=0)
{
   _TrackID *me = (_TrackID*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid trackID element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TrackID_getsetters[] = {
   {(char*)"E",
    (getter)_TrackID_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"arm",
    (getter)_TrackID_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_TrackID_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_TrackID_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"dEdx",
    (getter)_TrackID_getDEdx, 0,
    (char*)"dEdx value",
    NULL},
   {(char*)"dradius",
    (getter)_TrackID_getDradius, 0,
    (char*)"dradius value",
    NULL},
   {(char*)"eventNo",
    (getter)_TrackID_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_TrackID_getItrack, (setter)_TrackID_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"layer",
    (getter)_TrackID_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TrackID_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_TrackID_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_TrackID_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"phi",
    (getter)_TrackID_getPhi, 0,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_TrackID_getPrimary, 0,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_TrackID_getPtype, 0,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_TrackID_getPx, 0,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_TrackID_getPy, 0,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_TrackID_getPz, 0,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_TrackID_getR, 0,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_TrackID_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_TrackID_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_TrackID_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_TrackID_getTrack, 0,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_TrackID_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_TrackID_getX, 0,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_TrackID_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_TrackID_getY, 0,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_TrackID_getZ, 0,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TrackID_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TrackID_methods[] = {
   {"toString", _TrackID_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TrackID_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TrackID_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TrackID",         /*tp_name*/
    sizeof(_TrackID),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TrackID_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TrackID_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s trackID element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TrackID_methods,          /* tp_methods */
    _TrackID_members,          /* tp_members */
    _TrackID_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TrackID_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TrackID_new,              /* tp_new */
};



// wrap element class hddm_s::TrackOrigin as hddm_s.TrackOrigin

typedef struct {
   PyObject_HEAD
   TrackOrigin *elem;
   PyObject *host;
} _TrackOrigin;

static void
_TrackOrigin_dealloc(_TrackOrigin* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TrackOrigin_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TrackOrigin *self;
   self = (_TrackOrigin*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TrackOrigin_init(_TrackOrigin *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TrackOrigin_getClass(_TrackOrigin *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackOrigin_getVersion(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TrackOrigin_getXmlns(_TrackOrigin *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackOrigin_getEventNo(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TrackOrigin_getRunNo(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TrackOrigin_getE(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_TrackOrigin_getPrimary(_TrackOrigin *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static PyObject*
_TrackOrigin_getPx(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static PyObject*
_TrackOrigin_getPy(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static PyObject*
_TrackOrigin_getPz(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static PyObject*
_TrackOrigin_getTrack(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static PyObject*
_TrackOrigin_getDEdx(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static PyObject*
_TrackOrigin_getPhi(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static PyObject*
_TrackOrigin_getR(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static PyObject*
_TrackOrigin_getArm(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_TrackOrigin_getModule(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_TrackOrigin_getColumn(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_TrackOrigin_getSector(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_TrackOrigin_getLayer(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_TrackOrigin_getDradius(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDradius());
}

static PyObject*
_TrackOrigin_getItrack(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_TrackOrigin_setItrack(_TrackOrigin *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_TrackOrigin_getMaxOccurs(_TrackOrigin *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackOrigin_getMinOccurs(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TrackOrigin_getPtype(_TrackOrigin *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_TrackOrigin_setPtype(_TrackOrigin *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_TrackOrigin_getT(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TrackOrigin_setT(_TrackOrigin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TrackOrigin_getX(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_TrackOrigin_setX(_TrackOrigin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_TrackOrigin_getY(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_TrackOrigin_setY(_TrackOrigin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_TrackOrigin_getZ(_TrackOrigin *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_TrackOrigin_setZ(_TrackOrigin *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_TrackOrigin_toString(PyObject *self, PyObject *args=0)
{
   _TrackOrigin *me = (_TrackOrigin*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid trackOrigin element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TrackOrigin_toXML(PyObject *self, PyObject *args=0)
{
   _TrackOrigin *me = (_TrackOrigin*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid trackOrigin element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TrackOrigin_getsetters[] = {
   {(char*)"E",
    (getter)_TrackOrigin_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"arm",
    (getter)_TrackOrigin_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_TrackOrigin_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_TrackOrigin_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"dEdx",
    (getter)_TrackOrigin_getDEdx, 0,
    (char*)"dEdx value",
    NULL},
   {(char*)"dradius",
    (getter)_TrackOrigin_getDradius, 0,
    (char*)"dradius value",
    NULL},
   {(char*)"eventNo",
    (getter)_TrackOrigin_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_TrackOrigin_getItrack, (setter)_TrackOrigin_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"layer",
    (getter)_TrackOrigin_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TrackOrigin_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TrackOrigin_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_TrackOrigin_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"phi",
    (getter)_TrackOrigin_getPhi, 0,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_TrackOrigin_getPrimary, 0,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_TrackOrigin_getPtype, (setter)_TrackOrigin_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_TrackOrigin_getPx, 0,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_TrackOrigin_getPy, 0,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_TrackOrigin_getPz, 0,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_TrackOrigin_getR, 0,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_TrackOrigin_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_TrackOrigin_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_TrackOrigin_getT, (setter)_TrackOrigin_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_TrackOrigin_getTrack, 0,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_TrackOrigin_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_TrackOrigin_getX, (setter)_TrackOrigin_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_TrackOrigin_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_TrackOrigin_getY, (setter)_TrackOrigin_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_TrackOrigin_getZ, (setter)_TrackOrigin_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TrackOrigin_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TrackOrigin_methods[] = {
   {"toString", _TrackOrigin_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TrackOrigin_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TrackOrigin_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TrackOrigin",         /*tp_name*/
    sizeof(_TrackOrigin),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TrackOrigin_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TrackOrigin_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s trackOrigin element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TrackOrigin_methods,          /* tp_methods */
    _TrackOrigin_members,          /* tp_members */
    _TrackOrigin_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TrackOrigin_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TrackOrigin_new,              /* tp_new */
};



// wrap element class hddm_s::CdcTruthPoint as hddm_s.CdcTruthPoint

typedef struct {
   PyObject_HEAD
   CdcTruthPoint *elem;
   PyObject *host;
} _CdcTruthPoint;

static void
_CdcTruthPoint_dealloc(_CdcTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CdcTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CdcTruthPoint *self;
   self = (_CdcTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CdcTruthPoint_init(_CdcTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CdcTruthPoint_getClass(_CdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcTruthPoint_getVersion(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CdcTruthPoint_getXmlns(_CdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcTruthPoint_getEventNo(_CdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CdcTruthPoint_getRunNo(_CdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CdcTruthPoint_getDEdx(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_CdcTruthPoint_setDEdx(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getDradius(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDradius());
}

static int
_CdcTruthPoint_setDradius(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDradius((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getMaxOccurs(_CdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CdcTruthPoint_getMinOccurs(_CdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CdcTruthPoint_getPhi(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static int
_CdcTruthPoint_setPhi(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPhi((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getPrimary(_CdcTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_CdcTruthPoint_setPrimary(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_CdcTruthPoint_getPtype(_CdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_CdcTruthPoint_setPtype(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getPx(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_CdcTruthPoint_setPx(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getPy(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_CdcTruthPoint_setPy(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getPz(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_CdcTruthPoint_setPz(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getR(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static int
_CdcTruthPoint_setR(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setR((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getT(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CdcTruthPoint_setT(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getTrack(_CdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_CdcTruthPoint_setTrack(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getZ(_CdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_CdcTruthPoint_setZ(_CdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_CdcTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CdcTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CdcTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CdcTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CdcTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CdcTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _CdcTruthPoint *me = (_CdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cdcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CdcTruthPoint_getsetters[] = {
   {(char*)"class",
    (getter)_CdcTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dEdx",
    (getter)_CdcTruthPoint_getDEdx, (setter)_CdcTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"dradius",
    (getter)_CdcTruthPoint_getDradius, (setter)_CdcTruthPoint_setDradius,
    (char*)"dradius value",
    NULL},
   {(char*)"eventNo",
    (getter)_CdcTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CdcTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CdcTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"phi",
    (getter)_CdcTruthPoint_getPhi, (setter)_CdcTruthPoint_setPhi,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_CdcTruthPoint_getPrimary, (setter)_CdcTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_CdcTruthPoint_getPtype, (setter)_CdcTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_CdcTruthPoint_getPx, (setter)_CdcTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_CdcTruthPoint_getPy, (setter)_CdcTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_CdcTruthPoint_getPz, (setter)_CdcTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_CdcTruthPoint_getR, (setter)_CdcTruthPoint_setR,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_CdcTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CdcTruthPoint_getT, (setter)_CdcTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_CdcTruthPoint_getTrack, (setter)_CdcTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_CdcTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CdcTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"z",
    (getter)_CdcTruthPoint_getZ, (setter)_CdcTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CdcTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CdcTruthPoint_methods[] = {
   {"addTrackIDs", _CdcTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this cdcTruthPoint"},
   {"addTrackOrigins", _CdcTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this cdcTruthPoint"},
   {"deleteTrackIDs", _CdcTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this cdcTruthPoint"},
   {"deleteTrackOrigins", _CdcTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this cdcTruthPoint"},
   {"getTrackID", _CdcTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this cdcTruthPoint"},
   {"getTrackIDs", _CdcTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this cdcTruthPoint"},
   {"getTrackOrigin", _CdcTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this cdcTruthPoint"},
   {"getTrackOrigins", _CdcTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this cdcTruthPoint"},
   {"toString", _CdcTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CdcTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CdcTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CdcTruthPoint",         /*tp_name*/
    sizeof(_CdcTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CdcTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CdcTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cdcTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CdcTruthPoint_methods,          /* tp_methods */
    _CdcTruthPoint_members,          /* tp_members */
    _CdcTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CdcTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CdcTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::CentralDC as hddm_s.CentralDC

typedef struct {
   PyObject_HEAD
   CentralDC *elem;
   PyObject *host;
} _CentralDC;

static void
_CentralDC_dealloc(_CentralDC* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CentralDC_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CentralDC *self;
   self = (_CentralDC*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CentralDC_init(_CentralDC *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CentralDC_getClass(_CentralDC *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CentralDC_getVersion(_CentralDC *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CentralDC_getXmlns(_CentralDC *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CentralDC_getEventNo(_CentralDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CentralDC_getMaxOccurs(_CentralDC *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CentralDC_getRunNo(_CentralDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CentralDC_getMinOccurs(_CentralDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CentralDC_getCdcStraw(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *obj = _CdcStraw_new(&_CdcStraw_type, 0, 0);
   ((_CdcStraw*)obj)->elem = &me->elem->getCdcStraw(index);
   ((_CdcStraw*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CentralDC_getCdcStraws(PyObject *self, PyObject *args)
{
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStraw_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcStraws();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CentralDC_addCdcStraws(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStraw_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawList(me->elem->addCdcStraws(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CentralDC_deleteCdcStraws(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid centralDC element");
      return NULL;
   }
   me->elem->deleteCdcStraws(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CentralDC_getCdcTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *obj = _CdcTruthPoint_new(&_CdcTruthPoint_type, 0, 0);
   ((_CdcTruthPoint*)obj)->elem = &me->elem->getCdcTruthPoint(index);
   ((_CdcTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CentralDC_getCdcTruthPoints(PyObject *self, PyObject *args)
{
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCdcTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CentralDC_addCdcTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid centralDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcTruthPointList(me->elem->addCdcTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CentralDC_deleteCdcTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid centralDC element");
      return NULL;
   }
   me->elem->deleteCdcTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CentralDC_toString(PyObject *self, PyObject *args=0)
{
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CentralDC_toXML(PyObject *self, PyObject *args=0)
{
   _CentralDC *me = (_CentralDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid centralDC element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CentralDC_getsetters[] = {
   {(char*)"class",
    (getter)_CentralDC_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CentralDC_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CentralDC_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_CentralDC_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CentralDC_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_CentralDC_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CentralDC_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CentralDC_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CentralDC_methods[] = {
   {"addCdcStraws", _CentralDC_addCdcStraws, METH_VARARGS,
    "extend (or insert into) the list of cdcStraw objects for this centralDC"},
   {"addCdcTruthPoints", _CentralDC_addCdcTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of cdcTruthPoint objects for this centralDC"},
   {"deleteCdcStraws", _CentralDC_deleteCdcStraws, METH_VARARGS,
    "delete cdcStraw objects for this centralDC"},
   {"deleteCdcTruthPoints", _CentralDC_deleteCdcTruthPoints, METH_VARARGS,
    "delete cdcTruthPoint objects for this centralDC"},
   {"getCdcStraw", _CentralDC_getCdcStraw, METH_VARARGS,
    "get an individual cdcStraw object from this centralDC"},
   {"getCdcStraws", _CentralDC_getCdcStraws, METH_NOARGS,
    "get list of cdcStraw objects for this centralDC"},
   {"getCdcTruthPoint", _CentralDC_getCdcTruthPoint, METH_VARARGS,
    "get an individual cdcTruthPoint object from this centralDC"},
   {"getCdcTruthPoints", _CentralDC_getCdcTruthPoints, METH_NOARGS,
    "get list of cdcTruthPoint objects for this centralDC"},
   {"toString", _CentralDC_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CentralDC_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CentralDC_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CentralDC",         /*tp_name*/
    sizeof(_CentralDC),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CentralDC_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CentralDC_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s centralDC element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CentralDC_methods,          /* tp_methods */
    _CentralDC_members,          /* tp_members */
    _CentralDC_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CentralDC_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CentralDC_new,              /* tp_new */
};



// wrap element class hddm_s::FdcAnodeHit as hddm_s.FdcAnodeHit

typedef struct {
   PyObject_HEAD
   FdcAnodeHit *elem;
   PyObject *host;
} _FdcAnodeHit;

static void
_FdcAnodeHit_dealloc(_FdcAnodeHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcAnodeHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcAnodeHit *self;
   self = (_FdcAnodeHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcAnodeHit_init(_FdcAnodeHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcAnodeHit_getClass(_FdcAnodeHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeHit_getVersion(_FdcAnodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcAnodeHit_getXmlns(_FdcAnodeHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeHit_getEventNo(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcAnodeHit_getRunNo(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcAnodeHit_getMinOccurs(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcAnodeHit_getLayer(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcAnodeHit_getModule(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcAnodeHit_getWire(_FdcAnodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FdcAnodeHit_getDE(_FdcAnodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FdcAnodeHit_setDE(_FdcAnodeHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FdcAnodeHit_getMaxOccurs(_FdcAnodeHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeHit_getT(_FdcAnodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FdcAnodeHit_setT(_FdcAnodeHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FdcAnodeHit_toString(PyObject *self, PyObject *args=0)
{
   _FdcAnodeHit *me = (_FdcAnodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcAnodeHit_toXML(PyObject *self, PyObject *args=0)
{
   _FdcAnodeHit *me = (_FdcAnodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcAnodeHit_getsetters[] = {
   {(char*)"class",
    (getter)_FdcAnodeHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FdcAnodeHit_getDE, (setter)_FdcAnodeHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcAnodeHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcAnodeHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcAnodeHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcAnodeHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcAnodeHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcAnodeHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FdcAnodeHit_getT, (setter)_FdcAnodeHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FdcAnodeHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FdcAnodeHit_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcAnodeHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcAnodeHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcAnodeHit_methods[] = {
   {"toString", _FdcAnodeHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcAnodeHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcAnodeHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcAnodeHit",         /*tp_name*/
    sizeof(_FdcAnodeHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcAnodeHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcAnodeHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcAnodeHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcAnodeHit_methods,          /* tp_methods */
    _FdcAnodeHit_members,          /* tp_members */
    _FdcAnodeHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcAnodeHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcAnodeHit_new,              /* tp_new */
};



// wrap element class hddm_s::FdcAnodeTruthHit as hddm_s.FdcAnodeTruthHit

typedef struct {
   PyObject_HEAD
   FdcAnodeTruthHit *elem;
   PyObject *host;
} _FdcAnodeTruthHit;

static void
_FdcAnodeTruthHit_dealloc(_FdcAnodeTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcAnodeTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcAnodeTruthHit *self;
   self = (_FdcAnodeTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcAnodeTruthHit_init(_FdcAnodeTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcAnodeTruthHit_getClass(_FdcAnodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeTruthHit_getVersion(_FdcAnodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcAnodeTruthHit_getXmlns(_FdcAnodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeTruthHit_getEventNo(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcAnodeTruthHit_getRunNo(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcAnodeTruthHit_getMinOccurs(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcAnodeTruthHit_getLayer(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcAnodeTruthHit_getModule(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcAnodeTruthHit_getWire(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FdcAnodeTruthHit_getD(_FdcAnodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getD());
}

static int
_FdcAnodeTruthHit_setD(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setD((float)var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_getDE(_FdcAnodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FdcAnodeTruthHit_setDE(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_getItrack(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_FdcAnodeTruthHit_setItrack(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_getMaxOccurs(_FdcAnodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeTruthHit_getPtype(_FdcAnodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FdcAnodeTruthHit_setPtype(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_getT(_FdcAnodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FdcAnodeTruthHit_setT(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_getT_unsmeared(_FdcAnodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT_unsmeared());
}

static int
_FdcAnodeTruthHit_setT_unsmeared(_FdcAnodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT_unsmeared((float)var);
   return 0;
}

static PyObject*
_FdcAnodeTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _FdcAnodeTruthHit *me = (_FdcAnodeTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcAnodeTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _FdcAnodeTruthHit *me = (_FdcAnodeTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcAnodeTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_FdcAnodeTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"d",
    (getter)_FdcAnodeTruthHit_getD, (setter)_FdcAnodeTruthHit_setD,
    (char*)"d value",
    NULL},
   {(char*)"dE",
    (getter)_FdcAnodeTruthHit_getDE, (setter)_FdcAnodeTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcAnodeTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_FdcAnodeTruthHit_getItrack, (setter)_FdcAnodeTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"layer",
    (getter)_FdcAnodeTruthHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcAnodeTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcAnodeTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcAnodeTruthHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"ptype",
    (getter)_FdcAnodeTruthHit_getPtype, (setter)_FdcAnodeTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcAnodeTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FdcAnodeTruthHit_getT, (setter)_FdcAnodeTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"t_unsmeared",
    (getter)_FdcAnodeTruthHit_getT_unsmeared, (setter)_FdcAnodeTruthHit_setT_unsmeared,
    (char*)"t_unsmeared value",
    NULL},
   {(char*)"version",
    (getter)_FdcAnodeTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FdcAnodeTruthHit_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcAnodeTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcAnodeTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcAnodeTruthHit_methods[] = {
   {"toString", _FdcAnodeTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcAnodeTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcAnodeTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcAnodeTruthHit",         /*tp_name*/
    sizeof(_FdcAnodeTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcAnodeTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcAnodeTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcAnodeTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcAnodeTruthHit_methods,          /* tp_methods */
    _FdcAnodeTruthHit_members,          /* tp_members */
    _FdcAnodeTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcAnodeTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcAnodeTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::FdcAnodeWire as hddm_s.FdcAnodeWire

typedef struct {
   PyObject_HEAD
   FdcAnodeWire *elem;
   PyObject *host;
} _FdcAnodeWire;

static void
_FdcAnodeWire_dealloc(_FdcAnodeWire* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcAnodeWire_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcAnodeWire *self;
   self = (_FdcAnodeWire*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcAnodeWire_init(_FdcAnodeWire *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcAnodeWire_getClass(_FdcAnodeWire *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeWire_getVersion(_FdcAnodeWire *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcAnodeWire_getXmlns(_FdcAnodeWire *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeWire_getEventNo(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcAnodeWire_getRunNo(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcAnodeWire_getLayer(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcAnodeWire_getModule(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcAnodeWire_getMaxOccurs(_FdcAnodeWire *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcAnodeWire_getMinOccurs(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcAnodeWire_getWire(_FdcAnodeWire *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static int
_FdcAnodeWire_setWire(_FdcAnodeWire *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setWire(var);
   return 0;
}

static PyObject*
_FdcAnodeWire_getFdcAnodeHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *obj = _FdcAnodeHit_new(&_FdcAnodeHit_type, 0, 0);
   ((_FdcAnodeHit*)obj)->elem = &me->elem->getFdcAnodeHit(index);
   ((_FdcAnodeHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcAnodeWire_getFdcAnodeHits(PyObject *self, PyObject *args)
{
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcAnodeHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcAnodeWire_addFdcAnodeHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeHitList(me->elem->addFdcAnodeHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcAnodeWire_deleteFdcAnodeHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   me->elem->deleteFdcAnodeHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcAnodeWire_getFdcAnodeTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *obj = _FdcAnodeTruthHit_new(&_FdcAnodeTruthHit_type, 0, 0);
   ((_FdcAnodeTruthHit*)obj)->elem = &me->elem->getFdcAnodeTruthHit(index);
   ((_FdcAnodeTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcAnodeWire_getFdcAnodeTruthHits(PyObject *self, PyObject *args)
{
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcAnodeTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcAnodeWire_addFdcAnodeTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeTruthHitList(me->elem->addFdcAnodeTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcAnodeWire_deleteFdcAnodeTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   me->elem->deleteFdcAnodeTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcAnodeWire_toString(PyObject *self, PyObject *args=0)
{
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcAnodeWire_toXML(PyObject *self, PyObject *args=0)
{
   _FdcAnodeWire *me = (_FdcAnodeWire*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcAnodeWire element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcAnodeWire_getsetters[] = {
   {(char*)"class",
    (getter)_FdcAnodeWire_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcAnodeWire_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcAnodeWire_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcAnodeWire_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcAnodeWire_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcAnodeWire_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcAnodeWire_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_FdcAnodeWire_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FdcAnodeWire_getWire, (setter)_FdcAnodeWire_setWire,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcAnodeWire_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcAnodeWire_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcAnodeWire_methods[] = {
   {"addFdcAnodeHits", _FdcAnodeWire_addFdcAnodeHits, METH_VARARGS,
    "extend (or insert into) the list of fdcAnodeHit objects for this fdcAnodeWire"},
   {"addFdcAnodeTruthHits", _FdcAnodeWire_addFdcAnodeTruthHits, METH_VARARGS,
    "extend (or insert into) the list of fdcAnodeTruthHit objects for this fdcAnodeWire"},
   {"deleteFdcAnodeHits", _FdcAnodeWire_deleteFdcAnodeHits, METH_VARARGS,
    "delete fdcAnodeHit objects for this fdcAnodeWire"},
   {"deleteFdcAnodeTruthHits", _FdcAnodeWire_deleteFdcAnodeTruthHits, METH_VARARGS,
    "delete fdcAnodeTruthHit objects for this fdcAnodeWire"},
   {"getFdcAnodeHit", _FdcAnodeWire_getFdcAnodeHit, METH_VARARGS,
    "get an individual fdcAnodeHit object from this fdcAnodeWire"},
   {"getFdcAnodeHits", _FdcAnodeWire_getFdcAnodeHits, METH_NOARGS,
    "get list of fdcAnodeHit objects for this fdcAnodeWire"},
   {"getFdcAnodeTruthHit", _FdcAnodeWire_getFdcAnodeTruthHit, METH_VARARGS,
    "get an individual fdcAnodeTruthHit object from this fdcAnodeWire"},
   {"getFdcAnodeTruthHits", _FdcAnodeWire_getFdcAnodeTruthHits, METH_NOARGS,
    "get list of fdcAnodeTruthHit objects for this fdcAnodeWire"},
   {"toString", _FdcAnodeWire_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcAnodeWire_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcAnodeWire_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcAnodeWire",         /*tp_name*/
    sizeof(_FdcAnodeWire),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcAnodeWire_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcAnodeWire_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcAnodeWire element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcAnodeWire_methods,          /* tp_methods */
    _FdcAnodeWire_members,          /* tp_members */
    _FdcAnodeWire_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcAnodeWire_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcAnodeWire_new,              /* tp_new */
};



// wrap element class hddm_s::FdcDigihit as hddm_s.FdcDigihit

typedef struct {
   PyObject_HEAD
   FdcDigihit *elem;
   PyObject *host;
} _FdcDigihit;

static void
_FdcDigihit_dealloc(_FdcDigihit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcDigihit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcDigihit *self;
   self = (_FdcDigihit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcDigihit_init(_FdcDigihit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcDigihit_getClass(_FdcDigihit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcDigihit_getVersion(_FdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcDigihit_getXmlns(_FdcDigihit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcDigihit_getEventNo(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcDigihit_getMaxOccurs(_FdcDigihit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcDigihit_getRunNo(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcDigihit_getLayer(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcDigihit_getModule(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcDigihit_getPlane(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FdcDigihit_getStrip(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStrip());
}

static PyObject*
_FdcDigihit_getQ(_FdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static PyObject*
_FdcDigihit_getT(_FdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FdcDigihit_getMinOccurs(_FdcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcDigihit_getPeakAmp(_FdcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPeakAmp());
}

static int
_FdcDigihit_setPeakAmp(_FdcDigihit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPeakAmp((float)var);
   return 0;
}

static PyObject*
_FdcDigihit_toString(PyObject *self, PyObject *args=0)
{
   _FdcDigihit *me = (_FdcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcDigihit_toXML(PyObject *self, PyObject *args=0)
{
   _FdcDigihit *me = (_FdcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcDigihit_getsetters[] = {
   {(char*)"class",
    (getter)_FdcDigihit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcDigihit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcDigihit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcDigihit_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcDigihit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcDigihit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"peakAmp",
    (getter)_FdcDigihit_getPeakAmp, (setter)_FdcDigihit_setPeakAmp,
    (char*)"peakAmp value",
    NULL},
   {(char*)"plane",
    (getter)_FdcDigihit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"q",
    (getter)_FdcDigihit_getQ, 0,
    (char*)"q value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcDigihit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"strip",
    (getter)_FdcDigihit_getStrip, 0,
    (char*)"strip value",
    NULL},
   {(char*)"t",
    (getter)_FdcDigihit_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FdcDigihit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcDigihit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcDigihit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcDigihit_methods[] = {
   {"toString", _FdcDigihit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcDigihit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcDigihit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcDigihit",         /*tp_name*/
    sizeof(_FdcDigihit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcDigihit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcDigihit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcDigihit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcDigihit_methods,          /* tp_methods */
    _FdcDigihit_members,          /* tp_members */
    _FdcDigihit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcDigihit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcDigihit_new,              /* tp_new */
};



// wrap element class hddm_s::FdcCathodeHit as hddm_s.FdcCathodeHit

typedef struct {
   PyObject_HEAD
   FdcCathodeHit *elem;
   PyObject *host;
} _FdcCathodeHit;

static void
_FdcCathodeHit_dealloc(_FdcCathodeHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcCathodeHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcCathodeHit *self;
   self = (_FdcCathodeHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcCathodeHit_init(_FdcCathodeHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcCathodeHit_getClass(_FdcCathodeHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeHit_getVersion(_FdcCathodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcCathodeHit_getXmlns(_FdcCathodeHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeHit_getEventNo(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcCathodeHit_getRunNo(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcCathodeHit_getMinOccurs(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcCathodeHit_getLayer(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcCathodeHit_getModule(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcCathodeHit_getPlane(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FdcCathodeHit_getStrip(_FdcCathodeHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStrip());
}

static PyObject*
_FdcCathodeHit_getMaxOccurs(_FdcCathodeHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeHit_getQ(_FdcCathodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_FdcCathodeHit_setQ(_FdcCathodeHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_FdcCathodeHit_getT(_FdcCathodeHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FdcCathodeHit_setT(_FdcCathodeHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FdcCathodeHit_getFdcDigihit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   PyObject *obj = _FdcDigihit_new(&_FdcDigihit_type, 0, 0);
   ((_FdcDigihit*)obj)->elem = &me->elem->getFdcDigihit();
   ((_FdcDigihit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcCathodeHit_getFdcDigihits(PyObject *self, PyObject *args)
{
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcDigihits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcCathodeHit_addFdcDigihits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcDigihitList(me->elem->addFdcDigihits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcCathodeHit_deleteFdcDigihits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   me->elem->deleteFdcDigihits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcCathodeHit_toString(PyObject *self, PyObject *args=0)
{
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcCathodeHit_toXML(PyObject *self, PyObject *args=0)
{
   _FdcCathodeHit *me = (_FdcCathodeHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcCathodeHit_getsetters[] = {
   {(char*)"class",
    (getter)_FdcCathodeHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcCathodeHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcCathodeHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcCathodeHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcCathodeHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcCathodeHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"plane",
    (getter)_FdcCathodeHit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"q",
    (getter)_FdcCathodeHit_getQ, (setter)_FdcCathodeHit_setQ,
    (char*)"q value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcCathodeHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"strip",
    (getter)_FdcCathodeHit_getStrip, 0,
    (char*)"strip value",
    NULL},
   {(char*)"t",
    (getter)_FdcCathodeHit_getT, (setter)_FdcCathodeHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FdcCathodeHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcCathodeHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcCathodeHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcCathodeHit_methods[] = {
   {"addFdcDigihits", _FdcCathodeHit_addFdcDigihits, METH_VARARGS,
    "extend (or insert into) the list of fdcDigihit objects for this fdcCathodeHit"},
   {"deleteFdcDigihits", _FdcCathodeHit_deleteFdcDigihits, METH_VARARGS,
    "delete fdcDigihit objects for this fdcCathodeHit"},
   {"getFdcDigihit", _FdcCathodeHit_getFdcDigihit, METH_VARARGS,
    "get an individual fdcDigihit object from this fdcCathodeHit"},
   {"getFdcDigihits", _FdcCathodeHit_getFdcDigihits, METH_NOARGS,
    "get list of fdcDigihit objects for this fdcCathodeHit"},
   {"toString", _FdcCathodeHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcCathodeHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcCathodeHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcCathodeHit",         /*tp_name*/
    sizeof(_FdcCathodeHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcCathodeHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcCathodeHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcCathodeHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcCathodeHit_methods,          /* tp_methods */
    _FdcCathodeHit_members,          /* tp_members */
    _FdcCathodeHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcCathodeHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcCathodeHit_new,              /* tp_new */
};



// wrap element class hddm_s::FdcCathodeTruthHit as hddm_s.FdcCathodeTruthHit

typedef struct {
   PyObject_HEAD
   FdcCathodeTruthHit *elem;
   PyObject *host;
} _FdcCathodeTruthHit;

static void
_FdcCathodeTruthHit_dealloc(_FdcCathodeTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcCathodeTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcCathodeTruthHit *self;
   self = (_FdcCathodeTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcCathodeTruthHit_init(_FdcCathodeTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcCathodeTruthHit_getClass(_FdcCathodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeTruthHit_getVersion(_FdcCathodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcCathodeTruthHit_getXmlns(_FdcCathodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeTruthHit_getEventNo(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcCathodeTruthHit_getRunNo(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcCathodeTruthHit_getMinOccurs(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcCathodeTruthHit_getLayer(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcCathodeTruthHit_getModule(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcCathodeTruthHit_getPlane(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FdcCathodeTruthHit_getStrip(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStrip());
}

static PyObject*
_FdcCathodeTruthHit_getItrack(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_FdcCathodeTruthHit_setItrack(_FdcCathodeTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_FdcCathodeTruthHit_getMaxOccurs(_FdcCathodeTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeTruthHit_getPtype(_FdcCathodeTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FdcCathodeTruthHit_setPtype(_FdcCathodeTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FdcCathodeTruthHit_getQ(_FdcCathodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_FdcCathodeTruthHit_setQ(_FdcCathodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_FdcCathodeTruthHit_getT(_FdcCathodeTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FdcCathodeTruthHit_setT(_FdcCathodeTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FdcCathodeTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _FdcCathodeTruthHit *me = (_FdcCathodeTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcCathodeTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _FdcCathodeTruthHit *me = (_FdcCathodeTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcCathodeTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_FdcCathodeTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcCathodeTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_FdcCathodeTruthHit_getItrack, (setter)_FdcCathodeTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"layer",
    (getter)_FdcCathodeTruthHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcCathodeTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcCathodeTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcCathodeTruthHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"plane",
    (getter)_FdcCathodeTruthHit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"ptype",
    (getter)_FdcCathodeTruthHit_getPtype, (setter)_FdcCathodeTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"q",
    (getter)_FdcCathodeTruthHit_getQ, (setter)_FdcCathodeTruthHit_setQ,
    (char*)"q value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcCathodeTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"strip",
    (getter)_FdcCathodeTruthHit_getStrip, 0,
    (char*)"strip value",
    NULL},
   {(char*)"t",
    (getter)_FdcCathodeTruthHit_getT, (setter)_FdcCathodeTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FdcCathodeTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcCathodeTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcCathodeTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcCathodeTruthHit_methods[] = {
   {"toString", _FdcCathodeTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcCathodeTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcCathodeTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcCathodeTruthHit",         /*tp_name*/
    sizeof(_FdcCathodeTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcCathodeTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcCathodeTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcCathodeTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcCathodeTruthHit_methods,          /* tp_methods */
    _FdcCathodeTruthHit_members,          /* tp_members */
    _FdcCathodeTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcCathodeTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcCathodeTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::FdcCathodeStrip as hddm_s.FdcCathodeStrip

typedef struct {
   PyObject_HEAD
   FdcCathodeStrip *elem;
   PyObject *host;
} _FdcCathodeStrip;

static void
_FdcCathodeStrip_dealloc(_FdcCathodeStrip* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcCathodeStrip_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcCathodeStrip *self;
   self = (_FdcCathodeStrip*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcCathodeStrip_init(_FdcCathodeStrip *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcCathodeStrip_getClass(_FdcCathodeStrip *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeStrip_getVersion(_FdcCathodeStrip *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcCathodeStrip_getXmlns(_FdcCathodeStrip *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeStrip_getEventNo(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcCathodeStrip_getRunNo(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcCathodeStrip_getLayer(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcCathodeStrip_getModule(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcCathodeStrip_getMaxOccurs(_FdcCathodeStrip *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcCathodeStrip_getMinOccurs(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcCathodeStrip_getPlane(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static int
_FdcCathodeStrip_setPlane(_FdcCathodeStrip *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPlane(var);
   return 0;
}

static PyObject*
_FdcCathodeStrip_getStrip(_FdcCathodeStrip *self, void *closure)
{
   return PyLong_FromLong(self->elem->getStrip());
}

static int
_FdcCathodeStrip_setStrip(_FdcCathodeStrip *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setStrip(var);
   return 0;
}

static PyObject*
_FdcCathodeStrip_getFdcCathodeHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *obj = _FdcCathodeHit_new(&_FdcCathodeHit_type, 0, 0);
   ((_FdcCathodeHit*)obj)->elem = &me->elem->getFdcCathodeHit(index);
   ((_FdcCathodeHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcCathodeStrip_getFdcCathodeHits(PyObject *self, PyObject *args)
{
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcCathodeHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcCathodeStrip_addFdcCathodeHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeHitList(me->elem->addFdcCathodeHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcCathodeStrip_deleteFdcCathodeHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   me->elem->deleteFdcCathodeHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcCathodeStrip_getFdcCathodeTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *obj = _FdcCathodeTruthHit_new(&_FdcCathodeTruthHit_type, 0, 0);
   ((_FdcCathodeTruthHit*)obj)->elem = &me->elem->getFdcCathodeTruthHit(index);
   ((_FdcCathodeTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcCathodeStrip_getFdcCathodeTruthHits(PyObject *self, PyObject *args)
{
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcCathodeTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcCathodeStrip_addFdcCathodeTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeTruthHitList(me->elem->addFdcCathodeTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcCathodeStrip_deleteFdcCathodeTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   me->elem->deleteFdcCathodeTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcCathodeStrip_toString(PyObject *self, PyObject *args=0)
{
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcCathodeStrip_toXML(PyObject *self, PyObject *args=0)
{
   _FdcCathodeStrip *me = (_FdcCathodeStrip*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcCathodeStrip element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcCathodeStrip_getsetters[] = {
   {(char*)"class",
    (getter)_FdcCathodeStrip_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcCathodeStrip_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcCathodeStrip_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcCathodeStrip_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcCathodeStrip_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcCathodeStrip_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"plane",
    (getter)_FdcCathodeStrip_getPlane, (setter)_FdcCathodeStrip_setPlane,
    (char*)"plane value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcCathodeStrip_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"strip",
    (getter)_FdcCathodeStrip_getStrip, (setter)_FdcCathodeStrip_setStrip,
    (char*)"strip value",
    NULL},
   {(char*)"version",
    (getter)_FdcCathodeStrip_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcCathodeStrip_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcCathodeStrip_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcCathodeStrip_methods[] = {
   {"addFdcCathodeHits", _FdcCathodeStrip_addFdcCathodeHits, METH_VARARGS,
    "extend (or insert into) the list of fdcCathodeHit objects for this fdcCathodeStrip"},
   {"addFdcCathodeTruthHits", _FdcCathodeStrip_addFdcCathodeTruthHits, METH_VARARGS,
    "extend (or insert into) the list of fdcCathodeTruthHit objects for this fdcCathodeStrip"},
   {"deleteFdcCathodeHits", _FdcCathodeStrip_deleteFdcCathodeHits, METH_VARARGS,
    "delete fdcCathodeHit objects for this fdcCathodeStrip"},
   {"deleteFdcCathodeTruthHits", _FdcCathodeStrip_deleteFdcCathodeTruthHits, METH_VARARGS,
    "delete fdcCathodeTruthHit objects for this fdcCathodeStrip"},
   {"getFdcCathodeHit", _FdcCathodeStrip_getFdcCathodeHit, METH_VARARGS,
    "get an individual fdcCathodeHit object from this fdcCathodeStrip"},
   {"getFdcCathodeHits", _FdcCathodeStrip_getFdcCathodeHits, METH_NOARGS,
    "get list of fdcCathodeHit objects for this fdcCathodeStrip"},
   {"getFdcCathodeTruthHit", _FdcCathodeStrip_getFdcCathodeTruthHit, METH_VARARGS,
    "get an individual fdcCathodeTruthHit object from this fdcCathodeStrip"},
   {"getFdcCathodeTruthHits", _FdcCathodeStrip_getFdcCathodeTruthHits, METH_NOARGS,
    "get list of fdcCathodeTruthHit objects for this fdcCathodeStrip"},
   {"toString", _FdcCathodeStrip_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcCathodeStrip_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcCathodeStrip_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcCathodeStrip",         /*tp_name*/
    sizeof(_FdcCathodeStrip),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcCathodeStrip_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcCathodeStrip_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcCathodeStrip element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcCathodeStrip_methods,          /* tp_methods */
    _FdcCathodeStrip_members,          /* tp_members */
    _FdcCathodeStrip_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcCathodeStrip_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcCathodeStrip_new,              /* tp_new */
};



// wrap element class hddm_s::FdcTruthPoint as hddm_s.FdcTruthPoint

typedef struct {
   PyObject_HEAD
   FdcTruthPoint *elem;
   PyObject *host;
} _FdcTruthPoint;

static void
_FdcTruthPoint_dealloc(_FdcTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcTruthPoint *self;
   self = (_FdcTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcTruthPoint_init(_FdcTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcTruthPoint_getClass(_FdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcTruthPoint_getVersion(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcTruthPoint_getXmlns(_FdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcTruthPoint_getEventNo(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcTruthPoint_getRunNo(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcTruthPoint_getLayer(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FdcTruthPoint_getModule(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_FdcTruthPoint_getE(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FdcTruthPoint_setE(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getDEdx(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_FdcTruthPoint_setDEdx(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getDradius(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDradius());
}

static int
_FdcTruthPoint_setDradius(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDradius((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getMaxOccurs(_FdcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcTruthPoint_getMinOccurs(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcTruthPoint_getPrimary(_FdcTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_FdcTruthPoint_setPrimary(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_FdcTruthPoint_getPtype(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FdcTruthPoint_setPtype(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getPx(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_FdcTruthPoint_setPx(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getPy(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_FdcTruthPoint_setPy(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getPz(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_FdcTruthPoint_setPz(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getT(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FdcTruthPoint_setT(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getTrack(_FdcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_FdcTruthPoint_setTrack(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getX(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_FdcTruthPoint_setX(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getY(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_FdcTruthPoint_setY(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getZ(_FdcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_FdcTruthPoint_setZ(_FdcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_FdcTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _FdcTruthPoint *me = (_FdcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_FdcTruthPoint_getE, (setter)_FdcTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FdcTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dEdx",
    (getter)_FdcTruthPoint_getDEdx, (setter)_FdcTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"dradius",
    (getter)_FdcTruthPoint_getDradius, (setter)_FdcTruthPoint_setDradius,
    (char*)"dradius value",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcTruthPoint_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcTruthPoint_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"primary",
    (getter)_FdcTruthPoint_getPrimary, (setter)_FdcTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_FdcTruthPoint_getPtype, (setter)_FdcTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_FdcTruthPoint_getPx, (setter)_FdcTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_FdcTruthPoint_getPy, (setter)_FdcTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_FdcTruthPoint_getPz, (setter)_FdcTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FdcTruthPoint_getT, (setter)_FdcTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_FdcTruthPoint_getTrack, (setter)_FdcTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_FdcTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_FdcTruthPoint_getX, (setter)_FdcTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_FdcTruthPoint_getY, (setter)_FdcTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_FdcTruthPoint_getZ, (setter)_FdcTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcTruthPoint_methods[] = {
   {"addTrackIDs", _FdcTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this fdcTruthPoint"},
   {"addTrackOrigins", _FdcTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this fdcTruthPoint"},
   {"deleteTrackIDs", _FdcTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this fdcTruthPoint"},
   {"deleteTrackOrigins", _FdcTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this fdcTruthPoint"},
   {"getTrackID", _FdcTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this fdcTruthPoint"},
   {"getTrackIDs", _FdcTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this fdcTruthPoint"},
   {"getTrackOrigin", _FdcTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this fdcTruthPoint"},
   {"getTrackOrigins", _FdcTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this fdcTruthPoint"},
   {"toString", _FdcTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcTruthPoint",         /*tp_name*/
    sizeof(_FdcTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcTruthPoint_methods,          /* tp_methods */
    _FdcTruthPoint_members,          /* tp_members */
    _FdcTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::FdcChamber as hddm_s.FdcChamber

typedef struct {
   PyObject_HEAD
   FdcChamber *elem;
   PyObject *host;
} _FdcChamber;

static void
_FdcChamber_dealloc(_FdcChamber* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FdcChamber_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FdcChamber *self;
   self = (_FdcChamber*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FdcChamber_init(_FdcChamber *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FdcChamber_getClass(_FdcChamber *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcChamber_getVersion(_FdcChamber *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FdcChamber_getXmlns(_FdcChamber *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcChamber_getEventNo(_FdcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FdcChamber_getRunNo(_FdcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FdcChamber_getMinOccurs(_FdcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FdcChamber_getLayer(_FdcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static int
_FdcChamber_setLayer(_FdcChamber *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setLayer(var);
   return 0;
}

static PyObject*
_FdcChamber_getMaxOccurs(_FdcChamber *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FdcChamber_getModule(_FdcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static int
_FdcChamber_setModule(_FdcChamber *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setModule(var);
   return 0;
}

static PyObject*
_FdcChamber_getFdcAnodeWire(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *obj = _FdcAnodeWire_new(&_FdcAnodeWire_type, 0, 0);
   ((_FdcAnodeWire*)obj)->elem = &me->elem->getFdcAnodeWire(index);
   ((_FdcAnodeWire*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcChamber_getFdcAnodeWires(PyObject *self, PyObject *args)
{
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeWire_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcAnodeWires();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcChamber_addFdcAnodeWires(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeWire_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeWireList(me->elem->addFdcAnodeWires(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcChamber_deleteFdcAnodeWires(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcChamber element");
      return NULL;
   }
   me->elem->deleteFdcAnodeWires(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcChamber_getFdcCathodeStrip(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *obj = _FdcCathodeStrip_new(&_FdcCathodeStrip_type, 0, 0);
   ((_FdcCathodeStrip*)obj)->elem = &me->elem->getFdcCathodeStrip(index);
   ((_FdcCathodeStrip*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcChamber_getFdcCathodeStrips(PyObject *self, PyObject *args)
{
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeStrip_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcCathodeStrips();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcChamber_addFdcCathodeStrips(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeStrip_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeStripList(me->elem->addFdcCathodeStrips(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcChamber_deleteFdcCathodeStrips(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcChamber element");
      return NULL;
   }
   me->elem->deleteFdcCathodeStrips(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcChamber_getFdcTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *obj = _FdcTruthPoint_new(&_FdcTruthPoint_type, 0, 0);
   ((_FdcTruthPoint*)obj)->elem = &me->elem->getFdcTruthPoint(index);
   ((_FdcTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FdcChamber_getFdcTruthPoints(PyObject *self, PyObject *args)
{
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FdcChamber_addFdcTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fdcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcTruthPointList(me->elem->addFdcTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FdcChamber_deleteFdcTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fdcChamber element");
      return NULL;
   }
   me->elem->deleteFdcTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FdcChamber_toString(PyObject *self, PyObject *args=0)
{
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FdcChamber_toXML(PyObject *self, PyObject *args=0)
{
   _FdcChamber *me = (_FdcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fdcChamber element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FdcChamber_getsetters[] = {
   {(char*)"class",
    (getter)_FdcChamber_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FdcChamber_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FdcChamber_getLayer, (setter)_FdcChamber_setLayer,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FdcChamber_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FdcChamber_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_FdcChamber_getModule, (setter)_FdcChamber_setModule,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_FdcChamber_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_FdcChamber_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FdcChamber_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FdcChamber_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FdcChamber_methods[] = {
   {"addFdcAnodeWires", _FdcChamber_addFdcAnodeWires, METH_VARARGS,
    "extend (or insert into) the list of fdcAnodeWire objects for this fdcChamber"},
   {"addFdcCathodeStrips", _FdcChamber_addFdcCathodeStrips, METH_VARARGS,
    "extend (or insert into) the list of fdcCathodeStrip objects for this fdcChamber"},
   {"addFdcTruthPoints", _FdcChamber_addFdcTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of fdcTruthPoint objects for this fdcChamber"},
   {"deleteFdcAnodeWires", _FdcChamber_deleteFdcAnodeWires, METH_VARARGS,
    "delete fdcAnodeWire objects for this fdcChamber"},
   {"deleteFdcCathodeStrips", _FdcChamber_deleteFdcCathodeStrips, METH_VARARGS,
    "delete fdcCathodeStrip objects for this fdcChamber"},
   {"deleteFdcTruthPoints", _FdcChamber_deleteFdcTruthPoints, METH_VARARGS,
    "delete fdcTruthPoint objects for this fdcChamber"},
   {"getFdcAnodeWire", _FdcChamber_getFdcAnodeWire, METH_VARARGS,
    "get an individual fdcAnodeWire object from this fdcChamber"},
   {"getFdcAnodeWires", _FdcChamber_getFdcAnodeWires, METH_NOARGS,
    "get list of fdcAnodeWire objects for this fdcChamber"},
   {"getFdcCathodeStrip", _FdcChamber_getFdcCathodeStrip, METH_VARARGS,
    "get an individual fdcCathodeStrip object from this fdcChamber"},
   {"getFdcCathodeStrips", _FdcChamber_getFdcCathodeStrips, METH_NOARGS,
    "get list of fdcCathodeStrip objects for this fdcChamber"},
   {"getFdcTruthPoint", _FdcChamber_getFdcTruthPoint, METH_VARARGS,
    "get an individual fdcTruthPoint object from this fdcChamber"},
   {"getFdcTruthPoints", _FdcChamber_getFdcTruthPoints, METH_NOARGS,
    "get list of fdcTruthPoint objects for this fdcChamber"},
   {"toString", _FdcChamber_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FdcChamber_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FdcChamber_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FdcChamber",         /*tp_name*/
    sizeof(_FdcChamber),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FdcChamber_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FdcChamber_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fdcChamber element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FdcChamber_methods,          /* tp_methods */
    _FdcChamber_members,          /* tp_members */
    _FdcChamber_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FdcChamber_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FdcChamber_new,              /* tp_new */
};



// wrap element class hddm_s::ForwardDC as hddm_s.ForwardDC

typedef struct {
   PyObject_HEAD
   ForwardDC *elem;
   PyObject *host;
} _ForwardDC;

static void
_ForwardDC_dealloc(_ForwardDC* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ForwardDC_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ForwardDC *self;
   self = (_ForwardDC*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ForwardDC_init(_ForwardDC *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ForwardDC_getClass(_ForwardDC *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardDC_getVersion(_ForwardDC *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ForwardDC_getXmlns(_ForwardDC *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardDC_getEventNo(_ForwardDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ForwardDC_getMaxOccurs(_ForwardDC *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardDC_getRunNo(_ForwardDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ForwardDC_getMinOccurs(_ForwardDC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ForwardDC_getFdcChamber(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardDC element");
      return NULL;
   }
   PyObject *obj = _FdcChamber_new(&_FdcChamber_type, 0, 0);
   ((_FdcChamber*)obj)->elem = &me->elem->getFdcChamber(index);
   ((_FdcChamber*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardDC_getFdcChambers(PyObject *self, PyObject *args)
{
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFdcChambers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardDC_addFdcChambers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardDC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcChamberList(me->elem->addFdcChambers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardDC_deleteFdcChambers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardDC element");
      return NULL;
   }
   me->elem->deleteFdcChambers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardDC_toString(PyObject *self, PyObject *args=0)
{
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardDC element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ForwardDC_toXML(PyObject *self, PyObject *args=0)
{
   _ForwardDC *me = (_ForwardDC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardDC element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ForwardDC_getsetters[] = {
   {(char*)"class",
    (getter)_ForwardDC_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ForwardDC_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ForwardDC_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ForwardDC_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ForwardDC_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ForwardDC_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ForwardDC_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ForwardDC_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ForwardDC_methods[] = {
   {"addFdcChambers", _ForwardDC_addFdcChambers, METH_VARARGS,
    "extend (or insert into) the list of fdcChamber objects for this forwardDC"},
   {"deleteFdcChambers", _ForwardDC_deleteFdcChambers, METH_VARARGS,
    "delete fdcChamber objects for this forwardDC"},
   {"getFdcChamber", _ForwardDC_getFdcChamber, METH_VARARGS,
    "get an individual fdcChamber object from this forwardDC"},
   {"getFdcChambers", _ForwardDC_getFdcChambers, METH_NOARGS,
    "get list of fdcChamber objects for this forwardDC"},
   {"toString", _ForwardDC_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ForwardDC_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ForwardDC_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ForwardDC",         /*tp_name*/
    sizeof(_ForwardDC),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ForwardDC_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ForwardDC_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s forwardDC element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ForwardDC_methods,          /* tp_methods */
    _ForwardDC_members,          /* tp_members */
    _ForwardDC_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ForwardDC_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ForwardDC_new,              /* tp_new */
};



// wrap element class hddm_s::StcDigihit as hddm_s.StcDigihit

typedef struct {
   PyObject_HEAD
   StcDigihit *elem;
   PyObject *host;
} _StcDigihit;

static void
_StcDigihit_dealloc(_StcDigihit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StcDigihit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StcDigihit *self;
   self = (_StcDigihit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StcDigihit_init(_StcDigihit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StcDigihit_getClass(_StcDigihit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcDigihit_getVersion(_StcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StcDigihit_getXmlns(_StcDigihit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcDigihit_getEventNo(_StcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StcDigihit_getMaxOccurs(_StcDigihit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcDigihit_getRunNo(_StcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StcDigihit_getSector(_StcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_StcDigihit_getDE(_StcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static PyObject*
_StcDigihit_getT(_StcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_StcDigihit_getMinOccurs(_StcDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StcDigihit_getPeakAmp(_StcDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPeakAmp());
}

static int
_StcDigihit_setPeakAmp(_StcDigihit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPeakAmp((float)var);
   return 0;
}

static PyObject*
_StcDigihit_toString(PyObject *self, PyObject *args=0)
{
   _StcDigihit *me = (_StcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StcDigihit_toXML(PyObject *self, PyObject *args=0)
{
   _StcDigihit *me = (_StcDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcDigihit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StcDigihit_getsetters[] = {
   {(char*)"class",
    (getter)_StcDigihit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_StcDigihit_getDE, 0,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_StcDigihit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StcDigihit_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_StcDigihit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"peakAmp",
    (getter)_StcDigihit_getPeakAmp, (setter)_StcDigihit_setPeakAmp,
    (char*)"peakAmp value",
    NULL},
   {(char*)"runNo",
    (getter)_StcDigihit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_StcDigihit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_StcDigihit_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_StcDigihit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StcDigihit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StcDigihit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StcDigihit_methods[] = {
   {"toString", _StcDigihit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StcDigihit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StcDigihit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StcDigihit",         /*tp_name*/
    sizeof(_StcDigihit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StcDigihit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StcDigihit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s stcDigihit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StcDigihit_methods,          /* tp_methods */
    _StcDigihit_members,          /* tp_members */
    _StcDigihit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StcDigihit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StcDigihit_new,              /* tp_new */
};



// wrap element class hddm_s::StcHit as hddm_s.StcHit

typedef struct {
   PyObject_HEAD
   StcHit *elem;
   PyObject *host;
} _StcHit;

static void
_StcHit_dealloc(_StcHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StcHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StcHit *self;
   self = (_StcHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StcHit_init(_StcHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StcHit_getClass(_StcHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcHit_getVersion(_StcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StcHit_getXmlns(_StcHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcHit_getEventNo(_StcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StcHit_getRunNo(_StcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StcHit_getMinOccurs(_StcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StcHit_getSector(_StcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_StcHit_getDE(_StcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_StcHit_setDE(_StcHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_StcHit_getMaxOccurs(_StcHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcHit_getT(_StcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_StcHit_setT(_StcHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_StcHit_getStcDigihit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcHit element");
      return NULL;
   }
   PyObject *obj = _StcDigihit_new(&_StcDigihit_type, 0, 0);
   ((_StcDigihit*)obj)->elem = &me->elem->getStcDigihit();
   ((_StcDigihit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StcHit_getStcDigihits(PyObject *self, PyObject *args)
{
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStcDigihits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StcHit_addStcDigihits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid stcHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcDigihitList(me->elem->addStcDigihits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StcHit_deleteStcDigihits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid stcHit element");
      return NULL;
   }
   me->elem->deleteStcDigihits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StcHit_toString(PyObject *self, PyObject *args=0)
{
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StcHit_toXML(PyObject *self, PyObject *args=0)
{
   _StcHit *me = (_StcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StcHit_getsetters[] = {
   {(char*)"class",
    (getter)_StcHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_StcHit_getDE, (setter)_StcHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_StcHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StcHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_StcHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_StcHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_StcHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_StcHit_getT, (setter)_StcHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_StcHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StcHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StcHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StcHit_methods[] = {
   {"addStcDigihits", _StcHit_addStcDigihits, METH_VARARGS,
    "extend (or insert into) the list of stcDigihit objects for this stcHit"},
   {"deleteStcDigihits", _StcHit_deleteStcDigihits, METH_VARARGS,
    "delete stcDigihit objects for this stcHit"},
   {"getStcDigihit", _StcHit_getStcDigihit, METH_VARARGS,
    "get an individual stcDigihit object from this stcHit"},
   {"getStcDigihits", _StcHit_getStcDigihits, METH_NOARGS,
    "get list of stcDigihit objects for this stcHit"},
   {"toString", _StcHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StcHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StcHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StcHit",         /*tp_name*/
    sizeof(_StcHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StcHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StcHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s stcHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StcHit_methods,          /* tp_methods */
    _StcHit_members,          /* tp_members */
    _StcHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StcHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StcHit_new,              /* tp_new */
};



// wrap element class hddm_s::StcTruthHit as hddm_s.StcTruthHit

typedef struct {
   PyObject_HEAD
   StcTruthHit *elem;
   PyObject *host;
} _StcTruthHit;

static void
_StcTruthHit_dealloc(_StcTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StcTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StcTruthHit *self;
   self = (_StcTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StcTruthHit_init(_StcTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StcTruthHit_getClass(_StcTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthHit_getVersion(_StcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StcTruthHit_getXmlns(_StcTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthHit_getEventNo(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StcTruthHit_getRunNo(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StcTruthHit_getMinOccurs(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StcTruthHit_getSector(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_StcTruthHit_getDE(_StcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_StcTruthHit_setDE(_StcTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_StcTruthHit_getItrack(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_StcTruthHit_setItrack(_StcTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_StcTruthHit_getMaxOccurs(_StcTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthHit_getPtype(_StcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_StcTruthHit_setPtype(_StcTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_StcTruthHit_getT(_StcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_StcTruthHit_setT(_StcTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_StcTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _StcTruthHit *me = (_StcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StcTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _StcTruthHit *me = (_StcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StcTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_StcTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_StcTruthHit_getDE, (setter)_StcTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_StcTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_StcTruthHit_getItrack, (setter)_StcTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StcTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_StcTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ptype",
    (getter)_StcTruthHit_getPtype, (setter)_StcTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"runNo",
    (getter)_StcTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_StcTruthHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_StcTruthHit_getT, (setter)_StcTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_StcTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StcTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StcTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StcTruthHit_methods[] = {
   {"toString", _StcTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StcTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StcTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StcTruthHit",         /*tp_name*/
    sizeof(_StcTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StcTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StcTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s stcTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StcTruthHit_methods,          /* tp_methods */
    _StcTruthHit_members,          /* tp_members */
    _StcTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StcTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StcTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::StcPaddle as hddm_s.StcPaddle

typedef struct {
   PyObject_HEAD
   StcPaddle *elem;
   PyObject *host;
} _StcPaddle;

static void
_StcPaddle_dealloc(_StcPaddle* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StcPaddle_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StcPaddle *self;
   self = (_StcPaddle*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StcPaddle_init(_StcPaddle *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StcPaddle_getClass(_StcPaddle *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcPaddle_getVersion(_StcPaddle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StcPaddle_getXmlns(_StcPaddle *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcPaddle_getEventNo(_StcPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StcPaddle_getRunNo(_StcPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StcPaddle_getMaxOccurs(_StcPaddle *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcPaddle_getMinOccurs(_StcPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StcPaddle_getSector(_StcPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static int
_StcPaddle_setSector(_StcPaddle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSector(var);
   return 0;
}

static PyObject*
_StcPaddle_getStcHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *obj = _StcHit_new(&_StcHit_type, 0, 0);
   ((_StcHit*)obj)->elem = &me->elem->getStcHit(index);
   ((_StcHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StcPaddle_getStcHits(PyObject *self, PyObject *args)
{
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStcHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StcPaddle_addStcHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcHitList(me->elem->addStcHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StcPaddle_deleteStcHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid stcPaddle element");
      return NULL;
   }
   me->elem->deleteStcHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StcPaddle_getStcTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *obj = _StcTruthHit_new(&_StcTruthHit_type, 0, 0);
   ((_StcTruthHit*)obj)->elem = &me->elem->getStcTruthHit(index);
   ((_StcTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StcPaddle_getStcTruthHits(PyObject *self, PyObject *args)
{
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStcTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StcPaddle_addStcTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid stcPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcTruthHitList(me->elem->addStcTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StcPaddle_deleteStcTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid stcPaddle element");
      return NULL;
   }
   me->elem->deleteStcTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StcPaddle_toString(PyObject *self, PyObject *args=0)
{
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StcPaddle_toXML(PyObject *self, PyObject *args=0)
{
   _StcPaddle *me = (_StcPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcPaddle element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StcPaddle_getsetters[] = {
   {(char*)"class",
    (getter)_StcPaddle_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_StcPaddle_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StcPaddle_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_StcPaddle_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_StcPaddle_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_StcPaddle_getSector, (setter)_StcPaddle_setSector,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_StcPaddle_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StcPaddle_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StcPaddle_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StcPaddle_methods[] = {
   {"addStcHits", _StcPaddle_addStcHits, METH_VARARGS,
    "extend (or insert into) the list of stcHit objects for this stcPaddle"},
   {"addStcTruthHits", _StcPaddle_addStcTruthHits, METH_VARARGS,
    "extend (or insert into) the list of stcTruthHit objects for this stcPaddle"},
   {"deleteStcHits", _StcPaddle_deleteStcHits, METH_VARARGS,
    "delete stcHit objects for this stcPaddle"},
   {"deleteStcTruthHits", _StcPaddle_deleteStcTruthHits, METH_VARARGS,
    "delete stcTruthHit objects for this stcPaddle"},
   {"getStcHit", _StcPaddle_getStcHit, METH_VARARGS,
    "get an individual stcHit object from this stcPaddle"},
   {"getStcHits", _StcPaddle_getStcHits, METH_NOARGS,
    "get list of stcHit objects for this stcPaddle"},
   {"getStcTruthHit", _StcPaddle_getStcTruthHit, METH_VARARGS,
    "get an individual stcTruthHit object from this stcPaddle"},
   {"getStcTruthHits", _StcPaddle_getStcTruthHits, METH_NOARGS,
    "get list of stcTruthHit objects for this stcPaddle"},
   {"toString", _StcPaddle_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StcPaddle_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StcPaddle_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StcPaddle",         /*tp_name*/
    sizeof(_StcPaddle),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StcPaddle_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StcPaddle_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s stcPaddle element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StcPaddle_methods,          /* tp_methods */
    _StcPaddle_members,          /* tp_members */
    _StcPaddle_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StcPaddle_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StcPaddle_new,              /* tp_new */
};



// wrap element class hddm_s::StcTruthPoint as hddm_s.StcTruthPoint

typedef struct {
   PyObject_HEAD
   StcTruthPoint *elem;
   PyObject *host;
} _StcTruthPoint;

static void
_StcTruthPoint_dealloc(_StcTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StcTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StcTruthPoint *self;
   self = (_StcTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StcTruthPoint_init(_StcTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StcTruthPoint_getClass(_StcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthPoint_getVersion(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StcTruthPoint_getXmlns(_StcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthPoint_getEventNo(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StcTruthPoint_getRunNo(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StcTruthPoint_getE(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_StcTruthPoint_setE(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getDEdx(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_StcTruthPoint_setDEdx(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getMaxOccurs(_StcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StcTruthPoint_getMinOccurs(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StcTruthPoint_getPhi(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static int
_StcTruthPoint_setPhi(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPhi((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getPrimary(_StcTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_StcTruthPoint_setPrimary(_StcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_StcTruthPoint_getPtype(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_StcTruthPoint_setPtype(_StcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_StcTruthPoint_getPx(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_StcTruthPoint_setPx(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getPy(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_StcTruthPoint_setPy(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getPz(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_StcTruthPoint_setPz(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getR(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static int
_StcTruthPoint_setR(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setR((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getSector(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static int
_StcTruthPoint_setSector(_StcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSector(var);
   return 0;
}

static PyObject*
_StcTruthPoint_getT(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_StcTruthPoint_setT(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getTrack(_StcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_StcTruthPoint_setTrack(_StcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_StcTruthPoint_getZ(_StcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_StcTruthPoint_setZ(_StcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_StcTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StcTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StcTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StcTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid stcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StcTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StcTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StcTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid stcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StcTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid stcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StcTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StcTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _StcTruthPoint *me = (_StcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid stcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StcTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_StcTruthPoint_getE, (setter)_StcTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_StcTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dEdx",
    (getter)_StcTruthPoint_getDEdx, (setter)_StcTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"eventNo",
    (getter)_StcTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StcTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_StcTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"phi",
    (getter)_StcTruthPoint_getPhi, (setter)_StcTruthPoint_setPhi,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_StcTruthPoint_getPrimary, (setter)_StcTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_StcTruthPoint_getPtype, (setter)_StcTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_StcTruthPoint_getPx, (setter)_StcTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_StcTruthPoint_getPy, (setter)_StcTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_StcTruthPoint_getPz, (setter)_StcTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_StcTruthPoint_getR, (setter)_StcTruthPoint_setR,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_StcTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_StcTruthPoint_getSector, (setter)_StcTruthPoint_setSector,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_StcTruthPoint_getT, (setter)_StcTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_StcTruthPoint_getTrack, (setter)_StcTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_StcTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StcTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"z",
    (getter)_StcTruthPoint_getZ, (setter)_StcTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StcTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StcTruthPoint_methods[] = {
   {"addTrackIDs", _StcTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this stcTruthPoint"},
   {"addTrackOrigins", _StcTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this stcTruthPoint"},
   {"deleteTrackIDs", _StcTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this stcTruthPoint"},
   {"deleteTrackOrigins", _StcTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this stcTruthPoint"},
   {"getTrackID", _StcTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this stcTruthPoint"},
   {"getTrackIDs", _StcTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this stcTruthPoint"},
   {"getTrackOrigin", _StcTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this stcTruthPoint"},
   {"getTrackOrigins", _StcTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this stcTruthPoint"},
   {"toString", _StcTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StcTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StcTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StcTruthPoint",         /*tp_name*/
    sizeof(_StcTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StcTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StcTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s stcTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StcTruthPoint_methods,          /* tp_methods */
    _StcTruthPoint_members,          /* tp_members */
    _StcTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StcTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StcTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::StartCntr as hddm_s.StartCntr

typedef struct {
   PyObject_HEAD
   StartCntr *elem;
   PyObject *host;
} _StartCntr;

static void
_StartCntr_dealloc(_StartCntr* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_StartCntr_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _StartCntr *self;
   self = (_StartCntr*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_StartCntr_init(_StartCntr *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_StartCntr_getClass(_StartCntr *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StartCntr_getVersion(_StartCntr *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_StartCntr_getXmlns(_StartCntr *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StartCntr_getEventNo(_StartCntr *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_StartCntr_getMaxOccurs(_StartCntr *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_StartCntr_getRunNo(_StartCntr *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_StartCntr_getMinOccurs(_StartCntr *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_StartCntr_getStcPaddle(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *obj = _StcPaddle_new(&_StcPaddle_type, 0, 0);
   ((_StcPaddle*)obj)->elem = &me->elem->getStcPaddle(index);
   ((_StcPaddle*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StartCntr_getStcPaddles(PyObject *self, PyObject *args)
{
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStcPaddles();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StartCntr_addStcPaddles(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcPaddleList(me->elem->addStcPaddles(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StartCntr_deleteStcPaddles(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid startCntr element");
      return NULL;
   }
   me->elem->deleteStcPaddles(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StartCntr_getStcTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *obj = _StcTruthPoint_new(&_StcTruthPoint_type, 0, 0);
   ((_StcTruthPoint*)obj)->elem = &me->elem->getStcTruthPoint(index);
   ((_StcTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_StartCntr_getStcTruthPoints(PyObject *self, PyObject *args)
{
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStcTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_StartCntr_addStcTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid startCntr element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcTruthPointList(me->elem->addStcTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_StartCntr_deleteStcTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid startCntr element");
      return NULL;
   }
   me->elem->deleteStcTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_StartCntr_toString(PyObject *self, PyObject *args=0)
{
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_StartCntr_toXML(PyObject *self, PyObject *args=0)
{
   _StartCntr *me = (_StartCntr*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid startCntr element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _StartCntr_getsetters[] = {
   {(char*)"class",
    (getter)_StartCntr_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_StartCntr_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_StartCntr_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_StartCntr_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_StartCntr_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_StartCntr_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_StartCntr_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _StartCntr_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _StartCntr_methods[] = {
   {"addStcPaddles", _StartCntr_addStcPaddles, METH_VARARGS,
    "extend (or insert into) the list of stcPaddle objects for this startCntr"},
   {"addStcTruthPoints", _StartCntr_addStcTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of stcTruthPoint objects for this startCntr"},
   {"deleteStcPaddles", _StartCntr_deleteStcPaddles, METH_VARARGS,
    "delete stcPaddle objects for this startCntr"},
   {"deleteStcTruthPoints", _StartCntr_deleteStcTruthPoints, METH_VARARGS,
    "delete stcTruthPoint objects for this startCntr"},
   {"getStcPaddle", _StartCntr_getStcPaddle, METH_VARARGS,
    "get an individual stcPaddle object from this startCntr"},
   {"getStcPaddles", _StartCntr_getStcPaddles, METH_NOARGS,
    "get list of stcPaddle objects for this startCntr"},
   {"getStcTruthPoint", _StartCntr_getStcTruthPoint, METH_VARARGS,
    "get an individual stcTruthPoint object from this startCntr"},
   {"getStcTruthPoints", _StartCntr_getStcTruthPoints, METH_NOARGS,
    "get list of stcTruthPoint objects for this startCntr"},
   {"toString", _StartCntr_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _StartCntr_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _StartCntr_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.StartCntr",         /*tp_name*/
    sizeof(_StartCntr),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_StartCntr_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_StartCntr_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s startCntr element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _StartCntr_methods,          /* tp_methods */
    _StartCntr_members,          /* tp_members */
    _StartCntr_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_StartCntr_init,   /* tp_init */
    0,                         /* tp_alloc */
    _StartCntr_new,              /* tp_new */
};



// wrap element class hddm_s::BcalSiPMUpHit as hddm_s.BcalSiPMUpHit

typedef struct {
   PyObject_HEAD
   BcalSiPMUpHit *elem;
   PyObject *host;
} _BcalSiPMUpHit;

static void
_BcalSiPMUpHit_dealloc(_BcalSiPMUpHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalSiPMUpHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalSiPMUpHit *self;
   self = (_BcalSiPMUpHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalSiPMUpHit_init(_BcalSiPMUpHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalSiPMUpHit_getClass(_BcalSiPMUpHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMUpHit_getVersion(_BcalSiPMUpHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalSiPMUpHit_getXmlns(_BcalSiPMUpHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMUpHit_getEventNo(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalSiPMUpHit_getRunNo(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalSiPMUpHit_getLayer(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalSiPMUpHit_getModule(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalSiPMUpHit_getSector(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalSiPMUpHit_getE(_BcalSiPMUpHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalSiPMUpHit_setE(_BcalSiPMUpHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalSiPMUpHit_getMaxOccurs(_BcalSiPMUpHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMUpHit_getMinOccurs(_BcalSiPMUpHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalSiPMUpHit_getT(_BcalSiPMUpHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalSiPMUpHit_setT(_BcalSiPMUpHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalSiPMUpHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalSiPMUpHit *me = (_BcalSiPMUpHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMUpHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalSiPMUpHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalSiPMUpHit *me = (_BcalSiPMUpHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMUpHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalSiPMUpHit_getsetters[] = {
   {(char*)"E",
    (getter)_BcalSiPMUpHit_getE, (setter)_BcalSiPMUpHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_BcalSiPMUpHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalSiPMUpHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalSiPMUpHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalSiPMUpHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalSiPMUpHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalSiPMUpHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalSiPMUpHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalSiPMUpHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_BcalSiPMUpHit_getT, (setter)_BcalSiPMUpHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_BcalSiPMUpHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalSiPMUpHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalSiPMUpHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalSiPMUpHit_methods[] = {
   {"toString", _BcalSiPMUpHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalSiPMUpHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalSiPMUpHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalSiPMUpHit",         /*tp_name*/
    sizeof(_BcalSiPMUpHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalSiPMUpHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalSiPMUpHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalSiPMUpHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalSiPMUpHit_methods,          /* tp_methods */
    _BcalSiPMUpHit_members,          /* tp_members */
    _BcalSiPMUpHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalSiPMUpHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalSiPMUpHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalSiPMDownHit as hddm_s.BcalSiPMDownHit

typedef struct {
   PyObject_HEAD
   BcalSiPMDownHit *elem;
   PyObject *host;
} _BcalSiPMDownHit;

static void
_BcalSiPMDownHit_dealloc(_BcalSiPMDownHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalSiPMDownHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalSiPMDownHit *self;
   self = (_BcalSiPMDownHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalSiPMDownHit_init(_BcalSiPMDownHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalSiPMDownHit_getClass(_BcalSiPMDownHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMDownHit_getVersion(_BcalSiPMDownHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalSiPMDownHit_getXmlns(_BcalSiPMDownHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMDownHit_getEventNo(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalSiPMDownHit_getRunNo(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalSiPMDownHit_getLayer(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalSiPMDownHit_getModule(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalSiPMDownHit_getSector(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalSiPMDownHit_getE(_BcalSiPMDownHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalSiPMDownHit_setE(_BcalSiPMDownHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalSiPMDownHit_getMaxOccurs(_BcalSiPMDownHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMDownHit_getMinOccurs(_BcalSiPMDownHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalSiPMDownHit_getT(_BcalSiPMDownHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalSiPMDownHit_setT(_BcalSiPMDownHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalSiPMDownHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalSiPMDownHit *me = (_BcalSiPMDownHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMDownHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalSiPMDownHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalSiPMDownHit *me = (_BcalSiPMDownHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMDownHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalSiPMDownHit_getsetters[] = {
   {(char*)"E",
    (getter)_BcalSiPMDownHit_getE, (setter)_BcalSiPMDownHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_BcalSiPMDownHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalSiPMDownHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalSiPMDownHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalSiPMDownHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalSiPMDownHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalSiPMDownHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalSiPMDownHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalSiPMDownHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_BcalSiPMDownHit_getT, (setter)_BcalSiPMDownHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_BcalSiPMDownHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalSiPMDownHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalSiPMDownHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalSiPMDownHit_methods[] = {
   {"toString", _BcalSiPMDownHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalSiPMDownHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalSiPMDownHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalSiPMDownHit",         /*tp_name*/
    sizeof(_BcalSiPMDownHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalSiPMDownHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalSiPMDownHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalSiPMDownHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalSiPMDownHit_methods,          /* tp_methods */
    _BcalSiPMDownHit_members,          /* tp_members */
    _BcalSiPMDownHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalSiPMDownHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalSiPMDownHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalSiPMTruth as hddm_s.BcalSiPMTruth

typedef struct {
   PyObject_HEAD
   BcalSiPMTruth *elem;
   PyObject *host;
} _BcalSiPMTruth;

static void
_BcalSiPMTruth_dealloc(_BcalSiPMTruth* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalSiPMTruth_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalSiPMTruth *self;
   self = (_BcalSiPMTruth*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalSiPMTruth_init(_BcalSiPMTruth *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalSiPMTruth_getClass(_BcalSiPMTruth *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMTruth_getVersion(_BcalSiPMTruth *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalSiPMTruth_getXmlns(_BcalSiPMTruth *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMTruth_getEventNo(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalSiPMTruth_getMaxOccurs(_BcalSiPMTruth *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMTruth_getRunNo(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalSiPMTruth_getLayer(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalSiPMTruth_getModule(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalSiPMTruth_getSector(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalSiPMTruth_getBin_width(_BcalSiPMTruth *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getBin_width());
}

static PyObject*
_BcalSiPMTruth_getEnd(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static PyObject*
_BcalSiPMTruth_getTstart(_BcalSiPMTruth *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTstart());
}

static PyObject*
_BcalSiPMTruth_getVals(_BcalSiPMTruth *self, void *closure)
{
   std::string val(self->elem->getVals());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMTruth_getE(_BcalSiPMTruth *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalSiPMTruth_setE(_BcalSiPMTruth *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalSiPMTruth_getIncident_id(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getIncident_id());
}

static int
_BcalSiPMTruth_setIncident_id(_BcalSiPMTruth *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setIncident_id(var);
   return 0;
}

static PyObject*
_BcalSiPMTruth_getMinOccurs(_BcalSiPMTruth *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalSiPMTruth_toString(PyObject *self, PyObject *args=0)
{
   _BcalSiPMTruth *me = (_BcalSiPMTruth*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMTruth element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalSiPMTruth_toXML(PyObject *self, PyObject *args=0)
{
   _BcalSiPMTruth *me = (_BcalSiPMTruth*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMTruth element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalSiPMTruth_getsetters[] = {
   {(char*)"E",
    (getter)_BcalSiPMTruth_getE, (setter)_BcalSiPMTruth_setE,
    (char*)"E value",
    NULL},
   {(char*)"bin_width",
    (getter)_BcalSiPMTruth_getBin_width, 0,
    (char*)"bin_width value",
    NULL},
   {(char*)"class",
    (getter)_BcalSiPMTruth_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalSiPMTruth_getEnd, 0,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalSiPMTruth_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"incident_id",
    (getter)_BcalSiPMTruth_getIncident_id, (setter)_BcalSiPMTruth_setIncident_id,
    (char*)"incident_id value",
    NULL},
   {(char*)"layer",
    (getter)_BcalSiPMTruth_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalSiPMTruth_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalSiPMTruth_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalSiPMTruth_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalSiPMTruth_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalSiPMTruth_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"tstart",
    (getter)_BcalSiPMTruth_getTstart, 0,
    (char*)"tstart value",
    NULL},
   {(char*)"vals",
    (getter)_BcalSiPMTruth_getVals, 0,
    (char*)"vals string",
    NULL},
   {(char*)"version",
    (getter)_BcalSiPMTruth_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalSiPMTruth_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalSiPMTruth_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalSiPMTruth_methods[] = {
   {"toString", _BcalSiPMTruth_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalSiPMTruth_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalSiPMTruth_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalSiPMTruth",         /*tp_name*/
    sizeof(_BcalSiPMTruth),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalSiPMTruth_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalSiPMTruth_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalSiPMTruth element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalSiPMTruth_methods,          /* tp_methods */
    _BcalSiPMTruth_members,          /* tp_members */
    _BcalSiPMTruth_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalSiPMTruth_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalSiPMTruth_new,              /* tp_new */
};



// wrap element class hddm_s::BcalSiPMSpectrum as hddm_s.BcalSiPMSpectrum

typedef struct {
   PyObject_HEAD
   BcalSiPMSpectrum *elem;
   PyObject *host;
} _BcalSiPMSpectrum;

static void
_BcalSiPMSpectrum_dealloc(_BcalSiPMSpectrum* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalSiPMSpectrum_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalSiPMSpectrum *self;
   self = (_BcalSiPMSpectrum*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalSiPMSpectrum_init(_BcalSiPMSpectrum *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalSiPMSpectrum_getClass(_BcalSiPMSpectrum *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMSpectrum_getVersion(_BcalSiPMSpectrum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalSiPMSpectrum_getXmlns(_BcalSiPMSpectrum *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMSpectrum_getEventNo(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalSiPMSpectrum_getRunNo(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalSiPMSpectrum_getLayer(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalSiPMSpectrum_getModule(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalSiPMSpectrum_getSector(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalSiPMSpectrum_getBin_width(_BcalSiPMSpectrum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getBin_width());
}

static int
_BcalSiPMSpectrum_setBin_width(_BcalSiPMSpectrum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setBin_width((float)var);
   return 0;
}

static PyObject*
_BcalSiPMSpectrum_getEnd(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_BcalSiPMSpectrum_setEnd(_BcalSiPMSpectrum *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_BcalSiPMSpectrum_getMaxOccurs(_BcalSiPMSpectrum *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalSiPMSpectrum_getMinOccurs(_BcalSiPMSpectrum *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalSiPMSpectrum_getTstart(_BcalSiPMSpectrum *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTstart());
}

static int
_BcalSiPMSpectrum_setTstart(_BcalSiPMSpectrum *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setTstart((float)var);
   return 0;
}

static PyObject*
_BcalSiPMSpectrum_getVals(_BcalSiPMSpectrum *self, void *closure)
{
   std::string val(self->elem->getVals());
   return PyUnicode_FromString(val.c_str());
}

static int
_BcalSiPMSpectrum_setVals(_BcalSiPMSpectrum *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setVals(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_BcalSiPMSpectrum_getBcalSiPMTruth(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   PyObject *obj = _BcalSiPMTruth_new(&_BcalSiPMTruth_type, 0, 0);
   ((_BcalSiPMTruth*)obj)->elem = &me->elem->getBcalSiPMTruth();
   ((_BcalSiPMTruth*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalSiPMSpectrum_getBcalSiPMTruths(PyObject *self, PyObject *args)
{
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMTruth_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalSiPMTruths();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalSiPMSpectrum_addBcalSiPMTruths(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMTruth_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMTruthList(me->elem->addBcalSiPMTruths(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalSiPMSpectrum_deleteBcalSiPMTruths(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   me->elem->deleteBcalSiPMTruths(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalSiPMSpectrum_toString(PyObject *self, PyObject *args=0)
{
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalSiPMSpectrum_toXML(PyObject *self, PyObject *args=0)
{
   _BcalSiPMSpectrum *me = (_BcalSiPMSpectrum*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalSiPMSpectrum element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalSiPMSpectrum_getsetters[] = {
   {(char*)"bin_width",
    (getter)_BcalSiPMSpectrum_getBin_width, (setter)_BcalSiPMSpectrum_setBin_width,
    (char*)"bin_width value",
    NULL},
   {(char*)"class",
    (getter)_BcalSiPMSpectrum_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalSiPMSpectrum_getEnd, (setter)_BcalSiPMSpectrum_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalSiPMSpectrum_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalSiPMSpectrum_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalSiPMSpectrum_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalSiPMSpectrum_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalSiPMSpectrum_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalSiPMSpectrum_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalSiPMSpectrum_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"tstart",
    (getter)_BcalSiPMSpectrum_getTstart, (setter)_BcalSiPMSpectrum_setTstart,
    (char*)"tstart value",
    NULL},
   {(char*)"vals",
    (getter)_BcalSiPMSpectrum_getVals, (setter)_BcalSiPMSpectrum_setVals,
    (char*)"vals string",
    NULL},
   {(char*)"version",
    (getter)_BcalSiPMSpectrum_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalSiPMSpectrum_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalSiPMSpectrum_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalSiPMSpectrum_methods[] = {
   {"addBcalSiPMTruths", _BcalSiPMSpectrum_addBcalSiPMTruths, METH_VARARGS,
    "extend (or insert into) the list of bcalSiPMTruth objects for this bcalSiPMSpectrum"},
   {"deleteBcalSiPMTruths", _BcalSiPMSpectrum_deleteBcalSiPMTruths, METH_VARARGS,
    "delete bcalSiPMTruth objects for this bcalSiPMSpectrum"},
   {"getBcalSiPMTruth", _BcalSiPMSpectrum_getBcalSiPMTruth, METH_VARARGS,
    "get an individual bcalSiPMTruth object from this bcalSiPMSpectrum"},
   {"getBcalSiPMTruths", _BcalSiPMSpectrum_getBcalSiPMTruths, METH_NOARGS,
    "get list of bcalSiPMTruth objects for this bcalSiPMSpectrum"},
   {"toString", _BcalSiPMSpectrum_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalSiPMSpectrum_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalSiPMSpectrum_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalSiPMSpectrum",         /*tp_name*/
    sizeof(_BcalSiPMSpectrum),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalSiPMSpectrum_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalSiPMSpectrum_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalSiPMSpectrum element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalSiPMSpectrum_methods,          /* tp_methods */
    _BcalSiPMSpectrum_members,          /* tp_members */
    _BcalSiPMSpectrum_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalSiPMSpectrum_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalSiPMSpectrum_new,              /* tp_new */
};



// wrap element class hddm_s::BcalfADCHit as hddm_s.BcalfADCHit

typedef struct {
   PyObject_HEAD
   BcalfADCHit *elem;
   PyObject *host;
} _BcalfADCHit;

static void
_BcalfADCHit_dealloc(_BcalfADCHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalfADCHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalfADCHit *self;
   self = (_BcalfADCHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalfADCHit_init(_BcalfADCHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalfADCHit_getClass(_BcalfADCHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCHit_getVersion(_BcalfADCHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalfADCHit_getXmlns(_BcalfADCHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCHit_getEventNo(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalfADCHit_getRunNo(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalfADCHit_getLayer(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalfADCHit_getModule(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalfADCHit_getSector(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalfADCHit_getE(_BcalfADCHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalfADCHit_setE(_BcalfADCHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalfADCHit_getEnd(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_BcalfADCHit_setEnd(_BcalfADCHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_BcalfADCHit_getMaxOccurs(_BcalfADCHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCHit_getMinOccurs(_BcalfADCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalfADCHit_getT(_BcalfADCHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalfADCHit_setT(_BcalfADCHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalfADCHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalfADCHit *me = (_BcalfADCHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalfADCHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalfADCHit *me = (_BcalfADCHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalfADCHit_getsetters[] = {
   {(char*)"E",
    (getter)_BcalfADCHit_getE, (setter)_BcalfADCHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_BcalfADCHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalfADCHit_getEnd, (setter)_BcalfADCHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalfADCHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalfADCHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalfADCHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalfADCHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalfADCHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalfADCHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalfADCHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_BcalfADCHit_getT, (setter)_BcalfADCHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_BcalfADCHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalfADCHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalfADCHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalfADCHit_methods[] = {
   {"toString", _BcalfADCHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalfADCHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalfADCHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalfADCHit",         /*tp_name*/
    sizeof(_BcalfADCHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalfADCHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalfADCHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalfADCHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalfADCHit_methods,          /* tp_methods */
    _BcalfADCHit_members,          /* tp_members */
    _BcalfADCHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalfADCHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalfADCHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalfADCPeak as hddm_s.BcalfADCPeak

typedef struct {
   PyObject_HEAD
   BcalfADCPeak *elem;
   PyObject *host;
} _BcalfADCPeak;

static void
_BcalfADCPeak_dealloc(_BcalfADCPeak* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalfADCPeak_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalfADCPeak *self;
   self = (_BcalfADCPeak*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalfADCPeak_init(_BcalfADCPeak *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalfADCPeak_getClass(_BcalfADCPeak *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCPeak_getVersion(_BcalfADCPeak *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalfADCPeak_getXmlns(_BcalfADCPeak *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCPeak_getEventNo(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalfADCPeak_getMaxOccurs(_BcalfADCPeak *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCPeak_getRunNo(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalfADCPeak_getLayer(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalfADCPeak_getModule(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalfADCPeak_getSector(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalfADCPeak_getEnd(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static PyObject*
_BcalfADCPeak_getPulse_integral(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPulse_integral());
}

static PyObject*
_BcalfADCPeak_getPulse_time(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPulse_time());
}

static PyObject*
_BcalfADCPeak_getMinOccurs(_BcalfADCPeak *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalfADCPeak_getPeakAmp(_BcalfADCPeak *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPeakAmp());
}

static int
_BcalfADCPeak_setPeakAmp(_BcalfADCPeak *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPeakAmp((float)var);
   return 0;
}

static PyObject*
_BcalfADCPeak_toString(PyObject *self, PyObject *args=0)
{
   _BcalfADCPeak *me = (_BcalfADCPeak*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCPeak element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalfADCPeak_toXML(PyObject *self, PyObject *args=0)
{
   _BcalfADCPeak *me = (_BcalfADCPeak*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCPeak element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalfADCPeak_getsetters[] = {
   {(char*)"class",
    (getter)_BcalfADCPeak_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalfADCPeak_getEnd, 0,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalfADCPeak_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalfADCPeak_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalfADCPeak_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalfADCPeak_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalfADCPeak_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"peakAmp",
    (getter)_BcalfADCPeak_getPeakAmp, (setter)_BcalfADCPeak_setPeakAmp,
    (char*)"peakAmp value",
    NULL},
   {(char*)"pulse_integral",
    (getter)_BcalfADCPeak_getPulse_integral, 0,
    (char*)"pulse_integral value",
    NULL},
   {(char*)"pulse_time",
    (getter)_BcalfADCPeak_getPulse_time, 0,
    (char*)"pulse_time value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalfADCPeak_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalfADCPeak_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_BcalfADCPeak_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalfADCPeak_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalfADCPeak_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalfADCPeak_methods[] = {
   {"toString", _BcalfADCPeak_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalfADCPeak_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalfADCPeak_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalfADCPeak",         /*tp_name*/
    sizeof(_BcalfADCPeak),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalfADCPeak_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalfADCPeak_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalfADCPeak element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalfADCPeak_methods,          /* tp_methods */
    _BcalfADCPeak_members,          /* tp_members */
    _BcalfADCPeak_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalfADCPeak_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalfADCPeak_new,              /* tp_new */
};



// wrap element class hddm_s::BcalfADCDigiHit as hddm_s.BcalfADCDigiHit

typedef struct {
   PyObject_HEAD
   BcalfADCDigiHit *elem;
   PyObject *host;
} _BcalfADCDigiHit;

static void
_BcalfADCDigiHit_dealloc(_BcalfADCDigiHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalfADCDigiHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalfADCDigiHit *self;
   self = (_BcalfADCDigiHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalfADCDigiHit_init(_BcalfADCDigiHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalfADCDigiHit_getClass(_BcalfADCDigiHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCDigiHit_getVersion(_BcalfADCDigiHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalfADCDigiHit_getXmlns(_BcalfADCDigiHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCDigiHit_getEventNo(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalfADCDigiHit_getRunNo(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalfADCDigiHit_getLayer(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalfADCDigiHit_getModule(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalfADCDigiHit_getSector(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalfADCDigiHit_getEnd(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_BcalfADCDigiHit_setEnd(_BcalfADCDigiHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_BcalfADCDigiHit_getMaxOccurs(_BcalfADCDigiHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalfADCDigiHit_getMinOccurs(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalfADCDigiHit_getPulse_integral(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPulse_integral());
}

static int
_BcalfADCDigiHit_setPulse_integral(_BcalfADCDigiHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPulse_integral(var);
   return 0;
}

static PyObject*
_BcalfADCDigiHit_getPulse_time(_BcalfADCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPulse_time());
}

static int
_BcalfADCDigiHit_setPulse_time(_BcalfADCDigiHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPulse_time(var);
   return 0;
}

static PyObject*
_BcalfADCDigiHit_getBcalfADCPeak(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   PyObject *obj = _BcalfADCPeak_new(&_BcalfADCPeak_type, 0, 0);
   ((_BcalfADCPeak*)obj)->elem = &me->elem->getBcalfADCPeak();
   ((_BcalfADCPeak*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalfADCDigiHit_getBcalfADCPeaks(PyObject *self, PyObject *args)
{
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCPeak_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalfADCPeaks();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalfADCDigiHit_addBcalfADCPeaks(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCPeak_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCPeakList(me->elem->addBcalfADCPeaks(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalfADCDigiHit_deleteBcalfADCPeaks(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   me->elem->deleteBcalfADCPeaks(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalfADCDigiHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalfADCDigiHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalfADCDigiHit *me = (_BcalfADCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalfADCDigiHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalfADCDigiHit_getsetters[] = {
   {(char*)"class",
    (getter)_BcalfADCDigiHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalfADCDigiHit_getEnd, (setter)_BcalfADCDigiHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalfADCDigiHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalfADCDigiHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalfADCDigiHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalfADCDigiHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalfADCDigiHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"pulse_integral",
    (getter)_BcalfADCDigiHit_getPulse_integral, (setter)_BcalfADCDigiHit_setPulse_integral,
    (char*)"pulse_integral value",
    NULL},
   {(char*)"pulse_time",
    (getter)_BcalfADCDigiHit_getPulse_time, (setter)_BcalfADCDigiHit_setPulse_time,
    (char*)"pulse_time value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalfADCDigiHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalfADCDigiHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_BcalfADCDigiHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalfADCDigiHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalfADCDigiHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalfADCDigiHit_methods[] = {
   {"addBcalfADCPeaks", _BcalfADCDigiHit_addBcalfADCPeaks, METH_VARARGS,
    "extend (or insert into) the list of bcalfADCPeak objects for this bcalfADCDigiHit"},
   {"deleteBcalfADCPeaks", _BcalfADCDigiHit_deleteBcalfADCPeaks, METH_VARARGS,
    "delete bcalfADCPeak objects for this bcalfADCDigiHit"},
   {"getBcalfADCPeak", _BcalfADCDigiHit_getBcalfADCPeak, METH_VARARGS,
    "get an individual bcalfADCPeak object from this bcalfADCDigiHit"},
   {"getBcalfADCPeaks", _BcalfADCDigiHit_getBcalfADCPeaks, METH_NOARGS,
    "get list of bcalfADCPeak objects for this bcalfADCDigiHit"},
   {"toString", _BcalfADCDigiHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalfADCDigiHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalfADCDigiHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalfADCDigiHit",         /*tp_name*/
    sizeof(_BcalfADCDigiHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalfADCDigiHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalfADCDigiHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalfADCDigiHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalfADCDigiHit_methods,          /* tp_methods */
    _BcalfADCDigiHit_members,          /* tp_members */
    _BcalfADCDigiHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalfADCDigiHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalfADCDigiHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalTDCHit as hddm_s.BcalTDCHit

typedef struct {
   PyObject_HEAD
   BcalTDCHit *elem;
   PyObject *host;
} _BcalTDCHit;

static void
_BcalTDCHit_dealloc(_BcalTDCHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalTDCHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalTDCHit *self;
   self = (_BcalTDCHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalTDCHit_init(_BcalTDCHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalTDCHit_getClass(_BcalTDCHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCHit_getVersion(_BcalTDCHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalTDCHit_getXmlns(_BcalTDCHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCHit_getEventNo(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalTDCHit_getRunNo(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalTDCHit_getLayer(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalTDCHit_getModule(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalTDCHit_getSector(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalTDCHit_getEnd(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_BcalTDCHit_setEnd(_BcalTDCHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_BcalTDCHit_getMaxOccurs(_BcalTDCHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCHit_getMinOccurs(_BcalTDCHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalTDCHit_getT(_BcalTDCHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalTDCHit_setT(_BcalTDCHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalTDCHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalTDCHit *me = (_BcalTDCHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTDCHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalTDCHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalTDCHit *me = (_BcalTDCHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTDCHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalTDCHit_getsetters[] = {
   {(char*)"class",
    (getter)_BcalTDCHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalTDCHit_getEnd, (setter)_BcalTDCHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalTDCHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalTDCHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalTDCHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalTDCHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalTDCHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalTDCHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalTDCHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_BcalTDCHit_getT, (setter)_BcalTDCHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_BcalTDCHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalTDCHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalTDCHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalTDCHit_methods[] = {
   {"toString", _BcalTDCHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalTDCHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalTDCHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalTDCHit",         /*tp_name*/
    sizeof(_BcalTDCHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalTDCHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalTDCHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalTDCHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalTDCHit_methods,          /* tp_methods */
    _BcalTDCHit_members,          /* tp_members */
    _BcalTDCHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalTDCHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalTDCHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalTDCDigiHit as hddm_s.BcalTDCDigiHit

typedef struct {
   PyObject_HEAD
   BcalTDCDigiHit *elem;
   PyObject *host;
} _BcalTDCDigiHit;

static void
_BcalTDCDigiHit_dealloc(_BcalTDCDigiHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalTDCDigiHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalTDCDigiHit *self;
   self = (_BcalTDCDigiHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalTDCDigiHit_init(_BcalTDCDigiHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalTDCDigiHit_getClass(_BcalTDCDigiHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCDigiHit_getVersion(_BcalTDCDigiHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalTDCDigiHit_getXmlns(_BcalTDCDigiHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCDigiHit_getEventNo(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalTDCDigiHit_getRunNo(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalTDCDigiHit_getLayer(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalTDCDigiHit_getModule(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalTDCDigiHit_getSector(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalTDCDigiHit_getEnd(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_BcalTDCDigiHit_setEnd(_BcalTDCDigiHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_BcalTDCDigiHit_getMaxOccurs(_BcalTDCDigiHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTDCDigiHit_getMinOccurs(_BcalTDCDigiHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalTDCDigiHit_getTime(_BcalTDCDigiHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTime());
}

static int
_BcalTDCDigiHit_setTime(_BcalTDCDigiHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setTime((float)var);
   return 0;
}

static PyObject*
_BcalTDCDigiHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalTDCDigiHit *me = (_BcalTDCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTDCDigiHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalTDCDigiHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalTDCDigiHit *me = (_BcalTDCDigiHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTDCDigiHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalTDCDigiHit_getsetters[] = {
   {(char*)"class",
    (getter)_BcalTDCDigiHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_BcalTDCDigiHit_getEnd, (setter)_BcalTDCDigiHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalTDCDigiHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalTDCDigiHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalTDCDigiHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalTDCDigiHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalTDCDigiHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalTDCDigiHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalTDCDigiHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"time",
    (getter)_BcalTDCDigiHit_getTime, (setter)_BcalTDCDigiHit_setTime,
    (char*)"time value",
    NULL},
   {(char*)"version",
    (getter)_BcalTDCDigiHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalTDCDigiHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalTDCDigiHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalTDCDigiHit_methods[] = {
   {"toString", _BcalTDCDigiHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalTDCDigiHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalTDCDigiHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalTDCDigiHit",         /*tp_name*/
    sizeof(_BcalTDCDigiHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalTDCDigiHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalTDCDigiHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalTDCDigiHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalTDCDigiHit_methods,          /* tp_methods */
    _BcalTDCDigiHit_members,          /* tp_members */
    _BcalTDCDigiHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalTDCDigiHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalTDCDigiHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalTruthHit as hddm_s.BcalTruthHit

typedef struct {
   PyObject_HEAD
   BcalTruthHit *elem;
   PyObject *host;
} _BcalTruthHit;

static void
_BcalTruthHit_dealloc(_BcalTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalTruthHit *self;
   self = (_BcalTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalTruthHit_init(_BcalTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalTruthHit_getClass(_BcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthHit_getVersion(_BcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalTruthHit_getXmlns(_BcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthHit_getEventNo(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalTruthHit_getRunNo(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalTruthHit_getLayer(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_BcalTruthHit_getModule(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_BcalTruthHit_getSector(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_BcalTruthHit_getE(_BcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalTruthHit_setE(_BcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalTruthHit_getIncident_id(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getIncident_id());
}

static int
_BcalTruthHit_setIncident_id(_BcalTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setIncident_id(var);
   return 0;
}

static PyObject*
_BcalTruthHit_getMaxOccurs(_BcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthHit_getMinOccurs(_BcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalTruthHit_getT(_BcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalTruthHit_setT(_BcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalTruthHit_getZLocal(_BcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZLocal());
}

static int
_BcalTruthHit_setZLocal(_BcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZLocal((float)var);
   return 0;
}

static PyObject*
_BcalTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _BcalTruthHit *me = (_BcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _BcalTruthHit *me = (_BcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_BcalTruthHit_getE, (setter)_BcalTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_BcalTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"incident_id",
    (getter)_BcalTruthHit_getIncident_id, (setter)_BcalTruthHit_setIncident_id,
    (char*)"incident_id value",
    NULL},
   {(char*)"layer",
    (getter)_BcalTruthHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalTruthHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalTruthHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_BcalTruthHit_getT, (setter)_BcalTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_BcalTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"zLocal",
    (getter)_BcalTruthHit_getZLocal, (setter)_BcalTruthHit_setZLocal,
    (char*)"zLocal value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalTruthHit_methods[] = {
   {"toString", _BcalTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalTruthHit",         /*tp_name*/
    sizeof(_BcalTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalTruthHit_methods,          /* tp_methods */
    _BcalTruthHit_members,          /* tp_members */
    _BcalTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::BcalCell as hddm_s.BcalCell

typedef struct {
   PyObject_HEAD
   BcalCell *elem;
   PyObject *host;
} _BcalCell;

static void
_BcalCell_dealloc(_BcalCell* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalCell_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalCell *self;
   self = (_BcalCell*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalCell_init(_BcalCell *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalCell_getClass(_BcalCell *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalCell_getVersion(_BcalCell *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalCell_getXmlns(_BcalCell *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalCell_getEventNo(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalCell_getRunNo(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalCell_getLayer(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static int
_BcalCell_setLayer(_BcalCell *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setLayer(var);
   return 0;
}

static PyObject*
_BcalCell_getMaxOccurs(_BcalCell *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalCell_getMinOccurs(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalCell_getModule(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static int
_BcalCell_setModule(_BcalCell *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setModule(var);
   return 0;
}

static PyObject*
_BcalCell_getSector(_BcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static int
_BcalCell_setSector(_BcalCell *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSector(var);
   return 0;
}

static PyObject*
_BcalCell_getBcalSiPMUpHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalSiPMUpHit_new(&_BcalSiPMUpHit_type, 0, 0);
   ((_BcalSiPMUpHit*)obj)->elem = &me->elem->getBcalSiPMUpHit(index);
   ((_BcalSiPMUpHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalSiPMUpHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMUpHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalSiPMUpHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalSiPMUpHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMUpHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMUpHitList(me->elem->addBcalSiPMUpHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalSiPMUpHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalSiPMUpHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalSiPMDownHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalSiPMDownHit_new(&_BcalSiPMDownHit_type, 0, 0);
   ((_BcalSiPMDownHit*)obj)->elem = &me->elem->getBcalSiPMDownHit(index);
   ((_BcalSiPMDownHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalSiPMDownHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMDownHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalSiPMDownHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalSiPMDownHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMDownHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMDownHitList(me->elem->addBcalSiPMDownHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalSiPMDownHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalSiPMDownHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalSiPMSpectrum(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalSiPMSpectrum_new(&_BcalSiPMSpectrum_type, 0, 0);
   ((_BcalSiPMSpectrum*)obj)->elem = &me->elem->getBcalSiPMSpectrum(index);
   ((_BcalSiPMSpectrum*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalSiPMSpectrums(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMSpectrum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalSiPMSpectrums();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalSiPMSpectrums(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMSpectrum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMSpectrumList(me->elem->addBcalSiPMSpectrums(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalSiPMSpectrums(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalSiPMSpectrums(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalfADCHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalfADCHit_new(&_BcalfADCHit_type, 0, 0);
   ((_BcalfADCHit*)obj)->elem = &me->elem->getBcalfADCHit(index);
   ((_BcalfADCHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalfADCHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalfADCHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalfADCHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCHitList(me->elem->addBcalfADCHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalfADCHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalfADCHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalfADCDigiHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalfADCDigiHit_new(&_BcalfADCDigiHit_type, 0, 0);
   ((_BcalfADCDigiHit*)obj)->elem = &me->elem->getBcalfADCDigiHit(index);
   ((_BcalfADCDigiHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalfADCDigiHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalfADCDigiHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalfADCDigiHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCDigiHitList(me->elem->addBcalfADCDigiHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalfADCDigiHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalfADCDigiHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalTDCHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalTDCHit_new(&_BcalTDCHit_type, 0, 0);
   ((_BcalTDCHit*)obj)->elem = &me->elem->getBcalTDCHit(index);
   ((_BcalTDCHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalTDCHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalTDCHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalTDCHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTDCHitList(me->elem->addBcalTDCHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalTDCHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalTDCHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalTDCDigiHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalTDCDigiHit_new(&_BcalTDCDigiHit_type, 0, 0);
   ((_BcalTDCDigiHit*)obj)->elem = &me->elem->getBcalTDCDigiHit(index);
   ((_BcalTDCDigiHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalTDCDigiHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalTDCDigiHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalTDCDigiHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTDCDigiHitList(me->elem->addBcalTDCDigiHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalTDCDigiHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalTDCDigiHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_getBcalTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *obj = _BcalTruthHit_new(&_BcalTruthHit_type, 0, 0);
   ((_BcalTruthHit*)obj)->elem = &me->elem->getBcalTruthHit(index);
   ((_BcalTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalCell_getBcalTruthHits(PyObject *self, PyObject *args)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalCell_addBcalTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthHitList(me->elem->addBcalTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalCell_deleteBcalTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalCell element");
      return NULL;
   }
   me->elem->deleteBcalTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalCell_toString(PyObject *self, PyObject *args=0)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalCell_toXML(PyObject *self, PyObject *args=0)
{
   _BcalCell *me = (_BcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalCell element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalCell_getsetters[] = {
   {(char*)"class",
    (getter)_BcalCell_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalCell_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_BcalCell_getLayer, (setter)_BcalCell_setLayer,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalCell_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalCell_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_BcalCell_getModule, (setter)_BcalCell_setModule,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalCell_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_BcalCell_getSector, (setter)_BcalCell_setSector,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_BcalCell_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalCell_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalCell_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalCell_methods[] = {
   {"addBcalSiPMDownHits", _BcalCell_addBcalSiPMDownHits, METH_VARARGS,
    "extend (or insert into) the list of bcalSiPMDownHit objects for this bcalCell"},
   {"addBcalSiPMSpectrums", _BcalCell_addBcalSiPMSpectrums, METH_VARARGS,
    "extend (or insert into) the list of bcalSiPMSpectrum objects for this bcalCell"},
   {"addBcalSiPMUpHits", _BcalCell_addBcalSiPMUpHits, METH_VARARGS,
    "extend (or insert into) the list of bcalSiPMUpHit objects for this bcalCell"},
   {"addBcalTDCDigiHits", _BcalCell_addBcalTDCDigiHits, METH_VARARGS,
    "extend (or insert into) the list of bcalTDCDigiHit objects for this bcalCell"},
   {"addBcalTDCHits", _BcalCell_addBcalTDCHits, METH_VARARGS,
    "extend (or insert into) the list of bcalTDCHit objects for this bcalCell"},
   {"addBcalTruthHits", _BcalCell_addBcalTruthHits, METH_VARARGS,
    "extend (or insert into) the list of bcalTruthHit objects for this bcalCell"},
   {"addBcalfADCDigiHits", _BcalCell_addBcalfADCDigiHits, METH_VARARGS,
    "extend (or insert into) the list of bcalfADCDigiHit objects for this bcalCell"},
   {"addBcalfADCHits", _BcalCell_addBcalfADCHits, METH_VARARGS,
    "extend (or insert into) the list of bcalfADCHit objects for this bcalCell"},
   {"deleteBcalSiPMDownHits", _BcalCell_deleteBcalSiPMDownHits, METH_VARARGS,
    "delete bcalSiPMDownHit objects for this bcalCell"},
   {"deleteBcalSiPMSpectrums", _BcalCell_deleteBcalSiPMSpectrums, METH_VARARGS,
    "delete bcalSiPMSpectrum objects for this bcalCell"},
   {"deleteBcalSiPMUpHits", _BcalCell_deleteBcalSiPMUpHits, METH_VARARGS,
    "delete bcalSiPMUpHit objects for this bcalCell"},
   {"deleteBcalTDCDigiHits", _BcalCell_deleteBcalTDCDigiHits, METH_VARARGS,
    "delete bcalTDCDigiHit objects for this bcalCell"},
   {"deleteBcalTDCHits", _BcalCell_deleteBcalTDCHits, METH_VARARGS,
    "delete bcalTDCHit objects for this bcalCell"},
   {"deleteBcalTruthHits", _BcalCell_deleteBcalTruthHits, METH_VARARGS,
    "delete bcalTruthHit objects for this bcalCell"},
   {"deleteBcalfADCDigiHits", _BcalCell_deleteBcalfADCDigiHits, METH_VARARGS,
    "delete bcalfADCDigiHit objects for this bcalCell"},
   {"deleteBcalfADCHits", _BcalCell_deleteBcalfADCHits, METH_VARARGS,
    "delete bcalfADCHit objects for this bcalCell"},
   {"getBcalSiPMDownHit", _BcalCell_getBcalSiPMDownHit, METH_VARARGS,
    "get an individual bcalSiPMDownHit object from this bcalCell"},
   {"getBcalSiPMDownHits", _BcalCell_getBcalSiPMDownHits, METH_NOARGS,
    "get list of bcalSiPMDownHit objects for this bcalCell"},
   {"getBcalSiPMSpectrum", _BcalCell_getBcalSiPMSpectrum, METH_VARARGS,
    "get an individual bcalSiPMSpectrum object from this bcalCell"},
   {"getBcalSiPMSpectrums", _BcalCell_getBcalSiPMSpectrums, METH_NOARGS,
    "get list of bcalSiPMSpectrum objects for this bcalCell"},
   {"getBcalSiPMUpHit", _BcalCell_getBcalSiPMUpHit, METH_VARARGS,
    "get an individual bcalSiPMUpHit object from this bcalCell"},
   {"getBcalSiPMUpHits", _BcalCell_getBcalSiPMUpHits, METH_NOARGS,
    "get list of bcalSiPMUpHit objects for this bcalCell"},
   {"getBcalTDCDigiHit", _BcalCell_getBcalTDCDigiHit, METH_VARARGS,
    "get an individual bcalTDCDigiHit object from this bcalCell"},
   {"getBcalTDCDigiHits", _BcalCell_getBcalTDCDigiHits, METH_NOARGS,
    "get list of bcalTDCDigiHit objects for this bcalCell"},
   {"getBcalTDCHit", _BcalCell_getBcalTDCHit, METH_VARARGS,
    "get an individual bcalTDCHit object from this bcalCell"},
   {"getBcalTDCHits", _BcalCell_getBcalTDCHits, METH_NOARGS,
    "get list of bcalTDCHit objects for this bcalCell"},
   {"getBcalTruthHit", _BcalCell_getBcalTruthHit, METH_VARARGS,
    "get an individual bcalTruthHit object from this bcalCell"},
   {"getBcalTruthHits", _BcalCell_getBcalTruthHits, METH_NOARGS,
    "get list of bcalTruthHit objects for this bcalCell"},
   {"getBcalfADCDigiHit", _BcalCell_getBcalfADCDigiHit, METH_VARARGS,
    "get an individual bcalfADCDigiHit object from this bcalCell"},
   {"getBcalfADCDigiHits", _BcalCell_getBcalfADCDigiHits, METH_NOARGS,
    "get list of bcalfADCDigiHit objects for this bcalCell"},
   {"getBcalfADCHit", _BcalCell_getBcalfADCHit, METH_VARARGS,
    "get an individual bcalfADCHit object from this bcalCell"},
   {"getBcalfADCHits", _BcalCell_getBcalfADCHits, METH_NOARGS,
    "get list of bcalfADCHit objects for this bcalCell"},
   {"toString", _BcalCell_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalCell_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalCell_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalCell",         /*tp_name*/
    sizeof(_BcalCell),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalCell_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalCell_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalCell element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalCell_methods,          /* tp_methods */
    _BcalCell_members,          /* tp_members */
    _BcalCell_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalCell_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalCell_new,              /* tp_new */
};



// wrap element class hddm_s::BcalTruthIncidentParticle as hddm_s.BcalTruthIncidentParticle

typedef struct {
   PyObject_HEAD
   BcalTruthIncidentParticle *elem;
   PyObject *host;
} _BcalTruthIncidentParticle;

static void
_BcalTruthIncidentParticle_dealloc(_BcalTruthIncidentParticle* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalTruthIncidentParticle_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalTruthIncidentParticle *self;
   self = (_BcalTruthIncidentParticle*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalTruthIncidentParticle_init(_BcalTruthIncidentParticle *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalTruthIncidentParticle_getClass(_BcalTruthIncidentParticle *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthIncidentParticle_getVersion(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalTruthIncidentParticle_getXmlns(_BcalTruthIncidentParticle *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthIncidentParticle_getEventNo(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalTruthIncidentParticle_getRunNo(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalTruthIncidentParticle_getId(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static int
_BcalTruthIncidentParticle_setId(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setId(var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getMaxOccurs(_BcalTruthIncidentParticle *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthIncidentParticle_getMinOccurs(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalTruthIncidentParticle_getPtype(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_BcalTruthIncidentParticle_setPtype(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getPx(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_BcalTruthIncidentParticle_setPx(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getPy(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_BcalTruthIncidentParticle_setPy(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getPz(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_BcalTruthIncidentParticle_setPz(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getX(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_BcalTruthIncidentParticle_setX(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getY(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_BcalTruthIncidentParticle_setY(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_getZ(_BcalTruthIncidentParticle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_BcalTruthIncidentParticle_setZ(_BcalTruthIncidentParticle *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_BcalTruthIncidentParticle_toString(PyObject *self, PyObject *args=0)
{
   _BcalTruthIncidentParticle *me = (_BcalTruthIncidentParticle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthIncidentParticle element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalTruthIncidentParticle_toXML(PyObject *self, PyObject *args=0)
{
   _BcalTruthIncidentParticle *me = (_BcalTruthIncidentParticle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthIncidentParticle element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalTruthIncidentParticle_getsetters[] = {
   {(char*)"class",
    (getter)_BcalTruthIncidentParticle_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalTruthIncidentParticle_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_BcalTruthIncidentParticle_getId, (setter)_BcalTruthIncidentParticle_setId,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalTruthIncidentParticle_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalTruthIncidentParticle_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ptype",
    (getter)_BcalTruthIncidentParticle_getPtype, (setter)_BcalTruthIncidentParticle_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_BcalTruthIncidentParticle_getPx, (setter)_BcalTruthIncidentParticle_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_BcalTruthIncidentParticle_getPy, (setter)_BcalTruthIncidentParticle_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_BcalTruthIncidentParticle_getPz, (setter)_BcalTruthIncidentParticle_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalTruthIncidentParticle_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_BcalTruthIncidentParticle_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_BcalTruthIncidentParticle_getX, (setter)_BcalTruthIncidentParticle_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalTruthIncidentParticle_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_BcalTruthIncidentParticle_getY, (setter)_BcalTruthIncidentParticle_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_BcalTruthIncidentParticle_getZ, (setter)_BcalTruthIncidentParticle_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalTruthIncidentParticle_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalTruthIncidentParticle_methods[] = {
   {"toString", _BcalTruthIncidentParticle_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalTruthIncidentParticle_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalTruthIncidentParticle_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalTruthIncidentParticle",         /*tp_name*/
    sizeof(_BcalTruthIncidentParticle),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalTruthIncidentParticle_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalTruthIncidentParticle_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalTruthIncidentParticle element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalTruthIncidentParticle_methods,          /* tp_methods */
    _BcalTruthIncidentParticle_members,          /* tp_members */
    _BcalTruthIncidentParticle_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalTruthIncidentParticle_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalTruthIncidentParticle_new,              /* tp_new */
};



// wrap element class hddm_s::BcalTruthShower as hddm_s.BcalTruthShower

typedef struct {
   PyObject_HEAD
   BcalTruthShower *elem;
   PyObject *host;
} _BcalTruthShower;

static void
_BcalTruthShower_dealloc(_BcalTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BcalTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BcalTruthShower *self;
   self = (_BcalTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BcalTruthShower_init(_BcalTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BcalTruthShower_getClass(_BcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthShower_getVersion(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BcalTruthShower_getXmlns(_BcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthShower_getEventNo(_BcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BcalTruthShower_getRunNo(_BcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BcalTruthShower_getE(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_BcalTruthShower_setE(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getMaxOccurs(_BcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BcalTruthShower_getMinOccurs(_BcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BcalTruthShower_getPhi(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static int
_BcalTruthShower_setPhi(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPhi((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getPrimary(_BcalTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_BcalTruthShower_setPrimary(_BcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_BcalTruthShower_getPtype(_BcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_BcalTruthShower_setPtype(_BcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_BcalTruthShower_getPx(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_BcalTruthShower_setPx(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getPy(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_BcalTruthShower_setPy(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getPz(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_BcalTruthShower_setPz(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getR(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static int
_BcalTruthShower_setR(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setR((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getT(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_BcalTruthShower_setT(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getTrack(_BcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_BcalTruthShower_setTrack(_BcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_BcalTruthShower_getZ(_BcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_BcalTruthShower_setZ(_BcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_BcalTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BcalTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BcalTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid bcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BcalTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid bcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BcalTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BcalTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _BcalTruthShower *me = (_BcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid bcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BcalTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_BcalTruthShower_getE, (setter)_BcalTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_BcalTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BcalTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BcalTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_BcalTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"phi",
    (getter)_BcalTruthShower_getPhi, (setter)_BcalTruthShower_setPhi,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_BcalTruthShower_getPrimary, (setter)_BcalTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_BcalTruthShower_getPtype, (setter)_BcalTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_BcalTruthShower_getPx, (setter)_BcalTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_BcalTruthShower_getPy, (setter)_BcalTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_BcalTruthShower_getPz, (setter)_BcalTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_BcalTruthShower_getR, (setter)_BcalTruthShower_setR,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_BcalTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_BcalTruthShower_getT, (setter)_BcalTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_BcalTruthShower_getTrack, (setter)_BcalTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_BcalTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BcalTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"z",
    (getter)_BcalTruthShower_getZ, (setter)_BcalTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BcalTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BcalTruthShower_methods[] = {
   {"addTrackIDs", _BcalTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this bcalTruthShower"},
   {"addTrackOrigins", _BcalTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this bcalTruthShower"},
   {"deleteTrackIDs", _BcalTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this bcalTruthShower"},
   {"deleteTrackOrigins", _BcalTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this bcalTruthShower"},
   {"getTrackID", _BcalTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this bcalTruthShower"},
   {"getTrackIDs", _BcalTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this bcalTruthShower"},
   {"getTrackOrigin", _BcalTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this bcalTruthShower"},
   {"getTrackOrigins", _BcalTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this bcalTruthShower"},
   {"toString", _BcalTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BcalTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BcalTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BcalTruthShower",         /*tp_name*/
    sizeof(_BcalTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BcalTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BcalTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s bcalTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BcalTruthShower_methods,          /* tp_methods */
    _BcalTruthShower_members,          /* tp_members */
    _BcalTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BcalTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BcalTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::BarrelEMcal as hddm_s.BarrelEMcal

typedef struct {
   PyObject_HEAD
   BarrelEMcal *elem;
   PyObject *host;
} _BarrelEMcal;

static void
_BarrelEMcal_dealloc(_BarrelEMcal* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_BarrelEMcal_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _BarrelEMcal *self;
   self = (_BarrelEMcal*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_BarrelEMcal_init(_BarrelEMcal *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_BarrelEMcal_getClass(_BarrelEMcal *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BarrelEMcal_getVersion(_BarrelEMcal *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_BarrelEMcal_getXmlns(_BarrelEMcal *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BarrelEMcal_getEventNo(_BarrelEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_BarrelEMcal_getMaxOccurs(_BarrelEMcal *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_BarrelEMcal_getRunNo(_BarrelEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_BarrelEMcal_getMinOccurs(_BarrelEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_BarrelEMcal_getBcalCell(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *obj = _BcalCell_new(&_BcalCell_type, 0, 0);
   ((_BcalCell*)obj)->elem = &me->elem->getBcalCell(index);
   ((_BcalCell*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BarrelEMcal_getBcalCells(PyObject *self, PyObject *args)
{
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalCells();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BarrelEMcal_addBcalCells(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalCellList(me->elem->addBcalCells(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BarrelEMcal_deleteBcalCells(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid barrelEMcal element");
      return NULL;
   }
   me->elem->deleteBcalCells(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BarrelEMcal_getBcalTruthIncidentParticle(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *obj = _BcalTruthIncidentParticle_new(&_BcalTruthIncidentParticle_type, 0, 0);
   ((_BcalTruthIncidentParticle*)obj)->elem = &me->elem->getBcalTruthIncidentParticle(index);
   ((_BcalTruthIncidentParticle*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BarrelEMcal_getBcalTruthIncidentParticles(PyObject *self, PyObject *args)
{
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthIncidentParticle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalTruthIncidentParticles();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BarrelEMcal_addBcalTruthIncidentParticles(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthIncidentParticle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthIncidentParticleList(me->elem->addBcalTruthIncidentParticles(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BarrelEMcal_deleteBcalTruthIncidentParticles(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid barrelEMcal element");
      return NULL;
   }
   me->elem->deleteBcalTruthIncidentParticles(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BarrelEMcal_getBcalTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *obj = _BcalTruthShower_new(&_BcalTruthShower_type, 0, 0);
   ((_BcalTruthShower*)obj)->elem = &me->elem->getBcalTruthShower(index);
   ((_BcalTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_BarrelEMcal_getBcalTruthShowers(PyObject *self, PyObject *args)
{
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBcalTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_BarrelEMcal_addBcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid barrelEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthShowerList(me->elem->addBcalTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_BarrelEMcal_deleteBcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid barrelEMcal element");
      return NULL;
   }
   me->elem->deleteBcalTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_BarrelEMcal_toString(PyObject *self, PyObject *args=0)
{
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_BarrelEMcal_toXML(PyObject *self, PyObject *args=0)
{
   _BarrelEMcal *me = (_BarrelEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid barrelEMcal element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _BarrelEMcal_getsetters[] = {
   {(char*)"class",
    (getter)_BarrelEMcal_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_BarrelEMcal_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_BarrelEMcal_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_BarrelEMcal_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_BarrelEMcal_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_BarrelEMcal_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_BarrelEMcal_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _BarrelEMcal_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _BarrelEMcal_methods[] = {
   {"addBcalCells", _BarrelEMcal_addBcalCells, METH_VARARGS,
    "extend (or insert into) the list of bcalCell objects for this barrelEMcal"},
   {"addBcalTruthIncidentParticles", _BarrelEMcal_addBcalTruthIncidentParticles, METH_VARARGS,
    "extend (or insert into) the list of bcalTruthIncidentParticle objects for this barrelEMcal"},
   {"addBcalTruthShowers", _BarrelEMcal_addBcalTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of bcalTruthShower objects for this barrelEMcal"},
   {"deleteBcalCells", _BarrelEMcal_deleteBcalCells, METH_VARARGS,
    "delete bcalCell objects for this barrelEMcal"},
   {"deleteBcalTruthIncidentParticles", _BarrelEMcal_deleteBcalTruthIncidentParticles, METH_VARARGS,
    "delete bcalTruthIncidentParticle objects for this barrelEMcal"},
   {"deleteBcalTruthShowers", _BarrelEMcal_deleteBcalTruthShowers, METH_VARARGS,
    "delete bcalTruthShower objects for this barrelEMcal"},
   {"getBcalCell", _BarrelEMcal_getBcalCell, METH_VARARGS,
    "get an individual bcalCell object from this barrelEMcal"},
   {"getBcalCells", _BarrelEMcal_getBcalCells, METH_NOARGS,
    "get list of bcalCell objects for this barrelEMcal"},
   {"getBcalTruthIncidentParticle", _BarrelEMcal_getBcalTruthIncidentParticle, METH_VARARGS,
    "get an individual bcalTruthIncidentParticle object from this barrelEMcal"},
   {"getBcalTruthIncidentParticles", _BarrelEMcal_getBcalTruthIncidentParticles, METH_NOARGS,
    "get list of bcalTruthIncidentParticle objects for this barrelEMcal"},
   {"getBcalTruthShower", _BarrelEMcal_getBcalTruthShower, METH_VARARGS,
    "get an individual bcalTruthShower object from this barrelEMcal"},
   {"getBcalTruthShowers", _BarrelEMcal_getBcalTruthShowers, METH_NOARGS,
    "get list of bcalTruthShower objects for this barrelEMcal"},
   {"toString", _BarrelEMcal_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _BarrelEMcal_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _BarrelEMcal_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.BarrelEMcal",         /*tp_name*/
    sizeof(_BarrelEMcal),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_BarrelEMcal_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_BarrelEMcal_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s barrelEMcal element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _BarrelEMcal_methods,          /* tp_methods */
    _BarrelEMcal_members,          /* tp_members */
    _BarrelEMcal_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_BarrelEMcal_init,   /* tp_init */
    0,                         /* tp_alloc */
    _BarrelEMcal_new,              /* tp_new */
};



// wrap element class hddm_s::GcalHit as hddm_s.GcalHit

typedef struct {
   PyObject_HEAD
   GcalHit *elem;
   PyObject *host;
} _GcalHit;

static void
_GcalHit_dealloc(_GcalHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_GcalHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _GcalHit *self;
   self = (_GcalHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_GcalHit_init(_GcalHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_GcalHit_getClass(_GcalHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalHit_getVersion(_GcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_GcalHit_getXmlns(_GcalHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalHit_getEventNo(_GcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_GcalHit_getRunNo(_GcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_GcalHit_getModule(_GcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_GcalHit_getE(_GcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_GcalHit_setE(_GcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_GcalHit_getMaxOccurs(_GcalHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalHit_getMinOccurs(_GcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_GcalHit_getT(_GcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_GcalHit_setT(_GcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_GcalHit_getZLocal(_GcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZLocal());
}

static int
_GcalHit_setZLocal(_GcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZLocal((float)var);
   return 0;
}

static PyObject*
_GcalHit_toString(PyObject *self, PyObject *args=0)
{
   _GcalHit *me = (_GcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_GcalHit_toXML(PyObject *self, PyObject *args=0)
{
   _GcalHit *me = (_GcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _GcalHit_getsetters[] = {
   {(char*)"E",
    (getter)_GcalHit_getE, (setter)_GcalHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_GcalHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_GcalHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_GcalHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_GcalHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_GcalHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_GcalHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_GcalHit_getT, (setter)_GcalHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_GcalHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_GcalHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"zLocal",
    (getter)_GcalHit_getZLocal, (setter)_GcalHit_setZLocal,
    (char*)"zLocal value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _GcalHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _GcalHit_methods[] = {
   {"toString", _GcalHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _GcalHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _GcalHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.GcalHit",         /*tp_name*/
    sizeof(_GcalHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_GcalHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_GcalHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s gcalHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _GcalHit_methods,          /* tp_methods */
    _GcalHit_members,          /* tp_members */
    _GcalHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_GcalHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _GcalHit_new,              /* tp_new */
};



// wrap element class hddm_s::GcalTruthHit as hddm_s.GcalTruthHit

typedef struct {
   PyObject_HEAD
   GcalTruthHit *elem;
   PyObject *host;
} _GcalTruthHit;

static void
_GcalTruthHit_dealloc(_GcalTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_GcalTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _GcalTruthHit *self;
   self = (_GcalTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_GcalTruthHit_init(_GcalTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_GcalTruthHit_getClass(_GcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthHit_getVersion(_GcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_GcalTruthHit_getXmlns(_GcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthHit_getEventNo(_GcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_GcalTruthHit_getRunNo(_GcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_GcalTruthHit_getModule(_GcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_GcalTruthHit_getE(_GcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_GcalTruthHit_setE(_GcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_GcalTruthHit_getMaxOccurs(_GcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthHit_getMinOccurs(_GcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_GcalTruthHit_getT(_GcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_GcalTruthHit_setT(_GcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_GcalTruthHit_getZLocal(_GcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZLocal());
}

static int
_GcalTruthHit_setZLocal(_GcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZLocal((float)var);
   return 0;
}

static PyObject*
_GcalTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _GcalTruthHit *me = (_GcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_GcalTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _GcalTruthHit *me = (_GcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _GcalTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_GcalTruthHit_getE, (setter)_GcalTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_GcalTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_GcalTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_GcalTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_GcalTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_GcalTruthHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_GcalTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_GcalTruthHit_getT, (setter)_GcalTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_GcalTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_GcalTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"zLocal",
    (getter)_GcalTruthHit_getZLocal, (setter)_GcalTruthHit_setZLocal,
    (char*)"zLocal value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _GcalTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _GcalTruthHit_methods[] = {
   {"toString", _GcalTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _GcalTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _GcalTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.GcalTruthHit",         /*tp_name*/
    sizeof(_GcalTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_GcalTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_GcalTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s gcalTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _GcalTruthHit_methods,          /* tp_methods */
    _GcalTruthHit_members,          /* tp_members */
    _GcalTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_GcalTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _GcalTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::GcalCell as hddm_s.GcalCell

typedef struct {
   PyObject_HEAD
   GcalCell *elem;
   PyObject *host;
} _GcalCell;

static void
_GcalCell_dealloc(_GcalCell* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_GcalCell_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _GcalCell *self;
   self = (_GcalCell*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_GcalCell_init(_GcalCell *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_GcalCell_getClass(_GcalCell *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalCell_getVersion(_GcalCell *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_GcalCell_getXmlns(_GcalCell *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalCell_getEventNo(_GcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_GcalCell_getRunNo(_GcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_GcalCell_getMaxOccurs(_GcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMaxOccurs());
}

static PyObject*
_GcalCell_getMinOccurs(_GcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_GcalCell_getModule(_GcalCell *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static int
_GcalCell_setModule(_GcalCell *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setModule(var);
   return 0;
}

static PyObject*
_GcalCell_getGcalHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *obj = _GcalHit_new(&_GcalHit_type, 0, 0);
   ((_GcalHit*)obj)->elem = &me->elem->getGcalHit(index);
   ((_GcalHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GcalCell_getGcalHits(PyObject *self, PyObject *args)
{
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGcalHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GcalCell_addGcalHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalHitList(me->elem->addGcalHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GcalCell_deleteGcalHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gcalCell element");
      return NULL;
   }
   me->elem->deleteGcalHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GcalCell_getGcalTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *obj = _GcalTruthHit_new(&_GcalTruthHit_type, 0, 0);
   ((_GcalTruthHit*)obj)->elem = &me->elem->getGcalTruthHit(index);
   ((_GcalTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GcalCell_getGcalTruthHits(PyObject *self, PyObject *args)
{
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGcalTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GcalCell_addGcalTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gcalCell element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalTruthHitList(me->elem->addGcalTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GcalCell_deleteGcalTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gcalCell element");
      return NULL;
   }
   me->elem->deleteGcalTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GcalCell_toString(PyObject *self, PyObject *args=0)
{
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_GcalCell_toXML(PyObject *self, PyObject *args=0)
{
   _GcalCell *me = (_GcalCell*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalCell element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _GcalCell_getsetters[] = {
   {(char*)"class",
    (getter)_GcalCell_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_GcalCell_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_GcalCell_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_GcalCell_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_GcalCell_getModule, (setter)_GcalCell_setModule,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_GcalCell_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_GcalCell_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_GcalCell_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _GcalCell_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _GcalCell_methods[] = {
   {"addGcalHits", _GcalCell_addGcalHits, METH_VARARGS,
    "extend (or insert into) the list of gcalHit objects for this gcalCell"},
   {"addGcalTruthHits", _GcalCell_addGcalTruthHits, METH_VARARGS,
    "extend (or insert into) the list of gcalTruthHit objects for this gcalCell"},
   {"deleteGcalHits", _GcalCell_deleteGcalHits, METH_VARARGS,
    "delete gcalHit objects for this gcalCell"},
   {"deleteGcalTruthHits", _GcalCell_deleteGcalTruthHits, METH_VARARGS,
    "delete gcalTruthHit objects for this gcalCell"},
   {"getGcalHit", _GcalCell_getGcalHit, METH_VARARGS,
    "get an individual gcalHit object from this gcalCell"},
   {"getGcalHits", _GcalCell_getGcalHits, METH_NOARGS,
    "get list of gcalHit objects for this gcalCell"},
   {"getGcalTruthHit", _GcalCell_getGcalTruthHit, METH_VARARGS,
    "get an individual gcalTruthHit object from this gcalCell"},
   {"getGcalTruthHits", _GcalCell_getGcalTruthHits, METH_NOARGS,
    "get list of gcalTruthHit objects for this gcalCell"},
   {"toString", _GcalCell_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _GcalCell_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _GcalCell_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.GcalCell",         /*tp_name*/
    sizeof(_GcalCell),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_GcalCell_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_GcalCell_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s gcalCell element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _GcalCell_methods,          /* tp_methods */
    _GcalCell_members,          /* tp_members */
    _GcalCell_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_GcalCell_init,   /* tp_init */
    0,                         /* tp_alloc */
    _GcalCell_new,              /* tp_new */
};



// wrap element class hddm_s::GcalTruthShower as hddm_s.GcalTruthShower

typedef struct {
   PyObject_HEAD
   GcalTruthShower *elem;
   PyObject *host;
} _GcalTruthShower;

static void
_GcalTruthShower_dealloc(_GcalTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_GcalTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _GcalTruthShower *self;
   self = (_GcalTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_GcalTruthShower_init(_GcalTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_GcalTruthShower_getClass(_GcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthShower_getVersion(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_GcalTruthShower_getXmlns(_GcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthShower_getEventNo(_GcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_GcalTruthShower_getRunNo(_GcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_GcalTruthShower_getE(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_GcalTruthShower_setE(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getMaxOccurs(_GcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GcalTruthShower_getMinOccurs(_GcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_GcalTruthShower_getPhi(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static int
_GcalTruthShower_setPhi(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPhi((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getPrimary(_GcalTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_GcalTruthShower_setPrimary(_GcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_GcalTruthShower_getPtype(_GcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_GcalTruthShower_setPtype(_GcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_GcalTruthShower_getPx(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_GcalTruthShower_setPx(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getPy(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_GcalTruthShower_setPy(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getPz(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_GcalTruthShower_setPz(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getR(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static int
_GcalTruthShower_setR(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setR((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getT(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_GcalTruthShower_setT(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getTrack(_GcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_GcalTruthShower_setTrack(_GcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_GcalTruthShower_getZ(_GcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_GcalTruthShower_setZ(_GcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_GcalTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GcalTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GcalTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GcalTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GcalTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GcalTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GcalTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GcalTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GcalTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_GcalTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _GcalTruthShower *me = (_GcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _GcalTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_GcalTruthShower_getE, (setter)_GcalTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_GcalTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_GcalTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_GcalTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_GcalTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"phi",
    (getter)_GcalTruthShower_getPhi, (setter)_GcalTruthShower_setPhi,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_GcalTruthShower_getPrimary, (setter)_GcalTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_GcalTruthShower_getPtype, (setter)_GcalTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_GcalTruthShower_getPx, (setter)_GcalTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_GcalTruthShower_getPy, (setter)_GcalTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_GcalTruthShower_getPz, (setter)_GcalTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_GcalTruthShower_getR, (setter)_GcalTruthShower_setR,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_GcalTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_GcalTruthShower_getT, (setter)_GcalTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_GcalTruthShower_getTrack, (setter)_GcalTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_GcalTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_GcalTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"z",
    (getter)_GcalTruthShower_getZ, (setter)_GcalTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _GcalTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _GcalTruthShower_methods[] = {
   {"addTrackIDs", _GcalTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this gcalTruthShower"},
   {"addTrackOrigins", _GcalTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this gcalTruthShower"},
   {"deleteTrackIDs", _GcalTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this gcalTruthShower"},
   {"deleteTrackOrigins", _GcalTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this gcalTruthShower"},
   {"getTrackID", _GcalTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this gcalTruthShower"},
   {"getTrackIDs", _GcalTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this gcalTruthShower"},
   {"getTrackOrigin", _GcalTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this gcalTruthShower"},
   {"getTrackOrigins", _GcalTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this gcalTruthShower"},
   {"toString", _GcalTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _GcalTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _GcalTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.GcalTruthShower",         /*tp_name*/
    sizeof(_GcalTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_GcalTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_GcalTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s gcalTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _GcalTruthShower_methods,          /* tp_methods */
    _GcalTruthShower_members,          /* tp_members */
    _GcalTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_GcalTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _GcalTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::GapEMcal as hddm_s.GapEMcal

typedef struct {
   PyObject_HEAD
   GapEMcal *elem;
   PyObject *host;
} _GapEMcal;

static void
_GapEMcal_dealloc(_GapEMcal* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_GapEMcal_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _GapEMcal *self;
   self = (_GapEMcal*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_GapEMcal_init(_GapEMcal *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_GapEMcal_getClass(_GapEMcal *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GapEMcal_getVersion(_GapEMcal *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_GapEMcal_getXmlns(_GapEMcal *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GapEMcal_getEventNo(_GapEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_GapEMcal_getMaxOccurs(_GapEMcal *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_GapEMcal_getRunNo(_GapEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_GapEMcal_getMinOccurs(_GapEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_GapEMcal_getGcalCell(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *obj = _GcalCell_new(&_GcalCell_type, 0, 0);
   ((_GcalCell*)obj)->elem = &me->elem->getGcalCell(index);
   ((_GcalCell*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GapEMcal_getGcalCells(PyObject *self, PyObject *args)
{
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGcalCells();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GapEMcal_addGcalCells(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalCellList(me->elem->addGcalCells(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GapEMcal_deleteGcalCells(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gapEMcal element");
      return NULL;
   }
   me->elem->deleteGcalCells(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GapEMcal_getGcalTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *obj = _GcalTruthShower_new(&_GcalTruthShower_type, 0, 0);
   ((_GcalTruthShower*)obj)->elem = &me->elem->getGcalTruthShower(index);
   ((_GcalTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_GapEMcal_getGcalTruthShowers(PyObject *self, PyObject *args)
{
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGcalTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_GapEMcal_addGcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid gapEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalTruthShowerList(me->elem->addGcalTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_GapEMcal_deleteGcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid gapEMcal element");
      return NULL;
   }
   me->elem->deleteGcalTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_GapEMcal_toString(PyObject *self, PyObject *args=0)
{
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_GapEMcal_toXML(PyObject *self, PyObject *args=0)
{
   _GapEMcal *me = (_GapEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid gapEMcal element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _GapEMcal_getsetters[] = {
   {(char*)"class",
    (getter)_GapEMcal_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_GapEMcal_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_GapEMcal_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_GapEMcal_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_GapEMcal_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_GapEMcal_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_GapEMcal_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _GapEMcal_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _GapEMcal_methods[] = {
   {"addGcalCells", _GapEMcal_addGcalCells, METH_VARARGS,
    "extend (or insert into) the list of gcalCell objects for this gapEMcal"},
   {"addGcalTruthShowers", _GapEMcal_addGcalTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of gcalTruthShower objects for this gapEMcal"},
   {"deleteGcalCells", _GapEMcal_deleteGcalCells, METH_VARARGS,
    "delete gcalCell objects for this gapEMcal"},
   {"deleteGcalTruthShowers", _GapEMcal_deleteGcalTruthShowers, METH_VARARGS,
    "delete gcalTruthShower objects for this gapEMcal"},
   {"getGcalCell", _GapEMcal_getGcalCell, METH_VARARGS,
    "get an individual gcalCell object from this gapEMcal"},
   {"getGcalCells", _GapEMcal_getGcalCells, METH_NOARGS,
    "get list of gcalCell objects for this gapEMcal"},
   {"getGcalTruthShower", _GapEMcal_getGcalTruthShower, METH_VARARGS,
    "get an individual gcalTruthShower object from this gapEMcal"},
   {"getGcalTruthShowers", _GapEMcal_getGcalTruthShowers, METH_NOARGS,
    "get list of gcalTruthShower objects for this gapEMcal"},
   {"toString", _GapEMcal_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _GapEMcal_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _GapEMcal_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.GapEMcal",         /*tp_name*/
    sizeof(_GapEMcal),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_GapEMcal_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_GapEMcal_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s gapEMcal element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _GapEMcal_methods,          /* tp_methods */
    _GapEMcal_members,          /* tp_members */
    _GapEMcal_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_GapEMcal_init,   /* tp_init */
    0,                         /* tp_alloc */
    _GapEMcal_new,              /* tp_new */
};



// wrap element class hddm_s::CereHit as hddm_s.CereHit

typedef struct {
   PyObject_HEAD
   CereHit *elem;
   PyObject *host;
} _CereHit;

static void
_CereHit_dealloc(_CereHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CereHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CereHit *self;
   self = (_CereHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CereHit_init(_CereHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CereHit_getClass(_CereHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereHit_getVersion(_CereHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CereHit_getXmlns(_CereHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereHit_getEventNo(_CereHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CereHit_getRunNo(_CereHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CereHit_getMinOccurs(_CereHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CereHit_getSector(_CereHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_CereHit_getMaxOccurs(_CereHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereHit_getPe(_CereHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPe());
}

static int
_CereHit_setPe(_CereHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPe((float)var);
   return 0;
}

static PyObject*
_CereHit_getT(_CereHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CereHit_setT(_CereHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CereHit_toString(PyObject *self, PyObject *args=0)
{
   _CereHit *me = (_CereHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CereHit_toXML(PyObject *self, PyObject *args=0)
{
   _CereHit *me = (_CereHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CereHit_getsetters[] = {
   {(char*)"class",
    (getter)_CereHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CereHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CereHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CereHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"pe",
    (getter)_CereHit_getPe, (setter)_CereHit_setPe,
    (char*)"pe value",
    NULL},
   {(char*)"runNo",
    (getter)_CereHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_CereHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_CereHit_getT, (setter)_CereHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CereHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CereHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CereHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CereHit_methods[] = {
   {"toString", _CereHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CereHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CereHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CereHit",         /*tp_name*/
    sizeof(_CereHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CereHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CereHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cereHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CereHit_methods,          /* tp_methods */
    _CereHit_members,          /* tp_members */
    _CereHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CereHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CereHit_new,              /* tp_new */
};



// wrap element class hddm_s::CereTruthHit as hddm_s.CereTruthHit

typedef struct {
   PyObject_HEAD
   CereTruthHit *elem;
   PyObject *host;
} _CereTruthHit;

static void
_CereTruthHit_dealloc(_CereTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CereTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CereTruthHit *self;
   self = (_CereTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CereTruthHit_init(_CereTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CereTruthHit_getClass(_CereTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthHit_getVersion(_CereTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CereTruthHit_getXmlns(_CereTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthHit_getEventNo(_CereTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CereTruthHit_getRunNo(_CereTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CereTruthHit_getMinOccurs(_CereTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CereTruthHit_getSector(_CereTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_CereTruthHit_getMaxOccurs(_CereTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthHit_getPe(_CereTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPe());
}

static int
_CereTruthHit_setPe(_CereTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPe((float)var);
   return 0;
}

static PyObject*
_CereTruthHit_getT(_CereTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CereTruthHit_setT(_CereTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CereTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _CereTruthHit *me = (_CereTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CereTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _CereTruthHit *me = (_CereTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CereTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_CereTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CereTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CereTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CereTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"pe",
    (getter)_CereTruthHit_getPe, (setter)_CereTruthHit_setPe,
    (char*)"pe value",
    NULL},
   {(char*)"runNo",
    (getter)_CereTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_CereTruthHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_CereTruthHit_getT, (setter)_CereTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CereTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CereTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CereTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CereTruthHit_methods[] = {
   {"toString", _CereTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CereTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CereTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CereTruthHit",         /*tp_name*/
    sizeof(_CereTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CereTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CereTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cereTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CereTruthHit_methods,          /* tp_methods */
    _CereTruthHit_members,          /* tp_members */
    _CereTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CereTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CereTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::CereSection as hddm_s.CereSection

typedef struct {
   PyObject_HEAD
   CereSection *elem;
   PyObject *host;
} _CereSection;

static void
_CereSection_dealloc(_CereSection* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CereSection_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CereSection *self;
   self = (_CereSection*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CereSection_init(_CereSection *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CereSection_getClass(_CereSection *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereSection_getVersion(_CereSection *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CereSection_getXmlns(_CereSection *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereSection_getEventNo(_CereSection *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CereSection_getRunNo(_CereSection *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CereSection_getMaxOccurs(_CereSection *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereSection_getMinOccurs(_CereSection *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CereSection_getSector(_CereSection *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static int
_CereSection_setSector(_CereSection *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSector(var);
   return 0;
}

static PyObject*
_CereSection_getCereHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *obj = _CereHit_new(&_CereHit_type, 0, 0);
   ((_CereHit*)obj)->elem = &me->elem->getCereHit(index);
   ((_CereHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CereSection_getCereHits(PyObject *self, PyObject *args)
{
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCereHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CereSection_addCereHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereHitList(me->elem->addCereHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CereSection_deleteCereHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cereSection element");
      return NULL;
   }
   me->elem->deleteCereHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CereSection_getCereTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *obj = _CereTruthHit_new(&_CereTruthHit_type, 0, 0);
   ((_CereTruthHit*)obj)->elem = &me->elem->getCereTruthHit(index);
   ((_CereTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CereSection_getCereTruthHits(PyObject *self, PyObject *args)
{
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCereTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CereSection_addCereTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cereSection element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereTruthHitList(me->elem->addCereTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CereSection_deleteCereTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cereSection element");
      return NULL;
   }
   me->elem->deleteCereTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CereSection_toString(PyObject *self, PyObject *args=0)
{
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CereSection_toXML(PyObject *self, PyObject *args=0)
{
   _CereSection *me = (_CereSection*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereSection element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CereSection_getsetters[] = {
   {(char*)"class",
    (getter)_CereSection_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CereSection_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CereSection_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CereSection_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CereSection_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_CereSection_getSector, (setter)_CereSection_setSector,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_CereSection_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CereSection_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CereSection_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CereSection_methods[] = {
   {"addCereHits", _CereSection_addCereHits, METH_VARARGS,
    "extend (or insert into) the list of cereHit objects for this cereSection"},
   {"addCereTruthHits", _CereSection_addCereTruthHits, METH_VARARGS,
    "extend (or insert into) the list of cereTruthHit objects for this cereSection"},
   {"deleteCereHits", _CereSection_deleteCereHits, METH_VARARGS,
    "delete cereHit objects for this cereSection"},
   {"deleteCereTruthHits", _CereSection_deleteCereTruthHits, METH_VARARGS,
    "delete cereTruthHit objects for this cereSection"},
   {"getCereHit", _CereSection_getCereHit, METH_VARARGS,
    "get an individual cereHit object from this cereSection"},
   {"getCereHits", _CereSection_getCereHits, METH_NOARGS,
    "get list of cereHit objects for this cereSection"},
   {"getCereTruthHit", _CereSection_getCereTruthHit, METH_VARARGS,
    "get an individual cereTruthHit object from this cereSection"},
   {"getCereTruthHits", _CereSection_getCereTruthHits, METH_NOARGS,
    "get list of cereTruthHit objects for this cereSection"},
   {"toString", _CereSection_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CereSection_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CereSection_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CereSection",         /*tp_name*/
    sizeof(_CereSection),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CereSection_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CereSection_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cereSection element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CereSection_methods,          /* tp_methods */
    _CereSection_members,          /* tp_members */
    _CereSection_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CereSection_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CereSection_new,              /* tp_new */
};



// wrap element class hddm_s::CereTruthPoint as hddm_s.CereTruthPoint

typedef struct {
   PyObject_HEAD
   CereTruthPoint *elem;
   PyObject *host;
} _CereTruthPoint;

static void
_CereTruthPoint_dealloc(_CereTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CereTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CereTruthPoint *self;
   self = (_CereTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CereTruthPoint_init(_CereTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CereTruthPoint_getClass(_CereTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthPoint_getVersion(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CereTruthPoint_getXmlns(_CereTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthPoint_getEventNo(_CereTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CereTruthPoint_getRunNo(_CereTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CereTruthPoint_getE(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_CereTruthPoint_setE(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getMaxOccurs(_CereTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CereTruthPoint_getMinOccurs(_CereTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CereTruthPoint_getPrimary(_CereTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_CereTruthPoint_setPrimary(_CereTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_CereTruthPoint_getPtype(_CereTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_CereTruthPoint_setPtype(_CereTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_CereTruthPoint_getPx(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_CereTruthPoint_setPx(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getPy(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_CereTruthPoint_setPy(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getPz(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_CereTruthPoint_setPz(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getT(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CereTruthPoint_setT(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getTrack(_CereTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_CereTruthPoint_setTrack(_CereTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_CereTruthPoint_getX(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_CereTruthPoint_setX(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getY(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_CereTruthPoint_setY(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getZ(_CereTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_CereTruthPoint_setZ(_CereTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_CereTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CereTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CereTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CereTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cereTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CereTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CereTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CereTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cereTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CereTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cereTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CereTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CereTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _CereTruthPoint *me = (_CereTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cereTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CereTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_CereTruthPoint_getE, (setter)_CereTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_CereTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CereTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CereTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CereTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_CereTruthPoint_getPrimary, (setter)_CereTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_CereTruthPoint_getPtype, (setter)_CereTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_CereTruthPoint_getPx, (setter)_CereTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_CereTruthPoint_getPy, (setter)_CereTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_CereTruthPoint_getPz, (setter)_CereTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_CereTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CereTruthPoint_getT, (setter)_CereTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_CereTruthPoint_getTrack, (setter)_CereTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_CereTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_CereTruthPoint_getX, (setter)_CereTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_CereTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_CereTruthPoint_getY, (setter)_CereTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_CereTruthPoint_getZ, (setter)_CereTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CereTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CereTruthPoint_methods[] = {
   {"addTrackIDs", _CereTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this cereTruthPoint"},
   {"addTrackOrigins", _CereTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this cereTruthPoint"},
   {"deleteTrackIDs", _CereTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this cereTruthPoint"},
   {"deleteTrackOrigins", _CereTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this cereTruthPoint"},
   {"getTrackID", _CereTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this cereTruthPoint"},
   {"getTrackIDs", _CereTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this cereTruthPoint"},
   {"getTrackOrigin", _CereTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this cereTruthPoint"},
   {"getTrackOrigins", _CereTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this cereTruthPoint"},
   {"toString", _CereTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CereTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CereTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CereTruthPoint",         /*tp_name*/
    sizeof(_CereTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CereTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CereTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cereTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CereTruthPoint_methods,          /* tp_methods */
    _CereTruthPoint_members,          /* tp_members */
    _CereTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CereTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CereTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::Cerenkov as hddm_s.Cerenkov

typedef struct {
   PyObject_HEAD
   Cerenkov *elem;
   PyObject *host;
} _Cerenkov;

static void
_Cerenkov_dealloc(_Cerenkov* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Cerenkov_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Cerenkov *self;
   self = (_Cerenkov*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Cerenkov_init(_Cerenkov *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Cerenkov_getClass(_Cerenkov *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Cerenkov_getVersion(_Cerenkov *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Cerenkov_getXmlns(_Cerenkov *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Cerenkov_getEventNo(_Cerenkov *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Cerenkov_getMaxOccurs(_Cerenkov *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Cerenkov_getRunNo(_Cerenkov *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Cerenkov_getMinOccurs(_Cerenkov *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Cerenkov_getCereSection(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *obj = _CereSection_new(&_CereSection_type, 0, 0);
   ((_CereSection*)obj)->elem = &me->elem->getCereSection(index);
   ((_CereSection*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Cerenkov_getCereSections(PyObject *self, PyObject *args)
{
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereSection_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCereSections();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Cerenkov_addCereSections(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereSection_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereSectionList(me->elem->addCereSections(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Cerenkov_deleteCereSections(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid Cerenkov element");
      return NULL;
   }
   me->elem->deleteCereSections(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Cerenkov_getCereTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *obj = _CereTruthPoint_new(&_CereTruthPoint_type, 0, 0);
   ((_CereTruthPoint*)obj)->elem = &me->elem->getCereTruthPoint(index);
   ((_CereTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Cerenkov_getCereTruthPoints(PyObject *self, PyObject *args)
{
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCereTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Cerenkov_addCereTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid Cerenkov element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereTruthPointList(me->elem->addCereTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Cerenkov_deleteCereTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid Cerenkov element");
      return NULL;
   }
   me->elem->deleteCereTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Cerenkov_toString(PyObject *self, PyObject *args=0)
{
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Cerenkov_toXML(PyObject *self, PyObject *args=0)
{
   _Cerenkov *me = (_Cerenkov*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid Cerenkov element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Cerenkov_getsetters[] = {
   {(char*)"class",
    (getter)_Cerenkov_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Cerenkov_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Cerenkov_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Cerenkov_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Cerenkov_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_Cerenkov_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_Cerenkov_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Cerenkov_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Cerenkov_methods[] = {
   {"addCereSections", _Cerenkov_addCereSections, METH_VARARGS,
    "extend (or insert into) the list of cereSection objects for this Cerenkov"},
   {"addCereTruthPoints", _Cerenkov_addCereTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of cereTruthPoint objects for this Cerenkov"},
   {"deleteCereSections", _Cerenkov_deleteCereSections, METH_VARARGS,
    "delete cereSection objects for this Cerenkov"},
   {"deleteCereTruthPoints", _Cerenkov_deleteCereTruthPoints, METH_VARARGS,
    "delete cereTruthPoint objects for this Cerenkov"},
   {"getCereSection", _Cerenkov_getCereSection, METH_VARARGS,
    "get an individual cereSection object from this Cerenkov"},
   {"getCereSections", _Cerenkov_getCereSections, METH_NOARGS,
    "get list of cereSection objects for this Cerenkov"},
   {"getCereTruthPoint", _Cerenkov_getCereTruthPoint, METH_VARARGS,
    "get an individual cereTruthPoint object from this Cerenkov"},
   {"getCereTruthPoints", _Cerenkov_getCereTruthPoints, METH_NOARGS,
    "get list of cereTruthPoint objects for this Cerenkov"},
   {"toString", _Cerenkov_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Cerenkov_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Cerenkov_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Cerenkov",         /*tp_name*/
    sizeof(_Cerenkov),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Cerenkov_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Cerenkov_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s Cerenkov element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Cerenkov_methods,          /* tp_methods */
    _Cerenkov_members,          /* tp_members */
    _Cerenkov_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Cerenkov_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Cerenkov_new,              /* tp_new */
};



// wrap element class hddm_s::RichTruthHit as hddm_s.RichTruthHit

typedef struct {
   PyObject_HEAD
   RichTruthHit *elem;
   PyObject *host;
} _RichTruthHit;

static void
_RichTruthHit_dealloc(_RichTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_RichTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _RichTruthHit *self;
   self = (_RichTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_RichTruthHit_init(_RichTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_RichTruthHit_getClass(_RichTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthHit_getVersion(_RichTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_RichTruthHit_getXmlns(_RichTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthHit_getEventNo(_RichTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_RichTruthHit_getRunNo(_RichTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_RichTruthHit_getMaxOccurs(_RichTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthHit_getMinOccurs(_RichTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_RichTruthHit_getT(_RichTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_RichTruthHit_setT(_RichTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_RichTruthHit_getX(_RichTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_RichTruthHit_setX(_RichTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_RichTruthHit_getY(_RichTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_RichTruthHit_setY(_RichTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_RichTruthHit_getZ(_RichTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_RichTruthHit_setZ(_RichTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_RichTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _RichTruthHit *me = (_RichTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_RichTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _RichTruthHit *me = (_RichTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _RichTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_RichTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_RichTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_RichTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_RichTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_RichTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_RichTruthHit_getT, (setter)_RichTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_RichTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_RichTruthHit_getX, (setter)_RichTruthHit_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_RichTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_RichTruthHit_getY, (setter)_RichTruthHit_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_RichTruthHit_getZ, (setter)_RichTruthHit_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _RichTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _RichTruthHit_methods[] = {
   {"toString", _RichTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _RichTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _RichTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.RichTruthHit",         /*tp_name*/
    sizeof(_RichTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_RichTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_RichTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s richTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _RichTruthHit_methods,          /* tp_methods */
    _RichTruthHit_members,          /* tp_members */
    _RichTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_RichTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _RichTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::RichTruthPoint as hddm_s.RichTruthPoint

typedef struct {
   PyObject_HEAD
   RichTruthPoint *elem;
   PyObject *host;
} _RichTruthPoint;

static void
_RichTruthPoint_dealloc(_RichTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_RichTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _RichTruthPoint *self;
   self = (_RichTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_RichTruthPoint_init(_RichTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_RichTruthPoint_getClass(_RichTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthPoint_getVersion(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_RichTruthPoint_getXmlns(_RichTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthPoint_getEventNo(_RichTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_RichTruthPoint_getRunNo(_RichTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_RichTruthPoint_getE(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_RichTruthPoint_setE(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getMaxOccurs(_RichTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RichTruthPoint_getMinOccurs(_RichTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_RichTruthPoint_getPrimary(_RichTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_RichTruthPoint_setPrimary(_RichTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_RichTruthPoint_getPtype(_RichTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_RichTruthPoint_setPtype(_RichTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_RichTruthPoint_getPx(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_RichTruthPoint_setPx(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getPy(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_RichTruthPoint_setPy(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getPz(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_RichTruthPoint_setPz(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getT(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_RichTruthPoint_setT(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getTrack(_RichTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_RichTruthPoint_setTrack(_RichTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_RichTruthPoint_getX(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_RichTruthPoint_setX(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getY(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_RichTruthPoint_setY(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getZ(_RichTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_RichTruthPoint_setZ(_RichTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_RichTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_RichTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_RichTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_RichTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid richTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_RichTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_RichTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_RichTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid richTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_RichTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid richTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_RichTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_RichTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _RichTruthPoint *me = (_RichTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid richTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _RichTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_RichTruthPoint_getE, (setter)_RichTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_RichTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_RichTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_RichTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_RichTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_RichTruthPoint_getPrimary, (setter)_RichTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_RichTruthPoint_getPtype, (setter)_RichTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_RichTruthPoint_getPx, (setter)_RichTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_RichTruthPoint_getPy, (setter)_RichTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_RichTruthPoint_getPz, (setter)_RichTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_RichTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_RichTruthPoint_getT, (setter)_RichTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_RichTruthPoint_getTrack, (setter)_RichTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_RichTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_RichTruthPoint_getX, (setter)_RichTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_RichTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_RichTruthPoint_getY, (setter)_RichTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_RichTruthPoint_getZ, (setter)_RichTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _RichTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _RichTruthPoint_methods[] = {
   {"addTrackIDs", _RichTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this richTruthPoint"},
   {"addTrackOrigins", _RichTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this richTruthPoint"},
   {"deleteTrackIDs", _RichTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this richTruthPoint"},
   {"deleteTrackOrigins", _RichTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this richTruthPoint"},
   {"getTrackID", _RichTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this richTruthPoint"},
   {"getTrackIDs", _RichTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this richTruthPoint"},
   {"getTrackOrigin", _RichTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this richTruthPoint"},
   {"getTrackOrigins", _RichTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this richTruthPoint"},
   {"toString", _RichTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _RichTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _RichTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.RichTruthPoint",         /*tp_name*/
    sizeof(_RichTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_RichTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_RichTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s richTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _RichTruthPoint_methods,          /* tp_methods */
    _RichTruthPoint_members,          /* tp_members */
    _RichTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_RichTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _RichTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::RICH as hddm_s.RICH

typedef struct {
   PyObject_HEAD
   RICH *elem;
   PyObject *host;
} _RICH;

static void
_RICH_dealloc(_RICH* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_RICH_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _RICH *self;
   self = (_RICH*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_RICH_init(_RICH *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_RICH_getClass(_RICH *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RICH_getVersion(_RICH *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_RICH_getXmlns(_RICH *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RICH_getEventNo(_RICH *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_RICH_getMaxOccurs(_RICH *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RICH_getRunNo(_RICH *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_RICH_getMinOccurs(_RICH *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_RICH_getRichTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   PyObject *obj = _RichTruthHit_new(&_RichTruthHit_type, 0, 0);
   ((_RichTruthHit*)obj)->elem = &me->elem->getRichTruthHit(index);
   ((_RichTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_RICH_getRichTruthHits(PyObject *self, PyObject *args)
{
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRichTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_RICH_addRichTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid RICH element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RichTruthHitList(me->elem->addRichTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_RICH_deleteRichTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid RICH element");
      return NULL;
   }
   me->elem->deleteRichTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_RICH_getRichTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   PyObject *obj = _RichTruthPoint_new(&_RichTruthPoint_type, 0, 0);
   ((_RichTruthPoint*)obj)->elem = &me->elem->getRichTruthPoint(index);
   ((_RichTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_RICH_getRichTruthPoints(PyObject *self, PyObject *args)
{
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRichTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_RICH_addRichTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid RICH element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RichTruthPointList(me->elem->addRichTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_RICH_deleteRichTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid RICH element");
      return NULL;
   }
   me->elem->deleteRichTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_RICH_toString(PyObject *self, PyObject *args=0)
{
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_RICH_toXML(PyObject *self, PyObject *args=0)
{
   _RICH *me = (_RICH*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RICH element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _RICH_getsetters[] = {
   {(char*)"class",
    (getter)_RICH_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_RICH_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_RICH_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_RICH_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_RICH_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_RICH_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_RICH_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _RICH_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _RICH_methods[] = {
   {"addRichTruthHits", _RICH_addRichTruthHits, METH_VARARGS,
    "extend (or insert into) the list of richTruthHit objects for this RICH"},
   {"addRichTruthPoints", _RICH_addRichTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of richTruthPoint objects for this RICH"},
   {"deleteRichTruthHits", _RICH_deleteRichTruthHits, METH_VARARGS,
    "delete richTruthHit objects for this RICH"},
   {"deleteRichTruthPoints", _RICH_deleteRichTruthPoints, METH_VARARGS,
    "delete richTruthPoint objects for this RICH"},
   {"getRichTruthHit", _RICH_getRichTruthHit, METH_VARARGS,
    "get an individual richTruthHit object from this RICH"},
   {"getRichTruthHits", _RICH_getRichTruthHits, METH_NOARGS,
    "get list of richTruthHit objects for this RICH"},
   {"getRichTruthPoint", _RICH_getRichTruthPoint, METH_VARARGS,
    "get an individual richTruthPoint object from this RICH"},
   {"getRichTruthPoints", _RICH_getRichTruthPoints, METH_NOARGS,
    "get list of richTruthPoint objects for this RICH"},
   {"toString", _RICH_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _RICH_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _RICH_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.RICH",         /*tp_name*/
    sizeof(_RICH),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_RICH_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_RICH_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s RICH element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _RICH_methods,          /* tp_methods */
    _RICH_members,          /* tp_members */
    _RICH_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_RICH_init,   /* tp_init */
    0,                         /* tp_alloc */
    _RICH_new,              /* tp_new */
};



// wrap element class hddm_s::DircTruthBarHit as hddm_s.DircTruthBarHit

typedef struct {
   PyObject_HEAD
   DircTruthBarHit *elem;
   PyObject *host;
} _DircTruthBarHit;

static void
_DircTruthBarHit_dealloc(_DircTruthBarHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DircTruthBarHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DircTruthBarHit *self;
   self = (_DircTruthBarHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DircTruthBarHit_init(_DircTruthBarHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DircTruthBarHit_getClass(_DircTruthBarHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthBarHit_getVersion(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DircTruthBarHit_getXmlns(_DircTruthBarHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthBarHit_getEventNo(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DircTruthBarHit_getRunNo(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DircTruthBarHit_getE(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_DircTruthBarHit_setE(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getBar(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static int
_DircTruthBarHit_setBar(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setBar(var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getMaxOccurs(_DircTruthBarHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthBarHit_getMinOccurs(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DircTruthBarHit_getPdg(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPdg());
}

static int
_DircTruthBarHit_setPdg(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPdg(var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getPx(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_DircTruthBarHit_setPx(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getPy(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_DircTruthBarHit_setPy(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getPz(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_DircTruthBarHit_setPz(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getT(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_DircTruthBarHit_setT(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getTrack(_DircTruthBarHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_DircTruthBarHit_setTrack(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getX(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_DircTruthBarHit_setX(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getY(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_DircTruthBarHit_setY(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_getZ(_DircTruthBarHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_DircTruthBarHit_setZ(_DircTruthBarHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_DircTruthBarHit_toString(PyObject *self, PyObject *args=0)
{
   _DircTruthBarHit *me = (_DircTruthBarHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthBarHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DircTruthBarHit_toXML(PyObject *self, PyObject *args=0)
{
   _DircTruthBarHit *me = (_DircTruthBarHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthBarHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DircTruthBarHit_getsetters[] = {
   {(char*)"E",
    (getter)_DircTruthBarHit_getE, (setter)_DircTruthBarHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"bar",
    (getter)_DircTruthBarHit_getBar, (setter)_DircTruthBarHit_setBar,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_DircTruthBarHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DircTruthBarHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DircTruthBarHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_DircTruthBarHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"pdg",
    (getter)_DircTruthBarHit_getPdg, (setter)_DircTruthBarHit_setPdg,
    (char*)"pdg value",
    NULL},
   {(char*)"px",
    (getter)_DircTruthBarHit_getPx, (setter)_DircTruthBarHit_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_DircTruthBarHit_getPy, (setter)_DircTruthBarHit_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_DircTruthBarHit_getPz, (setter)_DircTruthBarHit_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_DircTruthBarHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_DircTruthBarHit_getT, (setter)_DircTruthBarHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_DircTruthBarHit_getTrack, (setter)_DircTruthBarHit_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_DircTruthBarHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_DircTruthBarHit_getX, (setter)_DircTruthBarHit_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_DircTruthBarHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_DircTruthBarHit_getY, (setter)_DircTruthBarHit_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_DircTruthBarHit_getZ, (setter)_DircTruthBarHit_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DircTruthBarHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DircTruthBarHit_methods[] = {
   {"toString", _DircTruthBarHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DircTruthBarHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DircTruthBarHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DircTruthBarHit",         /*tp_name*/
    sizeof(_DircTruthBarHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DircTruthBarHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DircTruthBarHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s dircTruthBarHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DircTruthBarHit_methods,          /* tp_methods */
    _DircTruthBarHit_members,          /* tp_members */
    _DircTruthBarHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DircTruthBarHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DircTruthBarHit_new,              /* tp_new */
};



// wrap element class hddm_s::DircTruthPmtHitExtra as hddm_s.DircTruthPmtHitExtra

typedef struct {
   PyObject_HEAD
   DircTruthPmtHitExtra *elem;
   PyObject *host;
} _DircTruthPmtHitExtra;

static void
_DircTruthPmtHitExtra_dealloc(_DircTruthPmtHitExtra* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DircTruthPmtHitExtra_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DircTruthPmtHitExtra *self;
   self = (_DircTruthPmtHitExtra*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DircTruthPmtHitExtra_init(_DircTruthPmtHitExtra *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DircTruthPmtHitExtra_getClass(_DircTruthPmtHitExtra *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHitExtra_getVersion(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DircTruthPmtHitExtra_getXmlns(_DircTruthPmtHitExtra *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHitExtra_getEventNo(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DircTruthPmtHitExtra_getRunNo(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DircTruthPmtHitExtra_getE(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_DircTruthPmtHitExtra_getCh(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCh());
}

static PyObject*
_DircTruthPmtHitExtra_getKey_bar(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getKey_bar());
}

static PyObject*
_DircTruthPmtHitExtra_getT(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_DircTruthPmtHitExtra_getX(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static PyObject*
_DircTruthPmtHitExtra_getY(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static PyObject*
_DircTruthPmtHitExtra_getZ(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static PyObject*
_DircTruthPmtHitExtra_getBbrefl(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyBool_FromLong(self->elem->getBbrefl());
}

static int
_DircTruthPmtHitExtra_setBbrefl(_DircTruthPmtHitExtra *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setBbrefl((var==0)? false : true);
   return 0;
}

static PyObject*
_DircTruthPmtHitExtra_getMaxOccurs(_DircTruthPmtHitExtra *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHitExtra_getMinOccurs(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DircTruthPmtHitExtra_getPath(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLongLong(self->elem->getPath());
}

static int
_DircTruthPmtHitExtra_setPath(_DircTruthPmtHitExtra *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPath(var);
   return 0;
}

static PyObject*
_DircTruthPmtHitExtra_getRefl(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRefl());
}

static int
_DircTruthPmtHitExtra_setRefl(_DircTruthPmtHitExtra *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRefl(var);
   return 0;
}

static PyObject*
_DircTruthPmtHitExtra_getT_fixed(_DircTruthPmtHitExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT_fixed());
}

static int
_DircTruthPmtHitExtra_setT_fixed(_DircTruthPmtHitExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT_fixed((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHitExtra_toString(PyObject *self, PyObject *args=0)
{
   _DircTruthPmtHitExtra *me = (_DircTruthPmtHitExtra*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHitExtra element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DircTruthPmtHitExtra_toXML(PyObject *self, PyObject *args=0)
{
   _DircTruthPmtHitExtra *me = (_DircTruthPmtHitExtra*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHitExtra element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DircTruthPmtHitExtra_getsetters[] = {
   {(char*)"E",
    (getter)_DircTruthPmtHitExtra_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"bbrefl",
    (getter)_DircTruthPmtHitExtra_getBbrefl, (setter)_DircTruthPmtHitExtra_setBbrefl,
    (char*)"bbrefl value",
    NULL},
   {(char*)"ch",
    (getter)_DircTruthPmtHitExtra_getCh, 0,
    (char*)"ch value",
    NULL},
   {(char*)"class",
    (getter)_DircTruthPmtHitExtra_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DircTruthPmtHitExtra_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"key_bar",
    (getter)_DircTruthPmtHitExtra_getKey_bar, 0,
    (char*)"key_bar value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DircTruthPmtHitExtra_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_DircTruthPmtHitExtra_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"path",
    (getter)_DircTruthPmtHitExtra_getPath, (setter)_DircTruthPmtHitExtra_setPath,
    (char*)"path value",
    NULL},
   {(char*)"refl",
    (getter)_DircTruthPmtHitExtra_getRefl, (setter)_DircTruthPmtHitExtra_setRefl,
    (char*)"refl value",
    NULL},
   {(char*)"runNo",
    (getter)_DircTruthPmtHitExtra_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_DircTruthPmtHitExtra_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"t_fixed",
    (getter)_DircTruthPmtHitExtra_getT_fixed, (setter)_DircTruthPmtHitExtra_setT_fixed,
    (char*)"t_fixed value",
    NULL},
   {(char*)"version",
    (getter)_DircTruthPmtHitExtra_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_DircTruthPmtHitExtra_getX, 0,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_DircTruthPmtHitExtra_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_DircTruthPmtHitExtra_getY, 0,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_DircTruthPmtHitExtra_getZ, 0,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DircTruthPmtHitExtra_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DircTruthPmtHitExtra_methods[] = {
   {"toString", _DircTruthPmtHitExtra_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DircTruthPmtHitExtra_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DircTruthPmtHitExtra_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DircTruthPmtHitExtra",         /*tp_name*/
    sizeof(_DircTruthPmtHitExtra),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DircTruthPmtHitExtra_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DircTruthPmtHitExtra_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s dircTruthPmtHitExtra element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DircTruthPmtHitExtra_methods,          /* tp_methods */
    _DircTruthPmtHitExtra_members,          /* tp_members */
    _DircTruthPmtHitExtra_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DircTruthPmtHitExtra_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DircTruthPmtHitExtra_new,              /* tp_new */
};



// wrap element class hddm_s::DircTruthPmtHit as hddm_s.DircTruthPmtHit

typedef struct {
   PyObject_HEAD
   DircTruthPmtHit *elem;
   PyObject *host;
} _DircTruthPmtHit;

static void
_DircTruthPmtHit_dealloc(_DircTruthPmtHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DircTruthPmtHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DircTruthPmtHit *self;
   self = (_DircTruthPmtHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DircTruthPmtHit_init(_DircTruthPmtHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DircTruthPmtHit_getClass(_DircTruthPmtHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHit_getVersion(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DircTruthPmtHit_getXmlns(_DircTruthPmtHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHit_getEventNo(_DircTruthPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DircTruthPmtHit_getRunNo(_DircTruthPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DircTruthPmtHit_getE(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_DircTruthPmtHit_setE(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getCh(_DircTruthPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCh());
}

static int
_DircTruthPmtHit_setCh(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setCh(var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getKey_bar(_DircTruthPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getKey_bar());
}

static int
_DircTruthPmtHit_setKey_bar(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setKey_bar(var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getMaxOccurs(_DircTruthPmtHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircTruthPmtHit_getMinOccurs(_DircTruthPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DircTruthPmtHit_getT(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_DircTruthPmtHit_setT(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getX(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_DircTruthPmtHit_setX(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getY(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_DircTruthPmtHit_setY(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getZ(_DircTruthPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_DircTruthPmtHit_setZ(_DircTruthPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_DircTruthPmtHit_getDircTruthPmtHitExtra(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   PyObject *obj = _DircTruthPmtHitExtra_new(&_DircTruthPmtHitExtra_type, 0, 0);
   ((_DircTruthPmtHitExtra*)obj)->elem = &me->elem->getDircTruthPmtHitExtra(index);
   ((_DircTruthPmtHitExtra*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_DircTruthPmtHit_getDircTruthPmtHitExtras(PyObject *self, PyObject *args)
{
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHitExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDircTruthPmtHitExtras();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_DircTruthPmtHit_addDircTruthPmtHitExtras(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHitExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthPmtHitExtraList(me->elem->addDircTruthPmtHitExtras(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_DircTruthPmtHit_deleteDircTruthPmtHitExtras(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   me->elem->deleteDircTruthPmtHitExtras(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_DircTruthPmtHit_toString(PyObject *self, PyObject *args=0)
{
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DircTruthPmtHit_toXML(PyObject *self, PyObject *args=0)
{
   _DircTruthPmtHit *me = (_DircTruthPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircTruthPmtHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DircTruthPmtHit_getsetters[] = {
   {(char*)"E",
    (getter)_DircTruthPmtHit_getE, (setter)_DircTruthPmtHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"ch",
    (getter)_DircTruthPmtHit_getCh, (setter)_DircTruthPmtHit_setCh,
    (char*)"ch value",
    NULL},
   {(char*)"class",
    (getter)_DircTruthPmtHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DircTruthPmtHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"key_bar",
    (getter)_DircTruthPmtHit_getKey_bar, (setter)_DircTruthPmtHit_setKey_bar,
    (char*)"key_bar value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DircTruthPmtHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_DircTruthPmtHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_DircTruthPmtHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_DircTruthPmtHit_getT, (setter)_DircTruthPmtHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_DircTruthPmtHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_DircTruthPmtHit_getX, (setter)_DircTruthPmtHit_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_DircTruthPmtHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_DircTruthPmtHit_getY, (setter)_DircTruthPmtHit_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_DircTruthPmtHit_getZ, (setter)_DircTruthPmtHit_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DircTruthPmtHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DircTruthPmtHit_methods[] = {
   {"addDircTruthPmtHitExtras", _DircTruthPmtHit_addDircTruthPmtHitExtras, METH_VARARGS,
    "extend (or insert into) the list of dircTruthPmtHitExtra objects for this dircTruthPmtHit"},
   {"deleteDircTruthPmtHitExtras", _DircTruthPmtHit_deleteDircTruthPmtHitExtras, METH_VARARGS,
    "delete dircTruthPmtHitExtra objects for this dircTruthPmtHit"},
   {"getDircTruthPmtHitExtra", _DircTruthPmtHit_getDircTruthPmtHitExtra, METH_VARARGS,
    "get an individual dircTruthPmtHitExtra object from this dircTruthPmtHit"},
   {"getDircTruthPmtHitExtras", _DircTruthPmtHit_getDircTruthPmtHitExtras, METH_NOARGS,
    "get list of dircTruthPmtHitExtra objects for this dircTruthPmtHit"},
   {"toString", _DircTruthPmtHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DircTruthPmtHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DircTruthPmtHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DircTruthPmtHit",         /*tp_name*/
    sizeof(_DircTruthPmtHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DircTruthPmtHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DircTruthPmtHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s dircTruthPmtHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DircTruthPmtHit_methods,          /* tp_methods */
    _DircTruthPmtHit_members,          /* tp_members */
    _DircTruthPmtHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DircTruthPmtHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DircTruthPmtHit_new,              /* tp_new */
};



// wrap element class hddm_s::DircPmtHit as hddm_s.DircPmtHit

typedef struct {
   PyObject_HEAD
   DircPmtHit *elem;
   PyObject *host;
} _DircPmtHit;

static void
_DircPmtHit_dealloc(_DircPmtHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DircPmtHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DircPmtHit *self;
   self = (_DircPmtHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DircPmtHit_init(_DircPmtHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DircPmtHit_getClass(_DircPmtHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircPmtHit_getVersion(_DircPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DircPmtHit_getXmlns(_DircPmtHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircPmtHit_getEventNo(_DircPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DircPmtHit_getRunNo(_DircPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DircPmtHit_getCh(_DircPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCh());
}

static int
_DircPmtHit_setCh(_DircPmtHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setCh(var);
   return 0;
}

static PyObject*
_DircPmtHit_getMaxOccurs(_DircPmtHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DircPmtHit_getMinOccurs(_DircPmtHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DircPmtHit_getT(_DircPmtHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_DircPmtHit_setT(_DircPmtHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_DircPmtHit_toString(PyObject *self, PyObject *args=0)
{
   _DircPmtHit *me = (_DircPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircPmtHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DircPmtHit_toXML(PyObject *self, PyObject *args=0)
{
   _DircPmtHit *me = (_DircPmtHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid dircPmtHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DircPmtHit_getsetters[] = {
   {(char*)"ch",
    (getter)_DircPmtHit_getCh, (setter)_DircPmtHit_setCh,
    (char*)"ch value",
    NULL},
   {(char*)"class",
    (getter)_DircPmtHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DircPmtHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DircPmtHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_DircPmtHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_DircPmtHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_DircPmtHit_getT, (setter)_DircPmtHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_DircPmtHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_DircPmtHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DircPmtHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DircPmtHit_methods[] = {
   {"toString", _DircPmtHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DircPmtHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DircPmtHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DircPmtHit",         /*tp_name*/
    sizeof(_DircPmtHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DircPmtHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DircPmtHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s dircPmtHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DircPmtHit_methods,          /* tp_methods */
    _DircPmtHit_members,          /* tp_members */
    _DircPmtHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DircPmtHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DircPmtHit_new,              /* tp_new */
};



// wrap element class hddm_s::DIRC as hddm_s.DIRC

typedef struct {
   PyObject_HEAD
   DIRC *elem;
   PyObject *host;
} _DIRC;

static void
_DIRC_dealloc(_DIRC* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_DIRC_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _DIRC *self;
   self = (_DIRC*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_DIRC_init(_DIRC *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_DIRC_getClass(_DIRC *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DIRC_getVersion(_DIRC *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_DIRC_getXmlns(_DIRC *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DIRC_getEventNo(_DIRC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_DIRC_getMaxOccurs(_DIRC *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_DIRC_getRunNo(_DIRC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_DIRC_getMinOccurs(_DIRC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_DIRC_getDircTruthBarHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *obj = _DircTruthBarHit_new(&_DircTruthBarHit_type, 0, 0);
   ((_DircTruthBarHit*)obj)->elem = &me->elem->getDircTruthBarHit(index);
   ((_DircTruthBarHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_DIRC_getDircTruthBarHits(PyObject *self, PyObject *args)
{
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthBarHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDircTruthBarHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_DIRC_addDircTruthBarHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthBarHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthBarHitList(me->elem->addDircTruthBarHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_DIRC_deleteDircTruthBarHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid DIRC element");
      return NULL;
   }
   me->elem->deleteDircTruthBarHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_DIRC_getDircTruthPmtHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *obj = _DircTruthPmtHit_new(&_DircTruthPmtHit_type, 0, 0);
   ((_DircTruthPmtHit*)obj)->elem = &me->elem->getDircTruthPmtHit(index);
   ((_DircTruthPmtHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_DIRC_getDircTruthPmtHits(PyObject *self, PyObject *args)
{
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDircTruthPmtHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_DIRC_addDircTruthPmtHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthPmtHitList(me->elem->addDircTruthPmtHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_DIRC_deleteDircTruthPmtHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid DIRC element");
      return NULL;
   }
   me->elem->deleteDircTruthPmtHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_DIRC_getDircPmtHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *obj = _DircPmtHit_new(&_DircPmtHit_type, 0, 0);
   ((_DircPmtHit*)obj)->elem = &me->elem->getDircPmtHit(index);
   ((_DircPmtHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_DIRC_getDircPmtHits(PyObject *self, PyObject *args)
{
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDircPmtHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_DIRC_addDircPmtHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid DIRC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircPmtHitList(me->elem->addDircPmtHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_DIRC_deleteDircPmtHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid DIRC element");
      return NULL;
   }
   me->elem->deleteDircPmtHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_DIRC_toString(PyObject *self, PyObject *args=0)
{
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_DIRC_toXML(PyObject *self, PyObject *args=0)
{
   _DIRC *me = (_DIRC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid DIRC element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _DIRC_getsetters[] = {
   {(char*)"class",
    (getter)_DIRC_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_DIRC_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_DIRC_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_DIRC_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_DIRC_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_DIRC_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_DIRC_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _DIRC_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _DIRC_methods[] = {
   {"addDircPmtHits", _DIRC_addDircPmtHits, METH_VARARGS,
    "extend (or insert into) the list of dircPmtHit objects for this DIRC"},
   {"addDircTruthBarHits", _DIRC_addDircTruthBarHits, METH_VARARGS,
    "extend (or insert into) the list of dircTruthBarHit objects for this DIRC"},
   {"addDircTruthPmtHits", _DIRC_addDircTruthPmtHits, METH_VARARGS,
    "extend (or insert into) the list of dircTruthPmtHit objects for this DIRC"},
   {"deleteDircPmtHits", _DIRC_deleteDircPmtHits, METH_VARARGS,
    "delete dircPmtHit objects for this DIRC"},
   {"deleteDircTruthBarHits", _DIRC_deleteDircTruthBarHits, METH_VARARGS,
    "delete dircTruthBarHit objects for this DIRC"},
   {"deleteDircTruthPmtHits", _DIRC_deleteDircTruthPmtHits, METH_VARARGS,
    "delete dircTruthPmtHit objects for this DIRC"},
   {"getDircPmtHit", _DIRC_getDircPmtHit, METH_VARARGS,
    "get an individual dircPmtHit object from this DIRC"},
   {"getDircPmtHits", _DIRC_getDircPmtHits, METH_NOARGS,
    "get list of dircPmtHit objects for this DIRC"},
   {"getDircTruthBarHit", _DIRC_getDircTruthBarHit, METH_VARARGS,
    "get an individual dircTruthBarHit object from this DIRC"},
   {"getDircTruthBarHits", _DIRC_getDircTruthBarHits, METH_NOARGS,
    "get list of dircTruthBarHit objects for this DIRC"},
   {"getDircTruthPmtHit", _DIRC_getDircTruthPmtHit, METH_VARARGS,
    "get an individual dircTruthPmtHit object from this DIRC"},
   {"getDircTruthPmtHits", _DIRC_getDircTruthPmtHits, METH_NOARGS,
    "get list of dircTruthPmtHit objects for this DIRC"},
   {"toString", _DIRC_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _DIRC_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _DIRC_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.DIRC",         /*tp_name*/
    sizeof(_DIRC),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_DIRC_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_DIRC_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s DIRC element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _DIRC_methods,          /* tp_methods */
    _DIRC_members,          /* tp_members */
    _DIRC_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_DIRC_init,   /* tp_init */
    0,                         /* tp_alloc */
    _DIRC_new,              /* tp_new */
};



// wrap element class hddm_s::FtofDigihit as hddm_s.FtofDigihit

typedef struct {
   PyObject_HEAD
   FtofDigihit *elem;
   PyObject *host;
} _FtofDigihit;

static void
_FtofDigihit_dealloc(_FtofDigihit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofDigihit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofDigihit *self;
   self = (_FtofDigihit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofDigihit_init(_FtofDigihit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofDigihit_getClass(_FtofDigihit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofDigihit_getVersion(_FtofDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofDigihit_getXmlns(_FtofDigihit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofDigihit_getEventNo(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofDigihit_getMaxOccurs(_FtofDigihit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofDigihit_getRunNo(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofDigihit_getBar(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_FtofDigihit_getPlane(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FtofDigihit_getDE(_FtofDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static PyObject*
_FtofDigihit_getEnd(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static PyObject*
_FtofDigihit_getT(_FtofDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FtofDigihit_getMinOccurs(_FtofDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofDigihit_getPeakAmp(_FtofDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPeakAmp());
}

static int
_FtofDigihit_setPeakAmp(_FtofDigihit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPeakAmp((float)var);
   return 0;
}

static PyObject*
_FtofDigihit_toString(PyObject *self, PyObject *args=0)
{
   _FtofDigihit *me = (_FtofDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofDigihit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofDigihit_toXML(PyObject *self, PyObject *args=0)
{
   _FtofDigihit *me = (_FtofDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofDigihit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofDigihit_getsetters[] = {
   {(char*)"bar",
    (getter)_FtofDigihit_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_FtofDigihit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FtofDigihit_getDE, 0,
    (char*)"dE value",
    NULL},
   {(char*)"end",
    (getter)_FtofDigihit_getEnd, 0,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofDigihit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofDigihit_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofDigihit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"peakAmp",
    (getter)_FtofDigihit_getPeakAmp, (setter)_FtofDigihit_setPeakAmp,
    (char*)"peakAmp value",
    NULL},
   {(char*)"plane",
    (getter)_FtofDigihit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofDigihit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FtofDigihit_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FtofDigihit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofDigihit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofDigihit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofDigihit_methods[] = {
   {"toString", _FtofDigihit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofDigihit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofDigihit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofDigihit",         /*tp_name*/
    sizeof(_FtofDigihit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofDigihit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofDigihit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofDigihit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofDigihit_methods,          /* tp_methods */
    _FtofDigihit_members,          /* tp_members */
    _FtofDigihit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofDigihit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofDigihit_new,              /* tp_new */
};



// wrap element class hddm_s::FtofHit as hddm_s.FtofHit

typedef struct {
   PyObject_HEAD
   FtofHit *elem;
   PyObject *host;
} _FtofHit;

static void
_FtofHit_dealloc(_FtofHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofHit *self;
   self = (_FtofHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofHit_init(_FtofHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofHit_getClass(_FtofHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofHit_getVersion(_FtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofHit_getXmlns(_FtofHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofHit_getEventNo(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofHit_getRunNo(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofHit_getBar(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_FtofHit_getPlane(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FtofHit_getDE(_FtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FtofHit_setDE(_FtofHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FtofHit_getEnd(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_FtofHit_setEnd(_FtofHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_FtofHit_getMaxOccurs(_FtofHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofHit_getMinOccurs(_FtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofHit_getT(_FtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FtofHit_setT(_FtofHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FtofHit_getFtofDigihit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofHit element");
      return NULL;
   }
   PyObject *obj = _FtofDigihit_new(&_FtofDigihit_type, 0, 0);
   ((_FtofDigihit*)obj)->elem = &me->elem->getFtofDigihit();
   ((_FtofDigihit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofHit_getFtofDigihits(PyObject *self, PyObject *args)
{
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofDigihits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofHit_addFtofDigihits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofDigihitList(me->elem->addFtofDigihits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofHit_deleteFtofDigihits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofHit element");
      return NULL;
   }
   me->elem->deleteFtofDigihits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofHit_toString(PyObject *self, PyObject *args=0)
{
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofHit_toXML(PyObject *self, PyObject *args=0)
{
   _FtofHit *me = (_FtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofHit_getsetters[] = {
   {(char*)"bar",
    (getter)_FtofHit_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_FtofHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FtofHit_getDE, (setter)_FtofHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"end",
    (getter)_FtofHit_getEnd, (setter)_FtofHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"plane",
    (getter)_FtofHit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FtofHit_getT, (setter)_FtofHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FtofHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofHit_methods[] = {
   {"addFtofDigihits", _FtofHit_addFtofDigihits, METH_VARARGS,
    "extend (or insert into) the list of ftofDigihit objects for this ftofHit"},
   {"deleteFtofDigihits", _FtofHit_deleteFtofDigihits, METH_VARARGS,
    "delete ftofDigihit objects for this ftofHit"},
   {"getFtofDigihit", _FtofHit_getFtofDigihit, METH_VARARGS,
    "get an individual ftofDigihit object from this ftofHit"},
   {"getFtofDigihits", _FtofHit_getFtofDigihits, METH_NOARGS,
    "get list of ftofDigihit objects for this ftofHit"},
   {"toString", _FtofHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofHit",         /*tp_name*/
    sizeof(_FtofHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofHit_methods,          /* tp_methods */
    _FtofHit_members,          /* tp_members */
    _FtofHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofHit_new,              /* tp_new */
};



// wrap element class hddm_s::FtofTruthExtra as hddm_s.FtofTruthExtra

typedef struct {
   PyObject_HEAD
   FtofTruthExtra *elem;
   PyObject *host;
} _FtofTruthExtra;

static void
_FtofTruthExtra_dealloc(_FtofTruthExtra* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofTruthExtra_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofTruthExtra *self;
   self = (_FtofTruthExtra*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofTruthExtra_init(_FtofTruthExtra *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofTruthExtra_getClass(_FtofTruthExtra *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthExtra_getVersion(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofTruthExtra_getXmlns(_FtofTruthExtra *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthExtra_getEventNo(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofTruthExtra_getRunNo(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofTruthExtra_getBar(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_FtofTruthExtra_getPlane(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FtofTruthExtra_getDE(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static PyObject*
_FtofTruthExtra_getEnd(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static PyObject*
_FtofTruthExtra_getT(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FtofTruthExtra_getE(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FtofTruthExtra_setE(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getDist(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDist());
}

static int
_FtofTruthExtra_setDist(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDist((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getItrack(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_FtofTruthExtra_setItrack(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getMaxOccurs(_FtofTruthExtra *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthExtra_getMinOccurs(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofTruthExtra_getPtype(_FtofTruthExtra *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FtofTruthExtra_setPtype(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getPx(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_FtofTruthExtra_setPx(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getPy(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_FtofTruthExtra_setPy(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getPz(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_FtofTruthExtra_setPz(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getX(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_FtofTruthExtra_setX(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getY(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_FtofTruthExtra_setY(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_getZ(_FtofTruthExtra *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_FtofTruthExtra_setZ(_FtofTruthExtra *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_FtofTruthExtra_toString(PyObject *self, PyObject *args=0)
{
   _FtofTruthExtra *me = (_FtofTruthExtra*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthExtra element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofTruthExtra_toXML(PyObject *self, PyObject *args=0)
{
   _FtofTruthExtra *me = (_FtofTruthExtra*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthExtra element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofTruthExtra_getsetters[] = {
   {(char*)"E",
    (getter)_FtofTruthExtra_getE, (setter)_FtofTruthExtra_setE,
    (char*)"E value",
    NULL},
   {(char*)"bar",
    (getter)_FtofTruthExtra_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_FtofTruthExtra_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FtofTruthExtra_getDE, 0,
    (char*)"dE value",
    NULL},
   {(char*)"dist",
    (getter)_FtofTruthExtra_getDist, (setter)_FtofTruthExtra_setDist,
    (char*)"dist value",
    NULL},
   {(char*)"end",
    (getter)_FtofTruthExtra_getEnd, 0,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofTruthExtra_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_FtofTruthExtra_getItrack, (setter)_FtofTruthExtra_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofTruthExtra_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofTruthExtra_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"plane",
    (getter)_FtofTruthExtra_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"ptype",
    (getter)_FtofTruthExtra_getPtype, (setter)_FtofTruthExtra_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_FtofTruthExtra_getPx, (setter)_FtofTruthExtra_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_FtofTruthExtra_getPy, (setter)_FtofTruthExtra_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_FtofTruthExtra_getPz, (setter)_FtofTruthExtra_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofTruthExtra_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FtofTruthExtra_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FtofTruthExtra_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_FtofTruthExtra_getX, (setter)_FtofTruthExtra_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofTruthExtra_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_FtofTruthExtra_getY, (setter)_FtofTruthExtra_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_FtofTruthExtra_getZ, (setter)_FtofTruthExtra_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofTruthExtra_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofTruthExtra_methods[] = {
   {"toString", _FtofTruthExtra_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofTruthExtra_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofTruthExtra_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofTruthExtra",         /*tp_name*/
    sizeof(_FtofTruthExtra),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofTruthExtra_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofTruthExtra_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofTruthExtra element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofTruthExtra_methods,          /* tp_methods */
    _FtofTruthExtra_members,          /* tp_members */
    _FtofTruthExtra_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofTruthExtra_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofTruthExtra_new,              /* tp_new */
};



// wrap element class hddm_s::FtofTruthHit as hddm_s.FtofTruthHit

typedef struct {
   PyObject_HEAD
   FtofTruthHit *elem;
   PyObject *host;
} _FtofTruthHit;

static void
_FtofTruthHit_dealloc(_FtofTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofTruthHit *self;
   self = (_FtofTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofTruthHit_init(_FtofTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofTruthHit_getClass(_FtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthHit_getVersion(_FtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofTruthHit_getXmlns(_FtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthHit_getEventNo(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofTruthHit_getRunNo(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofTruthHit_getBar(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_FtofTruthHit_getPlane(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static PyObject*
_FtofTruthHit_getDE(_FtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FtofTruthHit_setDE(_FtofTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FtofTruthHit_getEnd(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_FtofTruthHit_setEnd(_FtofTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_FtofTruthHit_getMaxOccurs(_FtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthHit_getMinOccurs(_FtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofTruthHit_getT(_FtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FtofTruthHit_setT(_FtofTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FtofTruthHit_getFtofTruthExtra(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthHit element");
      return NULL;
   }
   PyObject *obj = _FtofTruthExtra_new(&_FtofTruthExtra_type, 0, 0);
   ((_FtofTruthExtra*)obj)->elem = &me->elem->getFtofTruthExtra(index);
   ((_FtofTruthExtra*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofTruthHit_getFtofTruthExtras(PyObject *self, PyObject *args)
{
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofTruthExtras();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofTruthHit_addFtofTruthExtras(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthExtraList(me->elem->addFtofTruthExtras(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofTruthHit_deleteFtofTruthExtras(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofTruthHit element");
      return NULL;
   }
   me->elem->deleteFtofTruthExtras(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _FtofTruthHit *me = (_FtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofTruthHit_getsetters[] = {
   {(char*)"bar",
    (getter)_FtofTruthHit_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_FtofTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FtofTruthHit_getDE, (setter)_FtofTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"end",
    (getter)_FtofTruthHit_getEnd, (setter)_FtofTruthHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"plane",
    (getter)_FtofTruthHit_getPlane, 0,
    (char*)"plane value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FtofTruthHit_getT, (setter)_FtofTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FtofTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofTruthHit_methods[] = {
   {"addFtofTruthExtras", _FtofTruthHit_addFtofTruthExtras, METH_VARARGS,
    "extend (or insert into) the list of ftofTruthExtra objects for this ftofTruthHit"},
   {"deleteFtofTruthExtras", _FtofTruthHit_deleteFtofTruthExtras, METH_VARARGS,
    "delete ftofTruthExtra objects for this ftofTruthHit"},
   {"getFtofTruthExtra", _FtofTruthHit_getFtofTruthExtra, METH_VARARGS,
    "get an individual ftofTruthExtra object from this ftofTruthHit"},
   {"getFtofTruthExtras", _FtofTruthHit_getFtofTruthExtras, METH_NOARGS,
    "get list of ftofTruthExtra objects for this ftofTruthHit"},
   {"toString", _FtofTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofTruthHit",         /*tp_name*/
    sizeof(_FtofTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofTruthHit_methods,          /* tp_methods */
    _FtofTruthHit_members,          /* tp_members */
    _FtofTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::FtofCounter as hddm_s.FtofCounter

typedef struct {
   PyObject_HEAD
   FtofCounter *elem;
   PyObject *host;
} _FtofCounter;

static void
_FtofCounter_dealloc(_FtofCounter* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofCounter_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofCounter *self;
   self = (_FtofCounter*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofCounter_init(_FtofCounter *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofCounter_getClass(_FtofCounter *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofCounter_getVersion(_FtofCounter *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofCounter_getXmlns(_FtofCounter *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofCounter_getEventNo(_FtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofCounter_getRunNo(_FtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofCounter_getBar(_FtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static int
_FtofCounter_setBar(_FtofCounter *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setBar(var);
   return 0;
}

static PyObject*
_FtofCounter_getMaxOccurs(_FtofCounter *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofCounter_getMinOccurs(_FtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofCounter_getPlane(_FtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPlane());
}

static int
_FtofCounter_setPlane(_FtofCounter *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPlane(var);
   return 0;
}

static PyObject*
_FtofCounter_getFtofHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *obj = _FtofHit_new(&_FtofHit_type, 0, 0);
   ((_FtofHit*)obj)->elem = &me->elem->getFtofHit(index);
   ((_FtofHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofCounter_getFtofHits(PyObject *self, PyObject *args)
{
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofCounter_addFtofHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofHitList(me->elem->addFtofHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofCounter_deleteFtofHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofCounter element");
      return NULL;
   }
   me->elem->deleteFtofHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofCounter_getFtofTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *obj = _FtofTruthHit_new(&_FtofTruthHit_type, 0, 0);
   ((_FtofTruthHit*)obj)->elem = &me->elem->getFtofTruthHit(index);
   ((_FtofTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofCounter_getFtofTruthHits(PyObject *self, PyObject *args)
{
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofCounter_addFtofTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthHitList(me->elem->addFtofTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofCounter_deleteFtofTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofCounter element");
      return NULL;
   }
   me->elem->deleteFtofTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofCounter_toString(PyObject *self, PyObject *args=0)
{
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofCounter_toXML(PyObject *self, PyObject *args=0)
{
   _FtofCounter *me = (_FtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofCounter element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofCounter_getsetters[] = {
   {(char*)"bar",
    (getter)_FtofCounter_getBar, (setter)_FtofCounter_setBar,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_FtofCounter_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofCounter_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofCounter_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofCounter_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"plane",
    (getter)_FtofCounter_getPlane, (setter)_FtofCounter_setPlane,
    (char*)"plane value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofCounter_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_FtofCounter_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofCounter_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofCounter_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofCounter_methods[] = {
   {"addFtofHits", _FtofCounter_addFtofHits, METH_VARARGS,
    "extend (or insert into) the list of ftofHit objects for this ftofCounter"},
   {"addFtofTruthHits", _FtofCounter_addFtofTruthHits, METH_VARARGS,
    "extend (or insert into) the list of ftofTruthHit objects for this ftofCounter"},
   {"deleteFtofHits", _FtofCounter_deleteFtofHits, METH_VARARGS,
    "delete ftofHit objects for this ftofCounter"},
   {"deleteFtofTruthHits", _FtofCounter_deleteFtofTruthHits, METH_VARARGS,
    "delete ftofTruthHit objects for this ftofCounter"},
   {"getFtofHit", _FtofCounter_getFtofHit, METH_VARARGS,
    "get an individual ftofHit object from this ftofCounter"},
   {"getFtofHits", _FtofCounter_getFtofHits, METH_NOARGS,
    "get list of ftofHit objects for this ftofCounter"},
   {"getFtofTruthHit", _FtofCounter_getFtofTruthHit, METH_VARARGS,
    "get an individual ftofTruthHit object from this ftofCounter"},
   {"getFtofTruthHits", _FtofCounter_getFtofTruthHits, METH_NOARGS,
    "get list of ftofTruthHit objects for this ftofCounter"},
   {"toString", _FtofCounter_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofCounter_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofCounter_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofCounter",         /*tp_name*/
    sizeof(_FtofCounter),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofCounter_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofCounter_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofCounter element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofCounter_methods,          /* tp_methods */
    _FtofCounter_members,          /* tp_members */
    _FtofCounter_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofCounter_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofCounter_new,              /* tp_new */
};



// wrap element class hddm_s::FtofTruthPoint as hddm_s.FtofTruthPoint

typedef struct {
   PyObject_HEAD
   FtofTruthPoint *elem;
   PyObject *host;
} _FtofTruthPoint;

static void
_FtofTruthPoint_dealloc(_FtofTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FtofTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FtofTruthPoint *self;
   self = (_FtofTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FtofTruthPoint_init(_FtofTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FtofTruthPoint_getClass(_FtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthPoint_getVersion(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FtofTruthPoint_getXmlns(_FtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthPoint_getEventNo(_FtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FtofTruthPoint_getRunNo(_FtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FtofTruthPoint_getE(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FtofTruthPoint_setE(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getMaxOccurs(_FtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FtofTruthPoint_getMinOccurs(_FtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FtofTruthPoint_getPrimary(_FtofTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_FtofTruthPoint_setPrimary(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_FtofTruthPoint_getPtype(_FtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FtofTruthPoint_setPtype(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getPx(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_FtofTruthPoint_setPx(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getPy(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_FtofTruthPoint_setPy(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getPz(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_FtofTruthPoint_setPz(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getT(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FtofTruthPoint_setT(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getTrack(_FtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_FtofTruthPoint_setTrack(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getX(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_FtofTruthPoint_setX(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getY(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_FtofTruthPoint_setY(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getZ(_FtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_FtofTruthPoint_setZ(_FtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_FtofTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FtofTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FtofTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FtofTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FtofTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FtofTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _FtofTruthPoint *me = (_FtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ftofTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FtofTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_FtofTruthPoint_getE, (setter)_FtofTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FtofTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FtofTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FtofTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FtofTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_FtofTruthPoint_getPrimary, (setter)_FtofTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_FtofTruthPoint_getPtype, (setter)_FtofTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_FtofTruthPoint_getPx, (setter)_FtofTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_FtofTruthPoint_getPy, (setter)_FtofTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_FtofTruthPoint_getPz, (setter)_FtofTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_FtofTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FtofTruthPoint_getT, (setter)_FtofTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_FtofTruthPoint_getTrack, (setter)_FtofTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_FtofTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_FtofTruthPoint_getX, (setter)_FtofTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_FtofTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_FtofTruthPoint_getY, (setter)_FtofTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_FtofTruthPoint_getZ, (setter)_FtofTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FtofTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FtofTruthPoint_methods[] = {
   {"addTrackIDs", _FtofTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this ftofTruthPoint"},
   {"addTrackOrigins", _FtofTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this ftofTruthPoint"},
   {"deleteTrackIDs", _FtofTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this ftofTruthPoint"},
   {"deleteTrackOrigins", _FtofTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this ftofTruthPoint"},
   {"getTrackID", _FtofTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this ftofTruthPoint"},
   {"getTrackIDs", _FtofTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this ftofTruthPoint"},
   {"getTrackOrigin", _FtofTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this ftofTruthPoint"},
   {"getTrackOrigins", _FtofTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this ftofTruthPoint"},
   {"toString", _FtofTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FtofTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FtofTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FtofTruthPoint",         /*tp_name*/
    sizeof(_FtofTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FtofTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FtofTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ftofTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FtofTruthPoint_methods,          /* tp_methods */
    _FtofTruthPoint_members,          /* tp_members */
    _FtofTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FtofTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FtofTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::ForwardTOF as hddm_s.ForwardTOF

typedef struct {
   PyObject_HEAD
   ForwardTOF *elem;
   PyObject *host;
} _ForwardTOF;

static void
_ForwardTOF_dealloc(_ForwardTOF* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ForwardTOF_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ForwardTOF *self;
   self = (_ForwardTOF*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ForwardTOF_init(_ForwardTOF *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ForwardTOF_getClass(_ForwardTOF *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardTOF_getVersion(_ForwardTOF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ForwardTOF_getXmlns(_ForwardTOF *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardTOF_getEventNo(_ForwardTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ForwardTOF_getMaxOccurs(_ForwardTOF *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardTOF_getRunNo(_ForwardTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ForwardTOF_getMinOccurs(_ForwardTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ForwardTOF_getFtofCounter(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *obj = _FtofCounter_new(&_FtofCounter_type, 0, 0);
   ((_FtofCounter*)obj)->elem = &me->elem->getFtofCounter(index);
   ((_FtofCounter*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardTOF_getFtofCounters(PyObject *self, PyObject *args)
{
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofCounters();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardTOF_addFtofCounters(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofCounterList(me->elem->addFtofCounters(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardTOF_deleteFtofCounters(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardTOF element");
      return NULL;
   }
   me->elem->deleteFtofCounters(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardTOF_getFtofTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *obj = _FtofTruthPoint_new(&_FtofTruthPoint_type, 0, 0);
   ((_FtofTruthPoint*)obj)->elem = &me->elem->getFtofTruthPoint(index);
   ((_FtofTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardTOF_getFtofTruthPoints(PyObject *self, PyObject *args)
{
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFtofTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardTOF_addFtofTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthPointList(me->elem->addFtofTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardTOF_deleteFtofTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardTOF element");
      return NULL;
   }
   me->elem->deleteFtofTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardTOF_toString(PyObject *self, PyObject *args=0)
{
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ForwardTOF_toXML(PyObject *self, PyObject *args=0)
{
   _ForwardTOF *me = (_ForwardTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardTOF element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ForwardTOF_getsetters[] = {
   {(char*)"class",
    (getter)_ForwardTOF_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ForwardTOF_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ForwardTOF_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ForwardTOF_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ForwardTOF_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ForwardTOF_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ForwardTOF_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ForwardTOF_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ForwardTOF_methods[] = {
   {"addFtofCounters", _ForwardTOF_addFtofCounters, METH_VARARGS,
    "extend (or insert into) the list of ftofCounter objects for this forwardTOF"},
   {"addFtofTruthPoints", _ForwardTOF_addFtofTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of ftofTruthPoint objects for this forwardTOF"},
   {"deleteFtofCounters", _ForwardTOF_deleteFtofCounters, METH_VARARGS,
    "delete ftofCounter objects for this forwardTOF"},
   {"deleteFtofTruthPoints", _ForwardTOF_deleteFtofTruthPoints, METH_VARARGS,
    "delete ftofTruthPoint objects for this forwardTOF"},
   {"getFtofCounter", _ForwardTOF_getFtofCounter, METH_VARARGS,
    "get an individual ftofCounter object from this forwardTOF"},
   {"getFtofCounters", _ForwardTOF_getFtofCounters, METH_NOARGS,
    "get list of ftofCounter objects for this forwardTOF"},
   {"getFtofTruthPoint", _ForwardTOF_getFtofTruthPoint, METH_VARARGS,
    "get an individual ftofTruthPoint object from this forwardTOF"},
   {"getFtofTruthPoints", _ForwardTOF_getFtofTruthPoints, METH_NOARGS,
    "get list of ftofTruthPoint objects for this forwardTOF"},
   {"toString", _ForwardTOF_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ForwardTOF_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ForwardTOF_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ForwardTOF",         /*tp_name*/
    sizeof(_ForwardTOF),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ForwardTOF_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ForwardTOF_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s forwardTOF element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ForwardTOF_methods,          /* tp_methods */
    _ForwardTOF_members,          /* tp_members */
    _ForwardTOF_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ForwardTOF_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ForwardTOF_new,              /* tp_new */
};



// wrap element class hddm_s::FcalDigihit as hddm_s.FcalDigihit

typedef struct {
   PyObject_HEAD
   FcalDigihit *elem;
   PyObject *host;
} _FcalDigihit;

static void
_FcalDigihit_dealloc(_FcalDigihit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalDigihit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalDigihit *self;
   self = (_FcalDigihit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalDigihit_init(_FcalDigihit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalDigihit_getClass(_FcalDigihit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalDigihit_getVersion(_FcalDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalDigihit_getXmlns(_FcalDigihit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalDigihit_getEventNo(_FcalDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalDigihit_getMaxOccurs(_FcalDigihit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalDigihit_getRunNo(_FcalDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalDigihit_getColumn(_FcalDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_FcalDigihit_getRow(_FcalDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_FcalDigihit_getE(_FcalDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_FcalDigihit_getT(_FcalDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FcalDigihit_getIntegralOverPeak(_FcalDigihit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getIntegralOverPeak());
}

static int
_FcalDigihit_setIntegralOverPeak(_FcalDigihit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setIntegralOverPeak((float)var);
   return 0;
}

static PyObject*
_FcalDigihit_getMinOccurs(_FcalDigihit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalDigihit_toString(PyObject *self, PyObject *args=0)
{
   _FcalDigihit *me = (_FcalDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalDigihit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalDigihit_toXML(PyObject *self, PyObject *args=0)
{
   _FcalDigihit *me = (_FcalDigihit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalDigihit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalDigihit_getsetters[] = {
   {(char*)"E",
    (getter)_FcalDigihit_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FcalDigihit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_FcalDigihit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalDigihit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"integralOverPeak",
    (getter)_FcalDigihit_getIntegralOverPeak, (setter)_FcalDigihit_setIntegralOverPeak,
    (char*)"integralOverPeak value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalDigihit_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalDigihit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_FcalDigihit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalDigihit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FcalDigihit_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FcalDigihit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalDigihit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalDigihit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalDigihit_methods[] = {
   {"toString", _FcalDigihit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalDigihit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalDigihit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalDigihit",         /*tp_name*/
    sizeof(_FcalDigihit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalDigihit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalDigihit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalDigihit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalDigihit_methods,          /* tp_methods */
    _FcalDigihit_members,          /* tp_members */
    _FcalDigihit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalDigihit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalDigihit_new,              /* tp_new */
};



// wrap element class hddm_s::FcalHit as hddm_s.FcalHit

typedef struct {
   PyObject_HEAD
   FcalHit *elem;
   PyObject *host;
} _FcalHit;

static void
_FcalHit_dealloc(_FcalHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalHit *self;
   self = (_FcalHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalHit_init(_FcalHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalHit_getClass(_FcalHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalHit_getVersion(_FcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalHit_getXmlns(_FcalHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalHit_getEventNo(_FcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalHit_getRunNo(_FcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalHit_getMinOccurs(_FcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalHit_getColumn(_FcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_FcalHit_getRow(_FcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_FcalHit_getE(_FcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FcalHit_setE(_FcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FcalHit_getMaxOccurs(_FcalHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalHit_getT(_FcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FcalHit_setT(_FcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FcalHit_getFcalDigihit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalHit element");
      return NULL;
   }
   PyObject *obj = _FcalDigihit_new(&_FcalDigihit_type, 0, 0);
   ((_FcalDigihit*)obj)->elem = &me->elem->getFcalDigihit();
   ((_FcalDigihit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalHit_getFcalDigihits(PyObject *self, PyObject *args)
{
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalDigihits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalHit_addFcalDigihits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalDigihitList(me->elem->addFcalDigihits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalHit_deleteFcalDigihits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalHit element");
      return NULL;
   }
   me->elem->deleteFcalDigihits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalHit_toString(PyObject *self, PyObject *args=0)
{
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalHit_toXML(PyObject *self, PyObject *args=0)
{
   _FcalHit *me = (_FcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalHit_getsetters[] = {
   {(char*)"E",
    (getter)_FcalHit_getE, (setter)_FcalHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FcalHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_FcalHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_FcalHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FcalHit_getT, (setter)_FcalHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FcalHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalHit_methods[] = {
   {"addFcalDigihits", _FcalHit_addFcalDigihits, METH_VARARGS,
    "extend (or insert into) the list of fcalDigihit objects for this fcalHit"},
   {"deleteFcalDigihits", _FcalHit_deleteFcalDigihits, METH_VARARGS,
    "delete fcalDigihit objects for this fcalHit"},
   {"getFcalDigihit", _FcalHit_getFcalDigihit, METH_VARARGS,
    "get an individual fcalDigihit object from this fcalHit"},
   {"getFcalDigihits", _FcalHit_getFcalDigihits, METH_NOARGS,
    "get list of fcalDigihit objects for this fcalHit"},
   {"toString", _FcalHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalHit",         /*tp_name*/
    sizeof(_FcalHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalHit_methods,          /* tp_methods */
    _FcalHit_members,          /* tp_members */
    _FcalHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalHit_new,              /* tp_new */
};



// wrap element class hddm_s::FcalTruthLightGuide as hddm_s.FcalTruthLightGuide

typedef struct {
   PyObject_HEAD
   FcalTruthLightGuide *elem;
   PyObject *host;
} _FcalTruthLightGuide;

static void
_FcalTruthLightGuide_dealloc(_FcalTruthLightGuide* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalTruthLightGuide_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalTruthLightGuide *self;
   self = (_FcalTruthLightGuide*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalTruthLightGuide_init(_FcalTruthLightGuide *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalTruthLightGuide_getClass(_FcalTruthLightGuide *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthLightGuide_getVersion(_FcalTruthLightGuide *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalTruthLightGuide_getXmlns(_FcalTruthLightGuide *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthLightGuide_getEventNo(_FcalTruthLightGuide *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalTruthLightGuide_getRunNo(_FcalTruthLightGuide *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalTruthLightGuide_getMinOccurs(_FcalTruthLightGuide *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalTruthLightGuide_getColumn(_FcalTruthLightGuide *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_FcalTruthLightGuide_getRow(_FcalTruthLightGuide *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_FcalTruthLightGuide_getE(_FcalTruthLightGuide *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_FcalTruthLightGuide_getDE(_FcalTruthLightGuide *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FcalTruthLightGuide_setDE(_FcalTruthLightGuide *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FcalTruthLightGuide_getMaxOccurs(_FcalTruthLightGuide *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthLightGuide_getT(_FcalTruthLightGuide *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FcalTruthLightGuide_setT(_FcalTruthLightGuide *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FcalTruthLightGuide_toString(PyObject *self, PyObject *args=0)
{
   _FcalTruthLightGuide *me = (_FcalTruthLightGuide*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthLightGuide element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalTruthLightGuide_toXML(PyObject *self, PyObject *args=0)
{
   _FcalTruthLightGuide *me = (_FcalTruthLightGuide*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthLightGuide element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalTruthLightGuide_getsetters[] = {
   {(char*)"E",
    (getter)_FcalTruthLightGuide_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FcalTruthLightGuide_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_FcalTruthLightGuide_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"dE",
    (getter)_FcalTruthLightGuide_getDE, (setter)_FcalTruthLightGuide_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalTruthLightGuide_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalTruthLightGuide_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalTruthLightGuide_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_FcalTruthLightGuide_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalTruthLightGuide_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FcalTruthLightGuide_getT, (setter)_FcalTruthLightGuide_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FcalTruthLightGuide_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalTruthLightGuide_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalTruthLightGuide_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalTruthLightGuide_methods[] = {
   {"toString", _FcalTruthLightGuide_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalTruthLightGuide_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalTruthLightGuide_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalTruthLightGuide",         /*tp_name*/
    sizeof(_FcalTruthLightGuide),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalTruthLightGuide_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalTruthLightGuide_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalTruthLightGuide element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalTruthLightGuide_methods,          /* tp_methods */
    _FcalTruthLightGuide_members,          /* tp_members */
    _FcalTruthLightGuide_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalTruthLightGuide_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalTruthLightGuide_new,              /* tp_new */
};



// wrap element class hddm_s::FcalTruthHit as hddm_s.FcalTruthHit

typedef struct {
   PyObject_HEAD
   FcalTruthHit *elem;
   PyObject *host;
} _FcalTruthHit;

static void
_FcalTruthHit_dealloc(_FcalTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalTruthHit *self;
   self = (_FcalTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalTruthHit_init(_FcalTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalTruthHit_getClass(_FcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthHit_getVersion(_FcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalTruthHit_getXmlns(_FcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthHit_getEventNo(_FcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalTruthHit_getRunNo(_FcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalTruthHit_getMinOccurs(_FcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalTruthHit_getColumn(_FcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_FcalTruthHit_getRow(_FcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_FcalTruthHit_getE(_FcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FcalTruthHit_setE(_FcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FcalTruthHit_getMaxOccurs(_FcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthHit_getT(_FcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FcalTruthHit_setT(_FcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FcalTruthHit_getFcalTruthLightGuide(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthHit element");
      return NULL;
   }
   PyObject *obj = _FcalTruthLightGuide_new(&_FcalTruthLightGuide_type, 0, 0);
   ((_FcalTruthLightGuide*)obj)->elem = &me->elem->getFcalTruthLightGuide(index);
   ((_FcalTruthLightGuide*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalTruthHit_getFcalTruthLightGuides(PyObject *self, PyObject *args)
{
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthLightGuide_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalTruthLightGuides();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalTruthHit_addFcalTruthLightGuides(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthLightGuide_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthLightGuideList(me->elem->addFcalTruthLightGuides(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalTruthHit_deleteFcalTruthLightGuides(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalTruthHit element");
      return NULL;
   }
   me->elem->deleteFcalTruthLightGuides(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _FcalTruthHit *me = (_FcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_FcalTruthHit_getE, (setter)_FcalTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FcalTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_FcalTruthHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_FcalTruthHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FcalTruthHit_getT, (setter)_FcalTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FcalTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalTruthHit_methods[] = {
   {"addFcalTruthLightGuides", _FcalTruthHit_addFcalTruthLightGuides, METH_VARARGS,
    "extend (or insert into) the list of fcalTruthLightGuide objects for this fcalTruthHit"},
   {"deleteFcalTruthLightGuides", _FcalTruthHit_deleteFcalTruthLightGuides, METH_VARARGS,
    "delete fcalTruthLightGuide objects for this fcalTruthHit"},
   {"getFcalTruthLightGuide", _FcalTruthHit_getFcalTruthLightGuide, METH_VARARGS,
    "get an individual fcalTruthLightGuide object from this fcalTruthHit"},
   {"getFcalTruthLightGuides", _FcalTruthHit_getFcalTruthLightGuides, METH_NOARGS,
    "get list of fcalTruthLightGuide objects for this fcalTruthHit"},
   {"toString", _FcalTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalTruthHit",         /*tp_name*/
    sizeof(_FcalTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalTruthHit_methods,          /* tp_methods */
    _FcalTruthHit_members,          /* tp_members */
    _FcalTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::FcalBlock as hddm_s.FcalBlock

typedef struct {
   PyObject_HEAD
   FcalBlock *elem;
   PyObject *host;
} _FcalBlock;

static void
_FcalBlock_dealloc(_FcalBlock* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalBlock_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalBlock *self;
   self = (_FcalBlock*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalBlock_init(_FcalBlock *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalBlock_getClass(_FcalBlock *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalBlock_getVersion(_FcalBlock *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalBlock_getXmlns(_FcalBlock *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalBlock_getEventNo(_FcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalBlock_getRunNo(_FcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalBlock_getColumn(_FcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_FcalBlock_setColumn(_FcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_FcalBlock_getMaxOccurs(_FcalBlock *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalBlock_getMinOccurs(_FcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalBlock_getRow(_FcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static int
_FcalBlock_setRow(_FcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRow(var);
   return 0;
}

static PyObject*
_FcalBlock_getFcalHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *obj = _FcalHit_new(&_FcalHit_type, 0, 0);
   ((_FcalHit*)obj)->elem = &me->elem->getFcalHit(index);
   ((_FcalHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalBlock_getFcalHits(PyObject *self, PyObject *args)
{
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalBlock_addFcalHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalHitList(me->elem->addFcalHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalBlock_deleteFcalHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalBlock element");
      return NULL;
   }
   me->elem->deleteFcalHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalBlock_getFcalTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *obj = _FcalTruthHit_new(&_FcalTruthHit_type, 0, 0);
   ((_FcalTruthHit*)obj)->elem = &me->elem->getFcalTruthHit(index);
   ((_FcalTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalBlock_getFcalTruthHits(PyObject *self, PyObject *args)
{
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalBlock_addFcalTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthHitList(me->elem->addFcalTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalBlock_deleteFcalTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalBlock element");
      return NULL;
   }
   me->elem->deleteFcalTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalBlock_toString(PyObject *self, PyObject *args=0)
{
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalBlock_toXML(PyObject *self, PyObject *args=0)
{
   _FcalBlock *me = (_FcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalBlock element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalBlock_getsetters[] = {
   {(char*)"class",
    (getter)_FcalBlock_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_FcalBlock_getColumn, (setter)_FcalBlock_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalBlock_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalBlock_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalBlock_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_FcalBlock_getRow, (setter)_FcalBlock_setRow,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalBlock_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_FcalBlock_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalBlock_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalBlock_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalBlock_methods[] = {
   {"addFcalHits", _FcalBlock_addFcalHits, METH_VARARGS,
    "extend (or insert into) the list of fcalHit objects for this fcalBlock"},
   {"addFcalTruthHits", _FcalBlock_addFcalTruthHits, METH_VARARGS,
    "extend (or insert into) the list of fcalTruthHit objects for this fcalBlock"},
   {"deleteFcalHits", _FcalBlock_deleteFcalHits, METH_VARARGS,
    "delete fcalHit objects for this fcalBlock"},
   {"deleteFcalTruthHits", _FcalBlock_deleteFcalTruthHits, METH_VARARGS,
    "delete fcalTruthHit objects for this fcalBlock"},
   {"getFcalHit", _FcalBlock_getFcalHit, METH_VARARGS,
    "get an individual fcalHit object from this fcalBlock"},
   {"getFcalHits", _FcalBlock_getFcalHits, METH_NOARGS,
    "get list of fcalHit objects for this fcalBlock"},
   {"getFcalTruthHit", _FcalBlock_getFcalTruthHit, METH_VARARGS,
    "get an individual fcalTruthHit object from this fcalBlock"},
   {"getFcalTruthHits", _FcalBlock_getFcalTruthHits, METH_NOARGS,
    "get list of fcalTruthHit objects for this fcalBlock"},
   {"toString", _FcalBlock_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalBlock_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalBlock_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalBlock",         /*tp_name*/
    sizeof(_FcalBlock),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalBlock_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalBlock_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalBlock element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalBlock_methods,          /* tp_methods */
    _FcalBlock_members,          /* tp_members */
    _FcalBlock_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalBlock_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalBlock_new,              /* tp_new */
};



// wrap element class hddm_s::FcalTruthShower as hddm_s.FcalTruthShower

typedef struct {
   PyObject_HEAD
   FcalTruthShower *elem;
   PyObject *host;
} _FcalTruthShower;

static void
_FcalTruthShower_dealloc(_FcalTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FcalTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FcalTruthShower *self;
   self = (_FcalTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FcalTruthShower_init(_FcalTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FcalTruthShower_getClass(_FcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthShower_getVersion(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FcalTruthShower_getXmlns(_FcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthShower_getEventNo(_FcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FcalTruthShower_getRunNo(_FcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FcalTruthShower_getE(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FcalTruthShower_setE(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getMaxOccurs(_FcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FcalTruthShower_getMinOccurs(_FcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FcalTruthShower_getPrimary(_FcalTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_FcalTruthShower_setPrimary(_FcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_FcalTruthShower_getPtype(_FcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FcalTruthShower_setPtype(_FcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FcalTruthShower_getPx(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_FcalTruthShower_setPx(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getPy(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_FcalTruthShower_setPy(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getPz(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_FcalTruthShower_setPz(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getT(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FcalTruthShower_setT(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getTrack(_FcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_FcalTruthShower_setTrack(_FcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_FcalTruthShower_getX(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_FcalTruthShower_setX(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getY(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_FcalTruthShower_setY(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getZ(_FcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_FcalTruthShower_setZ(_FcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_FcalTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FcalTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FcalTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fcalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FcalTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fcalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FcalTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FcalTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _FcalTruthShower *me = (_FcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fcalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FcalTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_FcalTruthShower_getE, (setter)_FcalTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FcalTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FcalTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FcalTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FcalTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_FcalTruthShower_getPrimary, (setter)_FcalTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_FcalTruthShower_getPtype, (setter)_FcalTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_FcalTruthShower_getPx, (setter)_FcalTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_FcalTruthShower_getPy, (setter)_FcalTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_FcalTruthShower_getPz, (setter)_FcalTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_FcalTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FcalTruthShower_getT, (setter)_FcalTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_FcalTruthShower_getTrack, (setter)_FcalTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_FcalTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_FcalTruthShower_getX, (setter)_FcalTruthShower_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_FcalTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_FcalTruthShower_getY, (setter)_FcalTruthShower_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_FcalTruthShower_getZ, (setter)_FcalTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FcalTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FcalTruthShower_methods[] = {
   {"addTrackIDs", _FcalTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this fcalTruthShower"},
   {"addTrackOrigins", _FcalTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this fcalTruthShower"},
   {"deleteTrackIDs", _FcalTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this fcalTruthShower"},
   {"deleteTrackOrigins", _FcalTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this fcalTruthShower"},
   {"getTrackID", _FcalTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this fcalTruthShower"},
   {"getTrackIDs", _FcalTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this fcalTruthShower"},
   {"getTrackOrigin", _FcalTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this fcalTruthShower"},
   {"getTrackOrigins", _FcalTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this fcalTruthShower"},
   {"toString", _FcalTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FcalTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FcalTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FcalTruthShower",         /*tp_name*/
    sizeof(_FcalTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FcalTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FcalTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fcalTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FcalTruthShower_methods,          /* tp_methods */
    _FcalTruthShower_members,          /* tp_members */
    _FcalTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FcalTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FcalTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::ForwardEMcal as hddm_s.ForwardEMcal

typedef struct {
   PyObject_HEAD
   ForwardEMcal *elem;
   PyObject *host;
} _ForwardEMcal;

static void
_ForwardEMcal_dealloc(_ForwardEMcal* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ForwardEMcal_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ForwardEMcal *self;
   self = (_ForwardEMcal*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ForwardEMcal_init(_ForwardEMcal *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ForwardEMcal_getClass(_ForwardEMcal *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardEMcal_getVersion(_ForwardEMcal *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ForwardEMcal_getXmlns(_ForwardEMcal *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardEMcal_getEventNo(_ForwardEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ForwardEMcal_getMaxOccurs(_ForwardEMcal *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardEMcal_getRunNo(_ForwardEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ForwardEMcal_getMinOccurs(_ForwardEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ForwardEMcal_getFcalBlock(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *obj = _FcalBlock_new(&_FcalBlock_type, 0, 0);
   ((_FcalBlock*)obj)->elem = &me->elem->getFcalBlock(index);
   ((_FcalBlock*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardEMcal_getFcalBlocks(PyObject *self, PyObject *args)
{
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalBlocks();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardEMcal_addFcalBlocks(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalBlockList(me->elem->addFcalBlocks(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardEMcal_deleteFcalBlocks(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardEMcal element");
      return NULL;
   }
   me->elem->deleteFcalBlocks(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardEMcal_getFcalTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *obj = _FcalTruthShower_new(&_FcalTruthShower_type, 0, 0);
   ((_FcalTruthShower*)obj)->elem = &me->elem->getFcalTruthShower(index);
   ((_FcalTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardEMcal_getFcalTruthShowers(PyObject *self, PyObject *args)
{
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFcalTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardEMcal_addFcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthShowerList(me->elem->addFcalTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardEMcal_deleteFcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardEMcal element");
      return NULL;
   }
   me->elem->deleteFcalTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardEMcal_toString(PyObject *self, PyObject *args=0)
{
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ForwardEMcal_toXML(PyObject *self, PyObject *args=0)
{
   _ForwardEMcal *me = (_ForwardEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardEMcal element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ForwardEMcal_getsetters[] = {
   {(char*)"class",
    (getter)_ForwardEMcal_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ForwardEMcal_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ForwardEMcal_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ForwardEMcal_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ForwardEMcal_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ForwardEMcal_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ForwardEMcal_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ForwardEMcal_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ForwardEMcal_methods[] = {
   {"addFcalBlocks", _ForwardEMcal_addFcalBlocks, METH_VARARGS,
    "extend (or insert into) the list of fcalBlock objects for this forwardEMcal"},
   {"addFcalTruthShowers", _ForwardEMcal_addFcalTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of fcalTruthShower objects for this forwardEMcal"},
   {"deleteFcalBlocks", _ForwardEMcal_deleteFcalBlocks, METH_VARARGS,
    "delete fcalBlock objects for this forwardEMcal"},
   {"deleteFcalTruthShowers", _ForwardEMcal_deleteFcalTruthShowers, METH_VARARGS,
    "delete fcalTruthShower objects for this forwardEMcal"},
   {"getFcalBlock", _ForwardEMcal_getFcalBlock, METH_VARARGS,
    "get an individual fcalBlock object from this forwardEMcal"},
   {"getFcalBlocks", _ForwardEMcal_getFcalBlocks, METH_NOARGS,
    "get list of fcalBlock objects for this forwardEMcal"},
   {"getFcalTruthShower", _ForwardEMcal_getFcalTruthShower, METH_VARARGS,
    "get an individual fcalTruthShower object from this forwardEMcal"},
   {"getFcalTruthShowers", _ForwardEMcal_getFcalTruthShowers, METH_NOARGS,
    "get list of fcalTruthShower objects for this forwardEMcal"},
   {"toString", _ForwardEMcal_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ForwardEMcal_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ForwardEMcal_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ForwardEMcal",         /*tp_name*/
    sizeof(_ForwardEMcal),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ForwardEMcal_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ForwardEMcal_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s forwardEMcal element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ForwardEMcal_methods,          /* tp_methods */
    _ForwardEMcal_members,          /* tp_members */
    _ForwardEMcal_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ForwardEMcal_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ForwardEMcal_new,              /* tp_new */
};



// wrap element class hddm_s::EcalHit as hddm_s.EcalHit

typedef struct {
   PyObject_HEAD
   EcalHit *elem;
   PyObject *host;
} _EcalHit;

static void
_EcalHit_dealloc(_EcalHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_EcalHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _EcalHit *self;
   self = (_EcalHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_EcalHit_init(_EcalHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_EcalHit_getClass(_EcalHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalHit_getVersion(_EcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_EcalHit_getXmlns(_EcalHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalHit_getEventNo(_EcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_EcalHit_getRunNo(_EcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_EcalHit_getMinOccurs(_EcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_EcalHit_getColumn(_EcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_EcalHit_getRow(_EcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_EcalHit_getE(_EcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_EcalHit_setE(_EcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_EcalHit_getMaxOccurs(_EcalHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalHit_getT(_EcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_EcalHit_setT(_EcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_EcalHit_toString(PyObject *self, PyObject *args=0)
{
   _EcalHit *me = (_EcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_EcalHit_toXML(PyObject *self, PyObject *args=0)
{
   _EcalHit *me = (_EcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _EcalHit_getsetters[] = {
   {(char*)"E",
    (getter)_EcalHit_getE, (setter)_EcalHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_EcalHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_EcalHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_EcalHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_EcalHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_EcalHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_EcalHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_EcalHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_EcalHit_getT, (setter)_EcalHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_EcalHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_EcalHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _EcalHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _EcalHit_methods[] = {
   {"toString", _EcalHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _EcalHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _EcalHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.EcalHit",         /*tp_name*/
    sizeof(_EcalHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_EcalHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_EcalHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ecalHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _EcalHit_methods,          /* tp_methods */
    _EcalHit_members,          /* tp_members */
    _EcalHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_EcalHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _EcalHit_new,              /* tp_new */
};



// wrap element class hddm_s::EcalTruthHit as hddm_s.EcalTruthHit

typedef struct {
   PyObject_HEAD
   EcalTruthHit *elem;
   PyObject *host;
} _EcalTruthHit;

static void
_EcalTruthHit_dealloc(_EcalTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_EcalTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _EcalTruthHit *self;
   self = (_EcalTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_EcalTruthHit_init(_EcalTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_EcalTruthHit_getClass(_EcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthHit_getVersion(_EcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_EcalTruthHit_getXmlns(_EcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthHit_getEventNo(_EcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_EcalTruthHit_getRunNo(_EcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_EcalTruthHit_getMinOccurs(_EcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_EcalTruthHit_getColumn(_EcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_EcalTruthHit_getRow(_EcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_EcalTruthHit_getE(_EcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_EcalTruthHit_setE(_EcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_EcalTruthHit_getMaxOccurs(_EcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthHit_getT(_EcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_EcalTruthHit_setT(_EcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_EcalTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _EcalTruthHit *me = (_EcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_EcalTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _EcalTruthHit *me = (_EcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _EcalTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_EcalTruthHit_getE, (setter)_EcalTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_EcalTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_EcalTruthHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_EcalTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_EcalTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_EcalTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_EcalTruthHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_EcalTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_EcalTruthHit_getT, (setter)_EcalTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_EcalTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_EcalTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _EcalTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _EcalTruthHit_methods[] = {
   {"toString", _EcalTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _EcalTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _EcalTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.EcalTruthHit",         /*tp_name*/
    sizeof(_EcalTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_EcalTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_EcalTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ecalTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _EcalTruthHit_methods,          /* tp_methods */
    _EcalTruthHit_members,          /* tp_members */
    _EcalTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_EcalTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _EcalTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::EcalBlock as hddm_s.EcalBlock

typedef struct {
   PyObject_HEAD
   EcalBlock *elem;
   PyObject *host;
} _EcalBlock;

static void
_EcalBlock_dealloc(_EcalBlock* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_EcalBlock_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _EcalBlock *self;
   self = (_EcalBlock*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_EcalBlock_init(_EcalBlock *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_EcalBlock_getClass(_EcalBlock *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalBlock_getVersion(_EcalBlock *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_EcalBlock_getXmlns(_EcalBlock *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalBlock_getEventNo(_EcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_EcalBlock_getRunNo(_EcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_EcalBlock_getColumn(_EcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_EcalBlock_setColumn(_EcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_EcalBlock_getMaxOccurs(_EcalBlock *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalBlock_getMinOccurs(_EcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_EcalBlock_getRow(_EcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static int
_EcalBlock_setRow(_EcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRow(var);
   return 0;
}

static PyObject*
_EcalBlock_getEcalHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *obj = _EcalHit_new(&_EcalHit_type, 0, 0);
   ((_EcalHit*)obj)->elem = &me->elem->getEcalHit(index);
   ((_EcalHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_EcalBlock_getEcalHits(PyObject *self, PyObject *args)
{
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getEcalHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_EcalBlock_addEcalHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalHitList(me->elem->addEcalHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_EcalBlock_deleteEcalHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ecalBlock element");
      return NULL;
   }
   me->elem->deleteEcalHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_EcalBlock_getEcalTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *obj = _EcalTruthHit_new(&_EcalTruthHit_type, 0, 0);
   ((_EcalTruthHit*)obj)->elem = &me->elem->getEcalTruthHit(index);
   ((_EcalTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_EcalBlock_getEcalTruthHits(PyObject *self, PyObject *args)
{
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getEcalTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_EcalBlock_addEcalTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ecalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalTruthHitList(me->elem->addEcalTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_EcalBlock_deleteEcalTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ecalBlock element");
      return NULL;
   }
   me->elem->deleteEcalTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_EcalBlock_toString(PyObject *self, PyObject *args=0)
{
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_EcalBlock_toXML(PyObject *self, PyObject *args=0)
{
   _EcalBlock *me = (_EcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalBlock element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _EcalBlock_getsetters[] = {
   {(char*)"class",
    (getter)_EcalBlock_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_EcalBlock_getColumn, (setter)_EcalBlock_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_EcalBlock_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_EcalBlock_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_EcalBlock_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_EcalBlock_getRow, (setter)_EcalBlock_setRow,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_EcalBlock_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_EcalBlock_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_EcalBlock_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _EcalBlock_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _EcalBlock_methods[] = {
   {"addEcalHits", _EcalBlock_addEcalHits, METH_VARARGS,
    "extend (or insert into) the list of ecalHit objects for this ecalBlock"},
   {"addEcalTruthHits", _EcalBlock_addEcalTruthHits, METH_VARARGS,
    "extend (or insert into) the list of ecalTruthHit objects for this ecalBlock"},
   {"deleteEcalHits", _EcalBlock_deleteEcalHits, METH_VARARGS,
    "delete ecalHit objects for this ecalBlock"},
   {"deleteEcalTruthHits", _EcalBlock_deleteEcalTruthHits, METH_VARARGS,
    "delete ecalTruthHit objects for this ecalBlock"},
   {"getEcalHit", _EcalBlock_getEcalHit, METH_VARARGS,
    "get an individual ecalHit object from this ecalBlock"},
   {"getEcalHits", _EcalBlock_getEcalHits, METH_NOARGS,
    "get list of ecalHit objects for this ecalBlock"},
   {"getEcalTruthHit", _EcalBlock_getEcalTruthHit, METH_VARARGS,
    "get an individual ecalTruthHit object from this ecalBlock"},
   {"getEcalTruthHits", _EcalBlock_getEcalTruthHits, METH_NOARGS,
    "get list of ecalTruthHit objects for this ecalBlock"},
   {"toString", _EcalBlock_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _EcalBlock_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _EcalBlock_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.EcalBlock",         /*tp_name*/
    sizeof(_EcalBlock),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_EcalBlock_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_EcalBlock_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ecalBlock element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _EcalBlock_methods,          /* tp_methods */
    _EcalBlock_members,          /* tp_members */
    _EcalBlock_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_EcalBlock_init,   /* tp_init */
    0,                         /* tp_alloc */
    _EcalBlock_new,              /* tp_new */
};



// wrap element class hddm_s::EcalTruthShower as hddm_s.EcalTruthShower

typedef struct {
   PyObject_HEAD
   EcalTruthShower *elem;
   PyObject *host;
} _EcalTruthShower;

static void
_EcalTruthShower_dealloc(_EcalTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_EcalTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _EcalTruthShower *self;
   self = (_EcalTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_EcalTruthShower_init(_EcalTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_EcalTruthShower_getClass(_EcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthShower_getVersion(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_EcalTruthShower_getXmlns(_EcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthShower_getEventNo(_EcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_EcalTruthShower_getRunNo(_EcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_EcalTruthShower_getE(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_EcalTruthShower_setE(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getMaxOccurs(_EcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_EcalTruthShower_getMinOccurs(_EcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_EcalTruthShower_getPrimary(_EcalTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_EcalTruthShower_setPrimary(_EcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_EcalTruthShower_getPtype(_EcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_EcalTruthShower_setPtype(_EcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_EcalTruthShower_getPx(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_EcalTruthShower_setPx(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getPy(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_EcalTruthShower_setPy(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getPz(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_EcalTruthShower_setPz(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getT(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_EcalTruthShower_setT(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getTrack(_EcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_EcalTruthShower_setTrack(_EcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_EcalTruthShower_getX(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_EcalTruthShower_setX(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getY(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_EcalTruthShower_setY(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getZ(_EcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_EcalTruthShower_setZ(_EcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_EcalTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_EcalTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_EcalTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_EcalTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ecalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_EcalTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_EcalTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_EcalTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ecalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_EcalTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ecalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_EcalTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_EcalTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _EcalTruthShower *me = (_EcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ecalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _EcalTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_EcalTruthShower_getE, (setter)_EcalTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_EcalTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_EcalTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_EcalTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_EcalTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_EcalTruthShower_getPrimary, (setter)_EcalTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_EcalTruthShower_getPtype, (setter)_EcalTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_EcalTruthShower_getPx, (setter)_EcalTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_EcalTruthShower_getPy, (setter)_EcalTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_EcalTruthShower_getPz, (setter)_EcalTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_EcalTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_EcalTruthShower_getT, (setter)_EcalTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_EcalTruthShower_getTrack, (setter)_EcalTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_EcalTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_EcalTruthShower_getX, (setter)_EcalTruthShower_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_EcalTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_EcalTruthShower_getY, (setter)_EcalTruthShower_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_EcalTruthShower_getZ, (setter)_EcalTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _EcalTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _EcalTruthShower_methods[] = {
   {"addTrackIDs", _EcalTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this ecalTruthShower"},
   {"addTrackOrigins", _EcalTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this ecalTruthShower"},
   {"deleteTrackIDs", _EcalTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this ecalTruthShower"},
   {"deleteTrackOrigins", _EcalTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this ecalTruthShower"},
   {"getTrackID", _EcalTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this ecalTruthShower"},
   {"getTrackIDs", _EcalTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this ecalTruthShower"},
   {"getTrackOrigin", _EcalTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this ecalTruthShower"},
   {"getTrackOrigins", _EcalTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this ecalTruthShower"},
   {"toString", _EcalTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _EcalTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _EcalTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.EcalTruthShower",         /*tp_name*/
    sizeof(_EcalTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_EcalTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_EcalTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ecalTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _EcalTruthShower_methods,          /* tp_methods */
    _EcalTruthShower_members,          /* tp_members */
    _EcalTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_EcalTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _EcalTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::CrystalEcal as hddm_s.CrystalEcal

typedef struct {
   PyObject_HEAD
   CrystalEcal *elem;
   PyObject *host;
} _CrystalEcal;

static void
_CrystalEcal_dealloc(_CrystalEcal* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CrystalEcal_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CrystalEcal *self;
   self = (_CrystalEcal*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CrystalEcal_init(_CrystalEcal *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CrystalEcal_getClass(_CrystalEcal *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CrystalEcal_getVersion(_CrystalEcal *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CrystalEcal_getXmlns(_CrystalEcal *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CrystalEcal_getEventNo(_CrystalEcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CrystalEcal_getMaxOccurs(_CrystalEcal *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CrystalEcal_getRunNo(_CrystalEcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CrystalEcal_getMinOccurs(_CrystalEcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CrystalEcal_getEcalBlock(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *obj = _EcalBlock_new(&_EcalBlock_type, 0, 0);
   ((_EcalBlock*)obj)->elem = &me->elem->getEcalBlock(index);
   ((_EcalBlock*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CrystalEcal_getEcalBlocks(PyObject *self, PyObject *args)
{
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getEcalBlocks();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CrystalEcal_addEcalBlocks(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalBlockList(me->elem->addEcalBlocks(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CrystalEcal_deleteEcalBlocks(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid CrystalEcal element");
      return NULL;
   }
   me->elem->deleteEcalBlocks(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CrystalEcal_getEcalTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *obj = _EcalTruthShower_new(&_EcalTruthShower_type, 0, 0);
   ((_EcalTruthShower*)obj)->elem = &me->elem->getEcalTruthShower(index);
   ((_EcalTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CrystalEcal_getEcalTruthShowers(PyObject *self, PyObject *args)
{
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getEcalTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CrystalEcal_addEcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid CrystalEcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalTruthShowerList(me->elem->addEcalTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CrystalEcal_deleteEcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid CrystalEcal element");
      return NULL;
   }
   me->elem->deleteEcalTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CrystalEcal_toString(PyObject *self, PyObject *args=0)
{
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CrystalEcal_toXML(PyObject *self, PyObject *args=0)
{
   _CrystalEcal *me = (_CrystalEcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid CrystalEcal element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CrystalEcal_getsetters[] = {
   {(char*)"class",
    (getter)_CrystalEcal_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CrystalEcal_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CrystalEcal_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_CrystalEcal_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CrystalEcal_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_CrystalEcal_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CrystalEcal_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CrystalEcal_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CrystalEcal_methods[] = {
   {"addEcalBlocks", _CrystalEcal_addEcalBlocks, METH_VARARGS,
    "extend (or insert into) the list of ecalBlock objects for this CrystalEcal"},
   {"addEcalTruthShowers", _CrystalEcal_addEcalTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of ecalTruthShower objects for this CrystalEcal"},
   {"deleteEcalBlocks", _CrystalEcal_deleteEcalBlocks, METH_VARARGS,
    "delete ecalBlock objects for this CrystalEcal"},
   {"deleteEcalTruthShowers", _CrystalEcal_deleteEcalTruthShowers, METH_VARARGS,
    "delete ecalTruthShower objects for this CrystalEcal"},
   {"getEcalBlock", _CrystalEcal_getEcalBlock, METH_VARARGS,
    "get an individual ecalBlock object from this CrystalEcal"},
   {"getEcalBlocks", _CrystalEcal_getEcalBlocks, METH_NOARGS,
    "get list of ecalBlock objects for this CrystalEcal"},
   {"getEcalTruthShower", _CrystalEcal_getEcalTruthShower, METH_VARARGS,
    "get an individual ecalTruthShower object from this CrystalEcal"},
   {"getEcalTruthShowers", _CrystalEcal_getEcalTruthShowers, METH_NOARGS,
    "get list of ecalTruthShower objects for this CrystalEcal"},
   {"toString", _CrystalEcal_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CrystalEcal_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CrystalEcal_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CrystalEcal",         /*tp_name*/
    sizeof(_CrystalEcal),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CrystalEcal_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CrystalEcal_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s CrystalEcal element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CrystalEcal_methods,          /* tp_methods */
    _CrystalEcal_members,          /* tp_members */
    _CrystalEcal_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CrystalEcal_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CrystalEcal_new,              /* tp_new */
};



// wrap element class hddm_s::CcalHit as hddm_s.CcalHit

typedef struct {
   PyObject_HEAD
   CcalHit *elem;
   PyObject *host;
} _CcalHit;

static void
_CcalHit_dealloc(_CcalHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CcalHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CcalHit *self;
   self = (_CcalHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CcalHit_init(_CcalHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CcalHit_getClass(_CcalHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalHit_getVersion(_CcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CcalHit_getXmlns(_CcalHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalHit_getEventNo(_CcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CcalHit_getRunNo(_CcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CcalHit_getMinOccurs(_CcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CcalHit_getColumn(_CcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_CcalHit_getRow(_CcalHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_CcalHit_getE(_CcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_CcalHit_setE(_CcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_CcalHit_getMaxOccurs(_CcalHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalHit_getT(_CcalHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CcalHit_setT(_CcalHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CcalHit_toString(PyObject *self, PyObject *args=0)
{
   _CcalHit *me = (_CcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CcalHit_toXML(PyObject *self, PyObject *args=0)
{
   _CcalHit *me = (_CcalHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CcalHit_getsetters[] = {
   {(char*)"E",
    (getter)_CcalHit_getE, (setter)_CcalHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_CcalHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_CcalHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_CcalHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CcalHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CcalHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_CcalHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_CcalHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CcalHit_getT, (setter)_CcalHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CcalHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CcalHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CcalHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CcalHit_methods[] = {
   {"toString", _CcalHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CcalHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CcalHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CcalHit",         /*tp_name*/
    sizeof(_CcalHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CcalHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CcalHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ccalHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CcalHit_methods,          /* tp_methods */
    _CcalHit_members,          /* tp_members */
    _CcalHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CcalHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CcalHit_new,              /* tp_new */
};



// wrap element class hddm_s::CcalTruthHit as hddm_s.CcalTruthHit

typedef struct {
   PyObject_HEAD
   CcalTruthHit *elem;
   PyObject *host;
} _CcalTruthHit;

static void
_CcalTruthHit_dealloc(_CcalTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CcalTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CcalTruthHit *self;
   self = (_CcalTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CcalTruthHit_init(_CcalTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CcalTruthHit_getClass(_CcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthHit_getVersion(_CcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CcalTruthHit_getXmlns(_CcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthHit_getEventNo(_CcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CcalTruthHit_getRunNo(_CcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CcalTruthHit_getMinOccurs(_CcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CcalTruthHit_getColumn(_CcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_CcalTruthHit_getRow(_CcalTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_CcalTruthHit_getE(_CcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_CcalTruthHit_setE(_CcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_CcalTruthHit_getMaxOccurs(_CcalTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthHit_getT(_CcalTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CcalTruthHit_setT(_CcalTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CcalTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _CcalTruthHit *me = (_CcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CcalTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _CcalTruthHit *me = (_CcalTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CcalTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_CcalTruthHit_getE, (setter)_CcalTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_CcalTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_CcalTruthHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_CcalTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CcalTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CcalTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_CcalTruthHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_CcalTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CcalTruthHit_getT, (setter)_CcalTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CcalTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CcalTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CcalTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CcalTruthHit_methods[] = {
   {"toString", _CcalTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CcalTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CcalTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CcalTruthHit",         /*tp_name*/
    sizeof(_CcalTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CcalTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CcalTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ccalTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CcalTruthHit_methods,          /* tp_methods */
    _CcalTruthHit_members,          /* tp_members */
    _CcalTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CcalTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CcalTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::CcalBlock as hddm_s.CcalBlock

typedef struct {
   PyObject_HEAD
   CcalBlock *elem;
   PyObject *host;
} _CcalBlock;

static void
_CcalBlock_dealloc(_CcalBlock* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CcalBlock_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CcalBlock *self;
   self = (_CcalBlock*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CcalBlock_init(_CcalBlock *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CcalBlock_getClass(_CcalBlock *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalBlock_getVersion(_CcalBlock *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CcalBlock_getXmlns(_CcalBlock *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalBlock_getEventNo(_CcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CcalBlock_getRunNo(_CcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CcalBlock_getColumn(_CcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_CcalBlock_setColumn(_CcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_CcalBlock_getMaxOccurs(_CcalBlock *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalBlock_getMinOccurs(_CcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CcalBlock_getRow(_CcalBlock *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static int
_CcalBlock_setRow(_CcalBlock *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRow(var);
   return 0;
}

static PyObject*
_CcalBlock_getCcalHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *obj = _CcalHit_new(&_CcalHit_type, 0, 0);
   ((_CcalHit*)obj)->elem = &me->elem->getCcalHit(index);
   ((_CcalHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CcalBlock_getCcalHits(PyObject *self, PyObject *args)
{
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCcalHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CcalBlock_addCcalHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalHitList(me->elem->addCcalHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CcalBlock_deleteCcalHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ccalBlock element");
      return NULL;
   }
   me->elem->deleteCcalHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CcalBlock_getCcalTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *obj = _CcalTruthHit_new(&_CcalTruthHit_type, 0, 0);
   ((_CcalTruthHit*)obj)->elem = &me->elem->getCcalTruthHit(index);
   ((_CcalTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CcalBlock_getCcalTruthHits(PyObject *self, PyObject *args)
{
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCcalTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CcalBlock_addCcalTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ccalBlock element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalTruthHitList(me->elem->addCcalTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CcalBlock_deleteCcalTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ccalBlock element");
      return NULL;
   }
   me->elem->deleteCcalTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CcalBlock_toString(PyObject *self, PyObject *args=0)
{
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CcalBlock_toXML(PyObject *self, PyObject *args=0)
{
   _CcalBlock *me = (_CcalBlock*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalBlock element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CcalBlock_getsetters[] = {
   {(char*)"class",
    (getter)_CcalBlock_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_CcalBlock_getColumn, (setter)_CcalBlock_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_CcalBlock_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CcalBlock_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CcalBlock_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_CcalBlock_getRow, (setter)_CcalBlock_setRow,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_CcalBlock_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_CcalBlock_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CcalBlock_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CcalBlock_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CcalBlock_methods[] = {
   {"addCcalHits", _CcalBlock_addCcalHits, METH_VARARGS,
    "extend (or insert into) the list of ccalHit objects for this ccalBlock"},
   {"addCcalTruthHits", _CcalBlock_addCcalTruthHits, METH_VARARGS,
    "extend (or insert into) the list of ccalTruthHit objects for this ccalBlock"},
   {"deleteCcalHits", _CcalBlock_deleteCcalHits, METH_VARARGS,
    "delete ccalHit objects for this ccalBlock"},
   {"deleteCcalTruthHits", _CcalBlock_deleteCcalTruthHits, METH_VARARGS,
    "delete ccalTruthHit objects for this ccalBlock"},
   {"getCcalHit", _CcalBlock_getCcalHit, METH_VARARGS,
    "get an individual ccalHit object from this ccalBlock"},
   {"getCcalHits", _CcalBlock_getCcalHits, METH_NOARGS,
    "get list of ccalHit objects for this ccalBlock"},
   {"getCcalTruthHit", _CcalBlock_getCcalTruthHit, METH_VARARGS,
    "get an individual ccalTruthHit object from this ccalBlock"},
   {"getCcalTruthHits", _CcalBlock_getCcalTruthHits, METH_NOARGS,
    "get list of ccalTruthHit objects for this ccalBlock"},
   {"toString", _CcalBlock_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CcalBlock_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CcalBlock_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CcalBlock",         /*tp_name*/
    sizeof(_CcalBlock),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CcalBlock_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CcalBlock_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ccalBlock element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CcalBlock_methods,          /* tp_methods */
    _CcalBlock_members,          /* tp_members */
    _CcalBlock_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CcalBlock_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CcalBlock_new,              /* tp_new */
};



// wrap element class hddm_s::CcalTruthShower as hddm_s.CcalTruthShower

typedef struct {
   PyObject_HEAD
   CcalTruthShower *elem;
   PyObject *host;
} _CcalTruthShower;

static void
_CcalTruthShower_dealloc(_CcalTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CcalTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CcalTruthShower *self;
   self = (_CcalTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CcalTruthShower_init(_CcalTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CcalTruthShower_getClass(_CcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthShower_getVersion(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CcalTruthShower_getXmlns(_CcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthShower_getEventNo(_CcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CcalTruthShower_getRunNo(_CcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CcalTruthShower_getE(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_CcalTruthShower_setE(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getMaxOccurs(_CcalTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CcalTruthShower_getMinOccurs(_CcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CcalTruthShower_getPrimary(_CcalTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_CcalTruthShower_setPrimary(_CcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_CcalTruthShower_getPtype(_CcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_CcalTruthShower_setPtype(_CcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_CcalTruthShower_getPx(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_CcalTruthShower_setPx(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getPy(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_CcalTruthShower_setPy(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getPz(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_CcalTruthShower_setPz(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getT(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CcalTruthShower_setT(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getTrack(_CcalTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_CcalTruthShower_setTrack(_CcalTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_CcalTruthShower_getX(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_CcalTruthShower_setX(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getY(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_CcalTruthShower_setY(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getZ(_CcalTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_CcalTruthShower_setZ(_CcalTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_CcalTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CcalTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CcalTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CcalTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ccalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CcalTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CcalTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CcalTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ccalTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CcalTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ccalTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CcalTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CcalTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _CcalTruthShower *me = (_CcalTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ccalTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CcalTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_CcalTruthShower_getE, (setter)_CcalTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_CcalTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CcalTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CcalTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CcalTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_CcalTruthShower_getPrimary, (setter)_CcalTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_CcalTruthShower_getPtype, (setter)_CcalTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_CcalTruthShower_getPx, (setter)_CcalTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_CcalTruthShower_getPy, (setter)_CcalTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_CcalTruthShower_getPz, (setter)_CcalTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_CcalTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CcalTruthShower_getT, (setter)_CcalTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_CcalTruthShower_getTrack, (setter)_CcalTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_CcalTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_CcalTruthShower_getX, (setter)_CcalTruthShower_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_CcalTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_CcalTruthShower_getY, (setter)_CcalTruthShower_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_CcalTruthShower_getZ, (setter)_CcalTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CcalTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CcalTruthShower_methods[] = {
   {"addTrackIDs", _CcalTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this ccalTruthShower"},
   {"addTrackOrigins", _CcalTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this ccalTruthShower"},
   {"deleteTrackIDs", _CcalTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this ccalTruthShower"},
   {"deleteTrackOrigins", _CcalTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this ccalTruthShower"},
   {"getTrackID", _CcalTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this ccalTruthShower"},
   {"getTrackIDs", _CcalTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this ccalTruthShower"},
   {"getTrackOrigin", _CcalTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this ccalTruthShower"},
   {"getTrackOrigins", _CcalTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this ccalTruthShower"},
   {"toString", _CcalTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CcalTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CcalTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CcalTruthShower",         /*tp_name*/
    sizeof(_CcalTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CcalTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CcalTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ccalTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CcalTruthShower_methods,          /* tp_methods */
    _CcalTruthShower_members,          /* tp_members */
    _CcalTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CcalTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CcalTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::ComptonEMcal as hddm_s.ComptonEMcal

typedef struct {
   PyObject_HEAD
   ComptonEMcal *elem;
   PyObject *host;
} _ComptonEMcal;

static void
_ComptonEMcal_dealloc(_ComptonEMcal* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ComptonEMcal_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ComptonEMcal *self;
   self = (_ComptonEMcal*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ComptonEMcal_init(_ComptonEMcal *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ComptonEMcal_getClass(_ComptonEMcal *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ComptonEMcal_getVersion(_ComptonEMcal *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ComptonEMcal_getXmlns(_ComptonEMcal *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ComptonEMcal_getEventNo(_ComptonEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ComptonEMcal_getMaxOccurs(_ComptonEMcal *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ComptonEMcal_getRunNo(_ComptonEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ComptonEMcal_getMinOccurs(_ComptonEMcal *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ComptonEMcal_getCcalBlock(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *obj = _CcalBlock_new(&_CcalBlock_type, 0, 0);
   ((_CcalBlock*)obj)->elem = &me->elem->getCcalBlock(index);
   ((_CcalBlock*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ComptonEMcal_getCcalBlocks(PyObject *self, PyObject *args)
{
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCcalBlocks();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ComptonEMcal_addCcalBlocks(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalBlockList(me->elem->addCcalBlocks(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ComptonEMcal_deleteCcalBlocks(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ComptonEMcal element");
      return NULL;
   }
   me->elem->deleteCcalBlocks(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ComptonEMcal_getCcalTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *obj = _CcalTruthShower_new(&_CcalTruthShower_type, 0, 0);
   ((_CcalTruthShower*)obj)->elem = &me->elem->getCcalTruthShower(index);
   ((_CcalTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ComptonEMcal_getCcalTruthShowers(PyObject *self, PyObject *args)
{
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCcalTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ComptonEMcal_addCcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ComptonEMcal element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalTruthShowerList(me->elem->addCcalTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ComptonEMcal_deleteCcalTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ComptonEMcal element");
      return NULL;
   }
   me->elem->deleteCcalTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ComptonEMcal_toString(PyObject *self, PyObject *args=0)
{
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ComptonEMcal_toXML(PyObject *self, PyObject *args=0)
{
   _ComptonEMcal *me = (_ComptonEMcal*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ComptonEMcal element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ComptonEMcal_getsetters[] = {
   {(char*)"class",
    (getter)_ComptonEMcal_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ComptonEMcal_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ComptonEMcal_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ComptonEMcal_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ComptonEMcal_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ComptonEMcal_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ComptonEMcal_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ComptonEMcal_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ComptonEMcal_methods[] = {
   {"addCcalBlocks", _ComptonEMcal_addCcalBlocks, METH_VARARGS,
    "extend (or insert into) the list of ccalBlock objects for this ComptonEMcal"},
   {"addCcalTruthShowers", _ComptonEMcal_addCcalTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of ccalTruthShower objects for this ComptonEMcal"},
   {"deleteCcalBlocks", _ComptonEMcal_deleteCcalBlocks, METH_VARARGS,
    "delete ccalBlock objects for this ComptonEMcal"},
   {"deleteCcalTruthShowers", _ComptonEMcal_deleteCcalTruthShowers, METH_VARARGS,
    "delete ccalTruthShower objects for this ComptonEMcal"},
   {"getCcalBlock", _ComptonEMcal_getCcalBlock, METH_VARARGS,
    "get an individual ccalBlock object from this ComptonEMcal"},
   {"getCcalBlocks", _ComptonEMcal_getCcalBlocks, METH_NOARGS,
    "get list of ccalBlock objects for this ComptonEMcal"},
   {"getCcalTruthShower", _ComptonEMcal_getCcalTruthShower, METH_VARARGS,
    "get an individual ccalTruthShower object from this ComptonEMcal"},
   {"getCcalTruthShowers", _ComptonEMcal_getCcalTruthShowers, METH_NOARGS,
    "get list of ccalTruthShower objects for this ComptonEMcal"},
   {"toString", _ComptonEMcal_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ComptonEMcal_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ComptonEMcal_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ComptonEMcal",         /*tp_name*/
    sizeof(_ComptonEMcal),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ComptonEMcal_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ComptonEMcal_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ComptonEMcal element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ComptonEMcal_methods,          /* tp_methods */
    _ComptonEMcal_members,          /* tp_members */
    _ComptonEMcal_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ComptonEMcal_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ComptonEMcal_new,              /* tp_new */
};



// wrap element class hddm_s::UpvHit as hddm_s.UpvHit

typedef struct {
   PyObject_HEAD
   UpvHit *elem;
   PyObject *host;
} _UpvHit;

static void
_UpvHit_dealloc(_UpvHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UpvHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UpvHit *self;
   self = (_UpvHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UpvHit_init(_UpvHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UpvHit_getClass(_UpvHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvHit_getVersion(_UpvHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UpvHit_getXmlns(_UpvHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvHit_getEventNo(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UpvHit_getRunNo(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UpvHit_getLayer(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_UpvHit_getRow(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_UpvHit_getE(_UpvHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_UpvHit_setE(_UpvHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_UpvHit_getEnd(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_UpvHit_setEnd(_UpvHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_UpvHit_getMaxOccurs(_UpvHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvHit_getMinOccurs(_UpvHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UpvHit_getT(_UpvHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_UpvHit_setT(_UpvHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_UpvHit_toString(PyObject *self, PyObject *args=0)
{
   _UpvHit *me = (_UpvHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UpvHit_toXML(PyObject *self, PyObject *args=0)
{
   _UpvHit *me = (_UpvHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UpvHit_getsetters[] = {
   {(char*)"E",
    (getter)_UpvHit_getE, (setter)_UpvHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_UpvHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_UpvHit_getEnd, (setter)_UpvHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_UpvHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_UpvHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UpvHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_UpvHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_UpvHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_UpvHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_UpvHit_getT, (setter)_UpvHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_UpvHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_UpvHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UpvHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UpvHit_methods[] = {
   {"toString", _UpvHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UpvHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UpvHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UpvHit",         /*tp_name*/
    sizeof(_UpvHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UpvHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UpvHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s upvHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UpvHit_methods,          /* tp_methods */
    _UpvHit_members,          /* tp_members */
    _UpvHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UpvHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UpvHit_new,              /* tp_new */
};



// wrap element class hddm_s::UpvTruthHit as hddm_s.UpvTruthHit

typedef struct {
   PyObject_HEAD
   UpvTruthHit *elem;
   PyObject *host;
} _UpvTruthHit;

static void
_UpvTruthHit_dealloc(_UpvTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UpvTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UpvTruthHit *self;
   self = (_UpvTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UpvTruthHit_init(_UpvTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UpvTruthHit_getClass(_UpvTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthHit_getVersion(_UpvTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UpvTruthHit_getXmlns(_UpvTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthHit_getEventNo(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UpvTruthHit_getRunNo(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UpvTruthHit_getLayer(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_UpvTruthHit_getRow(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_UpvTruthHit_getE(_UpvTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_UpvTruthHit_setE(_UpvTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_UpvTruthHit_getEnd(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_UpvTruthHit_setEnd(_UpvTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_UpvTruthHit_getMaxOccurs(_UpvTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthHit_getMinOccurs(_UpvTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UpvTruthHit_getT(_UpvTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_UpvTruthHit_setT(_UpvTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_UpvTruthHit_getXlocal(_UpvTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getXlocal());
}

static int
_UpvTruthHit_setXlocal(_UpvTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setXlocal((float)var);
   return 0;
}

static PyObject*
_UpvTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _UpvTruthHit *me = (_UpvTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UpvTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _UpvTruthHit *me = (_UpvTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UpvTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_UpvTruthHit_getE, (setter)_UpvTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_UpvTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"end",
    (getter)_UpvTruthHit_getEnd, (setter)_UpvTruthHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_UpvTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_UpvTruthHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UpvTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_UpvTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_UpvTruthHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_UpvTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_UpvTruthHit_getT, (setter)_UpvTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_UpvTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xlocal",
    (getter)_UpvTruthHit_getXlocal, (setter)_UpvTruthHit_setXlocal,
    (char*)"xlocal value",
    NULL},
   {(char*)"xmlns",
    (getter)_UpvTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UpvTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UpvTruthHit_methods[] = {
   {"toString", _UpvTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UpvTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UpvTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UpvTruthHit",         /*tp_name*/
    sizeof(_UpvTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UpvTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UpvTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s upvTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UpvTruthHit_methods,          /* tp_methods */
    _UpvTruthHit_members,          /* tp_members */
    _UpvTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UpvTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UpvTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::UpvPaddle as hddm_s.UpvPaddle

typedef struct {
   PyObject_HEAD
   UpvPaddle *elem;
   PyObject *host;
} _UpvPaddle;

static void
_UpvPaddle_dealloc(_UpvPaddle* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UpvPaddle_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UpvPaddle *self;
   self = (_UpvPaddle*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UpvPaddle_init(_UpvPaddle *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UpvPaddle_getClass(_UpvPaddle *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvPaddle_getVersion(_UpvPaddle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UpvPaddle_getXmlns(_UpvPaddle *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvPaddle_getEventNo(_UpvPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UpvPaddle_getRunNo(_UpvPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UpvPaddle_getLayer(_UpvPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static int
_UpvPaddle_setLayer(_UpvPaddle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setLayer(var);
   return 0;
}

static PyObject*
_UpvPaddle_getMaxOccurs(_UpvPaddle *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvPaddle_getMinOccurs(_UpvPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UpvPaddle_getRow(_UpvPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static int
_UpvPaddle_setRow(_UpvPaddle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRow(var);
   return 0;
}

static PyObject*
_UpvPaddle_getUpvHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *obj = _UpvHit_new(&_UpvHit_type, 0, 0);
   ((_UpvHit*)obj)->elem = &me->elem->getUpvHit(index);
   ((_UpvHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpvPaddle_getUpvHits(PyObject *self, PyObject *args)
{
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUpvHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpvPaddle_addUpvHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvHitList(me->elem->addUpvHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpvPaddle_deleteUpvHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upvPaddle element");
      return NULL;
   }
   me->elem->deleteUpvHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpvPaddle_getUpvTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *obj = _UpvTruthHit_new(&_UpvTruthHit_type, 0, 0);
   ((_UpvTruthHit*)obj)->elem = &me->elem->getUpvTruthHit(index);
   ((_UpvTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpvPaddle_getUpvTruthHits(PyObject *self, PyObject *args)
{
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUpvTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpvPaddle_addUpvTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upvPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvTruthHitList(me->elem->addUpvTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpvPaddle_deleteUpvTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upvPaddle element");
      return NULL;
   }
   me->elem->deleteUpvTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpvPaddle_toString(PyObject *self, PyObject *args=0)
{
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UpvPaddle_toXML(PyObject *self, PyObject *args=0)
{
   _UpvPaddle *me = (_UpvPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvPaddle element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UpvPaddle_getsetters[] = {
   {(char*)"class",
    (getter)_UpvPaddle_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_UpvPaddle_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_UpvPaddle_getLayer, (setter)_UpvPaddle_setLayer,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UpvPaddle_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_UpvPaddle_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_UpvPaddle_getRow, (setter)_UpvPaddle_setRow,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_UpvPaddle_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_UpvPaddle_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_UpvPaddle_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UpvPaddle_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UpvPaddle_methods[] = {
   {"addUpvHits", _UpvPaddle_addUpvHits, METH_VARARGS,
    "extend (or insert into) the list of upvHit objects for this upvPaddle"},
   {"addUpvTruthHits", _UpvPaddle_addUpvTruthHits, METH_VARARGS,
    "extend (or insert into) the list of upvTruthHit objects for this upvPaddle"},
   {"deleteUpvHits", _UpvPaddle_deleteUpvHits, METH_VARARGS,
    "delete upvHit objects for this upvPaddle"},
   {"deleteUpvTruthHits", _UpvPaddle_deleteUpvTruthHits, METH_VARARGS,
    "delete upvTruthHit objects for this upvPaddle"},
   {"getUpvHit", _UpvPaddle_getUpvHit, METH_VARARGS,
    "get an individual upvHit object from this upvPaddle"},
   {"getUpvHits", _UpvPaddle_getUpvHits, METH_NOARGS,
    "get list of upvHit objects for this upvPaddle"},
   {"getUpvTruthHit", _UpvPaddle_getUpvTruthHit, METH_VARARGS,
    "get an individual upvTruthHit object from this upvPaddle"},
   {"getUpvTruthHits", _UpvPaddle_getUpvTruthHits, METH_NOARGS,
    "get list of upvTruthHit objects for this upvPaddle"},
   {"toString", _UpvPaddle_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UpvPaddle_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UpvPaddle_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UpvPaddle",         /*tp_name*/
    sizeof(_UpvPaddle),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UpvPaddle_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UpvPaddle_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s upvPaddle element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UpvPaddle_methods,          /* tp_methods */
    _UpvPaddle_members,          /* tp_members */
    _UpvPaddle_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UpvPaddle_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UpvPaddle_new,              /* tp_new */
};



// wrap element class hddm_s::UpvTruthShower as hddm_s.UpvTruthShower

typedef struct {
   PyObject_HEAD
   UpvTruthShower *elem;
   PyObject *host;
} _UpvTruthShower;

static void
_UpvTruthShower_dealloc(_UpvTruthShower* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UpvTruthShower_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UpvTruthShower *self;
   self = (_UpvTruthShower*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UpvTruthShower_init(_UpvTruthShower *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UpvTruthShower_getClass(_UpvTruthShower *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthShower_getVersion(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UpvTruthShower_getXmlns(_UpvTruthShower *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthShower_getEventNo(_UpvTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UpvTruthShower_getRunNo(_UpvTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UpvTruthShower_getE(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_UpvTruthShower_setE(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getMaxOccurs(_UpvTruthShower *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpvTruthShower_getMinOccurs(_UpvTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UpvTruthShower_getPrimary(_UpvTruthShower *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_UpvTruthShower_setPrimary(_UpvTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_UpvTruthShower_getPtype(_UpvTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_UpvTruthShower_setPtype(_UpvTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_UpvTruthShower_getPx(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_UpvTruthShower_setPx(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getPy(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_UpvTruthShower_setPy(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getPz(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_UpvTruthShower_setPz(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getT(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_UpvTruthShower_setT(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getTrack(_UpvTruthShower *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_UpvTruthShower_setTrack(_UpvTruthShower *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_UpvTruthShower_getX(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_UpvTruthShower_setX(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getY(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_UpvTruthShower_setY(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getZ(_UpvTruthShower *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_UpvTruthShower_setZ(_UpvTruthShower *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_UpvTruthShower_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpvTruthShower_getTrackIDs(PyObject *self, PyObject *args)
{
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpvTruthShower_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpvTruthShower_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upvTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpvTruthShower_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpvTruthShower_getTrackOrigins(PyObject *self, PyObject *args)
{
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpvTruthShower_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upvTruthShower element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpvTruthShower_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upvTruthShower element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpvTruthShower_toString(PyObject *self, PyObject *args=0)
{
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UpvTruthShower_toXML(PyObject *self, PyObject *args=0)
{
   _UpvTruthShower *me = (_UpvTruthShower*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upvTruthShower element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UpvTruthShower_getsetters[] = {
   {(char*)"E",
    (getter)_UpvTruthShower_getE, (setter)_UpvTruthShower_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_UpvTruthShower_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_UpvTruthShower_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UpvTruthShower_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_UpvTruthShower_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_UpvTruthShower_getPrimary, (setter)_UpvTruthShower_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_UpvTruthShower_getPtype, (setter)_UpvTruthShower_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_UpvTruthShower_getPx, (setter)_UpvTruthShower_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_UpvTruthShower_getPy, (setter)_UpvTruthShower_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_UpvTruthShower_getPz, (setter)_UpvTruthShower_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_UpvTruthShower_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_UpvTruthShower_getT, (setter)_UpvTruthShower_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_UpvTruthShower_getTrack, (setter)_UpvTruthShower_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_UpvTruthShower_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_UpvTruthShower_getX, (setter)_UpvTruthShower_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_UpvTruthShower_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_UpvTruthShower_getY, (setter)_UpvTruthShower_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_UpvTruthShower_getZ, (setter)_UpvTruthShower_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UpvTruthShower_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UpvTruthShower_methods[] = {
   {"addTrackIDs", _UpvTruthShower_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this upvTruthShower"},
   {"addTrackOrigins", _UpvTruthShower_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this upvTruthShower"},
   {"deleteTrackIDs", _UpvTruthShower_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this upvTruthShower"},
   {"deleteTrackOrigins", _UpvTruthShower_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this upvTruthShower"},
   {"getTrackID", _UpvTruthShower_getTrackID, METH_VARARGS,
    "get an individual trackID object from this upvTruthShower"},
   {"getTrackIDs", _UpvTruthShower_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this upvTruthShower"},
   {"getTrackOrigin", _UpvTruthShower_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this upvTruthShower"},
   {"getTrackOrigins", _UpvTruthShower_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this upvTruthShower"},
   {"toString", _UpvTruthShower_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UpvTruthShower_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UpvTruthShower_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UpvTruthShower",         /*tp_name*/
    sizeof(_UpvTruthShower),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UpvTruthShower_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UpvTruthShower_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s upvTruthShower element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UpvTruthShower_methods,          /* tp_methods */
    _UpvTruthShower_members,          /* tp_members */
    _UpvTruthShower_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UpvTruthShower_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UpvTruthShower_new,              /* tp_new */
};



// wrap element class hddm_s::UpstreamEMveto as hddm_s.UpstreamEMveto

typedef struct {
   PyObject_HEAD
   UpstreamEMveto *elem;
   PyObject *host;
} _UpstreamEMveto;

static void
_UpstreamEMveto_dealloc(_UpstreamEMveto* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_UpstreamEMveto_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _UpstreamEMveto *self;
   self = (_UpstreamEMveto*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_UpstreamEMveto_init(_UpstreamEMveto *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_UpstreamEMveto_getClass(_UpstreamEMveto *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpstreamEMveto_getVersion(_UpstreamEMveto *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_UpstreamEMveto_getXmlns(_UpstreamEMveto *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpstreamEMveto_getEventNo(_UpstreamEMveto *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_UpstreamEMveto_getMaxOccurs(_UpstreamEMveto *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_UpstreamEMveto_getRunNo(_UpstreamEMveto *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_UpstreamEMveto_getMinOccurs(_UpstreamEMveto *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_UpstreamEMveto_getUpvPaddle(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *obj = _UpvPaddle_new(&_UpvPaddle_type, 0, 0);
   ((_UpvPaddle*)obj)->elem = &me->elem->getUpvPaddle(index);
   ((_UpvPaddle*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpstreamEMveto_getUpvPaddles(PyObject *self, PyObject *args)
{
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUpvPaddles();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpstreamEMveto_addUpvPaddles(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvPaddleList(me->elem->addUpvPaddles(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpstreamEMveto_deleteUpvPaddles(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upstreamEMveto element");
      return NULL;
   }
   me->elem->deleteUpvPaddles(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpstreamEMveto_getUpvTruthShower(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *obj = _UpvTruthShower_new(&_UpvTruthShower_type, 0, 0);
   ((_UpvTruthShower*)obj)->elem = &me->elem->getUpvTruthShower(index);
   ((_UpvTruthShower*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_UpstreamEMveto_getUpvTruthShowers(PyObject *self, PyObject *args)
{
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUpvTruthShowers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_UpstreamEMveto_addUpvTruthShowers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid upstreamEMveto element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvTruthShowerList(me->elem->addUpvTruthShowers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_UpstreamEMveto_deleteUpvTruthShowers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid upstreamEMveto element");
      return NULL;
   }
   me->elem->deleteUpvTruthShowers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_UpstreamEMveto_toString(PyObject *self, PyObject *args=0)
{
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_UpstreamEMveto_toXML(PyObject *self, PyObject *args=0)
{
   _UpstreamEMveto *me = (_UpstreamEMveto*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid upstreamEMveto element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _UpstreamEMveto_getsetters[] = {
   {(char*)"class",
    (getter)_UpstreamEMveto_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_UpstreamEMveto_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_UpstreamEMveto_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_UpstreamEMveto_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_UpstreamEMveto_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_UpstreamEMveto_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_UpstreamEMveto_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _UpstreamEMveto_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _UpstreamEMveto_methods[] = {
   {"addUpvPaddles", _UpstreamEMveto_addUpvPaddles, METH_VARARGS,
    "extend (or insert into) the list of upvPaddle objects for this upstreamEMveto"},
   {"addUpvTruthShowers", _UpstreamEMveto_addUpvTruthShowers, METH_VARARGS,
    "extend (or insert into) the list of upvTruthShower objects for this upstreamEMveto"},
   {"deleteUpvPaddles", _UpstreamEMveto_deleteUpvPaddles, METH_VARARGS,
    "delete upvPaddle objects for this upstreamEMveto"},
   {"deleteUpvTruthShowers", _UpstreamEMveto_deleteUpvTruthShowers, METH_VARARGS,
    "delete upvTruthShower objects for this upstreamEMveto"},
   {"getUpvPaddle", _UpstreamEMveto_getUpvPaddle, METH_VARARGS,
    "get an individual upvPaddle object from this upstreamEMveto"},
   {"getUpvPaddles", _UpstreamEMveto_getUpvPaddles, METH_NOARGS,
    "get list of upvPaddle objects for this upstreamEMveto"},
   {"getUpvTruthShower", _UpstreamEMveto_getUpvTruthShower, METH_VARARGS,
    "get an individual upvTruthShower object from this upstreamEMveto"},
   {"getUpvTruthShowers", _UpstreamEMveto_getUpvTruthShowers, METH_NOARGS,
    "get list of upvTruthShower objects for this upstreamEMveto"},
   {"toString", _UpstreamEMveto_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _UpstreamEMveto_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _UpstreamEMveto_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.UpstreamEMveto",         /*tp_name*/
    sizeof(_UpstreamEMveto),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_UpstreamEMveto_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_UpstreamEMveto_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s upstreamEMveto element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _UpstreamEMveto_methods,          /* tp_methods */
    _UpstreamEMveto_members,          /* tp_members */
    _UpstreamEMveto_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_UpstreamEMveto_init,   /* tp_init */
    0,                         /* tp_alloc */
    _UpstreamEMveto_new,              /* tp_new */
};



// wrap element class hddm_s::TaggerHit as hddm_s.TaggerHit

typedef struct {
   PyObject_HEAD
   TaggerHit *elem;
   PyObject *host;
} _TaggerHit;

static void
_TaggerHit_dealloc(_TaggerHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TaggerHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TaggerHit *self;
   self = (_TaggerHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TaggerHit_init(_TaggerHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TaggerHit_getClass(_TaggerHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerHit_getVersion(_TaggerHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TaggerHit_getXmlns(_TaggerHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerHit_getEventNo(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TaggerHit_getRunNo(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TaggerHit_getE(_TaggerHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static PyObject*
_TaggerHit_getCounterId(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCounterId());
}

static PyObject*
_TaggerHit_getColumn(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_TaggerHit_getRow(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_TaggerHit_getMaxOccurs(_TaggerHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerHit_getMinOccurs(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TaggerHit_getNpe(_TaggerHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNpe());
}

static int
_TaggerHit_setNpe(_TaggerHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNpe(var);
   return 0;
}

static PyObject*
_TaggerHit_getT(_TaggerHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TaggerHit_setT(_TaggerHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TaggerHit_getTADC(_TaggerHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTADC());
}

static int
_TaggerHit_setTADC(_TaggerHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setTADC((float)var);
   return 0;
}

static PyObject*
_TaggerHit_toString(PyObject *self, PyObject *args=0)
{
   _TaggerHit *me = (_TaggerHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid taggerHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TaggerHit_toXML(PyObject *self, PyObject *args=0)
{
   _TaggerHit *me = (_TaggerHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid taggerHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TaggerHit_getsetters[] = {
   {(char*)"E",
    (getter)_TaggerHit_getE, 0,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_TaggerHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_TaggerHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"counterId",
    (getter)_TaggerHit_getCounterId, 0,
    (char*)"counterId value",
    NULL},
   {(char*)"eventNo",
    (getter)_TaggerHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TaggerHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TaggerHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"npe",
    (getter)_TaggerHit_getNpe, (setter)_TaggerHit_setNpe,
    (char*)"npe value",
    NULL},
   {(char*)"row",
    (getter)_TaggerHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_TaggerHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_TaggerHit_getT, (setter)_TaggerHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"tADC",
    (getter)_TaggerHit_getTADC, (setter)_TaggerHit_setTADC,
    (char*)"tADC value",
    NULL},
   {(char*)"version",
    (getter)_TaggerHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TaggerHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TaggerHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TaggerHit_methods[] = {
   {"toString", _TaggerHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TaggerHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TaggerHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TaggerHit",         /*tp_name*/
    sizeof(_TaggerHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TaggerHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TaggerHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s taggerHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TaggerHit_methods,          /* tp_methods */
    _TaggerHit_members,          /* tp_members */
    _TaggerHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TaggerHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TaggerHit_new,              /* tp_new */
};



// wrap element class hddm_s::TaggerTruthHit as hddm_s.TaggerTruthHit

typedef struct {
   PyObject_HEAD
   TaggerTruthHit *elem;
   PyObject *host;
} _TaggerTruthHit;

static void
_TaggerTruthHit_dealloc(_TaggerTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TaggerTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TaggerTruthHit *self;
   self = (_TaggerTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TaggerTruthHit_init(_TaggerTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TaggerTruthHit_getClass(_TaggerTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerTruthHit_getVersion(_TaggerTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TaggerTruthHit_getXmlns(_TaggerTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerTruthHit_getEventNo(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TaggerTruthHit_getRunNo(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TaggerTruthHit_getCounterId(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCounterId());
}

static PyObject*
_TaggerTruthHit_getColumn(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_TaggerTruthHit_getRow(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static PyObject*
_TaggerTruthHit_getE(_TaggerTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_TaggerTruthHit_setE(_TaggerTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_TaggerTruthHit_getBg(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBg());
}

static int
_TaggerTruthHit_setBg(_TaggerTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setBg(var);
   return 0;
}

static PyObject*
_TaggerTruthHit_getDE(_TaggerTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_TaggerTruthHit_setDE(_TaggerTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_TaggerTruthHit_getMaxOccurs(_TaggerTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TaggerTruthHit_getMinOccurs(_TaggerTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TaggerTruthHit_getT(_TaggerTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TaggerTruthHit_setT(_TaggerTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TaggerTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _TaggerTruthHit *me = (_TaggerTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid taggerTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TaggerTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _TaggerTruthHit *me = (_TaggerTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid taggerTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TaggerTruthHit_getsetters[] = {
   {(char*)"E",
    (getter)_TaggerTruthHit_getE, (setter)_TaggerTruthHit_setE,
    (char*)"E value",
    NULL},
   {(char*)"bg",
    (getter)_TaggerTruthHit_getBg, (setter)_TaggerTruthHit_setBg,
    (char*)"bg value",
    NULL},
   {(char*)"class",
    (getter)_TaggerTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_TaggerTruthHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"counterId",
    (getter)_TaggerTruthHit_getCounterId, 0,
    (char*)"counterId value",
    NULL},
   {(char*)"dE",
    (getter)_TaggerTruthHit_getDE, (setter)_TaggerTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_TaggerTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TaggerTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TaggerTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_TaggerTruthHit_getRow, 0,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_TaggerTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_TaggerTruthHit_getT, (setter)_TaggerTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_TaggerTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TaggerTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TaggerTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TaggerTruthHit_methods[] = {
   {"toString", _TaggerTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TaggerTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TaggerTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TaggerTruthHit",         /*tp_name*/
    sizeof(_TaggerTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TaggerTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TaggerTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s taggerTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TaggerTruthHit_methods,          /* tp_methods */
    _TaggerTruthHit_members,          /* tp_members */
    _TaggerTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TaggerTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TaggerTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::MicroChannel as hddm_s.MicroChannel

typedef struct {
   PyObject_HEAD
   MicroChannel *elem;
   PyObject *host;
} _MicroChannel;

static void
_MicroChannel_dealloc(_MicroChannel* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_MicroChannel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _MicroChannel *self;
   self = (_MicroChannel*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_MicroChannel_init(_MicroChannel *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_MicroChannel_getClass(_MicroChannel *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_MicroChannel_getVersion(_MicroChannel *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_MicroChannel_getXmlns(_MicroChannel *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_MicroChannel_getEventNo(_MicroChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_MicroChannel_getRunNo(_MicroChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_MicroChannel_getE(_MicroChannel *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_MicroChannel_setE(_MicroChannel *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_MicroChannel_getColumn(_MicroChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_MicroChannel_setColumn(_MicroChannel *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_MicroChannel_getMaxOccurs(_MicroChannel *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_MicroChannel_getMinOccurs(_MicroChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_MicroChannel_getRow(_MicroChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRow());
}

static int
_MicroChannel_setRow(_MicroChannel *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRow(var);
   return 0;
}

static PyObject*
_MicroChannel_getTaggerHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *obj = _TaggerHit_new(&_TaggerHit_type, 0, 0);
   ((_TaggerHit*)obj)->elem = &me->elem->getTaggerHit(index);
   ((_TaggerHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_MicroChannel_getTaggerHits(PyObject *self, PyObject *args)
{
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTaggerHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_MicroChannel_addTaggerHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerHitList(me->elem->addTaggerHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_MicroChannel_deleteTaggerHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid microChannel element");
      return NULL;
   }
   me->elem->deleteTaggerHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_MicroChannel_getTaggerTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *obj = _TaggerTruthHit_new(&_TaggerTruthHit_type, 0, 0);
   ((_TaggerTruthHit*)obj)->elem = &me->elem->getTaggerTruthHit(index);
   ((_TaggerTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_MicroChannel_getTaggerTruthHits(PyObject *self, PyObject *args)
{
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTaggerTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_MicroChannel_addTaggerTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid microChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerTruthHitList(me->elem->addTaggerTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_MicroChannel_deleteTaggerTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid microChannel element");
      return NULL;
   }
   me->elem->deleteTaggerTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_MicroChannel_toString(PyObject *self, PyObject *args=0)
{
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_MicroChannel_toXML(PyObject *self, PyObject *args=0)
{
   _MicroChannel *me = (_MicroChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid microChannel element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _MicroChannel_getsetters[] = {
   {(char*)"E",
    (getter)_MicroChannel_getE, (setter)_MicroChannel_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_MicroChannel_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_MicroChannel_getColumn, (setter)_MicroChannel_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_MicroChannel_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_MicroChannel_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_MicroChannel_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"row",
    (getter)_MicroChannel_getRow, (setter)_MicroChannel_setRow,
    (char*)"row value",
    NULL},
   {(char*)"runNo",
    (getter)_MicroChannel_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_MicroChannel_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_MicroChannel_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _MicroChannel_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _MicroChannel_methods[] = {
   {"addTaggerHits", _MicroChannel_addTaggerHits, METH_VARARGS,
    "extend (or insert into) the list of taggerHit objects for this microChannel"},
   {"addTaggerTruthHits", _MicroChannel_addTaggerTruthHits, METH_VARARGS,
    "extend (or insert into) the list of taggerTruthHit objects for this microChannel"},
   {"deleteTaggerHits", _MicroChannel_deleteTaggerHits, METH_VARARGS,
    "delete taggerHit objects for this microChannel"},
   {"deleteTaggerTruthHits", _MicroChannel_deleteTaggerTruthHits, METH_VARARGS,
    "delete taggerTruthHit objects for this microChannel"},
   {"getTaggerHit", _MicroChannel_getTaggerHit, METH_VARARGS,
    "get an individual taggerHit object from this microChannel"},
   {"getTaggerHits", _MicroChannel_getTaggerHits, METH_NOARGS,
    "get list of taggerHit objects for this microChannel"},
   {"getTaggerTruthHit", _MicroChannel_getTaggerTruthHit, METH_VARARGS,
    "get an individual taggerTruthHit object from this microChannel"},
   {"getTaggerTruthHits", _MicroChannel_getTaggerTruthHits, METH_NOARGS,
    "get list of taggerTruthHit objects for this microChannel"},
   {"toString", _MicroChannel_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _MicroChannel_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _MicroChannel_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.MicroChannel",         /*tp_name*/
    sizeof(_MicroChannel),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_MicroChannel_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_MicroChannel_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s microChannel element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _MicroChannel_methods,          /* tp_methods */
    _MicroChannel_members,          /* tp_members */
    _MicroChannel_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_MicroChannel_init,   /* tp_init */
    0,                         /* tp_alloc */
    _MicroChannel_new,              /* tp_new */
};



// wrap element class hddm_s::HodoChannel as hddm_s.HodoChannel

typedef struct {
   PyObject_HEAD
   HodoChannel *elem;
   PyObject *host;
} _HodoChannel;

static void
_HodoChannel_dealloc(_HodoChannel* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_HodoChannel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _HodoChannel *self;
   self = (_HodoChannel*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_HodoChannel_init(_HodoChannel *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_HodoChannel_getClass(_HodoChannel *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HodoChannel_getVersion(_HodoChannel *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_HodoChannel_getXmlns(_HodoChannel *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HodoChannel_getEventNo(_HodoChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_HodoChannel_getRunNo(_HodoChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_HodoChannel_getE(_HodoChannel *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_HodoChannel_setE(_HodoChannel *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_HodoChannel_getCounterId(_HodoChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCounterId());
}

static int
_HodoChannel_setCounterId(_HodoChannel *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setCounterId(var);
   return 0;
}

static PyObject*
_HodoChannel_getMaxOccurs(_HodoChannel *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HodoChannel_getMinOccurs(_HodoChannel *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_HodoChannel_getTaggerHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *obj = _TaggerHit_new(&_TaggerHit_type, 0, 0);
   ((_TaggerHit*)obj)->elem = &me->elem->getTaggerHit(index);
   ((_TaggerHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HodoChannel_getTaggerHits(PyObject *self, PyObject *args)
{
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTaggerHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HodoChannel_addTaggerHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerHitList(me->elem->addTaggerHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HodoChannel_deleteTaggerHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hodoChannel element");
      return NULL;
   }
   me->elem->deleteTaggerHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HodoChannel_getTaggerTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *obj = _TaggerTruthHit_new(&_TaggerTruthHit_type, 0, 0);
   ((_TaggerTruthHit*)obj)->elem = &me->elem->getTaggerTruthHit(index);
   ((_TaggerTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HodoChannel_getTaggerTruthHits(PyObject *self, PyObject *args)
{
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTaggerTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HodoChannel_addTaggerTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hodoChannel element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerTruthHitList(me->elem->addTaggerTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HodoChannel_deleteTaggerTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hodoChannel element");
      return NULL;
   }
   me->elem->deleteTaggerTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HodoChannel_toString(PyObject *self, PyObject *args=0)
{
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_HodoChannel_toXML(PyObject *self, PyObject *args=0)
{
   _HodoChannel *me = (_HodoChannel*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hodoChannel element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _HodoChannel_getsetters[] = {
   {(char*)"E",
    (getter)_HodoChannel_getE, (setter)_HodoChannel_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_HodoChannel_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"counterId",
    (getter)_HodoChannel_getCounterId, (setter)_HodoChannel_setCounterId,
    (char*)"counterId value",
    NULL},
   {(char*)"eventNo",
    (getter)_HodoChannel_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_HodoChannel_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_HodoChannel_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_HodoChannel_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_HodoChannel_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_HodoChannel_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _HodoChannel_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _HodoChannel_methods[] = {
   {"addTaggerHits", _HodoChannel_addTaggerHits, METH_VARARGS,
    "extend (or insert into) the list of taggerHit objects for this hodoChannel"},
   {"addTaggerTruthHits", _HodoChannel_addTaggerTruthHits, METH_VARARGS,
    "extend (or insert into) the list of taggerTruthHit objects for this hodoChannel"},
   {"deleteTaggerHits", _HodoChannel_deleteTaggerHits, METH_VARARGS,
    "delete taggerHit objects for this hodoChannel"},
   {"deleteTaggerTruthHits", _HodoChannel_deleteTaggerTruthHits, METH_VARARGS,
    "delete taggerTruthHit objects for this hodoChannel"},
   {"getTaggerHit", _HodoChannel_getTaggerHit, METH_VARARGS,
    "get an individual taggerHit object from this hodoChannel"},
   {"getTaggerHits", _HodoChannel_getTaggerHits, METH_NOARGS,
    "get list of taggerHit objects for this hodoChannel"},
   {"getTaggerTruthHit", _HodoChannel_getTaggerTruthHit, METH_VARARGS,
    "get an individual taggerTruthHit object from this hodoChannel"},
   {"getTaggerTruthHits", _HodoChannel_getTaggerTruthHits, METH_NOARGS,
    "get list of taggerTruthHit objects for this hodoChannel"},
   {"toString", _HodoChannel_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _HodoChannel_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _HodoChannel_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.HodoChannel",         /*tp_name*/
    sizeof(_HodoChannel),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_HodoChannel_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_HodoChannel_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s hodoChannel element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _HodoChannel_methods,          /* tp_methods */
    _HodoChannel_members,          /* tp_members */
    _HodoChannel_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_HodoChannel_init,   /* tp_init */
    0,                         /* tp_alloc */
    _HodoChannel_new,              /* tp_new */
};



// wrap element class hddm_s::Tagger as hddm_s.Tagger

typedef struct {
   PyObject_HEAD
   Tagger *elem;
   PyObject *host;
} _Tagger;

static void
_Tagger_dealloc(_Tagger* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Tagger_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Tagger *self;
   self = (_Tagger*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Tagger_init(_Tagger *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Tagger_getClass(_Tagger *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tagger_getVersion(_Tagger *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Tagger_getXmlns(_Tagger *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tagger_getEventNo(_Tagger *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Tagger_getMaxOccurs(_Tagger *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tagger_getRunNo(_Tagger *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Tagger_getMinOccurs(_Tagger *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Tagger_getMicroChannel(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   PyObject *obj = _MicroChannel_new(&_MicroChannel_type, 0, 0);
   ((_MicroChannel*)obj)->elem = &me->elem->getMicroChannel(index);
   ((_MicroChannel*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tagger_getMicroChannels(PyObject *self, PyObject *args)
{
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_MicroChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMicroChannels();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tagger_addMicroChannels(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tagger element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_MicroChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MicroChannelList(me->elem->addMicroChannels(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tagger_deleteMicroChannels(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tagger element");
      return NULL;
   }
   me->elem->deleteMicroChannels(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tagger_getHodoChannel(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   PyObject *obj = _HodoChannel_new(&_HodoChannel_type, 0, 0);
   ((_HodoChannel*)obj)->elem = &me->elem->getHodoChannel(index);
   ((_HodoChannel*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tagger_getHodoChannels(PyObject *self, PyObject *args)
{
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HodoChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getHodoChannels();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tagger_addHodoChannels(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tagger element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HodoChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new HodoChannelList(me->elem->addHodoChannels(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tagger_deleteHodoChannels(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tagger element");
      return NULL;
   }
   me->elem->deleteHodoChannels(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tagger_toString(PyObject *self, PyObject *args=0)
{
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Tagger_toXML(PyObject *self, PyObject *args=0)
{
   _Tagger *me = (_Tagger*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tagger element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Tagger_getsetters[] = {
   {(char*)"class",
    (getter)_Tagger_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Tagger_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Tagger_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_Tagger_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Tagger_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_Tagger_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_Tagger_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Tagger_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Tagger_methods[] = {
   {"addHodoChannels", _Tagger_addHodoChannels, METH_VARARGS,
    "extend (or insert into) the list of hodoChannel objects for this tagger"},
   {"addMicroChannels", _Tagger_addMicroChannels, METH_VARARGS,
    "extend (or insert into) the list of microChannel objects for this tagger"},
   {"deleteHodoChannels", _Tagger_deleteHodoChannels, METH_VARARGS,
    "delete hodoChannel objects for this tagger"},
   {"deleteMicroChannels", _Tagger_deleteMicroChannels, METH_VARARGS,
    "delete microChannel objects for this tagger"},
   {"getHodoChannel", _Tagger_getHodoChannel, METH_VARARGS,
    "get an individual hodoChannel object from this tagger"},
   {"getHodoChannels", _Tagger_getHodoChannels, METH_NOARGS,
    "get list of hodoChannel objects for this tagger"},
   {"getMicroChannel", _Tagger_getMicroChannel, METH_VARARGS,
    "get an individual microChannel object from this tagger"},
   {"getMicroChannels", _Tagger_getMicroChannels, METH_NOARGS,
    "get list of microChannel objects for this tagger"},
   {"toString", _Tagger_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Tagger_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Tagger_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Tagger",         /*tp_name*/
    sizeof(_Tagger),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Tagger_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Tagger_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tagger element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Tagger_methods,          /* tp_methods */
    _Tagger_members,          /* tp_members */
    _Tagger_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Tagger_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Tagger_new,              /* tp_new */
};



// wrap element class hddm_s::PsHit as hddm_s.PsHit

typedef struct {
   PyObject_HEAD
   PsHit *elem;
   PyObject *host;
} _PsHit;

static void
_PsHit_dealloc(_PsHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PsHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PsHit *self;
   self = (_PsHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PsHit_init(_PsHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PsHit_getClass(_PsHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsHit_getVersion(_PsHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PsHit_getXmlns(_PsHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsHit_getEventNo(_PsHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PsHit_getRunNo(_PsHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PsHit_getMinOccurs(_PsHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PsHit_getArm(_PsHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_PsHit_getColumn(_PsHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_PsHit_getDE(_PsHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_PsHit_setDE(_PsHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_PsHit_getMaxOccurs(_PsHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsHit_getT(_PsHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PsHit_setT(_PsHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PsHit_toString(PyObject *self, PyObject *args=0)
{
   _PsHit *me = (_PsHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PsHit_toXML(PyObject *self, PyObject *args=0)
{
   _PsHit *me = (_PsHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PsHit_getsetters[] = {
   {(char*)"arm",
    (getter)_PsHit_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PsHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_PsHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"dE",
    (getter)_PsHit_getDE, (setter)_PsHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_PsHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PsHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PsHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_PsHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PsHit_getT, (setter)_PsHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_PsHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PsHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PsHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PsHit_methods[] = {
   {"toString", _PsHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PsHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PsHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PsHit",         /*tp_name*/
    sizeof(_PsHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PsHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PsHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s psHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PsHit_methods,          /* tp_methods */
    _PsHit_members,          /* tp_members */
    _PsHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PsHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PsHit_new,              /* tp_new */
};



// wrap element class hddm_s::PsTruthHit as hddm_s.PsTruthHit

typedef struct {
   PyObject_HEAD
   PsTruthHit *elem;
   PyObject *host;
} _PsTruthHit;

static void
_PsTruthHit_dealloc(_PsTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PsTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PsTruthHit *self;
   self = (_PsTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PsTruthHit_init(_PsTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PsTruthHit_getClass(_PsTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthHit_getVersion(_PsTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PsTruthHit_getXmlns(_PsTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthHit_getEventNo(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PsTruthHit_getRunNo(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PsTruthHit_getMinOccurs(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PsTruthHit_getArm(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_PsTruthHit_getColumn(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static PyObject*
_PsTruthHit_getDE(_PsTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_PsTruthHit_setDE(_PsTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_PsTruthHit_getItrack(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_PsTruthHit_setItrack(_PsTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_PsTruthHit_getMaxOccurs(_PsTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthHit_getPtype(_PsTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_PsTruthHit_setPtype(_PsTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_PsTruthHit_getT(_PsTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PsTruthHit_setT(_PsTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PsTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _PsTruthHit *me = (_PsTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PsTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _PsTruthHit *me = (_PsTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PsTruthHit_getsetters[] = {
   {(char*)"arm",
    (getter)_PsTruthHit_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PsTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_PsTruthHit_getColumn, 0,
    (char*)"column value",
    NULL},
   {(char*)"dE",
    (getter)_PsTruthHit_getDE, (setter)_PsTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_PsTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_PsTruthHit_getItrack, (setter)_PsTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PsTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PsTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ptype",
    (getter)_PsTruthHit_getPtype, (setter)_PsTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"runNo",
    (getter)_PsTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PsTruthHit_getT, (setter)_PsTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_PsTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PsTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PsTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PsTruthHit_methods[] = {
   {"toString", _PsTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PsTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PsTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PsTruthHit",         /*tp_name*/
    sizeof(_PsTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PsTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PsTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s psTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PsTruthHit_methods,          /* tp_methods */
    _PsTruthHit_members,          /* tp_members */
    _PsTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PsTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PsTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::PsTile as hddm_s.PsTile

typedef struct {
   PyObject_HEAD
   PsTile *elem;
   PyObject *host;
} _PsTile;

static void
_PsTile_dealloc(_PsTile* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PsTile_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PsTile *self;
   self = (_PsTile*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PsTile_init(_PsTile *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PsTile_getClass(_PsTile *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTile_getVersion(_PsTile *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PsTile_getXmlns(_PsTile *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTile_getEventNo(_PsTile *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PsTile_getRunNo(_PsTile *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PsTile_getArm(_PsTile *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static int
_PsTile_setArm(_PsTile *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setArm(var);
   return 0;
}

static PyObject*
_PsTile_getColumn(_PsTile *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_PsTile_setColumn(_PsTile *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_PsTile_getMaxOccurs(_PsTile *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTile_getMinOccurs(_PsTile *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PsTile_getPsHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   PyObject *obj = _PsHit_new(&_PsHit_type, 0, 0);
   ((_PsHit*)obj)->elem = &me->elem->getPsHit(index);
   ((_PsHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PsTile_getPsHits(PyObject *self, PyObject *args)
{
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPsHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PsTile_addPsHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid psTile element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsHitList(me->elem->addPsHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PsTile_deletePsHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid psTile element");
      return NULL;
   }
   me->elem->deletePsHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PsTile_getPsTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   PyObject *obj = _PsTruthHit_new(&_PsTruthHit_type, 0, 0);
   ((_PsTruthHit*)obj)->elem = &me->elem->getPsTruthHit(index);
   ((_PsTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PsTile_getPsTruthHits(PyObject *self, PyObject *args)
{
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPsTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PsTile_addPsTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid psTile element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTruthHitList(me->elem->addPsTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PsTile_deletePsTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid psTile element");
      return NULL;
   }
   me->elem->deletePsTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PsTile_toString(PyObject *self, PyObject *args=0)
{
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PsTile_toXML(PyObject *self, PyObject *args=0)
{
   _PsTile *me = (_PsTile*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTile element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PsTile_getsetters[] = {
   {(char*)"arm",
    (getter)_PsTile_getArm, (setter)_PsTile_setArm,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PsTile_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_PsTile_getColumn, (setter)_PsTile_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"eventNo",
    (getter)_PsTile_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PsTile_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PsTile_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_PsTile_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_PsTile_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PsTile_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PsTile_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PsTile_methods[] = {
   {"addPsHits", _PsTile_addPsHits, METH_VARARGS,
    "extend (or insert into) the list of psHit objects for this psTile"},
   {"addPsTruthHits", _PsTile_addPsTruthHits, METH_VARARGS,
    "extend (or insert into) the list of psTruthHit objects for this psTile"},
   {"deletePsHits", _PsTile_deletePsHits, METH_VARARGS,
    "delete psHit objects for this psTile"},
   {"deletePsTruthHits", _PsTile_deletePsTruthHits, METH_VARARGS,
    "delete psTruthHit objects for this psTile"},
   {"getPsHit", _PsTile_getPsHit, METH_VARARGS,
    "get an individual psHit object from this psTile"},
   {"getPsHits", _PsTile_getPsHits, METH_NOARGS,
    "get list of psHit objects for this psTile"},
   {"getPsTruthHit", _PsTile_getPsTruthHit, METH_VARARGS,
    "get an individual psTruthHit object from this psTile"},
   {"getPsTruthHits", _PsTile_getPsTruthHits, METH_NOARGS,
    "get list of psTruthHit objects for this psTile"},
   {"toString", _PsTile_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PsTile_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PsTile_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PsTile",         /*tp_name*/
    sizeof(_PsTile),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PsTile_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PsTile_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s psTile element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PsTile_methods,          /* tp_methods */
    _PsTile_members,          /* tp_members */
    _PsTile_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PsTile_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PsTile_new,              /* tp_new */
};



// wrap element class hddm_s::PsTruthPoint as hddm_s.PsTruthPoint

typedef struct {
   PyObject_HEAD
   PsTruthPoint *elem;
   PyObject *host;
} _PsTruthPoint;

static void
_PsTruthPoint_dealloc(_PsTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PsTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PsTruthPoint *self;
   self = (_PsTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PsTruthPoint_init(_PsTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PsTruthPoint_getClass(_PsTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthPoint_getVersion(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PsTruthPoint_getXmlns(_PsTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthPoint_getEventNo(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PsTruthPoint_getRunNo(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PsTruthPoint_getE(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_PsTruthPoint_setE(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getArm(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static int
_PsTruthPoint_setArm(_PsTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setArm(var);
   return 0;
}

static PyObject*
_PsTruthPoint_getColumn(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getColumn());
}

static int
_PsTruthPoint_setColumn(_PsTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setColumn(var);
   return 0;
}

static PyObject*
_PsTruthPoint_getDEdx(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_PsTruthPoint_setDEdx(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getMaxOccurs(_PsTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PsTruthPoint_getMinOccurs(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PsTruthPoint_getPrimary(_PsTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_PsTruthPoint_setPrimary(_PsTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_PsTruthPoint_getPtype(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_PsTruthPoint_setPtype(_PsTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_PsTruthPoint_getPx(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_PsTruthPoint_setPx(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getPy(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_PsTruthPoint_setPy(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getPz(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_PsTruthPoint_setPz(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getT(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PsTruthPoint_setT(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getTrack(_PsTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_PsTruthPoint_setTrack(_PsTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_PsTruthPoint_getX(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_PsTruthPoint_setX(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getY(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_PsTruthPoint_setY(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getZ(_PsTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_PsTruthPoint_setZ(_PsTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_PsTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PsTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PsTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PsTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid psTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PsTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PsTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PsTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid psTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PsTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid psTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PsTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PsTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _PsTruthPoint *me = (_PsTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid psTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PsTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_PsTruthPoint_getE, (setter)_PsTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"arm",
    (getter)_PsTruthPoint_getArm, (setter)_PsTruthPoint_setArm,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PsTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"column",
    (getter)_PsTruthPoint_getColumn, (setter)_PsTruthPoint_setColumn,
    (char*)"column value",
    NULL},
   {(char*)"dEdx",
    (getter)_PsTruthPoint_getDEdx, (setter)_PsTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"eventNo",
    (getter)_PsTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PsTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PsTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_PsTruthPoint_getPrimary, (setter)_PsTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_PsTruthPoint_getPtype, (setter)_PsTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_PsTruthPoint_getPx, (setter)_PsTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_PsTruthPoint_getPy, (setter)_PsTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_PsTruthPoint_getPz, (setter)_PsTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_PsTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PsTruthPoint_getT, (setter)_PsTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_PsTruthPoint_getTrack, (setter)_PsTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_PsTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_PsTruthPoint_getX, (setter)_PsTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_PsTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_PsTruthPoint_getY, (setter)_PsTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_PsTruthPoint_getZ, (setter)_PsTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PsTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PsTruthPoint_methods[] = {
   {"addTrackIDs", _PsTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this psTruthPoint"},
   {"addTrackOrigins", _PsTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this psTruthPoint"},
   {"deleteTrackIDs", _PsTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this psTruthPoint"},
   {"deleteTrackOrigins", _PsTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this psTruthPoint"},
   {"getTrackID", _PsTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this psTruthPoint"},
   {"getTrackIDs", _PsTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this psTruthPoint"},
   {"getTrackOrigin", _PsTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this psTruthPoint"},
   {"getTrackOrigins", _PsTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this psTruthPoint"},
   {"toString", _PsTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PsTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PsTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PsTruthPoint",         /*tp_name*/
    sizeof(_PsTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PsTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PsTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s psTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PsTruthPoint_methods,          /* tp_methods */
    _PsTruthPoint_members,          /* tp_members */
    _PsTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PsTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PsTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::PairSpectrometerFine as hddm_s.PairSpectrometerFine

typedef struct {
   PyObject_HEAD
   PairSpectrometerFine *elem;
   PyObject *host;
} _PairSpectrometerFine;

static void
_PairSpectrometerFine_dealloc(_PairSpectrometerFine* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PairSpectrometerFine_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PairSpectrometerFine *self;
   self = (_PairSpectrometerFine*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PairSpectrometerFine_init(_PairSpectrometerFine *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PairSpectrometerFine_getClass(_PairSpectrometerFine *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerFine_getVersion(_PairSpectrometerFine *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PairSpectrometerFine_getXmlns(_PairSpectrometerFine *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerFine_getEventNo(_PairSpectrometerFine *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PairSpectrometerFine_getMaxOccurs(_PairSpectrometerFine *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerFine_getRunNo(_PairSpectrometerFine *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PairSpectrometerFine_getMinOccurs(_PairSpectrometerFine *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PairSpectrometerFine_getPsTile(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *obj = _PsTile_new(&_PsTile_type, 0, 0);
   ((_PsTile*)obj)->elem = &me->elem->getPsTile(index);
   ((_PsTile*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PairSpectrometerFine_getPsTiles(PyObject *self, PyObject *args)
{
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTile_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPsTiles();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PairSpectrometerFine_addPsTiles(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTile_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTileList(me->elem->addPsTiles(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PairSpectrometerFine_deletePsTiles(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   me->elem->deletePsTiles(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PairSpectrometerFine_getPsTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *obj = _PsTruthPoint_new(&_PsTruthPoint_type, 0, 0);
   ((_PsTruthPoint*)obj)->elem = &me->elem->getPsTruthPoint(index);
   ((_PsTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PairSpectrometerFine_getPsTruthPoints(PyObject *self, PyObject *args)
{
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPsTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PairSpectrometerFine_addPsTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTruthPointList(me->elem->addPsTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PairSpectrometerFine_deletePsTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   me->elem->deletePsTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PairSpectrometerFine_toString(PyObject *self, PyObject *args=0)
{
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PairSpectrometerFine_toXML(PyObject *self, PyObject *args=0)
{
   _PairSpectrometerFine *me = (_PairSpectrometerFine*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerFine element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PairSpectrometerFine_getsetters[] = {
   {(char*)"class",
    (getter)_PairSpectrometerFine_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_PairSpectrometerFine_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PairSpectrometerFine_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_PairSpectrometerFine_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_PairSpectrometerFine_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_PairSpectrometerFine_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PairSpectrometerFine_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PairSpectrometerFine_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PairSpectrometerFine_methods[] = {
   {"addPsTiles", _PairSpectrometerFine_addPsTiles, METH_VARARGS,
    "extend (or insert into) the list of psTile objects for this pairSpectrometerFine"},
   {"addPsTruthPoints", _PairSpectrometerFine_addPsTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of psTruthPoint objects for this pairSpectrometerFine"},
   {"deletePsTiles", _PairSpectrometerFine_deletePsTiles, METH_VARARGS,
    "delete psTile objects for this pairSpectrometerFine"},
   {"deletePsTruthPoints", _PairSpectrometerFine_deletePsTruthPoints, METH_VARARGS,
    "delete psTruthPoint objects for this pairSpectrometerFine"},
   {"getPsTile", _PairSpectrometerFine_getPsTile, METH_VARARGS,
    "get an individual psTile object from this pairSpectrometerFine"},
   {"getPsTiles", _PairSpectrometerFine_getPsTiles, METH_NOARGS,
    "get list of psTile objects for this pairSpectrometerFine"},
   {"getPsTruthPoint", _PairSpectrometerFine_getPsTruthPoint, METH_VARARGS,
    "get an individual psTruthPoint object from this pairSpectrometerFine"},
   {"getPsTruthPoints", _PairSpectrometerFine_getPsTruthPoints, METH_NOARGS,
    "get list of psTruthPoint objects for this pairSpectrometerFine"},
   {"toString", _PairSpectrometerFine_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PairSpectrometerFine_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PairSpectrometerFine_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PairSpectrometerFine",         /*tp_name*/
    sizeof(_PairSpectrometerFine),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PairSpectrometerFine_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PairSpectrometerFine_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pairSpectrometerFine element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PairSpectrometerFine_methods,          /* tp_methods */
    _PairSpectrometerFine_members,          /* tp_members */
    _PairSpectrometerFine_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PairSpectrometerFine_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PairSpectrometerFine_new,              /* tp_new */
};



// wrap element class hddm_s::PscHit as hddm_s.PscHit

typedef struct {
   PyObject_HEAD
   PscHit *elem;
   PyObject *host;
} _PscHit;

static void
_PscHit_dealloc(_PscHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PscHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PscHit *self;
   self = (_PscHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PscHit_init(_PscHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PscHit_getClass(_PscHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscHit_getVersion(_PscHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PscHit_getXmlns(_PscHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscHit_getEventNo(_PscHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PscHit_getRunNo(_PscHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PscHit_getMinOccurs(_PscHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PscHit_getArm(_PscHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_PscHit_getModule(_PscHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_PscHit_getDE(_PscHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_PscHit_setDE(_PscHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_PscHit_getMaxOccurs(_PscHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscHit_getT(_PscHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PscHit_setT(_PscHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PscHit_toString(PyObject *self, PyObject *args=0)
{
   _PscHit *me = (_PscHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PscHit_toXML(PyObject *self, PyObject *args=0)
{
   _PscHit *me = (_PscHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PscHit_getsetters[] = {
   {(char*)"arm",
    (getter)_PscHit_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PscHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_PscHit_getDE, (setter)_PscHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_PscHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PscHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PscHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_PscHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_PscHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PscHit_getT, (setter)_PscHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_PscHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PscHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PscHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PscHit_methods[] = {
   {"toString", _PscHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PscHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PscHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PscHit",         /*tp_name*/
    sizeof(_PscHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PscHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PscHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pscHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PscHit_methods,          /* tp_methods */
    _PscHit_members,          /* tp_members */
    _PscHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PscHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PscHit_new,              /* tp_new */
};



// wrap element class hddm_s::PscTruthHit as hddm_s.PscTruthHit

typedef struct {
   PyObject_HEAD
   PscTruthHit *elem;
   PyObject *host;
} _PscTruthHit;

static void
_PscTruthHit_dealloc(_PscTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PscTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PscTruthHit *self;
   self = (_PscTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PscTruthHit_init(_PscTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PscTruthHit_getClass(_PscTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthHit_getVersion(_PscTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PscTruthHit_getXmlns(_PscTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthHit_getEventNo(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PscTruthHit_getRunNo(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PscTruthHit_getMinOccurs(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PscTruthHit_getArm(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static PyObject*
_PscTruthHit_getModule(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static PyObject*
_PscTruthHit_getDE(_PscTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_PscTruthHit_setDE(_PscTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_PscTruthHit_getItrack(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_PscTruthHit_setItrack(_PscTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_PscTruthHit_getMaxOccurs(_PscTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthHit_getPtype(_PscTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_PscTruthHit_setPtype(_PscTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_PscTruthHit_getT(_PscTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PscTruthHit_setT(_PscTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PscTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _PscTruthHit *me = (_PscTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PscTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _PscTruthHit *me = (_PscTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PscTruthHit_getsetters[] = {
   {(char*)"arm",
    (getter)_PscTruthHit_getArm, 0,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PscTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_PscTruthHit_getDE, (setter)_PscTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_PscTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_PscTruthHit_getItrack, (setter)_PscTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PscTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PscTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_PscTruthHit_getModule, 0,
    (char*)"module value",
    NULL},
   {(char*)"ptype",
    (getter)_PscTruthHit_getPtype, (setter)_PscTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"runNo",
    (getter)_PscTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PscTruthHit_getT, (setter)_PscTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_PscTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PscTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PscTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PscTruthHit_methods[] = {
   {"toString", _PscTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PscTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PscTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PscTruthHit",         /*tp_name*/
    sizeof(_PscTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PscTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PscTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pscTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PscTruthHit_methods,          /* tp_methods */
    _PscTruthHit_members,          /* tp_members */
    _PscTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PscTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PscTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::PscPaddle as hddm_s.PscPaddle

typedef struct {
   PyObject_HEAD
   PscPaddle *elem;
   PyObject *host;
} _PscPaddle;

static void
_PscPaddle_dealloc(_PscPaddle* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PscPaddle_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PscPaddle *self;
   self = (_PscPaddle*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PscPaddle_init(_PscPaddle *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PscPaddle_getClass(_PscPaddle *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscPaddle_getVersion(_PscPaddle *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PscPaddle_getXmlns(_PscPaddle *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscPaddle_getEventNo(_PscPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PscPaddle_getRunNo(_PscPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PscPaddle_getArm(_PscPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static int
_PscPaddle_setArm(_PscPaddle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setArm(var);
   return 0;
}

static PyObject*
_PscPaddle_getMaxOccurs(_PscPaddle *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscPaddle_getMinOccurs(_PscPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PscPaddle_getModule(_PscPaddle *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static int
_PscPaddle_setModule(_PscPaddle *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setModule(var);
   return 0;
}

static PyObject*
_PscPaddle_getPscHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *obj = _PscHit_new(&_PscHit_type, 0, 0);
   ((_PscHit*)obj)->elem = &me->elem->getPscHit(index);
   ((_PscHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PscPaddle_getPscHits(PyObject *self, PyObject *args)
{
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPscHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PscPaddle_addPscHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscHitList(me->elem->addPscHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PscPaddle_deletePscHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pscPaddle element");
      return NULL;
   }
   me->elem->deletePscHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PscPaddle_getPscTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *obj = _PscTruthHit_new(&_PscTruthHit_type, 0, 0);
   ((_PscTruthHit*)obj)->elem = &me->elem->getPscTruthHit(index);
   ((_PscTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PscPaddle_getPscTruthHits(PyObject *self, PyObject *args)
{
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPscTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PscPaddle_addPscTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pscPaddle element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscTruthHitList(me->elem->addPscTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PscPaddle_deletePscTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pscPaddle element");
      return NULL;
   }
   me->elem->deletePscTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PscPaddle_toString(PyObject *self, PyObject *args=0)
{
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PscPaddle_toXML(PyObject *self, PyObject *args=0)
{
   _PscPaddle *me = (_PscPaddle*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscPaddle element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PscPaddle_getsetters[] = {
   {(char*)"arm",
    (getter)_PscPaddle_getArm, (setter)_PscPaddle_setArm,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PscPaddle_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_PscPaddle_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PscPaddle_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PscPaddle_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_PscPaddle_getModule, (setter)_PscPaddle_setModule,
    (char*)"module value",
    NULL},
   {(char*)"runNo",
    (getter)_PscPaddle_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_PscPaddle_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PscPaddle_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PscPaddle_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PscPaddle_methods[] = {
   {"addPscHits", _PscPaddle_addPscHits, METH_VARARGS,
    "extend (or insert into) the list of pscHit objects for this pscPaddle"},
   {"addPscTruthHits", _PscPaddle_addPscTruthHits, METH_VARARGS,
    "extend (or insert into) the list of pscTruthHit objects for this pscPaddle"},
   {"deletePscHits", _PscPaddle_deletePscHits, METH_VARARGS,
    "delete pscHit objects for this pscPaddle"},
   {"deletePscTruthHits", _PscPaddle_deletePscTruthHits, METH_VARARGS,
    "delete pscTruthHit objects for this pscPaddle"},
   {"getPscHit", _PscPaddle_getPscHit, METH_VARARGS,
    "get an individual pscHit object from this pscPaddle"},
   {"getPscHits", _PscPaddle_getPscHits, METH_NOARGS,
    "get list of pscHit objects for this pscPaddle"},
   {"getPscTruthHit", _PscPaddle_getPscTruthHit, METH_VARARGS,
    "get an individual pscTruthHit object from this pscPaddle"},
   {"getPscTruthHits", _PscPaddle_getPscTruthHits, METH_NOARGS,
    "get list of pscTruthHit objects for this pscPaddle"},
   {"toString", _PscPaddle_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PscPaddle_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PscPaddle_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PscPaddle",         /*tp_name*/
    sizeof(_PscPaddle),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PscPaddle_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PscPaddle_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pscPaddle element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PscPaddle_methods,          /* tp_methods */
    _PscPaddle_members,          /* tp_members */
    _PscPaddle_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PscPaddle_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PscPaddle_new,              /* tp_new */
};



// wrap element class hddm_s::PscTruthPoint as hddm_s.PscTruthPoint

typedef struct {
   PyObject_HEAD
   PscTruthPoint *elem;
   PyObject *host;
} _PscTruthPoint;

static void
_PscTruthPoint_dealloc(_PscTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PscTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PscTruthPoint *self;
   self = (_PscTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PscTruthPoint_init(_PscTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PscTruthPoint_getClass(_PscTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthPoint_getVersion(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PscTruthPoint_getXmlns(_PscTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthPoint_getEventNo(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PscTruthPoint_getRunNo(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PscTruthPoint_getE(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_PscTruthPoint_setE(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getArm(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getArm());
}

static int
_PscTruthPoint_setArm(_PscTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setArm(var);
   return 0;
}

static PyObject*
_PscTruthPoint_getDEdx(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_PscTruthPoint_setDEdx(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getMaxOccurs(_PscTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PscTruthPoint_getMinOccurs(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PscTruthPoint_getModule(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getModule());
}

static int
_PscTruthPoint_setModule(_PscTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setModule(var);
   return 0;
}

static PyObject*
_PscTruthPoint_getPrimary(_PscTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_PscTruthPoint_setPrimary(_PscTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_PscTruthPoint_getPtype(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_PscTruthPoint_setPtype(_PscTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_PscTruthPoint_getPx(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_PscTruthPoint_setPx(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getPy(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_PscTruthPoint_setPy(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getPz(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_PscTruthPoint_setPz(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getT(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_PscTruthPoint_setT(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getTrack(_PscTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_PscTruthPoint_setTrack(_PscTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_PscTruthPoint_getX(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_PscTruthPoint_setX(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getY(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_PscTruthPoint_setY(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getZ(_PscTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_PscTruthPoint_setZ(_PscTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_PscTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PscTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PscTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PscTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pscTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PscTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PscTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PscTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pscTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PscTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pscTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PscTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PscTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _PscTruthPoint *me = (_PscTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pscTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PscTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_PscTruthPoint_getE, (setter)_PscTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"arm",
    (getter)_PscTruthPoint_getArm, (setter)_PscTruthPoint_setArm,
    (char*)"arm value",
    NULL},
   {(char*)"class",
    (getter)_PscTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dEdx",
    (getter)_PscTruthPoint_getDEdx, (setter)_PscTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"eventNo",
    (getter)_PscTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PscTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_PscTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"module",
    (getter)_PscTruthPoint_getModule, (setter)_PscTruthPoint_setModule,
    (char*)"module value",
    NULL},
   {(char*)"primary",
    (getter)_PscTruthPoint_getPrimary, (setter)_PscTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_PscTruthPoint_getPtype, (setter)_PscTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_PscTruthPoint_getPx, (setter)_PscTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_PscTruthPoint_getPy, (setter)_PscTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_PscTruthPoint_getPz, (setter)_PscTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_PscTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_PscTruthPoint_getT, (setter)_PscTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_PscTruthPoint_getTrack, (setter)_PscTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_PscTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_PscTruthPoint_getX, (setter)_PscTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_PscTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_PscTruthPoint_getY, (setter)_PscTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_PscTruthPoint_getZ, (setter)_PscTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PscTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PscTruthPoint_methods[] = {
   {"addTrackIDs", _PscTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this pscTruthPoint"},
   {"addTrackOrigins", _PscTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this pscTruthPoint"},
   {"deleteTrackIDs", _PscTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this pscTruthPoint"},
   {"deleteTrackOrigins", _PscTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this pscTruthPoint"},
   {"getTrackID", _PscTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this pscTruthPoint"},
   {"getTrackIDs", _PscTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this pscTruthPoint"},
   {"getTrackOrigin", _PscTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this pscTruthPoint"},
   {"getTrackOrigins", _PscTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this pscTruthPoint"},
   {"toString", _PscTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PscTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PscTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PscTruthPoint",         /*tp_name*/
    sizeof(_PscTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PscTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PscTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pscTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PscTruthPoint_methods,          /* tp_methods */
    _PscTruthPoint_members,          /* tp_members */
    _PscTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PscTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PscTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::PairSpectrometerCoarse as hddm_s.PairSpectrometerCoarse

typedef struct {
   PyObject_HEAD
   PairSpectrometerCoarse *elem;
   PyObject *host;
} _PairSpectrometerCoarse;

static void
_PairSpectrometerCoarse_dealloc(_PairSpectrometerCoarse* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PairSpectrometerCoarse_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PairSpectrometerCoarse *self;
   self = (_PairSpectrometerCoarse*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PairSpectrometerCoarse_init(_PairSpectrometerCoarse *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PairSpectrometerCoarse_getClass(_PairSpectrometerCoarse *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerCoarse_getVersion(_PairSpectrometerCoarse *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PairSpectrometerCoarse_getXmlns(_PairSpectrometerCoarse *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerCoarse_getEventNo(_PairSpectrometerCoarse *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_PairSpectrometerCoarse_getMaxOccurs(_PairSpectrometerCoarse *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PairSpectrometerCoarse_getRunNo(_PairSpectrometerCoarse *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_PairSpectrometerCoarse_getMinOccurs(_PairSpectrometerCoarse *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_PairSpectrometerCoarse_getPscPaddle(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *obj = _PscPaddle_new(&_PscPaddle_type, 0, 0);
   ((_PscPaddle*)obj)->elem = &me->elem->getPscPaddle(index);
   ((_PscPaddle*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PairSpectrometerCoarse_getPscPaddles(PyObject *self, PyObject *args)
{
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPscPaddles();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PairSpectrometerCoarse_addPscPaddles(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscPaddleList(me->elem->addPscPaddles(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PairSpectrometerCoarse_deletePscPaddles(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   me->elem->deletePscPaddles(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PairSpectrometerCoarse_getPscTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *obj = _PscTruthPoint_new(&_PscTruthPoint_type, 0, 0);
   ((_PscTruthPoint*)obj)->elem = &me->elem->getPscTruthPoint(index);
   ((_PscTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PairSpectrometerCoarse_getPscTruthPoints(PyObject *self, PyObject *args)
{
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPscTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PairSpectrometerCoarse_addPscTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscTruthPointList(me->elem->addPscTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PairSpectrometerCoarse_deletePscTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   me->elem->deletePscTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PairSpectrometerCoarse_toString(PyObject *self, PyObject *args=0)
{
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PairSpectrometerCoarse_toXML(PyObject *self, PyObject *args=0)
{
   _PairSpectrometerCoarse *me = (_PairSpectrometerCoarse*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid pairSpectrometerCoarse element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PairSpectrometerCoarse_getsetters[] = {
   {(char*)"class",
    (getter)_PairSpectrometerCoarse_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_PairSpectrometerCoarse_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PairSpectrometerCoarse_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_PairSpectrometerCoarse_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_PairSpectrometerCoarse_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_PairSpectrometerCoarse_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PairSpectrometerCoarse_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PairSpectrometerCoarse_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PairSpectrometerCoarse_methods[] = {
   {"addPscPaddles", _PairSpectrometerCoarse_addPscPaddles, METH_VARARGS,
    "extend (or insert into) the list of pscPaddle objects for this pairSpectrometerCoarse"},
   {"addPscTruthPoints", _PairSpectrometerCoarse_addPscTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of pscTruthPoint objects for this pairSpectrometerCoarse"},
   {"deletePscPaddles", _PairSpectrometerCoarse_deletePscPaddles, METH_VARARGS,
    "delete pscPaddle objects for this pairSpectrometerCoarse"},
   {"deletePscTruthPoints", _PairSpectrometerCoarse_deletePscTruthPoints, METH_VARARGS,
    "delete pscTruthPoint objects for this pairSpectrometerCoarse"},
   {"getPscPaddle", _PairSpectrometerCoarse_getPscPaddle, METH_VARARGS,
    "get an individual pscPaddle object from this pairSpectrometerCoarse"},
   {"getPscPaddles", _PairSpectrometerCoarse_getPscPaddles, METH_NOARGS,
    "get list of pscPaddle objects for this pairSpectrometerCoarse"},
   {"getPscTruthPoint", _PairSpectrometerCoarse_getPscTruthPoint, METH_VARARGS,
    "get an individual pscTruthPoint object from this pairSpectrometerCoarse"},
   {"getPscTruthPoints", _PairSpectrometerCoarse_getPscTruthPoints, METH_NOARGS,
    "get list of pscTruthPoint objects for this pairSpectrometerCoarse"},
   {"toString", _PairSpectrometerCoarse_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PairSpectrometerCoarse_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PairSpectrometerCoarse_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PairSpectrometerCoarse",         /*tp_name*/
    sizeof(_PairSpectrometerCoarse),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PairSpectrometerCoarse_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PairSpectrometerCoarse_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s pairSpectrometerCoarse element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PairSpectrometerCoarse_methods,          /* tp_methods */
    _PairSpectrometerCoarse_members,          /* tp_members */
    _PairSpectrometerCoarse_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PairSpectrometerCoarse_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PairSpectrometerCoarse_new,              /* tp_new */
};



// wrap element class hddm_s::TpolHit as hddm_s.TpolHit

typedef struct {
   PyObject_HEAD
   TpolHit *elem;
   PyObject *host;
} _TpolHit;

static void
_TpolHit_dealloc(_TpolHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TpolHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TpolHit *self;
   self = (_TpolHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TpolHit_init(_TpolHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TpolHit_getClass(_TpolHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolHit_getVersion(_TpolHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TpolHit_getXmlns(_TpolHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolHit_getEventNo(_TpolHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TpolHit_getRunNo(_TpolHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TpolHit_getMinOccurs(_TpolHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TpolHit_getRing(_TpolHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_TpolHit_getSector(_TpolHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_TpolHit_getDE(_TpolHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_TpolHit_setDE(_TpolHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_TpolHit_getMaxOccurs(_TpolHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolHit_getT(_TpolHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TpolHit_setT(_TpolHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TpolHit_toString(PyObject *self, PyObject *args=0)
{
   _TpolHit *me = (_TpolHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TpolHit_toXML(PyObject *self, PyObject *args=0)
{
   _TpolHit *me = (_TpolHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TpolHit_getsetters[] = {
   {(char*)"class",
    (getter)_TpolHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_TpolHit_getDE, (setter)_TpolHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_TpolHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TpolHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TpolHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ring",
    (getter)_TpolHit_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_TpolHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_TpolHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_TpolHit_getT, (setter)_TpolHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_TpolHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TpolHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TpolHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TpolHit_methods[] = {
   {"toString", _TpolHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TpolHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TpolHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TpolHit",         /*tp_name*/
    sizeof(_TpolHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TpolHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TpolHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tpolHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TpolHit_methods,          /* tp_methods */
    _TpolHit_members,          /* tp_members */
    _TpolHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TpolHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TpolHit_new,              /* tp_new */
};



// wrap element class hddm_s::TpolTruthHit as hddm_s.TpolTruthHit

typedef struct {
   PyObject_HEAD
   TpolTruthHit *elem;
   PyObject *host;
} _TpolTruthHit;

static void
_TpolTruthHit_dealloc(_TpolTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TpolTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TpolTruthHit *self;
   self = (_TpolTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TpolTruthHit_init(_TpolTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TpolTruthHit_getClass(_TpolTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthHit_getVersion(_TpolTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TpolTruthHit_getXmlns(_TpolTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthHit_getEventNo(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TpolTruthHit_getRunNo(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TpolTruthHit_getMinOccurs(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TpolTruthHit_getRing(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static PyObject*
_TpolTruthHit_getSector(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static PyObject*
_TpolTruthHit_getDE(_TpolTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_TpolTruthHit_setDE(_TpolTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_TpolTruthHit_getItrack(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getItrack());
}

static int
_TpolTruthHit_setItrack(_TpolTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setItrack(var);
   return 0;
}

static PyObject*
_TpolTruthHit_getMaxOccurs(_TpolTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthHit_getPtype(_TpolTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_TpolTruthHit_setPtype(_TpolTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_TpolTruthHit_getT(_TpolTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TpolTruthHit_setT(_TpolTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TpolTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _TpolTruthHit *me = (_TpolTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TpolTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _TpolTruthHit *me = (_TpolTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TpolTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_TpolTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_TpolTruthHit_getDE, (setter)_TpolTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_TpolTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"itrack",
    (getter)_TpolTruthHit_getItrack, (setter)_TpolTruthHit_setItrack,
    (char*)"itrack value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TpolTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TpolTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ptype",
    (getter)_TpolTruthHit_getPtype, (setter)_TpolTruthHit_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"ring",
    (getter)_TpolTruthHit_getRing, 0,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_TpolTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_TpolTruthHit_getSector, 0,
    (char*)"sector value",
    NULL},
   {(char*)"t",
    (getter)_TpolTruthHit_getT, (setter)_TpolTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_TpolTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TpolTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TpolTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TpolTruthHit_methods[] = {
   {"toString", _TpolTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TpolTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TpolTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TpolTruthHit",         /*tp_name*/
    sizeof(_TpolTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TpolTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TpolTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tpolTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TpolTruthHit_methods,          /* tp_methods */
    _TpolTruthHit_members,          /* tp_members */
    _TpolTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TpolTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TpolTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::TpolSector as hddm_s.TpolSector

typedef struct {
   PyObject_HEAD
   TpolSector *elem;
   PyObject *host;
} _TpolSector;

static void
_TpolSector_dealloc(_TpolSector* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TpolSector_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TpolSector *self;
   self = (_TpolSector*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TpolSector_init(_TpolSector *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TpolSector_getClass(_TpolSector *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolSector_getVersion(_TpolSector *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TpolSector_getXmlns(_TpolSector *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolSector_getEventNo(_TpolSector *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TpolSector_getRunNo(_TpolSector *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TpolSector_getMaxOccurs(_TpolSector *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolSector_getMinOccurs(_TpolSector *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TpolSector_getRing(_TpolSector *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRing());
}

static int
_TpolSector_setRing(_TpolSector *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRing(var);
   return 0;
}

static PyObject*
_TpolSector_getSector(_TpolSector *self, void *closure)
{
   return PyLong_FromLong(self->elem->getSector());
}

static int
_TpolSector_setSector(_TpolSector *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setSector(var);
   return 0;
}

static PyObject*
_TpolSector_getTpolHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *obj = _TpolHit_new(&_TpolHit_type, 0, 0);
   ((_TpolHit*)obj)->elem = &me->elem->getTpolHit(index);
   ((_TpolHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TpolSector_getTpolHits(PyObject *self, PyObject *args)
{
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTpolHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TpolSector_addTpolHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolHitList(me->elem->addTpolHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TpolSector_deleteTpolHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tpolSector element");
      return NULL;
   }
   me->elem->deleteTpolHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TpolSector_getTpolTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *obj = _TpolTruthHit_new(&_TpolTruthHit_type, 0, 0);
   ((_TpolTruthHit*)obj)->elem = &me->elem->getTpolTruthHit(index);
   ((_TpolTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TpolSector_getTpolTruthHits(PyObject *self, PyObject *args)
{
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTpolTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TpolSector_addTpolTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tpolSector element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolTruthHitList(me->elem->addTpolTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TpolSector_deleteTpolTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tpolSector element");
      return NULL;
   }
   me->elem->deleteTpolTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TpolSector_toString(PyObject *self, PyObject *args=0)
{
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TpolSector_toXML(PyObject *self, PyObject *args=0)
{
   _TpolSector *me = (_TpolSector*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolSector element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TpolSector_getsetters[] = {
   {(char*)"class",
    (getter)_TpolSector_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_TpolSector_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TpolSector_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TpolSector_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"ring",
    (getter)_TpolSector_getRing, (setter)_TpolSector_setRing,
    (char*)"ring value",
    NULL},
   {(char*)"runNo",
    (getter)_TpolSector_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"sector",
    (getter)_TpolSector_getSector, (setter)_TpolSector_setSector,
    (char*)"sector value",
    NULL},
   {(char*)"version",
    (getter)_TpolSector_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TpolSector_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TpolSector_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TpolSector_methods[] = {
   {"addTpolHits", _TpolSector_addTpolHits, METH_VARARGS,
    "extend (or insert into) the list of tpolHit objects for this tpolSector"},
   {"addTpolTruthHits", _TpolSector_addTpolTruthHits, METH_VARARGS,
    "extend (or insert into) the list of tpolTruthHit objects for this tpolSector"},
   {"deleteTpolHits", _TpolSector_deleteTpolHits, METH_VARARGS,
    "delete tpolHit objects for this tpolSector"},
   {"deleteTpolTruthHits", _TpolSector_deleteTpolTruthHits, METH_VARARGS,
    "delete tpolTruthHit objects for this tpolSector"},
   {"getTpolHit", _TpolSector_getTpolHit, METH_VARARGS,
    "get an individual tpolHit object from this tpolSector"},
   {"getTpolHits", _TpolSector_getTpolHits, METH_NOARGS,
    "get list of tpolHit objects for this tpolSector"},
   {"getTpolTruthHit", _TpolSector_getTpolTruthHit, METH_VARARGS,
    "get an individual tpolTruthHit object from this tpolSector"},
   {"getTpolTruthHits", _TpolSector_getTpolTruthHits, METH_NOARGS,
    "get list of tpolTruthHit objects for this tpolSector"},
   {"toString", _TpolSector_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TpolSector_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TpolSector_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TpolSector",         /*tp_name*/
    sizeof(_TpolSector),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TpolSector_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TpolSector_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tpolSector element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TpolSector_methods,          /* tp_methods */
    _TpolSector_members,          /* tp_members */
    _TpolSector_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TpolSector_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TpolSector_new,              /* tp_new */
};



// wrap element class hddm_s::TpolTruthPoint as hddm_s.TpolTruthPoint

typedef struct {
   PyObject_HEAD
   TpolTruthPoint *elem;
   PyObject *host;
} _TpolTruthPoint;

static void
_TpolTruthPoint_dealloc(_TpolTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TpolTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TpolTruthPoint *self;
   self = (_TpolTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TpolTruthPoint_init(_TpolTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TpolTruthPoint_getClass(_TpolTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthPoint_getVersion(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TpolTruthPoint_getXmlns(_TpolTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthPoint_getEventNo(_TpolTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TpolTruthPoint_getRunNo(_TpolTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TpolTruthPoint_getE(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_TpolTruthPoint_setE(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getDEdx(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDEdx());
}

static int
_TpolTruthPoint_setDEdx(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDEdx((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getMaxOccurs(_TpolTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TpolTruthPoint_getMinOccurs(_TpolTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TpolTruthPoint_getPhi(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPhi());
}

static int
_TpolTruthPoint_setPhi(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPhi((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getPrimary(_TpolTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_TpolTruthPoint_setPrimary(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_TpolTruthPoint_getPtype(_TpolTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_TpolTruthPoint_setPtype(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getPx(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_TpolTruthPoint_setPx(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getPy(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_TpolTruthPoint_setPy(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getPz(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_TpolTruthPoint_setPz(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getR(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getR());
}

static int
_TpolTruthPoint_setR(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setR((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getT(_TpolTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_TpolTruthPoint_setT(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getTrack(_TpolTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_TpolTruthPoint_setTrack(_TpolTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_TpolTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TpolTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TpolTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TpolTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TpolTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TpolTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TpolTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TpolTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TpolTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TpolTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _TpolTruthPoint *me = (_TpolTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tpolTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TpolTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_TpolTruthPoint_getE, (setter)_TpolTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_TpolTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dEdx",
    (getter)_TpolTruthPoint_getDEdx, (setter)_TpolTruthPoint_setDEdx,
    (char*)"dEdx value",
    NULL},
   {(char*)"eventNo",
    (getter)_TpolTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TpolTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_TpolTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"phi",
    (getter)_TpolTruthPoint_getPhi, (setter)_TpolTruthPoint_setPhi,
    (char*)"phi value",
    NULL},
   {(char*)"primary",
    (getter)_TpolTruthPoint_getPrimary, (setter)_TpolTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_TpolTruthPoint_getPtype, (setter)_TpolTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_TpolTruthPoint_getPx, (setter)_TpolTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_TpolTruthPoint_getPy, (setter)_TpolTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_TpolTruthPoint_getPz, (setter)_TpolTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"r",
    (getter)_TpolTruthPoint_getR, (setter)_TpolTruthPoint_setR,
    (char*)"r value",
    NULL},
   {(char*)"runNo",
    (getter)_TpolTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_TpolTruthPoint_getT, (setter)_TpolTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_TpolTruthPoint_getTrack, (setter)_TpolTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_TpolTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TpolTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TpolTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TpolTruthPoint_methods[] = {
   {"addTrackIDs", _TpolTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this tpolTruthPoint"},
   {"addTrackOrigins", _TpolTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this tpolTruthPoint"},
   {"deleteTrackIDs", _TpolTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this tpolTruthPoint"},
   {"deleteTrackOrigins", _TpolTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this tpolTruthPoint"},
   {"getTrackID", _TpolTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this tpolTruthPoint"},
   {"getTrackIDs", _TpolTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this tpolTruthPoint"},
   {"getTrackOrigin", _TpolTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this tpolTruthPoint"},
   {"getTrackOrigins", _TpolTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this tpolTruthPoint"},
   {"toString", _TpolTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TpolTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TpolTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TpolTruthPoint",         /*tp_name*/
    sizeof(_TpolTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TpolTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TpolTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tpolTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TpolTruthPoint_methods,          /* tp_methods */
    _TpolTruthPoint_members,          /* tp_members */
    _TpolTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TpolTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TpolTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::TripletPolarimeter as hddm_s.TripletPolarimeter

typedef struct {
   PyObject_HEAD
   TripletPolarimeter *elem;
   PyObject *host;
} _TripletPolarimeter;

static void
_TripletPolarimeter_dealloc(_TripletPolarimeter* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TripletPolarimeter_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TripletPolarimeter *self;
   self = (_TripletPolarimeter*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TripletPolarimeter_init(_TripletPolarimeter *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TripletPolarimeter_getClass(_TripletPolarimeter *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TripletPolarimeter_getVersion(_TripletPolarimeter *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TripletPolarimeter_getXmlns(_TripletPolarimeter *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TripletPolarimeter_getEventNo(_TripletPolarimeter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TripletPolarimeter_getMaxOccurs(_TripletPolarimeter *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TripletPolarimeter_getRunNo(_TripletPolarimeter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TripletPolarimeter_getMinOccurs(_TripletPolarimeter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TripletPolarimeter_getTpolSector(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *obj = _TpolSector_new(&_TpolSector_type, 0, 0);
   ((_TpolSector*)obj)->elem = &me->elem->getTpolSector(index);
   ((_TpolSector*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TripletPolarimeter_getTpolSectors(PyObject *self, PyObject *args)
{
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolSector_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTpolSectors();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TripletPolarimeter_addTpolSectors(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolSector_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolSectorList(me->elem->addTpolSectors(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TripletPolarimeter_deleteTpolSectors(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   me->elem->deleteTpolSectors(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TripletPolarimeter_getTpolTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *obj = _TpolTruthPoint_new(&_TpolTruthPoint_type, 0, 0);
   ((_TpolTruthPoint*)obj)->elem = &me->elem->getTpolTruthPoint(index);
   ((_TpolTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_TripletPolarimeter_getTpolTruthPoints(PyObject *self, PyObject *args)
{
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTpolTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_TripletPolarimeter_addTpolTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolTruthPointList(me->elem->addTpolTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_TripletPolarimeter_deleteTpolTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   me->elem->deleteTpolTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_TripletPolarimeter_toString(PyObject *self, PyObject *args=0)
{
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TripletPolarimeter_toXML(PyObject *self, PyObject *args=0)
{
   _TripletPolarimeter *me = (_TripletPolarimeter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tripletPolarimeter element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TripletPolarimeter_getsetters[] = {
   {(char*)"class",
    (getter)_TripletPolarimeter_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_TripletPolarimeter_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TripletPolarimeter_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_TripletPolarimeter_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_TripletPolarimeter_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_TripletPolarimeter_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TripletPolarimeter_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TripletPolarimeter_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TripletPolarimeter_methods[] = {
   {"addTpolSectors", _TripletPolarimeter_addTpolSectors, METH_VARARGS,
    "extend (or insert into) the list of tpolSector objects for this tripletPolarimeter"},
   {"addTpolTruthPoints", _TripletPolarimeter_addTpolTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of tpolTruthPoint objects for this tripletPolarimeter"},
   {"deleteTpolSectors", _TripletPolarimeter_deleteTpolSectors, METH_VARARGS,
    "delete tpolSector objects for this tripletPolarimeter"},
   {"deleteTpolTruthPoints", _TripletPolarimeter_deleteTpolTruthPoints, METH_VARARGS,
    "delete tpolTruthPoint objects for this tripletPolarimeter"},
   {"getTpolSector", _TripletPolarimeter_getTpolSector, METH_VARARGS,
    "get an individual tpolSector object from this tripletPolarimeter"},
   {"getTpolSectors", _TripletPolarimeter_getTpolSectors, METH_NOARGS,
    "get list of tpolSector objects for this tripletPolarimeter"},
   {"getTpolTruthPoint", _TripletPolarimeter_getTpolTruthPoint, METH_VARARGS,
    "get an individual tpolTruthPoint object from this tripletPolarimeter"},
   {"getTpolTruthPoints", _TripletPolarimeter_getTpolTruthPoints, METH_NOARGS,
    "get list of tpolTruthPoint objects for this tripletPolarimeter"},
   {"toString", _TripletPolarimeter_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TripletPolarimeter_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TripletPolarimeter_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TripletPolarimeter",         /*tp_name*/
    sizeof(_TripletPolarimeter),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TripletPolarimeter_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TripletPolarimeter_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tripletPolarimeter element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TripletPolarimeter_methods,          /* tp_methods */
    _TripletPolarimeter_members,          /* tp_members */
    _TripletPolarimeter_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TripletPolarimeter_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TripletPolarimeter_new,              /* tp_new */
};



// wrap element class hddm_s::McTrajectoryPoint as hddm_s.McTrajectoryPoint

typedef struct {
   PyObject_HEAD
   McTrajectoryPoint *elem;
   PyObject *host;
} _McTrajectoryPoint;

static void
_McTrajectoryPoint_dealloc(_McTrajectoryPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_McTrajectoryPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _McTrajectoryPoint *self;
   self = (_McTrajectoryPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_McTrajectoryPoint_init(_McTrajectoryPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_McTrajectoryPoint_getClass(_McTrajectoryPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectoryPoint_getVersion(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_McTrajectoryPoint_getXmlns(_McTrajectoryPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectoryPoint_getEventNo(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_McTrajectoryPoint_getRunNo(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_McTrajectoryPoint_getE(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_McTrajectoryPoint_setE(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getDE(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_McTrajectoryPoint_setDE(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getMaxOccurs(_McTrajectoryPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectoryPoint_getMech(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMech());
}

static int
_McTrajectoryPoint_setMech(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setMech(var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getMinOccurs(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_McTrajectoryPoint_getPart(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPart());
}

static int
_McTrajectoryPoint_setPart(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPart(var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getPrimary_track(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPrimary_track());
}

static int
_McTrajectoryPoint_setPrimary_track(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary_track(var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getPx(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_McTrajectoryPoint_setPx(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getPy(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_McTrajectoryPoint_setPy(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getPz(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_McTrajectoryPoint_setPz(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getRadlen(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getRadlen());
}

static int
_McTrajectoryPoint_setRadlen(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setRadlen((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getStep(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getStep());
}

static int
_McTrajectoryPoint_setStep(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setStep((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getT(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_McTrajectoryPoint_setT(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getTrack(_McTrajectoryPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_McTrajectoryPoint_setTrack(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getX(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_McTrajectoryPoint_setX(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getY(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_McTrajectoryPoint_setY(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_getZ(_McTrajectoryPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_McTrajectoryPoint_setZ(_McTrajectoryPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_McTrajectoryPoint_toString(PyObject *self, PyObject *args=0)
{
   _McTrajectoryPoint *me = (_McTrajectoryPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectoryPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_McTrajectoryPoint_toXML(PyObject *self, PyObject *args=0)
{
   _McTrajectoryPoint *me = (_McTrajectoryPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectoryPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _McTrajectoryPoint_getsetters[] = {
   {(char*)"E",
    (getter)_McTrajectoryPoint_getE, (setter)_McTrajectoryPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_McTrajectoryPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_McTrajectoryPoint_getDE, (setter)_McTrajectoryPoint_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_McTrajectoryPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_McTrajectoryPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"mech",
    (getter)_McTrajectoryPoint_getMech, (setter)_McTrajectoryPoint_setMech,
    (char*)"mech value",
    NULL},
   {(char*)"minOccurs",
    (getter)_McTrajectoryPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"part",
    (getter)_McTrajectoryPoint_getPart, (setter)_McTrajectoryPoint_setPart,
    (char*)"part value",
    NULL},
   {(char*)"primary_track",
    (getter)_McTrajectoryPoint_getPrimary_track, (setter)_McTrajectoryPoint_setPrimary_track,
    (char*)"primary_track value",
    NULL},
   {(char*)"px",
    (getter)_McTrajectoryPoint_getPx, (setter)_McTrajectoryPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_McTrajectoryPoint_getPy, (setter)_McTrajectoryPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_McTrajectoryPoint_getPz, (setter)_McTrajectoryPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"radlen",
    (getter)_McTrajectoryPoint_getRadlen, (setter)_McTrajectoryPoint_setRadlen,
    (char*)"radlen value",
    NULL},
   {(char*)"runNo",
    (getter)_McTrajectoryPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"step",
    (getter)_McTrajectoryPoint_getStep, (setter)_McTrajectoryPoint_setStep,
    (char*)"step value",
    NULL},
   {(char*)"t",
    (getter)_McTrajectoryPoint_getT, (setter)_McTrajectoryPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_McTrajectoryPoint_getTrack, (setter)_McTrajectoryPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_McTrajectoryPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_McTrajectoryPoint_getX, (setter)_McTrajectoryPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_McTrajectoryPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_McTrajectoryPoint_getY, (setter)_McTrajectoryPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_McTrajectoryPoint_getZ, (setter)_McTrajectoryPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _McTrajectoryPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _McTrajectoryPoint_methods[] = {
   {"toString", _McTrajectoryPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _McTrajectoryPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _McTrajectoryPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.McTrajectoryPoint",         /*tp_name*/
    sizeof(_McTrajectoryPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_McTrajectoryPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_McTrajectoryPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s mcTrajectoryPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _McTrajectoryPoint_methods,          /* tp_methods */
    _McTrajectoryPoint_members,          /* tp_members */
    _McTrajectoryPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_McTrajectoryPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _McTrajectoryPoint_new,              /* tp_new */
};



// wrap element class hddm_s::McTrajectory as hddm_s.McTrajectory

typedef struct {
   PyObject_HEAD
   McTrajectory *elem;
   PyObject *host;
} _McTrajectory;

static void
_McTrajectory_dealloc(_McTrajectory* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_McTrajectory_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _McTrajectory *self;
   self = (_McTrajectory*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_McTrajectory_init(_McTrajectory *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_McTrajectory_getClass(_McTrajectory *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectory_getVersion(_McTrajectory *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_McTrajectory_getXmlns(_McTrajectory *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectory_getEventNo(_McTrajectory *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_McTrajectory_getMaxOccurs(_McTrajectory *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_McTrajectory_getRunNo(_McTrajectory *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_McTrajectory_getMinOccurs(_McTrajectory *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_McTrajectory_getMcTrajectoryPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectory element");
      return NULL;
   }
   PyObject *obj = _McTrajectoryPoint_new(&_McTrajectoryPoint_type, 0, 0);
   ((_McTrajectoryPoint*)obj)->elem = &me->elem->getMcTrajectoryPoint(index);
   ((_McTrajectoryPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_McTrajectory_getMcTrajectoryPoints(PyObject *self, PyObject *args)
{
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectory element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectoryPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMcTrajectoryPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_McTrajectory_addMcTrajectoryPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid mcTrajectory element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectoryPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new McTrajectoryPointList(me->elem->addMcTrajectoryPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_McTrajectory_deleteMcTrajectoryPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid mcTrajectory element");
      return NULL;
   }
   me->elem->deleteMcTrajectoryPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_McTrajectory_toString(PyObject *self, PyObject *args=0)
{
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectory element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_McTrajectory_toXML(PyObject *self, PyObject *args=0)
{
   _McTrajectory *me = (_McTrajectory*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid mcTrajectory element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _McTrajectory_getsetters[] = {
   {(char*)"class",
    (getter)_McTrajectory_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_McTrajectory_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_McTrajectory_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_McTrajectory_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_McTrajectory_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_McTrajectory_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_McTrajectory_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _McTrajectory_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _McTrajectory_methods[] = {
   {"addMcTrajectoryPoints", _McTrajectory_addMcTrajectoryPoints, METH_VARARGS,
    "extend (or insert into) the list of mcTrajectoryPoint objects for this mcTrajectory"},
   {"deleteMcTrajectoryPoints", _McTrajectory_deleteMcTrajectoryPoints, METH_VARARGS,
    "delete mcTrajectoryPoint objects for this mcTrajectory"},
   {"getMcTrajectoryPoint", _McTrajectory_getMcTrajectoryPoint, METH_VARARGS,
    "get an individual mcTrajectoryPoint object from this mcTrajectory"},
   {"getMcTrajectoryPoints", _McTrajectory_getMcTrajectoryPoints, METH_NOARGS,
    "get list of mcTrajectoryPoint objects for this mcTrajectory"},
   {"toString", _McTrajectory_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _McTrajectory_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _McTrajectory_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.McTrajectory",         /*tp_name*/
    sizeof(_McTrajectory),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_McTrajectory_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_McTrajectory_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s mcTrajectory element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _McTrajectory_methods,          /* tp_methods */
    _McTrajectory_members,          /* tp_members */
    _McTrajectory_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_McTrajectory_init,   /* tp_init */
    0,                         /* tp_alloc */
    _McTrajectory_new,              /* tp_new */
};



// wrap element class hddm_s::RFsubsystem as hddm_s.RFsubsystem

typedef struct {
   PyObject_HEAD
   RFsubsystem *elem;
   PyObject *host;
} _RFsubsystem;

static void
_RFsubsystem_dealloc(_RFsubsystem* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_RFsubsystem_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _RFsubsystem *self;
   self = (_RFsubsystem*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_RFsubsystem_init(_RFsubsystem *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_RFsubsystem_getClass(_RFsubsystem *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFsubsystem_getVersion(_RFsubsystem *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_RFsubsystem_getXmlns(_RFsubsystem *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFsubsystem_getEventNo(_RFsubsystem *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_RFsubsystem_getRunNo(_RFsubsystem *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_RFsubsystem_getJtag(_RFsubsystem *self, void *closure)
{
   std::string val(self->elem->getJtag());
   return PyUnicode_FromString(val.c_str());
}

static int
_RFsubsystem_setJtag(_RFsubsystem *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setJtag(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_RFsubsystem_getMaxOccurs(_RFsubsystem *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFsubsystem_getMinOccurs(_RFsubsystem *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_RFsubsystem_getTsync(_RFsubsystem *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTsync());
}

static int
_RFsubsystem_setTsync(_RFsubsystem *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setTsync((float)var);
   return 0;
}

static PyObject*
_RFsubsystem_getTunit(_RFsubsystem *self, void *closure)
{
   std::string val(self->elem->getTunit());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFsubsystem_toString(PyObject *self, PyObject *args=0)
{
   _RFsubsystem *me = (_RFsubsystem*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFsubsystem element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_RFsubsystem_toXML(PyObject *self, PyObject *args=0)
{
   _RFsubsystem *me = (_RFsubsystem*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFsubsystem element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _RFsubsystem_getsetters[] = {
   {(char*)"class",
    (getter)_RFsubsystem_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_RFsubsystem_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"jtag",
    (getter)_RFsubsystem_getJtag, (setter)_RFsubsystem_setJtag,
    (char*)"jtag string",
    NULL},
   {(char*)"maxOccurs",
    (getter)_RFsubsystem_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_RFsubsystem_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_RFsubsystem_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"tsync",
    (getter)_RFsubsystem_getTsync, (setter)_RFsubsystem_setTsync,
    (char*)"tsync value",
    NULL},
   {(char*)"tunit",
    (getter)_RFsubsystem_getTunit, 0,
    (char*)"tunit value",
    NULL},
   {(char*)"version",
    (getter)_RFsubsystem_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_RFsubsystem_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _RFsubsystem_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _RFsubsystem_methods[] = {
   {"toString", _RFsubsystem_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _RFsubsystem_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _RFsubsystem_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.RFsubsystem",         /*tp_name*/
    sizeof(_RFsubsystem),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_RFsubsystem_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_RFsubsystem_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s RFsubsystem element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _RFsubsystem_methods,          /* tp_methods */
    _RFsubsystem_members,          /* tp_members */
    _RFsubsystem_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_RFsubsystem_init,   /* tp_init */
    0,                         /* tp_alloc */
    _RFsubsystem_new,              /* tp_new */
};



// wrap element class hddm_s::RFtime as hddm_s.RFtime

typedef struct {
   PyObject_HEAD
   RFtime *elem;
   PyObject *host;
} _RFtime;

static void
_RFtime_dealloc(_RFtime* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_RFtime_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _RFtime *self;
   self = (_RFtime*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_RFtime_init(_RFtime *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_RFtime_getClass(_RFtime *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFtime_getVersion(_RFtime *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_RFtime_getXmlns(_RFtime *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFtime_getEventNo(_RFtime *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_RFtime_getMaxOccurs(_RFtime *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFtime_getRunNo(_RFtime *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_RFtime_getJtag(_RFtime *self, void *closure)
{
   std::string val(self->elem->getJtag());
   return PyUnicode_FromString(val.c_str());
}

static int
_RFtime_setJtag(_RFtime *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setJtag(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_RFtime_getMinOccurs(_RFtime *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_RFtime_getTsync(_RFtime *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getTsync());
}

static int
_RFtime_setTsync(_RFtime *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setTsync((float)var);
   return 0;
}

static PyObject*
_RFtime_getTunit(_RFtime *self, void *closure)
{
   std::string val(self->elem->getTunit());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_RFtime_getRFsubsystem(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFtime element");
      return NULL;
   }
   PyObject *obj = _RFsubsystem_new(&_RFsubsystem_type, 0, 0);
   ((_RFsubsystem*)obj)->elem = &me->elem->getRFsubsystem(index);
   ((_RFsubsystem*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_RFtime_getRFsubsystems(PyObject *self, PyObject *args)
{
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFtime element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFsubsystem_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRFsubsystems();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_RFtime_addRFsubsystems(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid RFtime element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFsubsystem_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RFsubsystemList(me->elem->addRFsubsystems(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_RFtime_deleteRFsubsystems(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid RFtime element");
      return NULL;
   }
   me->elem->deleteRFsubsystems(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_RFtime_toString(PyObject *self, PyObject *args=0)
{
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFtime element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_RFtime_toXML(PyObject *self, PyObject *args=0)
{
   _RFtime *me = (_RFtime*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid RFtime element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _RFtime_getsetters[] = {
   {(char*)"class",
    (getter)_RFtime_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_RFtime_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"jtag",
    (getter)_RFtime_getJtag, (setter)_RFtime_setJtag,
    (char*)"jtag string",
    NULL},
   {(char*)"maxOccurs",
    (getter)_RFtime_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_RFtime_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_RFtime_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"tsync",
    (getter)_RFtime_getTsync, (setter)_RFtime_setTsync,
    (char*)"tsync value",
    NULL},
   {(char*)"tunit",
    (getter)_RFtime_getTunit, 0,
    (char*)"tunit value",
    NULL},
   {(char*)"version",
    (getter)_RFtime_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_RFtime_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _RFtime_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _RFtime_methods[] = {
   {"addRFsubsystems", _RFtime_addRFsubsystems, METH_VARARGS,
    "extend (or insert into) the list of RFsubsystem objects for this RFtime"},
   {"deleteRFsubsystems", _RFtime_deleteRFsubsystems, METH_VARARGS,
    "delete RFsubsystem objects for this RFtime"},
   {"getRFsubsystem", _RFtime_getRFsubsystem, METH_VARARGS,
    "get an individual RFsubsystem object from this RFtime"},
   {"getRFsubsystems", _RFtime_getRFsubsystems, METH_NOARGS,
    "get list of RFsubsystem objects for this RFtime"},
   {"toString", _RFtime_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _RFtime_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _RFtime_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.RFtime",         /*tp_name*/
    sizeof(_RFtime),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_RFtime_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_RFtime_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s RFtime element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _RFtime_methods,          /* tp_methods */
    _RFtime_members,          /* tp_members */
    _RFtime_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_RFtime_init,   /* tp_init */
    0,                         /* tp_alloc */
    _RFtime_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcTruthHitQ as hddm_s.FmwpcTruthHitQ

typedef struct {
   PyObject_HEAD
   FmwpcTruthHitQ *elem;
   PyObject *host;
} _FmwpcTruthHitQ;

static void
_FmwpcTruthHitQ_dealloc(_FmwpcTruthHitQ* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcTruthHitQ_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcTruthHitQ *self;
   self = (_FmwpcTruthHitQ*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcTruthHitQ_init(_FmwpcTruthHitQ *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcTruthHitQ_getClass(_FmwpcTruthHitQ *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHitQ_getVersion(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcTruthHitQ_getXmlns(_FmwpcTruthHitQ *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHitQ_getEventNo(_FmwpcTruthHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcTruthHitQ_getRunNo(_FmwpcTruthHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcTruthHitQ_getMinOccurs(_FmwpcTruthHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcTruthHitQ_getLayer(_FmwpcTruthHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FmwpcTruthHitQ_getWire(_FmwpcTruthHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FmwpcTruthHitQ_getDE(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static PyObject*
_FmwpcTruthHitQ_getDx(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDx());
}

static PyObject*
_FmwpcTruthHitQ_getT(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FmwpcTruthHitQ_getD(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getD());
}

static int
_FmwpcTruthHitQ_setD(_FmwpcTruthHitQ *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setD((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthHitQ_getMaxOccurs(_FmwpcTruthHitQ *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHitQ_getQ(_FmwpcTruthHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_FmwpcTruthHitQ_setQ(_FmwpcTruthHitQ *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthHitQ_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthHitQ *me = (_FmwpcTruthHitQ*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHitQ element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcTruthHitQ_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthHitQ *me = (_FmwpcTruthHitQ*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHitQ element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcTruthHitQ_getsetters[] = {
   {(char*)"class",
    (getter)_FmwpcTruthHitQ_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"d",
    (getter)_FmwpcTruthHitQ_getD, (setter)_FmwpcTruthHitQ_setD,
    (char*)"d value",
    NULL},
   {(char*)"dE",
    (getter)_FmwpcTruthHitQ_getDE, 0,
    (char*)"dE value",
    NULL},
   {(char*)"dx",
    (getter)_FmwpcTruthHitQ_getDx, 0,
    (char*)"dx value",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcTruthHitQ_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FmwpcTruthHitQ_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcTruthHitQ_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcTruthHitQ_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"q",
    (getter)_FmwpcTruthHitQ_getQ, (setter)_FmwpcTruthHitQ_setQ,
    (char*)"q value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcTruthHitQ_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FmwpcTruthHitQ_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcTruthHitQ_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FmwpcTruthHitQ_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcTruthHitQ_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcTruthHitQ_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcTruthHitQ_methods[] = {
   {"toString", _FmwpcTruthHitQ_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcTruthHitQ_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcTruthHitQ_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcTruthHitQ",         /*tp_name*/
    sizeof(_FmwpcTruthHitQ),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcTruthHitQ_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcTruthHitQ_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcTruthHitQ element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcTruthHitQ_methods,          /* tp_methods */
    _FmwpcTruthHitQ_members,          /* tp_members */
    _FmwpcTruthHitQ_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcTruthHitQ_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcTruthHitQ_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcTruthHit as hddm_s.FmwpcTruthHit

typedef struct {
   PyObject_HEAD
   FmwpcTruthHit *elem;
   PyObject *host;
} _FmwpcTruthHit;

static void
_FmwpcTruthHit_dealloc(_FmwpcTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcTruthHit *self;
   self = (_FmwpcTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcTruthHit_init(_FmwpcTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcTruthHit_getClass(_FmwpcTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHit_getVersion(_FmwpcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcTruthHit_getXmlns(_FmwpcTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHit_getEventNo(_FmwpcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcTruthHit_getRunNo(_FmwpcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcTruthHit_getMinOccurs(_FmwpcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcTruthHit_getLayer(_FmwpcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FmwpcTruthHit_getWire(_FmwpcTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FmwpcTruthHit_getDE(_FmwpcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FmwpcTruthHit_setDE(_FmwpcTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthHit_getDx(_FmwpcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDx());
}

static int
_FmwpcTruthHit_setDx(_FmwpcTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDx((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthHit_getMaxOccurs(_FmwpcTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthHit_getT(_FmwpcTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FmwpcTruthHit_setT(_FmwpcTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthHit_getFmwpcTruthHitQ(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   PyObject *obj = _FmwpcTruthHitQ_new(&_FmwpcTruthHitQ_type, 0, 0);
   ((_FmwpcTruthHitQ*)obj)->elem = &me->elem->getFmwpcTruthHitQ(index);
   ((_FmwpcTruthHitQ*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcTruthHit_getFmwpcTruthHitQs(PyObject *self, PyObject *args)
{
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcTruthHitQs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcTruthHit_addFmwpcTruthHitQs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthHitQList(me->elem->addFmwpcTruthHitQs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcTruthHit_deleteFmwpcTruthHitQs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   me->elem->deleteFmwpcTruthHitQs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthHit *me = (_FmwpcTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcTruthHit_getsetters[] = {
   {(char*)"class",
    (getter)_FmwpcTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FmwpcTruthHit_getDE, (setter)_FmwpcTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"dx",
    (getter)_FmwpcTruthHit_getDx, (setter)_FmwpcTruthHit_setDx,
    (char*)"dx value",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FmwpcTruthHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FmwpcTruthHit_getT, (setter)_FmwpcTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FmwpcTruthHit_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcTruthHit_methods[] = {
   {"addFmwpcTruthHitQs", _FmwpcTruthHit_addFmwpcTruthHitQs, METH_VARARGS,
    "extend (or insert into) the list of fmwpcTruthHitQ objects for this fmwpcTruthHit"},
   {"deleteFmwpcTruthHitQs", _FmwpcTruthHit_deleteFmwpcTruthHitQs, METH_VARARGS,
    "delete fmwpcTruthHitQ objects for this fmwpcTruthHit"},
   {"getFmwpcTruthHitQ", _FmwpcTruthHit_getFmwpcTruthHitQ, METH_VARARGS,
    "get an individual fmwpcTruthHitQ object from this fmwpcTruthHit"},
   {"getFmwpcTruthHitQs", _FmwpcTruthHit_getFmwpcTruthHitQs, METH_NOARGS,
    "get list of fmwpcTruthHitQ objects for this fmwpcTruthHit"},
   {"toString", _FmwpcTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcTruthHit",         /*tp_name*/
    sizeof(_FmwpcTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcTruthHit_methods,          /* tp_methods */
    _FmwpcTruthHit_members,          /* tp_members */
    _FmwpcTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcHitQ as hddm_s.FmwpcHitQ

typedef struct {
   PyObject_HEAD
   FmwpcHitQ *elem;
   PyObject *host;
} _FmwpcHitQ;

static void
_FmwpcHitQ_dealloc(_FmwpcHitQ* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcHitQ_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcHitQ *self;
   self = (_FmwpcHitQ*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcHitQ_init(_FmwpcHitQ *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcHitQ_getClass(_FmwpcHitQ *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHitQ_getVersion(_FmwpcHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcHitQ_getXmlns(_FmwpcHitQ *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHitQ_getEventNo(_FmwpcHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcHitQ_getRunNo(_FmwpcHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcHitQ_getMinOccurs(_FmwpcHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcHitQ_getLayer(_FmwpcHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FmwpcHitQ_getWire(_FmwpcHitQ *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FmwpcHitQ_getDE(_FmwpcHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static PyObject*
_FmwpcHitQ_getT(_FmwpcHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static PyObject*
_FmwpcHitQ_getMaxOccurs(_FmwpcHitQ *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHitQ_getQ(_FmwpcHitQ *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getQ());
}

static int
_FmwpcHitQ_setQ(_FmwpcHitQ *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setQ((float)var);
   return 0;
}

static PyObject*
_FmwpcHitQ_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcHitQ *me = (_FmwpcHitQ*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHitQ element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcHitQ_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcHitQ *me = (_FmwpcHitQ*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHitQ element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcHitQ_getsetters[] = {
   {(char*)"class",
    (getter)_FmwpcHitQ_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FmwpcHitQ_getDE, 0,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcHitQ_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FmwpcHitQ_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcHitQ_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcHitQ_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"q",
    (getter)_FmwpcHitQ_getQ, (setter)_FmwpcHitQ_setQ,
    (char*)"q value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcHitQ_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FmwpcHitQ_getT, 0,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcHitQ_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FmwpcHitQ_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcHitQ_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcHitQ_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcHitQ_methods[] = {
   {"toString", _FmwpcHitQ_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcHitQ_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcHitQ_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcHitQ",         /*tp_name*/
    sizeof(_FmwpcHitQ),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcHitQ_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcHitQ_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcHitQ element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcHitQ_methods,          /* tp_methods */
    _FmwpcHitQ_members,          /* tp_members */
    _FmwpcHitQ_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcHitQ_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcHitQ_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcHit as hddm_s.FmwpcHit

typedef struct {
   PyObject_HEAD
   FmwpcHit *elem;
   PyObject *host;
} _FmwpcHit;

static void
_FmwpcHit_dealloc(_FmwpcHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcHit *self;
   self = (_FmwpcHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcHit_init(_FmwpcHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcHit_getClass(_FmwpcHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHit_getVersion(_FmwpcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcHit_getXmlns(_FmwpcHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHit_getEventNo(_FmwpcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcHit_getRunNo(_FmwpcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcHit_getMinOccurs(_FmwpcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcHit_getLayer(_FmwpcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static PyObject*
_FmwpcHit_getWire(_FmwpcHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static PyObject*
_FmwpcHit_getDE(_FmwpcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_FmwpcHit_setDE(_FmwpcHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_FmwpcHit_getMaxOccurs(_FmwpcHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcHit_getT(_FmwpcHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FmwpcHit_setT(_FmwpcHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FmwpcHit_getFmwpcHitQ(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHit element");
      return NULL;
   }
   PyObject *obj = _FmwpcHitQ_new(&_FmwpcHitQ_type, 0, 0);
   ((_FmwpcHitQ*)obj)->elem = &me->elem->getFmwpcHitQ(index);
   ((_FmwpcHitQ*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcHit_getFmwpcHitQs(PyObject *self, PyObject *args)
{
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcHitQs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcHit_addFmwpcHitQs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcHit element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcHitQList(me->elem->addFmwpcHitQs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcHit_deleteFmwpcHitQs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcHit element");
      return NULL;
   }
   me->elem->deleteFmwpcHitQs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcHit_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcHit_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcHit *me = (_FmwpcHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcHit_getsetters[] = {
   {(char*)"class",
    (getter)_FmwpcHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_FmwpcHit_getDE, (setter)_FmwpcHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FmwpcHit_getLayer, 0,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FmwpcHit_getT, (setter)_FmwpcHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FmwpcHit_getWire, 0,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcHit_methods[] = {
   {"addFmwpcHitQs", _FmwpcHit_addFmwpcHitQs, METH_VARARGS,
    "extend (or insert into) the list of fmwpcHitQ objects for this fmwpcHit"},
   {"deleteFmwpcHitQs", _FmwpcHit_deleteFmwpcHitQs, METH_VARARGS,
    "delete fmwpcHitQ objects for this fmwpcHit"},
   {"getFmwpcHitQ", _FmwpcHit_getFmwpcHitQ, METH_VARARGS,
    "get an individual fmwpcHitQ object from this fmwpcHit"},
   {"getFmwpcHitQs", _FmwpcHit_getFmwpcHitQs, METH_NOARGS,
    "get list of fmwpcHitQ objects for this fmwpcHit"},
   {"toString", _FmwpcHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcHit",         /*tp_name*/
    sizeof(_FmwpcHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcHit_methods,          /* tp_methods */
    _FmwpcHit_members,          /* tp_members */
    _FmwpcHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcHit_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcChamber as hddm_s.FmwpcChamber

typedef struct {
   PyObject_HEAD
   FmwpcChamber *elem;
   PyObject *host;
} _FmwpcChamber;

static void
_FmwpcChamber_dealloc(_FmwpcChamber* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcChamber_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcChamber *self;
   self = (_FmwpcChamber*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcChamber_init(_FmwpcChamber *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcChamber_getClass(_FmwpcChamber *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcChamber_getVersion(_FmwpcChamber *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcChamber_getXmlns(_FmwpcChamber *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcChamber_getEventNo(_FmwpcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcChamber_getRunNo(_FmwpcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcChamber_getLayer(_FmwpcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getLayer());
}

static int
_FmwpcChamber_setLayer(_FmwpcChamber *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setLayer(var);
   return 0;
}

static PyObject*
_FmwpcChamber_getMaxOccurs(_FmwpcChamber *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcChamber_getMinOccurs(_FmwpcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcChamber_getWire(_FmwpcChamber *self, void *closure)
{
   return PyLong_FromLong(self->elem->getWire());
}

static int
_FmwpcChamber_setWire(_FmwpcChamber *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setWire(var);
   return 0;
}

static PyObject*
_FmwpcChamber_getFmwpcTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *obj = _FmwpcTruthHit_new(&_FmwpcTruthHit_type, 0, 0);
   ((_FmwpcTruthHit*)obj)->elem = &me->elem->getFmwpcTruthHit(index);
   ((_FmwpcTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcChamber_getFmwpcTruthHits(PyObject *self, PyObject *args)
{
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcChamber_addFmwpcTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthHitList(me->elem->addFmwpcTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcChamber_deleteFmwpcTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcChamber element");
      return NULL;
   }
   me->elem->deleteFmwpcTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcChamber_getFmwpcHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *obj = _FmwpcHit_new(&_FmwpcHit_type, 0, 0);
   ((_FmwpcHit*)obj)->elem = &me->elem->getFmwpcHit(index);
   ((_FmwpcHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcChamber_getFmwpcHits(PyObject *self, PyObject *args)
{
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcChamber_addFmwpcHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcChamber element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcHitList(me->elem->addFmwpcHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcChamber_deleteFmwpcHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcChamber element");
      return NULL;
   }
   me->elem->deleteFmwpcHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcChamber_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcChamber_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcChamber *me = (_FmwpcChamber*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcChamber element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcChamber_getsetters[] = {
   {(char*)"class",
    (getter)_FmwpcChamber_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcChamber_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"layer",
    (getter)_FmwpcChamber_getLayer, (setter)_FmwpcChamber_setLayer,
    (char*)"layer value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcChamber_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcChamber_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcChamber_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcChamber_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"wire",
    (getter)_FmwpcChamber_getWire, (setter)_FmwpcChamber_setWire,
    (char*)"wire value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcChamber_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcChamber_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcChamber_methods[] = {
   {"addFmwpcHits", _FmwpcChamber_addFmwpcHits, METH_VARARGS,
    "extend (or insert into) the list of fmwpcHit objects for this fmwpcChamber"},
   {"addFmwpcTruthHits", _FmwpcChamber_addFmwpcTruthHits, METH_VARARGS,
    "extend (or insert into) the list of fmwpcTruthHit objects for this fmwpcChamber"},
   {"deleteFmwpcHits", _FmwpcChamber_deleteFmwpcHits, METH_VARARGS,
    "delete fmwpcHit objects for this fmwpcChamber"},
   {"deleteFmwpcTruthHits", _FmwpcChamber_deleteFmwpcTruthHits, METH_VARARGS,
    "delete fmwpcTruthHit objects for this fmwpcChamber"},
   {"getFmwpcHit", _FmwpcChamber_getFmwpcHit, METH_VARARGS,
    "get an individual fmwpcHit object from this fmwpcChamber"},
   {"getFmwpcHits", _FmwpcChamber_getFmwpcHits, METH_NOARGS,
    "get list of fmwpcHit objects for this fmwpcChamber"},
   {"getFmwpcTruthHit", _FmwpcChamber_getFmwpcTruthHit, METH_VARARGS,
    "get an individual fmwpcTruthHit object from this fmwpcChamber"},
   {"getFmwpcTruthHits", _FmwpcChamber_getFmwpcTruthHits, METH_NOARGS,
    "get list of fmwpcTruthHit objects for this fmwpcChamber"},
   {"toString", _FmwpcChamber_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcChamber_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcChamber_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcChamber",         /*tp_name*/
    sizeof(_FmwpcChamber),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcChamber_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcChamber_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcChamber element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcChamber_methods,          /* tp_methods */
    _FmwpcChamber_members,          /* tp_members */
    _FmwpcChamber_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcChamber_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcChamber_new,              /* tp_new */
};



// wrap element class hddm_s::FmwpcTruthPoint as hddm_s.FmwpcTruthPoint

typedef struct {
   PyObject_HEAD
   FmwpcTruthPoint *elem;
   PyObject *host;
} _FmwpcTruthPoint;

static void
_FmwpcTruthPoint_dealloc(_FmwpcTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_FmwpcTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _FmwpcTruthPoint *self;
   self = (_FmwpcTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_FmwpcTruthPoint_init(_FmwpcTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_FmwpcTruthPoint_getClass(_FmwpcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthPoint_getVersion(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_FmwpcTruthPoint_getXmlns(_FmwpcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthPoint_getEventNo(_FmwpcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_FmwpcTruthPoint_getRunNo(_FmwpcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_FmwpcTruthPoint_getE(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_FmwpcTruthPoint_setE(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getMaxOccurs(_FmwpcTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_FmwpcTruthPoint_getMinOccurs(_FmwpcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_FmwpcTruthPoint_getPrimary(_FmwpcTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_FmwpcTruthPoint_setPrimary(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getPtype(_FmwpcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_FmwpcTruthPoint_setPtype(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getPx(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_FmwpcTruthPoint_setPx(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getPy(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_FmwpcTruthPoint_setPy(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getPz(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_FmwpcTruthPoint_setPz(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getT(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_FmwpcTruthPoint_setT(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getTrack(_FmwpcTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_FmwpcTruthPoint_setTrack(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getX(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_FmwpcTruthPoint_setX(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getY(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_FmwpcTruthPoint_setY(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getZ(_FmwpcTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_FmwpcTruthPoint_setZ(_FmwpcTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_FmwpcTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_FmwpcTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_FmwpcTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_FmwpcTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_FmwpcTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_FmwpcTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _FmwpcTruthPoint *me = (_FmwpcTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid fmwpcTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _FmwpcTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_FmwpcTruthPoint_getE, (setter)_FmwpcTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_FmwpcTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_FmwpcTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_FmwpcTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_FmwpcTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_FmwpcTruthPoint_getPrimary, (setter)_FmwpcTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_FmwpcTruthPoint_getPtype, (setter)_FmwpcTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_FmwpcTruthPoint_getPx, (setter)_FmwpcTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_FmwpcTruthPoint_getPy, (setter)_FmwpcTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_FmwpcTruthPoint_getPz, (setter)_FmwpcTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_FmwpcTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_FmwpcTruthPoint_getT, (setter)_FmwpcTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_FmwpcTruthPoint_getTrack, (setter)_FmwpcTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_FmwpcTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_FmwpcTruthPoint_getX, (setter)_FmwpcTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_FmwpcTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_FmwpcTruthPoint_getY, (setter)_FmwpcTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_FmwpcTruthPoint_getZ, (setter)_FmwpcTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _FmwpcTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _FmwpcTruthPoint_methods[] = {
   {"addTrackIDs", _FmwpcTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this fmwpcTruthPoint"},
   {"addTrackOrigins", _FmwpcTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this fmwpcTruthPoint"},
   {"deleteTrackIDs", _FmwpcTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this fmwpcTruthPoint"},
   {"deleteTrackOrigins", _FmwpcTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this fmwpcTruthPoint"},
   {"getTrackID", _FmwpcTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this fmwpcTruthPoint"},
   {"getTrackIDs", _FmwpcTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this fmwpcTruthPoint"},
   {"getTrackOrigin", _FmwpcTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this fmwpcTruthPoint"},
   {"getTrackOrigins", _FmwpcTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this fmwpcTruthPoint"},
   {"toString", _FmwpcTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _FmwpcTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _FmwpcTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.FmwpcTruthPoint",         /*tp_name*/
    sizeof(_FmwpcTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_FmwpcTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_FmwpcTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s fmwpcTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _FmwpcTruthPoint_methods,          /* tp_methods */
    _FmwpcTruthPoint_members,          /* tp_members */
    _FmwpcTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_FmwpcTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _FmwpcTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::ForwardMWPC as hddm_s.ForwardMWPC

typedef struct {
   PyObject_HEAD
   ForwardMWPC *elem;
   PyObject *host;
} _ForwardMWPC;

static void
_ForwardMWPC_dealloc(_ForwardMWPC* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ForwardMWPC_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ForwardMWPC *self;
   self = (_ForwardMWPC*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ForwardMWPC_init(_ForwardMWPC *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ForwardMWPC_getClass(_ForwardMWPC *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardMWPC_getVersion(_ForwardMWPC *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ForwardMWPC_getXmlns(_ForwardMWPC *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardMWPC_getEventNo(_ForwardMWPC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ForwardMWPC_getMaxOccurs(_ForwardMWPC *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ForwardMWPC_getRunNo(_ForwardMWPC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ForwardMWPC_getMinOccurs(_ForwardMWPC *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ForwardMWPC_getFmwpcChamber(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *obj = _FmwpcChamber_new(&_FmwpcChamber_type, 0, 0);
   ((_FmwpcChamber*)obj)->elem = &me->elem->getFmwpcChamber(index);
   ((_FmwpcChamber*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardMWPC_getFmwpcChambers(PyObject *self, PyObject *args)
{
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcChambers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardMWPC_addFmwpcChambers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcChamberList(me->elem->addFmwpcChambers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardMWPC_deleteFmwpcChambers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardMWPC element");
      return NULL;
   }
   me->elem->deleteFmwpcChambers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardMWPC_getFmwpcTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *obj = _FmwpcTruthPoint_new(&_FmwpcTruthPoint_type, 0, 0);
   ((_FmwpcTruthPoint*)obj)->elem = &me->elem->getFmwpcTruthPoint(index);
   ((_FmwpcTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ForwardMWPC_getFmwpcTruthPoints(PyObject *self, PyObject *args)
{
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getFmwpcTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ForwardMWPC_addFmwpcTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid forwardMWPC element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthPointList(me->elem->addFmwpcTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ForwardMWPC_deleteFmwpcTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid forwardMWPC element");
      return NULL;
   }
   me->elem->deleteFmwpcTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ForwardMWPC_toString(PyObject *self, PyObject *args=0)
{
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ForwardMWPC_toXML(PyObject *self, PyObject *args=0)
{
   _ForwardMWPC *me = (_ForwardMWPC*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid forwardMWPC element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ForwardMWPC_getsetters[] = {
   {(char*)"class",
    (getter)_ForwardMWPC_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ForwardMWPC_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ForwardMWPC_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ForwardMWPC_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ForwardMWPC_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ForwardMWPC_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ForwardMWPC_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ForwardMWPC_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ForwardMWPC_methods[] = {
   {"addFmwpcChambers", _ForwardMWPC_addFmwpcChambers, METH_VARARGS,
    "extend (or insert into) the list of fmwpcChamber objects for this forwardMWPC"},
   {"addFmwpcTruthPoints", _ForwardMWPC_addFmwpcTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of fmwpcTruthPoint objects for this forwardMWPC"},
   {"deleteFmwpcChambers", _ForwardMWPC_deleteFmwpcChambers, METH_VARARGS,
    "delete fmwpcChamber objects for this forwardMWPC"},
   {"deleteFmwpcTruthPoints", _ForwardMWPC_deleteFmwpcTruthPoints, METH_VARARGS,
    "delete fmwpcTruthPoint objects for this forwardMWPC"},
   {"getFmwpcChamber", _ForwardMWPC_getFmwpcChamber, METH_VARARGS,
    "get an individual fmwpcChamber object from this forwardMWPC"},
   {"getFmwpcChambers", _ForwardMWPC_getFmwpcChambers, METH_NOARGS,
    "get list of fmwpcChamber objects for this forwardMWPC"},
   {"getFmwpcTruthPoint", _ForwardMWPC_getFmwpcTruthPoint, METH_VARARGS,
    "get an individual fmwpcTruthPoint object from this forwardMWPC"},
   {"getFmwpcTruthPoints", _ForwardMWPC_getFmwpcTruthPoints, METH_NOARGS,
    "get list of fmwpcTruthPoint objects for this forwardMWPC"},
   {"toString", _ForwardMWPC_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ForwardMWPC_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ForwardMWPC_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ForwardMWPC",         /*tp_name*/
    sizeof(_ForwardMWPC),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ForwardMWPC_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ForwardMWPC_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s forwardMWPC element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ForwardMWPC_methods,          /* tp_methods */
    _ForwardMWPC_members,          /* tp_members */
    _ForwardMWPC_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ForwardMWPC_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ForwardMWPC_new,              /* tp_new */
};



// wrap element class hddm_s::CtofHit as hddm_s.CtofHit

typedef struct {
   PyObject_HEAD
   CtofHit *elem;
   PyObject *host;
} _CtofHit;

static void
_CtofHit_dealloc(_CtofHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CtofHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CtofHit *self;
   self = (_CtofHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CtofHit_init(_CtofHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CtofHit_getClass(_CtofHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofHit_getVersion(_CtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CtofHit_getXmlns(_CtofHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofHit_getEventNo(_CtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CtofHit_getRunNo(_CtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CtofHit_getBar(_CtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_CtofHit_getDE(_CtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_CtofHit_setDE(_CtofHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_CtofHit_getEnd(_CtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_CtofHit_setEnd(_CtofHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_CtofHit_getMaxOccurs(_CtofHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofHit_getMinOccurs(_CtofHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CtofHit_getT(_CtofHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CtofHit_setT(_CtofHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CtofHit_toString(PyObject *self, PyObject *args=0)
{
   _CtofHit *me = (_CtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CtofHit_toXML(PyObject *self, PyObject *args=0)
{
   _CtofHit *me = (_CtofHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CtofHit_getsetters[] = {
   {(char*)"bar",
    (getter)_CtofHit_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_CtofHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_CtofHit_getDE, (setter)_CtofHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"end",
    (getter)_CtofHit_getEnd, (setter)_CtofHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_CtofHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CtofHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CtofHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CtofHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CtofHit_getT, (setter)_CtofHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CtofHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CtofHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CtofHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CtofHit_methods[] = {
   {"toString", _CtofHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CtofHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CtofHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CtofHit",         /*tp_name*/
    sizeof(_CtofHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CtofHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CtofHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ctofHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CtofHit_methods,          /* tp_methods */
    _CtofHit_members,          /* tp_members */
    _CtofHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CtofHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CtofHit_new,              /* tp_new */
};



// wrap element class hddm_s::CtofTruthHit as hddm_s.CtofTruthHit

typedef struct {
   PyObject_HEAD
   CtofTruthHit *elem;
   PyObject *host;
} _CtofTruthHit;

static void
_CtofTruthHit_dealloc(_CtofTruthHit* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CtofTruthHit_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CtofTruthHit *self;
   self = (_CtofTruthHit*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CtofTruthHit_init(_CtofTruthHit *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CtofTruthHit_getClass(_CtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthHit_getVersion(_CtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CtofTruthHit_getXmlns(_CtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthHit_getEventNo(_CtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CtofTruthHit_getRunNo(_CtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CtofTruthHit_getBar(_CtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static PyObject*
_CtofTruthHit_getDE(_CtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getDE());
}

static int
_CtofTruthHit_setDE(_CtofTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setDE((float)var);
   return 0;
}

static PyObject*
_CtofTruthHit_getEnd(_CtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEnd());
}

static int
_CtofTruthHit_setEnd(_CtofTruthHit *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEnd(var);
   return 0;
}

static PyObject*
_CtofTruthHit_getMaxOccurs(_CtofTruthHit *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthHit_getMinOccurs(_CtofTruthHit *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CtofTruthHit_getT(_CtofTruthHit *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CtofTruthHit_setT(_CtofTruthHit *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CtofTruthHit_toString(PyObject *self, PyObject *args=0)
{
   _CtofTruthHit *me = (_CtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CtofTruthHit_toXML(PyObject *self, PyObject *args=0)
{
   _CtofTruthHit *me = (_CtofTruthHit*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthHit element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CtofTruthHit_getsetters[] = {
   {(char*)"bar",
    (getter)_CtofTruthHit_getBar, 0,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_CtofTruthHit_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"dE",
    (getter)_CtofTruthHit_getDE, (setter)_CtofTruthHit_setDE,
    (char*)"dE value",
    NULL},
   {(char*)"end",
    (getter)_CtofTruthHit_getEnd, (setter)_CtofTruthHit_setEnd,
    (char*)"end value",
    NULL},
   {(char*)"eventNo",
    (getter)_CtofTruthHit_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CtofTruthHit_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CtofTruthHit_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CtofTruthHit_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CtofTruthHit_getT, (setter)_CtofTruthHit_setT,
    (char*)"t value",
    NULL},
   {(char*)"version",
    (getter)_CtofTruthHit_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CtofTruthHit_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CtofTruthHit_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CtofTruthHit_methods[] = {
   {"toString", _CtofTruthHit_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CtofTruthHit_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CtofTruthHit_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CtofTruthHit",         /*tp_name*/
    sizeof(_CtofTruthHit),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CtofTruthHit_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CtofTruthHit_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ctofTruthHit element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CtofTruthHit_methods,          /* tp_methods */
    _CtofTruthHit_members,          /* tp_members */
    _CtofTruthHit_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CtofTruthHit_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CtofTruthHit_new,              /* tp_new */
};



// wrap element class hddm_s::CtofCounter as hddm_s.CtofCounter

typedef struct {
   PyObject_HEAD
   CtofCounter *elem;
   PyObject *host;
} _CtofCounter;

static void
_CtofCounter_dealloc(_CtofCounter* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CtofCounter_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CtofCounter *self;
   self = (_CtofCounter*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CtofCounter_init(_CtofCounter *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CtofCounter_getClass(_CtofCounter *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofCounter_getVersion(_CtofCounter *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CtofCounter_getXmlns(_CtofCounter *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofCounter_getEventNo(_CtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CtofCounter_getRunNo(_CtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CtofCounter_getBar(_CtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getBar());
}

static int
_CtofCounter_setBar(_CtofCounter *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setBar(var);
   return 0;
}

static PyObject*
_CtofCounter_getMaxOccurs(_CtofCounter *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofCounter_getMinOccurs(_CtofCounter *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CtofCounter_getCtofHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *obj = _CtofHit_new(&_CtofHit_type, 0, 0);
   ((_CtofHit*)obj)->elem = &me->elem->getCtofHit(index);
   ((_CtofHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CtofCounter_getCtofHits(PyObject *self, PyObject *args)
{
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCtofHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CtofCounter_addCtofHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofHitList(me->elem->addCtofHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CtofCounter_deleteCtofHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ctofCounter element");
      return NULL;
   }
   me->elem->deleteCtofHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CtofCounter_getCtofTruthHit(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *obj = _CtofTruthHit_new(&_CtofTruthHit_type, 0, 0);
   ((_CtofTruthHit*)obj)->elem = &me->elem->getCtofTruthHit(index);
   ((_CtofTruthHit*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CtofCounter_getCtofTruthHits(PyObject *self, PyObject *args)
{
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCtofTruthHits();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CtofCounter_addCtofTruthHits(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ctofCounter element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofTruthHitList(me->elem->addCtofTruthHits(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CtofCounter_deleteCtofTruthHits(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ctofCounter element");
      return NULL;
   }
   me->elem->deleteCtofTruthHits(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CtofCounter_toString(PyObject *self, PyObject *args=0)
{
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CtofCounter_toXML(PyObject *self, PyObject *args=0)
{
   _CtofCounter *me = (_CtofCounter*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofCounter element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CtofCounter_getsetters[] = {
   {(char*)"bar",
    (getter)_CtofCounter_getBar, (setter)_CtofCounter_setBar,
    (char*)"bar value",
    NULL},
   {(char*)"class",
    (getter)_CtofCounter_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CtofCounter_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CtofCounter_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CtofCounter_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CtofCounter_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_CtofCounter_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CtofCounter_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CtofCounter_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CtofCounter_methods[] = {
   {"addCtofHits", _CtofCounter_addCtofHits, METH_VARARGS,
    "extend (or insert into) the list of ctofHit objects for this ctofCounter"},
   {"addCtofTruthHits", _CtofCounter_addCtofTruthHits, METH_VARARGS,
    "extend (or insert into) the list of ctofTruthHit objects for this ctofCounter"},
   {"deleteCtofHits", _CtofCounter_deleteCtofHits, METH_VARARGS,
    "delete ctofHit objects for this ctofCounter"},
   {"deleteCtofTruthHits", _CtofCounter_deleteCtofTruthHits, METH_VARARGS,
    "delete ctofTruthHit objects for this ctofCounter"},
   {"getCtofHit", _CtofCounter_getCtofHit, METH_VARARGS,
    "get an individual ctofHit object from this ctofCounter"},
   {"getCtofHits", _CtofCounter_getCtofHits, METH_NOARGS,
    "get list of ctofHit objects for this ctofCounter"},
   {"getCtofTruthHit", _CtofCounter_getCtofTruthHit, METH_VARARGS,
    "get an individual ctofTruthHit object from this ctofCounter"},
   {"getCtofTruthHits", _CtofCounter_getCtofTruthHits, METH_NOARGS,
    "get list of ctofTruthHit objects for this ctofCounter"},
   {"toString", _CtofCounter_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CtofCounter_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CtofCounter_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CtofCounter",         /*tp_name*/
    sizeof(_CtofCounter),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CtofCounter_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CtofCounter_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ctofCounter element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CtofCounter_methods,          /* tp_methods */
    _CtofCounter_members,          /* tp_members */
    _CtofCounter_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CtofCounter_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CtofCounter_new,              /* tp_new */
};



// wrap element class hddm_s::CtofTruthPoint as hddm_s.CtofTruthPoint

typedef struct {
   PyObject_HEAD
   CtofTruthPoint *elem;
   PyObject *host;
} _CtofTruthPoint;

static void
_CtofTruthPoint_dealloc(_CtofTruthPoint* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CtofTruthPoint_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CtofTruthPoint *self;
   self = (_CtofTruthPoint*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CtofTruthPoint_init(_CtofTruthPoint *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CtofTruthPoint_getClass(_CtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthPoint_getVersion(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CtofTruthPoint_getXmlns(_CtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthPoint_getEventNo(_CtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CtofTruthPoint_getRunNo(_CtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CtofTruthPoint_getE(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getE());
}

static int
_CtofTruthPoint_setE(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setE((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getMaxOccurs(_CtofTruthPoint *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CtofTruthPoint_getMinOccurs(_CtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CtofTruthPoint_getPrimary(_CtofTruthPoint *self, void *closure)
{
   return PyBool_FromLong(self->elem->getPrimary());
}

static int
_CtofTruthPoint_setPrimary(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPrimary((var==0)? false : true);
   return 0;
}

static PyObject*
_CtofTruthPoint_getPtype(_CtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getPtype());
}

static int
_CtofTruthPoint_setPtype(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setPtype(var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getPx(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPx());
}

static int
_CtofTruthPoint_setPx(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPx((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getPy(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPy());
}

static int
_CtofTruthPoint_setPy(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPy((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getPz(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getPz());
}

static int
_CtofTruthPoint_setPz(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setPz((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getT(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getT());
}

static int
_CtofTruthPoint_setT(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setT((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getTrack(_CtofTruthPoint *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrack());
}

static int
_CtofTruthPoint_setTrack(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrack(var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getX(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getX());
}

static int
_CtofTruthPoint_setX(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setX((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getY(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getY());
}

static int
_CtofTruthPoint_setY(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setY((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getZ(_CtofTruthPoint *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getZ());
}

static int
_CtofTruthPoint_setZ(_CtofTruthPoint *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setZ((float)var);
   return 0;
}

static PyObject*
_CtofTruthPoint_getTrackID(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackID_new(&_TrackID_type, 0, 0);
   ((_TrackID*)obj)->elem = &me->elem->getTrackID();
   ((_TrackID*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CtofTruthPoint_getTrackIDs(PyObject *self, PyObject *args)
{
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackIDs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CtofTruthPoint_addTrackIDs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->addTrackIDs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CtofTruthPoint_deleteTrackIDs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackIDs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CtofTruthPoint_getTrackOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *obj = _TrackOrigin_new(&_TrackOrigin_type, 0, 0);
   ((_TrackOrigin*)obj)->elem = &me->elem->getTrackOrigin(index);
   ((_TrackOrigin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CtofTruthPoint_getTrackOrigins(PyObject *self, PyObject *args)
{
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CtofTruthPoint_addTrackOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->addTrackOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CtofTruthPoint_deleteTrackOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   me->elem->deleteTrackOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CtofTruthPoint_toString(PyObject *self, PyObject *args=0)
{
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CtofTruthPoint_toXML(PyObject *self, PyObject *args=0)
{
   _CtofTruthPoint *me = (_CtofTruthPoint*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid ctofTruthPoint element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CtofTruthPoint_getsetters[] = {
   {(char*)"E",
    (getter)_CtofTruthPoint_getE, (setter)_CtofTruthPoint_setE,
    (char*)"E value",
    NULL},
   {(char*)"class",
    (getter)_CtofTruthPoint_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CtofTruthPoint_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CtofTruthPoint_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_CtofTruthPoint_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"primary",
    (getter)_CtofTruthPoint_getPrimary, (setter)_CtofTruthPoint_setPrimary,
    (char*)"primary value",
    NULL},
   {(char*)"ptype",
    (getter)_CtofTruthPoint_getPtype, (setter)_CtofTruthPoint_setPtype,
    (char*)"ptype value",
    NULL},
   {(char*)"px",
    (getter)_CtofTruthPoint_getPx, (setter)_CtofTruthPoint_setPx,
    (char*)"px value",
    NULL},
   {(char*)"py",
    (getter)_CtofTruthPoint_getPy, (setter)_CtofTruthPoint_setPy,
    (char*)"py value",
    NULL},
   {(char*)"pz",
    (getter)_CtofTruthPoint_getPz, (setter)_CtofTruthPoint_setPz,
    (char*)"pz value",
    NULL},
   {(char*)"runNo",
    (getter)_CtofTruthPoint_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"t",
    (getter)_CtofTruthPoint_getT, (setter)_CtofTruthPoint_setT,
    (char*)"t value",
    NULL},
   {(char*)"track",
    (getter)_CtofTruthPoint_getTrack, (setter)_CtofTruthPoint_setTrack,
    (char*)"track value",
    NULL},
   {(char*)"version",
    (getter)_CtofTruthPoint_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"x",
    (getter)_CtofTruthPoint_getX, (setter)_CtofTruthPoint_setX,
    (char*)"x value",
    NULL},
   {(char*)"xmlns",
    (getter)_CtofTruthPoint_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {(char*)"y",
    (getter)_CtofTruthPoint_getY, (setter)_CtofTruthPoint_setY,
    (char*)"y value",
    NULL},
   {(char*)"z",
    (getter)_CtofTruthPoint_getZ, (setter)_CtofTruthPoint_setZ,
    (char*)"z value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CtofTruthPoint_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CtofTruthPoint_methods[] = {
   {"addTrackIDs", _CtofTruthPoint_addTrackIDs, METH_VARARGS,
    "extend (or insert into) the list of trackID objects for this ctofTruthPoint"},
   {"addTrackOrigins", _CtofTruthPoint_addTrackOrigins, METH_VARARGS,
    "extend (or insert into) the list of trackOrigin objects for this ctofTruthPoint"},
   {"deleteTrackIDs", _CtofTruthPoint_deleteTrackIDs, METH_VARARGS,
    "delete trackID objects for this ctofTruthPoint"},
   {"deleteTrackOrigins", _CtofTruthPoint_deleteTrackOrigins, METH_VARARGS,
    "delete trackOrigin objects for this ctofTruthPoint"},
   {"getTrackID", _CtofTruthPoint_getTrackID, METH_VARARGS,
    "get an individual trackID object from this ctofTruthPoint"},
   {"getTrackIDs", _CtofTruthPoint_getTrackIDs, METH_NOARGS,
    "get list of trackID objects for this ctofTruthPoint"},
   {"getTrackOrigin", _CtofTruthPoint_getTrackOrigin, METH_VARARGS,
    "get an individual trackOrigin object from this ctofTruthPoint"},
   {"getTrackOrigins", _CtofTruthPoint_getTrackOrigins, METH_NOARGS,
    "get list of trackOrigin objects for this ctofTruthPoint"},
   {"toString", _CtofTruthPoint_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CtofTruthPoint_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CtofTruthPoint_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CtofTruthPoint",         /*tp_name*/
    sizeof(_CtofTruthPoint),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CtofTruthPoint_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CtofTruthPoint_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s ctofTruthPoint element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CtofTruthPoint_methods,          /* tp_methods */
    _CtofTruthPoint_members,          /* tp_members */
    _CtofTruthPoint_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CtofTruthPoint_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CtofTruthPoint_new,              /* tp_new */
};



// wrap element class hddm_s::CppTOF as hddm_s.CppTOF

typedef struct {
   PyObject_HEAD
   CppTOF *elem;
   PyObject *host;
} _CppTOF;

static void
_CppTOF_dealloc(_CppTOF* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_CppTOF_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _CppTOF *self;
   self = (_CppTOF*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_CppTOF_init(_CppTOF *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_CppTOF_getClass(_CppTOF *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CppTOF_getVersion(_CppTOF *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_CppTOF_getXmlns(_CppTOF *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CppTOF_getEventNo(_CppTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_CppTOF_getMaxOccurs(_CppTOF *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_CppTOF_getRunNo(_CppTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_CppTOF_getMinOccurs(_CppTOF *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_CppTOF_getCtofCounter(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *obj = _CtofCounter_new(&_CtofCounter_type, 0, 0);
   ((_CtofCounter*)obj)->elem = &me->elem->getCtofCounter(index);
   ((_CtofCounter*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CppTOF_getCtofCounters(PyObject *self, PyObject *args)
{
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCtofCounters();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CppTOF_addCtofCounters(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofCounterList(me->elem->addCtofCounters(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CppTOF_deleteCtofCounters(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cppTOF element");
      return NULL;
   }
   me->elem->deleteCtofCounters(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CppTOF_getCtofTruthPoint(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *obj = _CtofTruthPoint_new(&_CtofTruthPoint_type, 0, 0);
   ((_CtofTruthPoint*)obj)->elem = &me->elem->getCtofTruthPoint(index);
   ((_CtofTruthPoint*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_CppTOF_getCtofTruthPoints(PyObject *self, PyObject *args)
{
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCtofTruthPoints();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_CppTOF_addCtofTruthPoints(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid cppTOF element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofTruthPointList(me->elem->addCtofTruthPoints(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_CppTOF_deleteCtofTruthPoints(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid cppTOF element");
      return NULL;
   }
   me->elem->deleteCtofTruthPoints(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_CppTOF_toString(PyObject *self, PyObject *args=0)
{
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_CppTOF_toXML(PyObject *self, PyObject *args=0)
{
   _CppTOF *me = (_CppTOF*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid cppTOF element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _CppTOF_getsetters[] = {
   {(char*)"class",
    (getter)_CppTOF_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_CppTOF_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_CppTOF_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_CppTOF_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_CppTOF_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_CppTOF_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_CppTOF_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _CppTOF_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _CppTOF_methods[] = {
   {"addCtofCounters", _CppTOF_addCtofCounters, METH_VARARGS,
    "extend (or insert into) the list of ctofCounter objects for this cppTOF"},
   {"addCtofTruthPoints", _CppTOF_addCtofTruthPoints, METH_VARARGS,
    "extend (or insert into) the list of ctofTruthPoint objects for this cppTOF"},
   {"deleteCtofCounters", _CppTOF_deleteCtofCounters, METH_VARARGS,
    "delete ctofCounter objects for this cppTOF"},
   {"deleteCtofTruthPoints", _CppTOF_deleteCtofTruthPoints, METH_VARARGS,
    "delete ctofTruthPoint objects for this cppTOF"},
   {"getCtofCounter", _CppTOF_getCtofCounter, METH_VARARGS,
    "get an individual ctofCounter object from this cppTOF"},
   {"getCtofCounters", _CppTOF_getCtofCounters, METH_NOARGS,
    "get list of ctofCounter objects for this cppTOF"},
   {"getCtofTruthPoint", _CppTOF_getCtofTruthPoint, METH_VARARGS,
    "get an individual ctofTruthPoint object from this cppTOF"},
   {"getCtofTruthPoints", _CppTOF_getCtofTruthPoints, METH_NOARGS,
    "get list of ctofTruthPoint objects for this cppTOF"},
   {"toString", _CppTOF_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _CppTOF_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _CppTOF_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.CppTOF",         /*tp_name*/
    sizeof(_CppTOF),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_CppTOF_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_CppTOF_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s cppTOF element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _CppTOF_methods,          /* tp_methods */
    _CppTOF_members,          /* tp_members */
    _CppTOF_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_CppTOF_init,   /* tp_init */
    0,                         /* tp_alloc */
    _CppTOF_new,              /* tp_new */
};



// wrap element class hddm_s::HitView as hddm_s.HitView

typedef struct {
   PyObject_HEAD
   HitView *elem;
   PyObject *host;
} _HitView;

static void
_HitView_dealloc(_HitView* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_HitView_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _HitView *self;
   self = (_HitView*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_HitView_init(_HitView *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_HitView_getClass(_HitView *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HitView_getXmlns(_HitView *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HitView_getEventNo(_HitView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_HitView_getMaxOccurs(_HitView *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HitView_getRunNo(_HitView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_HitView_getMinOccurs(_HitView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_HitView_getVersion(_HitView *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_HitView_getCentralDC(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _CentralDC_new(&_CentralDC_type, 0, 0);
   ((_CentralDC*)obj)->elem = &me->elem->getCentralDC();
   ((_CentralDC*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getCentralDCs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CentralDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCentralDCs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addCentralDCs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CentralDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CentralDCList(me->elem->addCentralDCs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteCentralDCs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteCentralDCs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getForwardDC(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _ForwardDC_new(&_ForwardDC_type, 0, 0);
   ((_ForwardDC*)obj)->elem = &me->elem->getForwardDC();
   ((_ForwardDC*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getForwardDCs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getForwardDCs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addForwardDCs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardDCList(me->elem->addForwardDCs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteForwardDCs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteForwardDCs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getStartCntr(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _StartCntr_new(&_StartCntr_type, 0, 0);
   ((_StartCntr*)obj)->elem = &me->elem->getStartCntr();
   ((_StartCntr*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getStartCntrs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StartCntr_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getStartCntrs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addStartCntrs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StartCntr_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StartCntrList(me->elem->addStartCntrs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteStartCntrs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteStartCntrs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getBarrelEMcal(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _BarrelEMcal_new(&_BarrelEMcal_type, 0, 0);
   ((_BarrelEMcal*)obj)->elem = &me->elem->getBarrelEMcal();
   ((_BarrelEMcal*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getBarrelEMcals(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BarrelEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getBarrelEMcals();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addBarrelEMcals(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BarrelEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BarrelEMcalList(me->elem->addBarrelEMcals(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteBarrelEMcals(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteBarrelEMcals(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getGapEMcal(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _GapEMcal_new(&_GapEMcal_type, 0, 0);
   ((_GapEMcal*)obj)->elem = &me->elem->getGapEMcal();
   ((_GapEMcal*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getGapEMcals(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GapEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGapEMcals();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addGapEMcals(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GapEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GapEMcalList(me->elem->addGapEMcals(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteGapEMcals(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteGapEMcals(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getCerenkov(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _Cerenkov_new(&_Cerenkov_type, 0, 0);
   ((_Cerenkov*)obj)->elem = &me->elem->getCerenkov();
   ((_Cerenkov*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getCerenkovs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Cerenkov_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCerenkovs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addCerenkovs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Cerenkov_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CerenkovList(me->elem->addCerenkovs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteCerenkovs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteCerenkovs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getRICH(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _RICH_new(&_RICH_type, 0, 0);
   ((_RICH*)obj)->elem = &me->elem->getRICH();
   ((_RICH*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getRICHs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RICH_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRICHs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addRICHs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RICH_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RICHList(me->elem->addRICHs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteRICHs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteRICHs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getDIRC(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _DIRC_new(&_DIRC_type, 0, 0);
   ((_DIRC*)obj)->elem = &me->elem->getDIRC();
   ((_DIRC*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getDIRCs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DIRC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDIRCs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addDIRCs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DIRC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DIRCList(me->elem->addDIRCs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteDIRCs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteDIRCs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getForwardTOF(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _ForwardTOF_new(&_ForwardTOF_type, 0, 0);
   ((_ForwardTOF*)obj)->elem = &me->elem->getForwardTOF();
   ((_ForwardTOF*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getForwardTOFs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getForwardTOFs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addForwardTOFs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardTOFList(me->elem->addForwardTOFs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteForwardTOFs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteForwardTOFs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getForwardEMcal(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _ForwardEMcal_new(&_ForwardEMcal_type, 0, 0);
   ((_ForwardEMcal*)obj)->elem = &me->elem->getForwardEMcal();
   ((_ForwardEMcal*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getForwardEMcals(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getForwardEMcals();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addForwardEMcals(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardEMcalList(me->elem->addForwardEMcals(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteForwardEMcals(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteForwardEMcals(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getCrystalEcal(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _CrystalEcal_new(&_CrystalEcal_type, 0, 0);
   ((_CrystalEcal*)obj)->elem = &me->elem->getCrystalEcal();
   ((_CrystalEcal*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getCrystalEcals(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CrystalEcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCrystalEcals();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addCrystalEcals(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CrystalEcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CrystalEcalList(me->elem->addCrystalEcals(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteCrystalEcals(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteCrystalEcals(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getComptonEMcal(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _ComptonEMcal_new(&_ComptonEMcal_type, 0, 0);
   ((_ComptonEMcal*)obj)->elem = &me->elem->getComptonEMcal();
   ((_ComptonEMcal*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getComptonEMcals(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ComptonEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getComptonEMcals();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addComptonEMcals(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ComptonEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ComptonEMcalList(me->elem->addComptonEMcals(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteComptonEMcals(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteComptonEMcals(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getUpstreamEMveto(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _UpstreamEMveto_new(&_UpstreamEMveto_type, 0, 0);
   ((_UpstreamEMveto*)obj)->elem = &me->elem->getUpstreamEMveto();
   ((_UpstreamEMveto*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getUpstreamEMvetos(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpstreamEMveto_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getUpstreamEMvetos();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addUpstreamEMvetos(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpstreamEMveto_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpstreamEMvetoList(me->elem->addUpstreamEMvetos(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteUpstreamEMvetos(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteUpstreamEMvetos(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getTagger(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _Tagger_new(&_Tagger_type, 0, 0);
   ((_Tagger*)obj)->elem = &me->elem->getTagger();
   ((_Tagger*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getTaggers(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tagger_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTaggers();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addTaggers(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tagger_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerList(me->elem->addTaggers(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteTaggers(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteTaggers(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getPairSpectrometerFine(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _PairSpectrometerFine_new(&_PairSpectrometerFine_type, 0, 0);
   ((_PairSpectrometerFine*)obj)->elem = &me->elem->getPairSpectrometerFine();
   ((_PairSpectrometerFine*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getPairSpectrometerFines(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerFine_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPairSpectrometerFines();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addPairSpectrometerFines(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerFine_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PairSpectrometerFineList(me->elem->addPairSpectrometerFines(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deletePairSpectrometerFines(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deletePairSpectrometerFines(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getPairSpectrometerCoarse(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _PairSpectrometerCoarse_new(&_PairSpectrometerCoarse_type, 0, 0);
   ((_PairSpectrometerCoarse*)obj)->elem = &me->elem->getPairSpectrometerCoarse();
   ((_PairSpectrometerCoarse*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getPairSpectrometerCoarses(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerCoarse_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPairSpectrometerCoarses();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addPairSpectrometerCoarses(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerCoarse_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PairSpectrometerCoarseList(me->elem->addPairSpectrometerCoarses(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deletePairSpectrometerCoarses(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deletePairSpectrometerCoarses(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getTripletPolarimeter(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _TripletPolarimeter_new(&_TripletPolarimeter_type, 0, 0);
   ((_TripletPolarimeter*)obj)->elem = &me->elem->getTripletPolarimeter();
   ((_TripletPolarimeter*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getTripletPolarimeters(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TripletPolarimeter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTripletPolarimeters();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addTripletPolarimeters(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TripletPolarimeter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TripletPolarimeterList(me->elem->addTripletPolarimeters(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteTripletPolarimeters(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteTripletPolarimeters(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getMcTrajectory(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _McTrajectory_new(&_McTrajectory_type, 0, 0);
   ((_McTrajectory*)obj)->elem = &me->elem->getMcTrajectory();
   ((_McTrajectory*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getMcTrajectorys(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectory_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMcTrajectorys();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addMcTrajectorys(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectory_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new McTrajectoryList(me->elem->addMcTrajectorys(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteMcTrajectorys(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteMcTrajectorys(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getRFtime(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _RFtime_new(&_RFtime_type, 0, 0);
   ((_RFtime*)obj)->elem = &me->elem->getRFtime();
   ((_RFtime*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getRFtimes(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFtime_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getRFtimes();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addRFtimes(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFtime_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RFtimeList(me->elem->addRFtimes(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteRFtimes(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteRFtimes(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getForwardMWPC(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _ForwardMWPC_new(&_ForwardMWPC_type, 0, 0);
   ((_ForwardMWPC*)obj)->elem = &me->elem->getForwardMWPC();
   ((_ForwardMWPC*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getForwardMWPCs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardMWPC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getForwardMWPCs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addForwardMWPCs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardMWPC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardMWPCList(me->elem->addForwardMWPCs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteForwardMWPCs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteForwardMWPCs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_getCppTOF(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *obj = _CppTOF_new(&_CppTOF_type, 0, 0);
   ((_CppTOF*)obj)->elem = &me->elem->getCppTOF();
   ((_CppTOF*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HitView_getCppTOFs(PyObject *self, PyObject *args)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CppTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCppTOFs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HitView_addCppTOFs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid hitView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CppTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CppTOFList(me->elem->addCppTOFs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HitView_deleteCppTOFs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid hitView element");
      return NULL;
   }
   me->elem->deleteCppTOFs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HitView_toString(PyObject *self, PyObject *args=0)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_HitView_toXML(PyObject *self, PyObject *args=0)
{
   _HitView *me = (_HitView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid hitView element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _HitView_getsetters[] = {
   {(char*)"class",
    (getter)_HitView_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_HitView_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_HitView_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_HitView_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_HitView_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_HitView_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_HitView_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _HitView_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _HitView_methods[] = {
   {"addBarrelEMcals", _HitView_addBarrelEMcals, METH_VARARGS,
    "extend (or insert into) the list of barrelEMcal objects for this hitView"},
   {"addCentralDCs", _HitView_addCentralDCs, METH_VARARGS,
    "extend (or insert into) the list of centralDC objects for this hitView"},
   {"addCerenkovs", _HitView_addCerenkovs, METH_VARARGS,
    "extend (or insert into) the list of Cerenkov objects for this hitView"},
   {"addComptonEMcals", _HitView_addComptonEMcals, METH_VARARGS,
    "extend (or insert into) the list of ComptonEMcal objects for this hitView"},
   {"addCppTOFs", _HitView_addCppTOFs, METH_VARARGS,
    "extend (or insert into) the list of cppTOF objects for this hitView"},
   {"addCrystalEcals", _HitView_addCrystalEcals, METH_VARARGS,
    "extend (or insert into) the list of CrystalEcal objects for this hitView"},
   {"addDIRCs", _HitView_addDIRCs, METH_VARARGS,
    "extend (or insert into) the list of DIRC objects for this hitView"},
   {"addForwardDCs", _HitView_addForwardDCs, METH_VARARGS,
    "extend (or insert into) the list of forwardDC objects for this hitView"},
   {"addForwardEMcals", _HitView_addForwardEMcals, METH_VARARGS,
    "extend (or insert into) the list of forwardEMcal objects for this hitView"},
   {"addForwardMWPCs", _HitView_addForwardMWPCs, METH_VARARGS,
    "extend (or insert into) the list of forwardMWPC objects for this hitView"},
   {"addForwardTOFs", _HitView_addForwardTOFs, METH_VARARGS,
    "extend (or insert into) the list of forwardTOF objects for this hitView"},
   {"addGapEMcals", _HitView_addGapEMcals, METH_VARARGS,
    "extend (or insert into) the list of gapEMcal objects for this hitView"},
   {"addMcTrajectorys", _HitView_addMcTrajectorys, METH_VARARGS,
    "extend (or insert into) the list of mcTrajectory objects for this hitView"},
   {"addPairSpectrometerCoarses", _HitView_addPairSpectrometerCoarses, METH_VARARGS,
    "extend (or insert into) the list of pairSpectrometerCoarse objects for this hitView"},
   {"addPairSpectrometerFines", _HitView_addPairSpectrometerFines, METH_VARARGS,
    "extend (or insert into) the list of pairSpectrometerFine objects for this hitView"},
   {"addRFtimes", _HitView_addRFtimes, METH_VARARGS,
    "extend (or insert into) the list of RFtime objects for this hitView"},
   {"addRICHs", _HitView_addRICHs, METH_VARARGS,
    "extend (or insert into) the list of RICH objects for this hitView"},
   {"addStartCntrs", _HitView_addStartCntrs, METH_VARARGS,
    "extend (or insert into) the list of startCntr objects for this hitView"},
   {"addTaggers", _HitView_addTaggers, METH_VARARGS,
    "extend (or insert into) the list of tagger objects for this hitView"},
   {"addTripletPolarimeters", _HitView_addTripletPolarimeters, METH_VARARGS,
    "extend (or insert into) the list of tripletPolarimeter objects for this hitView"},
   {"addUpstreamEMvetos", _HitView_addUpstreamEMvetos, METH_VARARGS,
    "extend (or insert into) the list of upstreamEMveto objects for this hitView"},
   {"deleteBarrelEMcals", _HitView_deleteBarrelEMcals, METH_VARARGS,
    "delete barrelEMcal objects for this hitView"},
   {"deleteCentralDCs", _HitView_deleteCentralDCs, METH_VARARGS,
    "delete centralDC objects for this hitView"},
   {"deleteCerenkovs", _HitView_deleteCerenkovs, METH_VARARGS,
    "delete Cerenkov objects for this hitView"},
   {"deleteComptonEMcals", _HitView_deleteComptonEMcals, METH_VARARGS,
    "delete ComptonEMcal objects for this hitView"},
   {"deleteCppTOFs", _HitView_deleteCppTOFs, METH_VARARGS,
    "delete cppTOF objects for this hitView"},
   {"deleteCrystalEcals", _HitView_deleteCrystalEcals, METH_VARARGS,
    "delete CrystalEcal objects for this hitView"},
   {"deleteDIRCs", _HitView_deleteDIRCs, METH_VARARGS,
    "delete DIRC objects for this hitView"},
   {"deleteForwardDCs", _HitView_deleteForwardDCs, METH_VARARGS,
    "delete forwardDC objects for this hitView"},
   {"deleteForwardEMcals", _HitView_deleteForwardEMcals, METH_VARARGS,
    "delete forwardEMcal objects for this hitView"},
   {"deleteForwardMWPCs", _HitView_deleteForwardMWPCs, METH_VARARGS,
    "delete forwardMWPC objects for this hitView"},
   {"deleteForwardTOFs", _HitView_deleteForwardTOFs, METH_VARARGS,
    "delete forwardTOF objects for this hitView"},
   {"deleteGapEMcals", _HitView_deleteGapEMcals, METH_VARARGS,
    "delete gapEMcal objects for this hitView"},
   {"deleteMcTrajectorys", _HitView_deleteMcTrajectorys, METH_VARARGS,
    "delete mcTrajectory objects for this hitView"},
   {"deletePairSpectrometerCoarses", _HitView_deletePairSpectrometerCoarses, METH_VARARGS,
    "delete pairSpectrometerCoarse objects for this hitView"},
   {"deletePairSpectrometerFines", _HitView_deletePairSpectrometerFines, METH_VARARGS,
    "delete pairSpectrometerFine objects for this hitView"},
   {"deleteRFtimes", _HitView_deleteRFtimes, METH_VARARGS,
    "delete RFtime objects for this hitView"},
   {"deleteRICHs", _HitView_deleteRICHs, METH_VARARGS,
    "delete RICH objects for this hitView"},
   {"deleteStartCntrs", _HitView_deleteStartCntrs, METH_VARARGS,
    "delete startCntr objects for this hitView"},
   {"deleteTaggers", _HitView_deleteTaggers, METH_VARARGS,
    "delete tagger objects for this hitView"},
   {"deleteTripletPolarimeters", _HitView_deleteTripletPolarimeters, METH_VARARGS,
    "delete tripletPolarimeter objects for this hitView"},
   {"deleteUpstreamEMvetos", _HitView_deleteUpstreamEMvetos, METH_VARARGS,
    "delete upstreamEMveto objects for this hitView"},
   {"getBarrelEMcal", _HitView_getBarrelEMcal, METH_VARARGS,
    "get an individual barrelEMcal object from this hitView"},
   {"getBarrelEMcals", _HitView_getBarrelEMcals, METH_NOARGS,
    "get list of barrelEMcal objects for this hitView"},
   {"getCentralDC", _HitView_getCentralDC, METH_VARARGS,
    "get an individual centralDC object from this hitView"},
   {"getCentralDCs", _HitView_getCentralDCs, METH_NOARGS,
    "get list of centralDC objects for this hitView"},
   {"getCerenkov", _HitView_getCerenkov, METH_VARARGS,
    "get an individual Cerenkov object from this hitView"},
   {"getCerenkovs", _HitView_getCerenkovs, METH_NOARGS,
    "get list of Cerenkov objects for this hitView"},
   {"getComptonEMcal", _HitView_getComptonEMcal, METH_VARARGS,
    "get an individual ComptonEMcal object from this hitView"},
   {"getComptonEMcals", _HitView_getComptonEMcals, METH_NOARGS,
    "get list of ComptonEMcal objects for this hitView"},
   {"getCppTOF", _HitView_getCppTOF, METH_VARARGS,
    "get an individual cppTOF object from this hitView"},
   {"getCppTOFs", _HitView_getCppTOFs, METH_NOARGS,
    "get list of cppTOF objects for this hitView"},
   {"getCrystalEcal", _HitView_getCrystalEcal, METH_VARARGS,
    "get an individual CrystalEcal object from this hitView"},
   {"getCrystalEcals", _HitView_getCrystalEcals, METH_NOARGS,
    "get list of CrystalEcal objects for this hitView"},
   {"getDIRC", _HitView_getDIRC, METH_VARARGS,
    "get an individual DIRC object from this hitView"},
   {"getDIRCs", _HitView_getDIRCs, METH_NOARGS,
    "get list of DIRC objects for this hitView"},
   {"getForwardDC", _HitView_getForwardDC, METH_VARARGS,
    "get an individual forwardDC object from this hitView"},
   {"getForwardDCs", _HitView_getForwardDCs, METH_NOARGS,
    "get list of forwardDC objects for this hitView"},
   {"getForwardEMcal", _HitView_getForwardEMcal, METH_VARARGS,
    "get an individual forwardEMcal object from this hitView"},
   {"getForwardEMcals", _HitView_getForwardEMcals, METH_NOARGS,
    "get list of forwardEMcal objects for this hitView"},
   {"getForwardMWPC", _HitView_getForwardMWPC, METH_VARARGS,
    "get an individual forwardMWPC object from this hitView"},
   {"getForwardMWPCs", _HitView_getForwardMWPCs, METH_NOARGS,
    "get list of forwardMWPC objects for this hitView"},
   {"getForwardTOF", _HitView_getForwardTOF, METH_VARARGS,
    "get an individual forwardTOF object from this hitView"},
   {"getForwardTOFs", _HitView_getForwardTOFs, METH_NOARGS,
    "get list of forwardTOF objects for this hitView"},
   {"getGapEMcal", _HitView_getGapEMcal, METH_VARARGS,
    "get an individual gapEMcal object from this hitView"},
   {"getGapEMcals", _HitView_getGapEMcals, METH_NOARGS,
    "get list of gapEMcal objects for this hitView"},
   {"getMcTrajectory", _HitView_getMcTrajectory, METH_VARARGS,
    "get an individual mcTrajectory object from this hitView"},
   {"getMcTrajectorys", _HitView_getMcTrajectorys, METH_NOARGS,
    "get list of mcTrajectory objects for this hitView"},
   {"getPairSpectrometerCoarse", _HitView_getPairSpectrometerCoarse, METH_VARARGS,
    "get an individual pairSpectrometerCoarse object from this hitView"},
   {"getPairSpectrometerCoarses", _HitView_getPairSpectrometerCoarses, METH_NOARGS,
    "get list of pairSpectrometerCoarse objects for this hitView"},
   {"getPairSpectrometerFine", _HitView_getPairSpectrometerFine, METH_VARARGS,
    "get an individual pairSpectrometerFine object from this hitView"},
   {"getPairSpectrometerFines", _HitView_getPairSpectrometerFines, METH_NOARGS,
    "get list of pairSpectrometerFine objects for this hitView"},
   {"getRFtime", _HitView_getRFtime, METH_VARARGS,
    "get an individual RFtime object from this hitView"},
   {"getRFtimes", _HitView_getRFtimes, METH_NOARGS,
    "get list of RFtime objects for this hitView"},
   {"getRICH", _HitView_getRICH, METH_VARARGS,
    "get an individual RICH object from this hitView"},
   {"getRICHs", _HitView_getRICHs, METH_NOARGS,
    "get list of RICH objects for this hitView"},
   {"getStartCntr", _HitView_getStartCntr, METH_VARARGS,
    "get an individual startCntr object from this hitView"},
   {"getStartCntrs", _HitView_getStartCntrs, METH_NOARGS,
    "get list of startCntr objects for this hitView"},
   {"getTagger", _HitView_getTagger, METH_VARARGS,
    "get an individual tagger object from this hitView"},
   {"getTaggers", _HitView_getTaggers, METH_NOARGS,
    "get list of tagger objects for this hitView"},
   {"getTripletPolarimeter", _HitView_getTripletPolarimeter, METH_VARARGS,
    "get an individual tripletPolarimeter object from this hitView"},
   {"getTripletPolarimeters", _HitView_getTripletPolarimeters, METH_NOARGS,
    "get list of tripletPolarimeter objects for this hitView"},
   {"getUpstreamEMveto", _HitView_getUpstreamEMveto, METH_VARARGS,
    "get an individual upstreamEMveto object from this hitView"},
   {"getUpstreamEMvetos", _HitView_getUpstreamEMvetos, METH_NOARGS,
    "get list of upstreamEMveto objects for this hitView"},
   {"toString", _HitView_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _HitView_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _HitView_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.HitView",         /*tp_name*/
    sizeof(_HitView),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_HitView_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_HitView_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s hitView element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _HitView_methods,          /* tp_methods */
    _HitView_members,          /* tp_members */
    _HitView_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_HitView_init,   /* tp_init */
    0,                         /* tp_alloc */
    _HitView_new,              /* tp_new */
};



// wrap element class hddm_s::ErrorMatrix as hddm_s.ErrorMatrix

typedef struct {
   PyObject_HEAD
   ErrorMatrix *elem;
   PyObject *host;
} _ErrorMatrix;

static void
_ErrorMatrix_dealloc(_ErrorMatrix* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ErrorMatrix_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ErrorMatrix *self;
   self = (_ErrorMatrix*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ErrorMatrix_init(_ErrorMatrix *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ErrorMatrix_getClass(_ErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ErrorMatrix_getVersion(_ErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ErrorMatrix_getXmlns(_ErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ErrorMatrix_getEventNo(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ErrorMatrix_getMaxOccurs(_ErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ErrorMatrix_getRunNo(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ErrorMatrix_getMinOccurs(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ErrorMatrix_getFOM(_ErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static PyObject*
_ErrorMatrix_getNdof(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static PyObject*
_ErrorMatrix_getCandidateid(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static PyObject*
_ErrorMatrix_getChisq(_ErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static PyObject*
_ErrorMatrix_getId(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_ErrorMatrix_getTrackid(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static PyObject*
_ErrorMatrix_getNcols(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNcols());
}

static int
_ErrorMatrix_setNcols(_ErrorMatrix *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNcols(var);
   return 0;
}

static PyObject*
_ErrorMatrix_getNrows(_ErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNrows());
}

static int
_ErrorMatrix_setNrows(_ErrorMatrix *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNrows(var);
   return 0;
}

static PyObject*
_ErrorMatrix_getType(_ErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getType());
   return PyUnicode_FromString(val.c_str());
}

static int
_ErrorMatrix_setType(_ErrorMatrix *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setType(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_ErrorMatrix_getVals(_ErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getVals());
   return PyUnicode_FromString(val.c_str());
}

static int
_ErrorMatrix_setVals(_ErrorMatrix *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setVals(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_ErrorMatrix_toString(PyObject *self, PyObject *args=0)
{
   _ErrorMatrix *me = (_ErrorMatrix*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid errorMatrix element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ErrorMatrix_toXML(PyObject *self, PyObject *args=0)
{
   _ErrorMatrix *me = (_ErrorMatrix*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid errorMatrix element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ErrorMatrix_getsetters[] = {
   {(char*)"FOM",
    (getter)_ErrorMatrix_getFOM, 0,
    (char*)"FOM value",
    NULL},
   {(char*)"Ncols",
    (getter)_ErrorMatrix_getNcols, (setter)_ErrorMatrix_setNcols,
    (char*)"Ncols value",
    NULL},
   {(char*)"Ndof",
    (getter)_ErrorMatrix_getNdof, 0,
    (char*)"Ndof value",
    NULL},
   {(char*)"Nrows",
    (getter)_ErrorMatrix_getNrows, (setter)_ErrorMatrix_setNrows,
    (char*)"Nrows value",
    NULL},
   {(char*)"candidateid",
    (getter)_ErrorMatrix_getCandidateid, 0,
    (char*)"candidateid value",
    NULL},
   {(char*)"chisq",
    (getter)_ErrorMatrix_getChisq, 0,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_ErrorMatrix_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ErrorMatrix_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_ErrorMatrix_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ErrorMatrix_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ErrorMatrix_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ErrorMatrix_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"trackid",
    (getter)_ErrorMatrix_getTrackid, 0,
    (char*)"trackid value",
    NULL},
   {(char*)"type",
    (getter)_ErrorMatrix_getType, (setter)_ErrorMatrix_setType,
    (char*)"type string",
    NULL},
   {(char*)"vals",
    (getter)_ErrorMatrix_getVals, (setter)_ErrorMatrix_setVals,
    (char*)"vals string",
    NULL},
   {(char*)"version",
    (getter)_ErrorMatrix_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ErrorMatrix_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ErrorMatrix_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ErrorMatrix_methods[] = {
   {"toString", _ErrorMatrix_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ErrorMatrix_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ErrorMatrix_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ErrorMatrix",         /*tp_name*/
    sizeof(_ErrorMatrix),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ErrorMatrix_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ErrorMatrix_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s errorMatrix element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ErrorMatrix_methods,          /* tp_methods */
    _ErrorMatrix_members,          /* tp_members */
    _ErrorMatrix_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ErrorMatrix_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ErrorMatrix_new,              /* tp_new */
};



// wrap element class hddm_s::TrackingErrorMatrix as hddm_s.TrackingErrorMatrix

typedef struct {
   PyObject_HEAD
   TrackingErrorMatrix *elem;
   PyObject *host;
} _TrackingErrorMatrix;

static void
_TrackingErrorMatrix_dealloc(_TrackingErrorMatrix* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_TrackingErrorMatrix_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _TrackingErrorMatrix *self;
   self = (_TrackingErrorMatrix*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_TrackingErrorMatrix_init(_TrackingErrorMatrix *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_TrackingErrorMatrix_getClass(_TrackingErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackingErrorMatrix_getVersion(_TrackingErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_TrackingErrorMatrix_getXmlns(_TrackingErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackingErrorMatrix_getEventNo(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_TrackingErrorMatrix_getMaxOccurs(_TrackingErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_TrackingErrorMatrix_getRunNo(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_TrackingErrorMatrix_getMinOccurs(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_TrackingErrorMatrix_getFOM(_TrackingErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static PyObject*
_TrackingErrorMatrix_getNdof(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static PyObject*
_TrackingErrorMatrix_getCandidateid(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static PyObject*
_TrackingErrorMatrix_getChisq(_TrackingErrorMatrix *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static PyObject*
_TrackingErrorMatrix_getId(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static PyObject*
_TrackingErrorMatrix_getTrackid(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static PyObject*
_TrackingErrorMatrix_getNcols(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNcols());
}

static int
_TrackingErrorMatrix_setNcols(_TrackingErrorMatrix *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNcols(var);
   return 0;
}

static PyObject*
_TrackingErrorMatrix_getNrows(_TrackingErrorMatrix *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNrows());
}

static int
_TrackingErrorMatrix_setNrows(_TrackingErrorMatrix *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNrows(var);
   return 0;
}

static PyObject*
_TrackingErrorMatrix_getType(_TrackingErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getType());
   return PyUnicode_FromString(val.c_str());
}

static int
_TrackingErrorMatrix_setType(_TrackingErrorMatrix *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setType(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_TrackingErrorMatrix_getVals(_TrackingErrorMatrix *self, void *closure)
{
   std::string val(self->elem->getVals());
   return PyUnicode_FromString(val.c_str());
}

static int
_TrackingErrorMatrix_setVals(_TrackingErrorMatrix *self, PyObject *value, void *closure)
{
   PyObject *str=0;
   if (PyUnicode_Check(value))
      str = PyUnicode_AsEncodedString(value, "ASCII", "strict");
   else
      str = value;
#if PY_MAJOR_VERSION < 3
   char *var = PyString_AsString(str);
#else
   char *var = PyBytes_AsString(str);
#endif
   if (var == 0) {
      return -1;
   }
   self->elem->setVals(std::string(var));
   if (str != value) {
      Py_DECREF(str);
   }
   return 0;
}

static PyObject*
_TrackingErrorMatrix_toString(PyObject *self, PyObject *args=0)
{
   _TrackingErrorMatrix *me = (_TrackingErrorMatrix*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid TrackingErrorMatrix element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_TrackingErrorMatrix_toXML(PyObject *self, PyObject *args=0)
{
   _TrackingErrorMatrix *me = (_TrackingErrorMatrix*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid TrackingErrorMatrix element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _TrackingErrorMatrix_getsetters[] = {
   {(char*)"FOM",
    (getter)_TrackingErrorMatrix_getFOM, 0,
    (char*)"FOM value",
    NULL},
   {(char*)"Ncols",
    (getter)_TrackingErrorMatrix_getNcols, (setter)_TrackingErrorMatrix_setNcols,
    (char*)"Ncols value",
    NULL},
   {(char*)"Ndof",
    (getter)_TrackingErrorMatrix_getNdof, 0,
    (char*)"Ndof value",
    NULL},
   {(char*)"Nrows",
    (getter)_TrackingErrorMatrix_getNrows, (setter)_TrackingErrorMatrix_setNrows,
    (char*)"Nrows value",
    NULL},
   {(char*)"candidateid",
    (getter)_TrackingErrorMatrix_getCandidateid, 0,
    (char*)"candidateid value",
    NULL},
   {(char*)"chisq",
    (getter)_TrackingErrorMatrix_getChisq, 0,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_TrackingErrorMatrix_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_TrackingErrorMatrix_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_TrackingErrorMatrix_getId, 0,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_TrackingErrorMatrix_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_TrackingErrorMatrix_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_TrackingErrorMatrix_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"trackid",
    (getter)_TrackingErrorMatrix_getTrackid, 0,
    (char*)"trackid value",
    NULL},
   {(char*)"type",
    (getter)_TrackingErrorMatrix_getType, (setter)_TrackingErrorMatrix_setType,
    (char*)"type string",
    NULL},
   {(char*)"vals",
    (getter)_TrackingErrorMatrix_getVals, (setter)_TrackingErrorMatrix_setVals,
    (char*)"vals string",
    NULL},
   {(char*)"version",
    (getter)_TrackingErrorMatrix_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_TrackingErrorMatrix_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _TrackingErrorMatrix_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _TrackingErrorMatrix_methods[] = {
   {"toString", _TrackingErrorMatrix_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _TrackingErrorMatrix_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _TrackingErrorMatrix_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.TrackingErrorMatrix",         /*tp_name*/
    sizeof(_TrackingErrorMatrix),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_TrackingErrorMatrix_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_TrackingErrorMatrix_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s TrackingErrorMatrix element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _TrackingErrorMatrix_methods,          /* tp_methods */
    _TrackingErrorMatrix_members,          /* tp_members */
    _TrackingErrorMatrix_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_TrackingErrorMatrix_init,   /* tp_init */
    0,                         /* tp_alloc */
    _TrackingErrorMatrix_new,              /* tp_new */
};



// wrap element class hddm_s::Tracktimebased as hddm_s.Tracktimebased

typedef struct {
   PyObject_HEAD
   Tracktimebased *elem;
   PyObject *host;
} _Tracktimebased;

static void
_Tracktimebased_dealloc(_Tracktimebased* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_Tracktimebased_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _Tracktimebased *self;
   self = (_Tracktimebased*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_Tracktimebased_init(_Tracktimebased *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_Tracktimebased_getClass(_Tracktimebased *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tracktimebased_getVersion(_Tracktimebased *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_Tracktimebased_getXmlns(_Tracktimebased *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tracktimebased_getEventNo(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_Tracktimebased_getRunNo(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_Tracktimebased_getFOM(_Tracktimebased *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getFOM());
}

static int
_Tracktimebased_setFOM(_Tracktimebased *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setFOM((float)var);
   return 0;
}

static PyObject*
_Tracktimebased_getNdof(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getNdof());
}

static int
_Tracktimebased_setNdof(_Tracktimebased *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setNdof(var);
   return 0;
}

static PyObject*
_Tracktimebased_getCandidateid(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getCandidateid());
}

static int
_Tracktimebased_setCandidateid(_Tracktimebased *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setCandidateid(var);
   return 0;
}

static PyObject*
_Tracktimebased_getChisq(_Tracktimebased *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getChisq());
}

static int
_Tracktimebased_setChisq(_Tracktimebased *self, PyObject *value, void *closure)
{
   double var = PyFloat_AsDouble(value);
   if (var == -1 && PyErr_Occurred()) {
      return 1;
   }
   self->elem->setChisq((float)var);
   return 0;
}

static PyObject*
_Tracktimebased_getId(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getId());
}

static int
_Tracktimebased_setId(_Tracktimebased *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setId(var);
   return 0;
}

static PyObject*
_Tracktimebased_getMaxOccurs(_Tracktimebased *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_Tracktimebased_getMinOccurs(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_Tracktimebased_getTrackid(_Tracktimebased *self, void *closure)
{
   return PyLong_FromLong(self->elem->getTrackid());
}

static int
_Tracktimebased_setTrackid(_Tracktimebased *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setTrackid(var);
   return 0;
}

static PyObject*
_Tracktimebased_getMomentum(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *obj = _Momentum_new(&_Momentum_type, 0, 0);
   ((_Momentum*)obj)->elem = &me->elem->getMomentum();
   ((_Momentum*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tracktimebased_getMomenta(PyObject *self, PyObject *args)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getMomenta();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tracktimebased_addMomenta(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MomentumList(me->elem->addMomenta(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tracktimebased_deleteMomenta(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tracktimebased element");
      return NULL;
   }
   me->elem->deleteMomenta(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tracktimebased_getProperties(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *obj = _Properties_new(&_Properties_type, 0, 0);
   ((_Properties*)obj)->elem = &me->elem->getProperties();
   ((_Properties*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tracktimebased_getPropertiesList(PyObject *self, PyObject *args)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPropertiesList();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tracktimebased_addPropertiesList(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PropertiesList(me->elem->addPropertiesList(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tracktimebased_deletePropertiesList(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tracktimebased element");
      return NULL;
   }
   me->elem->deletePropertiesList(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tracktimebased_getOrigin(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *obj = _Origin_new(&_Origin_type, 0, 0);
   ((_Origin*)obj)->elem = &me->elem->getOrigin();
   ((_Origin*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tracktimebased_getOrigins(PyObject *self, PyObject *args)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Origin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getOrigins();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tracktimebased_addOrigins(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Origin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new OriginList(me->elem->addOrigins(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tracktimebased_deleteOrigins(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tracktimebased element");
      return NULL;
   }
   me->elem->deleteOrigins(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tracktimebased_getErrorMatrix(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *obj = _ErrorMatrix_new(&_ErrorMatrix_type, 0, 0);
   ((_ErrorMatrix*)obj)->elem = &me->elem->getErrorMatrix();
   ((_ErrorMatrix*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tracktimebased_getErrorMatrixs(PyObject *self, PyObject *args)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getErrorMatrixs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tracktimebased_addErrorMatrixs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ErrorMatrixList(me->elem->addErrorMatrixs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tracktimebased_deleteErrorMatrixs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tracktimebased element");
      return NULL;
   }
   me->elem->deleteErrorMatrixs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tracktimebased_getTrackingErrorMatrix(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *obj = _TrackingErrorMatrix_new(&_TrackingErrorMatrix_type, 0, 0);
   ((_TrackingErrorMatrix*)obj)->elem = &me->elem->getTrackingErrorMatrix();
   ((_TrackingErrorMatrix*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_Tracktimebased_getTrackingErrorMatrixs(PyObject *self, PyObject *args)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackingErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTrackingErrorMatrixs();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_Tracktimebased_addTrackingErrorMatrixs(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid tracktimebased element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackingErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackingErrorMatrixList(me->elem->addTrackingErrorMatrixs(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_Tracktimebased_deleteTrackingErrorMatrixs(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid tracktimebased element");
      return NULL;
   }
   me->elem->deleteTrackingErrorMatrixs(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_Tracktimebased_toString(PyObject *self, PyObject *args=0)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_Tracktimebased_toXML(PyObject *self, PyObject *args=0)
{
   _Tracktimebased *me = (_Tracktimebased*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid tracktimebased element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _Tracktimebased_getsetters[] = {
   {(char*)"FOM",
    (getter)_Tracktimebased_getFOM, (setter)_Tracktimebased_setFOM,
    (char*)"FOM value",
    NULL},
   {(char*)"Ndof",
    (getter)_Tracktimebased_getNdof, (setter)_Tracktimebased_setNdof,
    (char*)"Ndof value",
    NULL},
   {(char*)"candidateid",
    (getter)_Tracktimebased_getCandidateid, (setter)_Tracktimebased_setCandidateid,
    (char*)"candidateid value",
    NULL},
   {(char*)"chisq",
    (getter)_Tracktimebased_getChisq, (setter)_Tracktimebased_setChisq,
    (char*)"chisq value",
    NULL},
   {(char*)"class",
    (getter)_Tracktimebased_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_Tracktimebased_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"id",
    (getter)_Tracktimebased_getId, (setter)_Tracktimebased_setId,
    (char*)"id value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_Tracktimebased_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"minOccurs",
    (getter)_Tracktimebased_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_Tracktimebased_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"trackid",
    (getter)_Tracktimebased_getTrackid, (setter)_Tracktimebased_setTrackid,
    (char*)"trackid value",
    NULL},
   {(char*)"version",
    (getter)_Tracktimebased_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_Tracktimebased_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _Tracktimebased_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _Tracktimebased_methods[] = {
   {"addErrorMatrixs", _Tracktimebased_addErrorMatrixs, METH_VARARGS,
    "extend (or insert into) the list of errorMatrix objects for this tracktimebased"},
   {"addMomenta", _Tracktimebased_addMomenta, METH_VARARGS,
    "extend (or insert into) the list of momentum objects for this tracktimebased"},
   {"addOrigins", _Tracktimebased_addOrigins, METH_VARARGS,
    "extend (or insert into) the list of origin objects for this tracktimebased"},
   {"addPropertiesList", _Tracktimebased_addPropertiesList, METH_VARARGS,
    "extend (or insert into) the list of properties objects for this tracktimebased"},
   {"addTrackingErrorMatrixs", _Tracktimebased_addTrackingErrorMatrixs, METH_VARARGS,
    "extend (or insert into) the list of TrackingErrorMatrix objects for this tracktimebased"},
   {"deleteErrorMatrixs", _Tracktimebased_deleteErrorMatrixs, METH_VARARGS,
    "delete errorMatrix objects for this tracktimebased"},
   {"deleteMomenta", _Tracktimebased_deleteMomenta, METH_VARARGS,
    "delete momentum objects for this tracktimebased"},
   {"deleteOrigins", _Tracktimebased_deleteOrigins, METH_VARARGS,
    "delete origin objects for this tracktimebased"},
   {"deletePropertiesList", _Tracktimebased_deletePropertiesList, METH_VARARGS,
    "delete properties objects for this tracktimebased"},
   {"deleteTrackingErrorMatrixs", _Tracktimebased_deleteTrackingErrorMatrixs, METH_VARARGS,
    "delete TrackingErrorMatrix objects for this tracktimebased"},
   {"getErrorMatrix", _Tracktimebased_getErrorMatrix, METH_VARARGS,
    "get an individual errorMatrix object from this tracktimebased"},
   {"getErrorMatrixs", _Tracktimebased_getErrorMatrixs, METH_NOARGS,
    "get list of errorMatrix objects for this tracktimebased"},
   {"getMomenta", _Tracktimebased_getMomenta, METH_NOARGS,
    "get list of momentum objects for this tracktimebased"},
   {"getMomentum", _Tracktimebased_getMomentum, METH_VARARGS,
    "get an individual momentum object from this tracktimebased"},
   {"getOrigin", _Tracktimebased_getOrigin, METH_VARARGS,
    "get an individual origin object from this tracktimebased"},
   {"getOrigins", _Tracktimebased_getOrigins, METH_NOARGS,
    "get list of origin objects for this tracktimebased"},
   {"getProperties", _Tracktimebased_getProperties, METH_VARARGS,
    "get an individual properties object from this tracktimebased"},
   {"getPropertiesList", _Tracktimebased_getPropertiesList, METH_NOARGS,
    "get list of properties objects for this tracktimebased"},
   {"getTrackingErrorMatrix", _Tracktimebased_getTrackingErrorMatrix, METH_VARARGS,
    "get an individual TrackingErrorMatrix object from this tracktimebased"},
   {"getTrackingErrorMatrixs", _Tracktimebased_getTrackingErrorMatrixs, METH_NOARGS,
    "get list of TrackingErrorMatrix objects for this tracktimebased"},
   {"toString", _Tracktimebased_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _Tracktimebased_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _Tracktimebased_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.Tracktimebased",         /*tp_name*/
    sizeof(_Tracktimebased),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_Tracktimebased_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_Tracktimebased_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s tracktimebased element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _Tracktimebased_methods,          /* tp_methods */
    _Tracktimebased_members,          /* tp_members */
    _Tracktimebased_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_Tracktimebased_init,   /* tp_init */
    0,                         /* tp_alloc */
    _Tracktimebased_new,              /* tp_new */
};



// wrap element class hddm_s::ReconView as hddm_s.ReconView

typedef struct {
   PyObject_HEAD
   ReconView *elem;
   PyObject *host;
} _ReconView;

static void
_ReconView_dealloc(_ReconView* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ReconView_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ReconView *self;
   self = (_ReconView*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_ReconView_init(_ReconView *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_ReconView_getClass(_ReconView *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ReconView_getXmlns(_ReconView *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ReconView_getEventNo(_ReconView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static PyObject*
_ReconView_getMaxOccurs(_ReconView *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_ReconView_getRunNo(_ReconView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static PyObject*
_ReconView_getMinOccurs(_ReconView *self, void *closure)
{
   return PyLong_FromLong(self->elem->getMinOccurs());
}

static PyObject*
_ReconView_getVersion(_ReconView *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_ReconView_getTracktimebased(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reconView element");
      return NULL;
   }
   PyObject *obj = _Tracktimebased_new(&_Tracktimebased_type, 0, 0);
   ((_Tracktimebased*)obj)->elem = &me->elem->getTracktimebased(index);
   ((_Tracktimebased*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_ReconView_getTracktimebaseds(PyObject *self, PyObject *args)
{
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reconView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tracktimebased_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getTracktimebaseds();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_ReconView_addTracktimebaseds(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid reconView element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tracktimebased_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TracktimebasedList(me->elem->addTracktimebaseds(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_ReconView_deleteTracktimebaseds(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid reconView element");
      return NULL;
   }
   me->elem->deleteTracktimebaseds(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ReconView_toString(PyObject *self, PyObject *args=0)
{
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reconView element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_ReconView_toXML(PyObject *self, PyObject *args=0)
{
   _ReconView *me = (_ReconView*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid reconView element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _ReconView_getsetters[] = {
   {(char*)"class",
    (getter)_ReconView_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_ReconView_getEventNo, 0,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_ReconView_getMaxOccurs, 0,
    (char*)"maxOccurs string",
    NULL},
   {(char*)"minOccurs",
    (getter)_ReconView_getMinOccurs, 0,
    (char*)"minOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_ReconView_getRunNo, 0,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_ReconView_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_ReconView_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ReconView_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ReconView_methods[] = {
   {"addTracktimebaseds", _ReconView_addTracktimebaseds, METH_VARARGS,
    "extend (or insert into) the list of tracktimebased objects for this reconView"},
   {"deleteTracktimebaseds", _ReconView_deleteTracktimebaseds, METH_VARARGS,
    "delete tracktimebased objects for this reconView"},
   {"getTracktimebased", _ReconView_getTracktimebased, METH_VARARGS,
    "get an individual tracktimebased object from this reconView"},
   {"getTracktimebaseds", _ReconView_getTracktimebaseds, METH_NOARGS,
    "get list of tracktimebased objects for this reconView"},
   {"toString", _ReconView_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _ReconView_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ReconView_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ReconView",         /*tp_name*/
    sizeof(_ReconView),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ReconView_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ReconView_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s reconView element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ReconView_methods,          /* tp_methods */
    _ReconView_members,          /* tp_members */
    _ReconView_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ReconView_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ReconView_new,              /* tp_new */
};



// wrap element class hddm_s::PhysicsEvent as hddm_s.PhysicsEvent

typedef struct {
   PyObject_HEAD
   PhysicsEvent *elem;
   PyObject *host;
} _PhysicsEvent;

static void
_PhysicsEvent_dealloc(_PhysicsEvent* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_PhysicsEvent_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _PhysicsEvent *self;
   self = (_PhysicsEvent*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_PhysicsEvent_init(_PhysicsEvent *self, PyObject *args, PyObject *kwds)
{
   PyErr_SetString(PyExc_RuntimeError, "illegal constructor");
   return -1;
}

static PyObject*
_PhysicsEvent_getClass(_PhysicsEvent *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PhysicsEvent_getVersion(_PhysicsEvent *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_PhysicsEvent_getXmlns(_PhysicsEvent *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PhysicsEvent_getEventNo(_PhysicsEvent *self, void *closure)
{
   return PyLong_FromLong(self->elem->getEventNo());
}

static int
_PhysicsEvent_setEventNo(_PhysicsEvent *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setEventNo(var);
   return 0;
}

static PyObject*
_PhysicsEvent_getMaxOccurs(_PhysicsEvent *self, void *closure)
{
   std::string val(self->elem->getMaxOccurs());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_PhysicsEvent_getRunNo(_PhysicsEvent *self, void *closure)
{
   return PyLong_FromLong(self->elem->getRunNo());
}

static int
_PhysicsEvent_setRunNo(_PhysicsEvent *self, PyObject *value, void *closure)
{
   long var = PyInt_AsLong(value);
   if (var == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->elem->setRunNo(var);
   return 0;
}

static PyObject*
_PhysicsEvent_getDataVersionString(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *obj = _DataVersionString_new(&_DataVersionString_type, 0, 0);
   ((_DataVersionString*)obj)->elem = &me->elem->getDataVersionString(index);
   ((_DataVersionString*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PhysicsEvent_getDataVersionStrings(PyObject *self, PyObject *args)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DataVersionString_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getDataVersionStrings();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PhysicsEvent_addDataVersionStrings(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DataVersionString_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DataVersionStringList(me->elem->addDataVersionStrings(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PhysicsEvent_deleteDataVersionStrings(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid physicsEvent element");
      return NULL;
   }
   me->elem->deleteDataVersionStrings(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PhysicsEvent_getCcdbContext(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *obj = _CcdbContext_new(&_CcdbContext_type, 0, 0);
   ((_CcdbContext*)obj)->elem = &me->elem->getCcdbContext(index);
   ((_CcdbContext*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PhysicsEvent_getCcdbContexts(PyObject *self, PyObject *args)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcdbContext_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getCcdbContexts();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PhysicsEvent_addCcdbContexts(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcdbContext_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcdbContextList(me->elem->addCcdbContexts(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PhysicsEvent_deleteCcdbContexts(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid physicsEvent element");
      return NULL;
   }
   me->elem->deleteCcdbContexts(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PhysicsEvent_getReaction(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *obj = _Reaction_new(&_Reaction_type, 0, 0);
   ((_Reaction*)obj)->elem = &me->elem->getReaction(index);
   ((_Reaction*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PhysicsEvent_getReactions(PyObject *self, PyObject *args)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Reaction_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getReactions();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PhysicsEvent_addReactions(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Reaction_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ReactionList(me->elem->addReactions(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PhysicsEvent_deleteReactions(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid physicsEvent element");
      return NULL;
   }
   me->elem->deleteReactions(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PhysicsEvent_getHitView(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *obj = _HitView_new(&_HitView_type, 0, 0);
   ((_HitView*)obj)->elem = &me->elem->getHitView();
   ((_HitView*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PhysicsEvent_getHitViews(PyObject *self, PyObject *args)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HitView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getHitViews();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PhysicsEvent_addHitViews(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HitView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new HitViewList(me->elem->addHitViews(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PhysicsEvent_deleteHitViews(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid physicsEvent element");
      return NULL;
   }
   me->elem->deleteHitViews(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PhysicsEvent_getReconView(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *obj = _ReconView_new(&_ReconView_type, 0, 0);
   ((_ReconView*)obj)->elem = &me->elem->getReconView();
   ((_ReconView*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_PhysicsEvent_getReconViews(PyObject *self, PyObject *args)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ReconView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getReconViews();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_PhysicsEvent_addReconViews(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid physicsEvent element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ReconView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ReconViewList(me->elem->addReconViews(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_PhysicsEvent_deleteReconViews(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid physicsEvent element");
      return NULL;
   }
   me->elem->deleteReconViews(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_PhysicsEvent_toString(PyObject *self, PyObject *args=0)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_PhysicsEvent_toXML(PyObject *self, PyObject *args=0)
{
   _PhysicsEvent *me = (_PhysicsEvent*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid physicsEvent element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _PhysicsEvent_getsetters[] = {
   {(char*)"class",
    (getter)_PhysicsEvent_getClass, 0,
    (char*)"class string",
    NULL},
   {(char*)"eventNo",
    (getter)_PhysicsEvent_getEventNo, (setter)_PhysicsEvent_setEventNo,
    (char*)"eventNo value",
    NULL},
   {(char*)"maxOccurs",
    (getter)_PhysicsEvent_getMaxOccurs, 0,
    (char*)"maxOccurs value",
    NULL},
   {(char*)"runNo",
    (getter)_PhysicsEvent_getRunNo, (setter)_PhysicsEvent_setRunNo,
    (char*)"runNo value",
    NULL},
   {(char*)"version",
    (getter)_PhysicsEvent_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_PhysicsEvent_getXmlns, 0,
    (char*)"xmlns string",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _PhysicsEvent_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _PhysicsEvent_methods[] = {
   {"addCcdbContexts", _PhysicsEvent_addCcdbContexts, METH_VARARGS,
    "extend (or insert into) the list of ccdbContext objects for this physicsEvent"},
   {"addDataVersionStrings", _PhysicsEvent_addDataVersionStrings, METH_VARARGS,
    "extend (or insert into) the list of dataVersionString objects for this physicsEvent"},
   {"addHitViews", _PhysicsEvent_addHitViews, METH_VARARGS,
    "extend (or insert into) the list of hitView objects for this physicsEvent"},
   {"addReactions", _PhysicsEvent_addReactions, METH_VARARGS,
    "extend (or insert into) the list of reaction objects for this physicsEvent"},
   {"addReconViews", _PhysicsEvent_addReconViews, METH_VARARGS,
    "extend (or insert into) the list of reconView objects for this physicsEvent"},
   {"deleteCcdbContexts", _PhysicsEvent_deleteCcdbContexts, METH_VARARGS,
    "delete ccdbContext objects for this physicsEvent"},
   {"deleteDataVersionStrings", _PhysicsEvent_deleteDataVersionStrings, METH_VARARGS,
    "delete dataVersionString objects for this physicsEvent"},
   {"deleteHitViews", _PhysicsEvent_deleteHitViews, METH_VARARGS,
    "delete hitView objects for this physicsEvent"},
   {"deleteReactions", _PhysicsEvent_deleteReactions, METH_VARARGS,
    "delete reaction objects for this physicsEvent"},
   {"deleteReconViews", _PhysicsEvent_deleteReconViews, METH_VARARGS,
    "delete reconView objects for this physicsEvent"},
   {"getCcdbContext", _PhysicsEvent_getCcdbContext, METH_VARARGS,
    "get an individual ccdbContext object from this physicsEvent"},
   {"getCcdbContexts", _PhysicsEvent_getCcdbContexts, METH_NOARGS,
    "get list of ccdbContext objects for this physicsEvent"},
   {"getDataVersionString", _PhysicsEvent_getDataVersionString, METH_VARARGS,
    "get an individual dataVersionString object from this physicsEvent"},
   {"getDataVersionStrings", _PhysicsEvent_getDataVersionStrings, METH_NOARGS,
    "get list of dataVersionString objects for this physicsEvent"},
   {"getHitView", _PhysicsEvent_getHitView, METH_VARARGS,
    "get an individual hitView object from this physicsEvent"},
   {"getHitViews", _PhysicsEvent_getHitViews, METH_NOARGS,
    "get list of hitView objects for this physicsEvent"},
   {"getReaction", _PhysicsEvent_getReaction, METH_VARARGS,
    "get an individual reaction object from this physicsEvent"},
   {"getReactions", _PhysicsEvent_getReactions, METH_NOARGS,
    "get list of reaction objects for this physicsEvent"},
   {"getReconView", _PhysicsEvent_getReconView, METH_VARARGS,
    "get an individual reconView object from this physicsEvent"},
   {"getReconViews", _PhysicsEvent_getReconViews, METH_NOARGS,
    "get list of reconView objects for this physicsEvent"},
   {"toString", _PhysicsEvent_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _PhysicsEvent_toXML, METH_NOARGS,
    "show element as a XML fragment"},
   {NULL}  /* Sentinel */
};

static PyTypeObject _PhysicsEvent_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.PhysicsEvent",         /*tp_name*/
    sizeof(_PhysicsEvent),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_PhysicsEvent_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_PhysicsEvent_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s physicsEvent element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _PhysicsEvent_methods,          /* tp_methods */
    _PhysicsEvent_members,          /* tp_members */
    _PhysicsEvent_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_PhysicsEvent_init,   /* tp_init */
    0,                         /* tp_alloc */
    _PhysicsEvent_new,              /* tp_new */
};



// wrap element class hddm_s::HDDM as hddm_s.HDDM

typedef struct {
   PyObject_HEAD
   HDDM *elem;
   PyObject *host;
} _HDDM;

static void
_HDDM_dealloc(_HDDM* self)
{
   if (self->elem != 0) {
      LOG_DEALLOC(Py_TYPE(self), 0, self->host == (PyObject*)self);
      if (self->host == (PyObject*)self)
         delete self->elem;
      else
         My_DECREF(self->host);
   }
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_HDDM_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _HDDM *self;
   self = (_HDDM*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->elem = 0;
      self->host = 0;
   }
   return (PyObject*)self;
}

static int
_HDDM_init(_HDDM *self, PyObject *args, PyObject *kwds)
{
   LOG_NEW(Py_TYPE(self), 0, 1);
   self->elem = new HDDM();
   if (self->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "HDDM new constructor failed");
      return -1;
   }
   self->host = (PyObject*)self;
   return 0;
}

#ifdef HDF5_SUPPORT
static PyObject*
_HDDM_hdf5FileRead(PyObject *self, PyObject *args)
{
   hid_t file_id;
   long int entry = -1;
   if (! PyArg_ParseTuple(args, "k|l", &file_id, &entry)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   herr_t result = me->elem->hdf5FileRead(file_id, entry);
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5FileWrite(PyObject *self, PyObject *args)
{
   hid_t file_id;
   long int entry = -1;
   if (! PyArg_ParseTuple(args, "k|l", &file_id, &entry)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   herr_t result = me->elem->hdf5FileWrite(file_id, entry);
   return PyLong_FromLong(result);
}
#endif
static PyObject*
_HDDM_getClass(_HDDM *self, void *closure)
{
   std::string val(self->elem->getClass());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HDDM_getVersion(_HDDM *self, void *closure)
{
   return PyFloat_FromDouble(self->elem->getVersion());
}

static PyObject*
_HDDM_getXmlns(_HDDM *self, void *closure)
{
   std::string val(self->elem->getXmlns());
   return PyUnicode_FromString(val.c_str());
}

static PyObject*
_HDDM_getCerenkovs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Cerenkov_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CerenkovList(me->elem->getCerenkovs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getComptonEMcals(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ComptonEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ComptonEMcalList(me->elem->getComptonEMcals());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCrystalEcals(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CrystalEcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CrystalEcalList(me->elem->getCrystalEcals());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDIRCs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DIRC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DIRCList(me->elem->getDIRCs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRFsubsystems(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFsubsystem_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RFsubsystemList(me->elem->getRFsubsystems());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRFtimes(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RFtime_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RFtimeList(me->elem->getRFtimes());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRICHs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RICH_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RICHList(me->elem->getRICHs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTrackingErrorMatrixs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackingErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackingErrorMatrixList(me->elem->getTrackingErrorMatrixs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBarrelEMcals(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BarrelEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BarrelEMcalList(me->elem->getBarrelEMcals());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalCells(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalCellList(me->elem->getBcalCells());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalSiPMDownHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMDownHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMDownHitList(me->elem->getBcalSiPMDownHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalSiPMSpectrums(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMSpectrum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMSpectrumList(me->elem->getBcalSiPMSpectrums());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalSiPMTruths(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMTruth_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMTruthList(me->elem->getBcalSiPMTruths());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalSiPMUpHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalSiPMUpHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalSiPMUpHitList(me->elem->getBcalSiPMUpHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalTDCDigiHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTDCDigiHitList(me->elem->getBcalTDCDigiHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalTDCHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTDCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTDCHitList(me->elem->getBcalTDCHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthHitList(me->elem->getBcalTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalTruthIncidentParticles(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthIncidentParticle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthIncidentParticleList(me->elem->getBcalTruthIncidentParticles());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalTruthShowerList(me->elem->getBcalTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalfADCDigiHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCDigiHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCDigiHitList(me->elem->getBcalfADCDigiHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalfADCHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCHitList(me->elem->getBcalfADCHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBcalfADCPeaks(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_BcalfADCPeak_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BcalfADCPeakList(me->elem->getBcalfADCPeaks());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getBeams(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Beam_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new BeamList(me->elem->getBeams());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCcalBlocks(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalBlockList(me->elem->getCcalBlocks());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCcalHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalHitList(me->elem->getCcalHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCcalTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalTruthHitList(me->elem->getCcalTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCcalTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcalTruthShowerList(me->elem->getCcalTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCcdbContexts(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CcdbContext_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CcdbContextList(me->elem->getCcdbContexts());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcDigihits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcDigihitList(me->elem->getCdcDigihits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcHitQFs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcHitQF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcHitQFList(me->elem->getCdcHitQFs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcStraws(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStraw_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawList(me->elem->getCdcStraws());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcStrawHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawHitList(me->elem->getCdcStrawHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcStrawTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcStrawTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcStrawTruthHitList(me->elem->getCdcStrawTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCdcTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CdcTruthPointList(me->elem->getCdcTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCentralDCs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CentralDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CentralDCList(me->elem->getCentralDCs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCereHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereHitList(me->elem->getCereHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCereSections(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereSection_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereSectionList(me->elem->getCereSections());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCereTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereTruthHitList(me->elem->getCereTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCereTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CereTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CereTruthPointList(me->elem->getCereTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCppTOFs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CppTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CppTOFList(me->elem->getCppTOFs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCtofCounters(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofCounterList(me->elem->getCtofCounters());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCtofHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofHitList(me->elem->getCtofHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCtofTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofTruthHitList(me->elem->getCtofTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getCtofTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_CtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new CtofTruthPointList(me->elem->getCtofTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDataVersionStrings(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DataVersionString_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DataVersionStringList(me->elem->getDataVersionStrings());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDircPmtHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircPmtHitList(me->elem->getDircPmtHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDircTruthBarHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthBarHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthBarHitList(me->elem->getDircTruthBarHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDircTruthPmtHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthPmtHitList(me->elem->getDircTruthPmtHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getDircTruthPmtHitExtras(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_DircTruthPmtHitExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new DircTruthPmtHitExtraList(me->elem->getDircTruthPmtHitExtras());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getEcalBlocks(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalBlockList(me->elem->getEcalBlocks());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getEcalHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalHitList(me->elem->getEcalHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getEcalTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalTruthHitList(me->elem->getEcalTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getEcalTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_EcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new EcalTruthShowerList(me->elem->getEcalTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getErrorMatrixs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ErrorMatrix_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ErrorMatrixList(me->elem->getErrorMatrixs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalBlocks(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalBlock_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalBlockList(me->elem->getFcalBlocks());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalDigihits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalDigihitList(me->elem->getFcalDigihits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalHitList(me->elem->getFcalHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthHitList(me->elem->getFcalTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalTruthLightGuides(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthLightGuide_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthLightGuideList(me->elem->getFcalTruthLightGuides());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFcalTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FcalTruthShowerList(me->elem->getFcalTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcAnodeHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeHitList(me->elem->getFdcAnodeHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcAnodeTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeTruthHitList(me->elem->getFdcAnodeTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcAnodeWires(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcAnodeWire_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcAnodeWireList(me->elem->getFdcAnodeWires());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcCathodeHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeHitList(me->elem->getFdcCathodeHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcCathodeStrips(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeStrip_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeStripList(me->elem->getFdcCathodeStrips());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcCathodeTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcCathodeTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcCathodeTruthHitList(me->elem->getFdcCathodeTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcChambers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcChamberList(me->elem->getFdcChambers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcDigihits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcDigihitList(me->elem->getFdcDigihits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFdcTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FdcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FdcTruthPointList(me->elem->getFdcTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcChambers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcChamber_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcChamberList(me->elem->getFmwpcChambers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcHitList(me->elem->getFmwpcHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcHitQs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcHitQList(me->elem->getFmwpcHitQs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthHitList(me->elem->getFmwpcTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcTruthHitQs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthHitQ_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthHitQList(me->elem->getFmwpcTruthHitQs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFmwpcTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FmwpcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FmwpcTruthPointList(me->elem->getFmwpcTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getForwardDCs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardDC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardDCList(me->elem->getForwardDCs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getForwardEMcals(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardEMcalList(me->elem->getForwardEMcals());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getForwardMWPCs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardMWPC_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardMWPCList(me->elem->getForwardMWPCs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getForwardTOFs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ForwardTOF_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ForwardTOFList(me->elem->getForwardTOFs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofCounters(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofCounter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofCounterList(me->elem->getFtofCounters());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofDigihits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofDigihitList(me->elem->getFtofDigihits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofHitList(me->elem->getFtofHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofTruthExtras(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthExtra_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthExtraList(me->elem->getFtofTruthExtras());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthHitList(me->elem->getFtofTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getFtofTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_FtofTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new FtofTruthPointList(me->elem->getFtofTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGapEMcals(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GapEMcal_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GapEMcalList(me->elem->getGapEMcals());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGcalCells(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalCell_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalCellList(me->elem->getGcalCells());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGcalHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalHitList(me->elem->getGcalHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGcalTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalTruthHitList(me->elem->getGcalTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGcalTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_GcalTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GcalTruthShowerList(me->elem->getGcalTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getHitViews(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HitView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new HitViewList(me->elem->getHitViews());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getHodoChannels(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_HodoChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new HodoChannelList(me->elem->getHodoChannels());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getMcTrajectorys(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectory_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new McTrajectoryList(me->elem->getMcTrajectorys());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getMcTrajectoryPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_McTrajectoryPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new McTrajectoryPointList(me->elem->getMcTrajectoryPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getMicroChannels(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_MicroChannel_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MicroChannelList(me->elem->getMicroChannels());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getMomenta(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Momentum_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new MomentumList(me->elem->getMomenta());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getOrigins(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Origin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new OriginList(me->elem->getOrigins());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPairSpectrometerCoarses(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerCoarse_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PairSpectrometerCoarseList(me->elem->getPairSpectrometerCoarses());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPairSpectrometerFines(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PairSpectrometerFine_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PairSpectrometerFineList(me->elem->getPairSpectrometerFines());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPolarizations(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Polarization_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PolarizationList(me->elem->getPolarizations());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getProducts(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Product_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ProductList(me->elem->getProducts());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPropertiesList(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Properties_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PropertiesList(me->elem->getPropertiesList());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPsHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsHitList(me->elem->getPsHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPsTiles(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTile_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTileList(me->elem->getPsTiles());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPsTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTruthHitList(me->elem->getPsTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPsTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PsTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PsTruthPointList(me->elem->getPsTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPscHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscHitList(me->elem->getPscHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPscPaddles(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscPaddleList(me->elem->getPscPaddles());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPscTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscTruthHitList(me->elem->getPscTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getPscTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PscTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PscTruthPointList(me->elem->getPscTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRandoms(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Random_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RandomList(me->elem->getRandoms());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getReactions(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Reaction_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ReactionList(me->elem->getReactions());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getReconViews(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_ReconView_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new ReconViewList(me->elem->getReconViews());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRichTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RichTruthHitList(me->elem->getRichTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getRichTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_RichTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new RichTruthPointList(me->elem->getRichTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStartCntrs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StartCntr_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StartCntrList(me->elem->getStartCntrs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStcDigihits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcDigihit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcDigihitList(me->elem->getStcDigihits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStcHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcHitList(me->elem->getStcHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStcPaddles(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcPaddleList(me->elem->getStcPaddles());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStcTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcTruthHitList(me->elem->getStcTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getStcTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_StcTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new StcTruthPointList(me->elem->getStcTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTaggers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tagger_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerList(me->elem->getTaggers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTaggerHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerHitList(me->elem->getTaggerHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTaggerTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TaggerTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TaggerTruthHitList(me->elem->getTaggerTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTargets(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Target_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TargetList(me->elem->getTargets());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTpolHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolHitList(me->elem->getTpolHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTpolSectors(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolSector_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolSectorList(me->elem->getTpolSectors());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTpolTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolTruthHitList(me->elem->getTpolTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTpolTruthPoints(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TpolTruthPoint_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TpolTruthPointList(me->elem->getTpolTruthPoints());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTrackIDs(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackID_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackIDList(me->elem->getTrackIDs());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTrackOrigins(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TrackOrigin_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TrackOriginList(me->elem->getTrackOrigins());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTracktimebaseds(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Tracktimebased_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TracktimebasedList(me->elem->getTracktimebaseds());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getTripletPolarimeters(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_TripletPolarimeter_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new TripletPolarimeterList(me->elem->getTripletPolarimeters());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUpstreamEMvetos(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpstreamEMveto_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpstreamEMvetoList(me->elem->getUpstreamEMvetos());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUpvHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvHitList(me->elem->getUpvHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUpvPaddles(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvPaddle_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvPaddleList(me->elem->getUpvPaddles());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUpvTruthHits(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthHit_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvTruthHitList(me->elem->getUpvTruthHits());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUpvTruthShowers(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UpvTruthShower_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UpvTruthShowerList(me->elem->getUpvTruthShowers());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUserDatas(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserData_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataList(me->elem->getUserDatas());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUserDataFloats(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataFloat_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataFloatList(me->elem->getUserDataFloats());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getUserDataInts(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_UserDataInt_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new UserDataIntList(me->elem->getUserDataInts());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getVertices(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Vertex_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new VertexList(me->elem->getVertices());
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_getGeometry(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *obj = _Geometry_new(&_Geometry_type, 0, 0);
   ((_Geometry*)obj)->elem = &me->elem->getGeometry();
   ((_Geometry*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HDDM_getGeometrys(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Geometry_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getGeometrys();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HDDM_addGeometrys(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_Geometry_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new GeometryList(me->elem->addGeometrys(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_deleteGeometrys(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid HDDM element");
      return NULL;
   }
   me->elem->deleteGeometrys(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HDDM_getPhysicsEvent(PyObject *self, PyObject *args)
{
   int index=0;
   if (! PyArg_ParseTuple(args, "|i", &index)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *obj = _PhysicsEvent_new(&_PhysicsEvent_type, 0, 0);
   ((_PhysicsEvent*)obj)->elem = &me->elem->getPhysicsEvent(index);
   ((_PhysicsEvent*)obj)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(obj));
   return obj;
}

static PyObject*
_HDDM_getPhysicsEvents(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PhysicsEvent_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    &me->elem->getPhysicsEvents();
   ((_HDDM_ElementList*)list)->borrowed = 1;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 0);
   return list;
}

static PyObject*
_HDDM_addPhysicsEvents(PyObject *self, PyObject *args)
{
   int count=1;
   int start=-1;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "add attempted on invalid HDDM element");
      return NULL;
   }
   PyObject *list = _HDDM_ElementList_new(&_HDDM_ElementList_type, 0, 0);
   ((_HDDM_ElementList*)list)->subtype = &_PhysicsEvent_type;
   ((_HDDM_ElementList*)list)->list = (HDDM_ElementList<HDDM_Element>*)
    new PhysicsEventList(me->elem->addPhysicsEvents(count, start));
   ((_HDDM_ElementList*)list)->borrowed = 0;
   ((_HDDM_ElementList*)list)->host = me->host;
   My_INCREF(me->host);
   LOG_NEW(Py_TYPE(list), ((_HDDM_ElementList*)list)->subtype, 1);
   return list;
}

static PyObject*
_HDDM_deletePhysicsEvents(PyObject *self, PyObject *args)
{
   int count=-1;
   int start=0;
   if (! PyArg_ParseTuple(args, "|ii", &count, &start)) {
      return NULL;
   }
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "delete attempted on invalid HDDM element");
      return NULL;
   }
   me->elem->deletePhysicsEvents(count, start);
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HDDM_clear(PyObject *self, PyObject *args)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   me->elem->clear();
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_HDDM_toString(PyObject *self, PyObject *args=0)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   std::string str(me->elem->toString());
   return PyUnicode_FromString(str.c_str());
}

static PyObject*
_HDDM_toXML(PyObject *self, PyObject *args=0)
{
   _HDDM *me = (_HDDM*)self;
   if (me->elem == 0) {
      PyErr_SetString(PyExc_RuntimeError, "lookup attempted on invalid HDDM element");
      return NULL;
   }
   std::string str(me->elem->toXML());
   return PyUnicode_FromString(str.c_str());
}

static PyGetSetDef _HDDM_getsetters[] = {
   {(char*)"class",
    (getter)_HDDM_getClass, 0,
    (char*)"class value",
    NULL},
   {(char*)"version",
    (getter)_HDDM_getVersion, 0,
    (char*)"version value",
    NULL},
   {(char*)"xmlns",
    (getter)_HDDM_getXmlns, 0,
    (char*)"xmlns value",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _HDDM_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _HDDM_methods[] = {
   {"addGeometrys", _HDDM_addGeometrys, METH_VARARGS,
    "extend (or insert into) the list of geometry objects for this HDDM"},
   {"addPhysicsEvents", _HDDM_addPhysicsEvents, METH_VARARGS,
    "extend (or insert into) the list of physicsEvent objects for this HDDM"},
   {"clear", _HDDM_clear, METH_NOARGS,
    "clear all contents from this HDDM"},
   {"deleteGeometrys", _HDDM_deleteGeometrys, METH_VARARGS,
    "delete geometry objects for this HDDM"},
   {"deletePhysicsEvents", _HDDM_deletePhysicsEvents, METH_VARARGS,
    "delete physicsEvent objects for this HDDM"},
   {"getBarrelEMcals", _HDDM_getBarrelEMcals, METH_NOARGS,
    "get complete list of barrelEMcal objects for this record"},
   {"getBcalCells", _HDDM_getBcalCells, METH_NOARGS,
    "get complete list of bcalCell objects for this record"},
   {"getBcalSiPMDownHits", _HDDM_getBcalSiPMDownHits, METH_NOARGS,
    "get complete list of bcalSiPMDownHit objects for this record"},
   {"getBcalSiPMSpectrums", _HDDM_getBcalSiPMSpectrums, METH_NOARGS,
    "get complete list of bcalSiPMSpectrum objects for this record"},
   {"getBcalSiPMTruths", _HDDM_getBcalSiPMTruths, METH_NOARGS,
    "get complete list of bcalSiPMTruth objects for this record"},
   {"getBcalSiPMUpHits", _HDDM_getBcalSiPMUpHits, METH_NOARGS,
    "get complete list of bcalSiPMUpHit objects for this record"},
   {"getBcalTDCDigiHits", _HDDM_getBcalTDCDigiHits, METH_NOARGS,
    "get complete list of bcalTDCDigiHit objects for this record"},
   {"getBcalTDCHits", _HDDM_getBcalTDCHits, METH_NOARGS,
    "get complete list of bcalTDCHit objects for this record"},
   {"getBcalTruthHits", _HDDM_getBcalTruthHits, METH_NOARGS,
    "get complete list of bcalTruthHit objects for this record"},
   {"getBcalTruthIncidentParticles", _HDDM_getBcalTruthIncidentParticles, METH_NOARGS,
    "get complete list of bcalTruthIncidentParticle objects for this record"},
   {"getBcalTruthShowers", _HDDM_getBcalTruthShowers, METH_NOARGS,
    "get complete list of bcalTruthShower objects for this record"},
   {"getBcalfADCDigiHits", _HDDM_getBcalfADCDigiHits, METH_NOARGS,
    "get complete list of bcalfADCDigiHit objects for this record"},
   {"getBcalfADCHits", _HDDM_getBcalfADCHits, METH_NOARGS,
    "get complete list of bcalfADCHit objects for this record"},
   {"getBcalfADCPeaks", _HDDM_getBcalfADCPeaks, METH_NOARGS,
    "get complete list of bcalfADCPeak objects for this record"},
   {"getBeams", _HDDM_getBeams, METH_NOARGS,
    "get complete list of beam objects for this record"},
   {"getCcalBlocks", _HDDM_getCcalBlocks, METH_NOARGS,
    "get complete list of ccalBlock objects for this record"},
   {"getCcalHits", _HDDM_getCcalHits, METH_NOARGS,
    "get complete list of ccalHit objects for this record"},
   {"getCcalTruthHits", _HDDM_getCcalTruthHits, METH_NOARGS,
    "get complete list of ccalTruthHit objects for this record"},
   {"getCcalTruthShowers", _HDDM_getCcalTruthShowers, METH_NOARGS,
    "get complete list of ccalTruthShower objects for this record"},
   {"getCcdbContexts", _HDDM_getCcdbContexts, METH_NOARGS,
    "get complete list of ccdbContext objects for this record"},
   {"getCdcDigihits", _HDDM_getCdcDigihits, METH_NOARGS,
    "get complete list of cdcDigihit objects for this record"},
   {"getCdcHitQFs", _HDDM_getCdcHitQFs, METH_NOARGS,
    "get complete list of cdcHitQF objects for this record"},
   {"getCdcStrawHits", _HDDM_getCdcStrawHits, METH_NOARGS,
    "get complete list of cdcStrawHit objects for this record"},
   {"getCdcStrawTruthHits", _HDDM_getCdcStrawTruthHits, METH_NOARGS,
    "get complete list of cdcStrawTruthHit objects for this record"},
   {"getCdcStraws", _HDDM_getCdcStraws, METH_NOARGS,
    "get complete list of cdcStraw objects for this record"},
   {"getCdcTruthPoints", _HDDM_getCdcTruthPoints, METH_NOARGS,
    "get complete list of cdcTruthPoint objects for this record"},
   {"getCentralDCs", _HDDM_getCentralDCs, METH_NOARGS,
    "get complete list of centralDC objects for this record"},
   {"getCereHits", _HDDM_getCereHits, METH_NOARGS,
    "get complete list of cereHit objects for this record"},
   {"getCereSections", _HDDM_getCereSections, METH_NOARGS,
    "get complete list of cereSection objects for this record"},
   {"getCereTruthHits", _HDDM_getCereTruthHits, METH_NOARGS,
    "get complete list of cereTruthHit objects for this record"},
   {"getCereTruthPoints", _HDDM_getCereTruthPoints, METH_NOARGS,
    "get complete list of cereTruthPoint objects for this record"},
   {"getCerenkovs", _HDDM_getCerenkovs, METH_NOARGS,
    "get complete list of Cerenkov objects for this record"},
   {"getComptonEMcals", _HDDM_getComptonEMcals, METH_NOARGS,
    "get complete list of ComptonEMcal objects for this record"},
   {"getCppTOFs", _HDDM_getCppTOFs, METH_NOARGS,
    "get complete list of cppTOF objects for this record"},
   {"getCrystalEcals", _HDDM_getCrystalEcals, METH_NOARGS,
    "get complete list of CrystalEcal objects for this record"},
   {"getCtofCounters", _HDDM_getCtofCounters, METH_NOARGS,
    "get complete list of ctofCounter objects for this record"},
   {"getCtofHits", _HDDM_getCtofHits, METH_NOARGS,
    "get complete list of ctofHit objects for this record"},
   {"getCtofTruthHits", _HDDM_getCtofTruthHits, METH_NOARGS,
    "get complete list of ctofTruthHit objects for this record"},
   {"getCtofTruthPoints", _HDDM_getCtofTruthPoints, METH_NOARGS,
    "get complete list of ctofTruthPoint objects for this record"},
   {"getDIRCs", _HDDM_getDIRCs, METH_NOARGS,
    "get complete list of DIRC objects for this record"},
   {"getDataVersionStrings", _HDDM_getDataVersionStrings, METH_NOARGS,
    "get complete list of dataVersionString objects for this record"},
   {"getDircPmtHits", _HDDM_getDircPmtHits, METH_NOARGS,
    "get complete list of dircPmtHit objects for this record"},
   {"getDircTruthBarHits", _HDDM_getDircTruthBarHits, METH_NOARGS,
    "get complete list of dircTruthBarHit objects for this record"},
   {"getDircTruthPmtHitExtras", _HDDM_getDircTruthPmtHitExtras, METH_NOARGS,
    "get complete list of dircTruthPmtHitExtra objects for this record"},
   {"getDircTruthPmtHits", _HDDM_getDircTruthPmtHits, METH_NOARGS,
    "get complete list of dircTruthPmtHit objects for this record"},
   {"getEcalBlocks", _HDDM_getEcalBlocks, METH_NOARGS,
    "get complete list of ecalBlock objects for this record"},
   {"getEcalHits", _HDDM_getEcalHits, METH_NOARGS,
    "get complete list of ecalHit objects for this record"},
   {"getEcalTruthHits", _HDDM_getEcalTruthHits, METH_NOARGS,
    "get complete list of ecalTruthHit objects for this record"},
   {"getEcalTruthShowers", _HDDM_getEcalTruthShowers, METH_NOARGS,
    "get complete list of ecalTruthShower objects for this record"},
   {"getErrorMatrixs", _HDDM_getErrorMatrixs, METH_NOARGS,
    "get complete list of errorMatrix objects for this record"},
   {"getFcalBlocks", _HDDM_getFcalBlocks, METH_NOARGS,
    "get complete list of fcalBlock objects for this record"},
   {"getFcalDigihits", _HDDM_getFcalDigihits, METH_NOARGS,
    "get complete list of fcalDigihit objects for this record"},
   {"getFcalHits", _HDDM_getFcalHits, METH_NOARGS,
    "get complete list of fcalHit objects for this record"},
   {"getFcalTruthHits", _HDDM_getFcalTruthHits, METH_NOARGS,
    "get complete list of fcalTruthHit objects for this record"},
   {"getFcalTruthLightGuides", _HDDM_getFcalTruthLightGuides, METH_NOARGS,
    "get complete list of fcalTruthLightGuide objects for this record"},
   {"getFcalTruthShowers", _HDDM_getFcalTruthShowers, METH_NOARGS,
    "get complete list of fcalTruthShower objects for this record"},
   {"getFdcAnodeHits", _HDDM_getFdcAnodeHits, METH_NOARGS,
    "get complete list of fdcAnodeHit objects for this record"},
   {"getFdcAnodeTruthHits", _HDDM_getFdcAnodeTruthHits, METH_NOARGS,
    "get complete list of fdcAnodeTruthHit objects for this record"},
   {"getFdcAnodeWires", _HDDM_getFdcAnodeWires, METH_NOARGS,
    "get complete list of fdcAnodeWire objects for this record"},
   {"getFdcCathodeHits", _HDDM_getFdcCathodeHits, METH_NOARGS,
    "get complete list of fdcCathodeHit objects for this record"},
   {"getFdcCathodeStrips", _HDDM_getFdcCathodeStrips, METH_NOARGS,
    "get complete list of fdcCathodeStrip objects for this record"},
   {"getFdcCathodeTruthHits", _HDDM_getFdcCathodeTruthHits, METH_NOARGS,
    "get complete list of fdcCathodeTruthHit objects for this record"},
   {"getFdcChambers", _HDDM_getFdcChambers, METH_NOARGS,
    "get complete list of fdcChamber objects for this record"},
   {"getFdcDigihits", _HDDM_getFdcDigihits, METH_NOARGS,
    "get complete list of fdcDigihit objects for this record"},
   {"getFdcTruthPoints", _HDDM_getFdcTruthPoints, METH_NOARGS,
    "get complete list of fdcTruthPoint objects for this record"},
   {"getFmwpcChambers", _HDDM_getFmwpcChambers, METH_NOARGS,
    "get complete list of fmwpcChamber objects for this record"},
   {"getFmwpcHitQs", _HDDM_getFmwpcHitQs, METH_NOARGS,
    "get complete list of fmwpcHitQ objects for this record"},
   {"getFmwpcHits", _HDDM_getFmwpcHits, METH_NOARGS,
    "get complete list of fmwpcHit objects for this record"},
   {"getFmwpcTruthHitQs", _HDDM_getFmwpcTruthHitQs, METH_NOARGS,
    "get complete list of fmwpcTruthHitQ objects for this record"},
   {"getFmwpcTruthHits", _HDDM_getFmwpcTruthHits, METH_NOARGS,
    "get complete list of fmwpcTruthHit objects for this record"},
   {"getFmwpcTruthPoints", _HDDM_getFmwpcTruthPoints, METH_NOARGS,
    "get complete list of fmwpcTruthPoint objects for this record"},
   {"getForwardDCs", _HDDM_getForwardDCs, METH_NOARGS,
    "get complete list of forwardDC objects for this record"},
   {"getForwardEMcals", _HDDM_getForwardEMcals, METH_NOARGS,
    "get complete list of forwardEMcal objects for this record"},
   {"getForwardMWPCs", _HDDM_getForwardMWPCs, METH_NOARGS,
    "get complete list of forwardMWPC objects for this record"},
   {"getForwardTOFs", _HDDM_getForwardTOFs, METH_NOARGS,
    "get complete list of forwardTOF objects for this record"},
   {"getFtofCounters", _HDDM_getFtofCounters, METH_NOARGS,
    "get complete list of ftofCounter objects for this record"},
   {"getFtofDigihits", _HDDM_getFtofDigihits, METH_NOARGS,
    "get complete list of ftofDigihit objects for this record"},
   {"getFtofHits", _HDDM_getFtofHits, METH_NOARGS,
    "get complete list of ftofHit objects for this record"},
   {"getFtofTruthExtras", _HDDM_getFtofTruthExtras, METH_NOARGS,
    "get complete list of ftofTruthExtra objects for this record"},
   {"getFtofTruthHits", _HDDM_getFtofTruthHits, METH_NOARGS,
    "get complete list of ftofTruthHit objects for this record"},
   {"getFtofTruthPoints", _HDDM_getFtofTruthPoints, METH_NOARGS,
    "get complete list of ftofTruthPoint objects for this record"},
   {"getGapEMcals", _HDDM_getGapEMcals, METH_NOARGS,
    "get complete list of gapEMcal objects for this record"},
   {"getGcalCells", _HDDM_getGcalCells, METH_NOARGS,
    "get complete list of gcalCell objects for this record"},
   {"getGcalHits", _HDDM_getGcalHits, METH_NOARGS,
    "get complete list of gcalHit objects for this record"},
   {"getGcalTruthHits", _HDDM_getGcalTruthHits, METH_NOARGS,
    "get complete list of gcalTruthHit objects for this record"},
   {"getGcalTruthShowers", _HDDM_getGcalTruthShowers, METH_NOARGS,
    "get complete list of gcalTruthShower objects for this record"},
   {"getGeometry", _HDDM_getGeometry, METH_VARARGS,
    "get an individual geometry object from this HDDM"},
   {"getGeometrys", _HDDM_getGeometrys, METH_NOARGS,
    "get list of geometry objects for this HDDM"},
   {"getHitViews", _HDDM_getHitViews, METH_NOARGS,
    "get complete list of hitView objects for this record"},
   {"getHodoChannels", _HDDM_getHodoChannels, METH_NOARGS,
    "get complete list of hodoChannel objects for this record"},
   {"getMcTrajectoryPoints", _HDDM_getMcTrajectoryPoints, METH_NOARGS,
    "get complete list of mcTrajectoryPoint objects for this record"},
   {"getMcTrajectorys", _HDDM_getMcTrajectorys, METH_NOARGS,
    "get complete list of mcTrajectory objects for this record"},
   {"getMicroChannels", _HDDM_getMicroChannels, METH_NOARGS,
    "get complete list of microChannel objects for this record"},
   {"getMomenta", _HDDM_getMomenta, METH_NOARGS,
    "get complete list of momentum objects for this record"},
   {"getOrigins", _HDDM_getOrigins, METH_NOARGS,
    "get complete list of origin objects for this record"},
   {"getPairSpectrometerCoarses", _HDDM_getPairSpectrometerCoarses, METH_NOARGS,
    "get complete list of pairSpectrometerCoarse objects for this record"},
   {"getPairSpectrometerFines", _HDDM_getPairSpectrometerFines, METH_NOARGS,
    "get complete list of pairSpectrometerFine objects for this record"},
   {"getPhysicsEvent", _HDDM_getPhysicsEvent, METH_VARARGS,
    "get an individual physicsEvent object from this HDDM"},
   {"getPhysicsEvents", _HDDM_getPhysicsEvents, METH_NOARGS,
    "get list of physicsEvent objects for this HDDM"},
   {"getPolarizations", _HDDM_getPolarizations, METH_NOARGS,
    "get complete list of polarization objects for this record"},
   {"getProducts", _HDDM_getProducts, METH_NOARGS,
    "get complete list of product objects for this record"},
   {"getPropertiesList", _HDDM_getPropertiesList, METH_NOARGS,
    "get complete list of properties objects for this record"},
   {"getPsHits", _HDDM_getPsHits, METH_NOARGS,
    "get complete list of psHit objects for this record"},
   {"getPsTiles", _HDDM_getPsTiles, METH_NOARGS,
    "get complete list of psTile objects for this record"},
   {"getPsTruthHits", _HDDM_getPsTruthHits, METH_NOARGS,
    "get complete list of psTruthHit objects for this record"},
   {"getPsTruthPoints", _HDDM_getPsTruthPoints, METH_NOARGS,
    "get complete list of psTruthPoint objects for this record"},
   {"getPscHits", _HDDM_getPscHits, METH_NOARGS,
    "get complete list of pscHit objects for this record"},
   {"getPscPaddles", _HDDM_getPscPaddles, METH_NOARGS,
    "get complete list of pscPaddle objects for this record"},
   {"getPscTruthHits", _HDDM_getPscTruthHits, METH_NOARGS,
    "get complete list of pscTruthHit objects for this record"},
   {"getPscTruthPoints", _HDDM_getPscTruthPoints, METH_NOARGS,
    "get complete list of pscTruthPoint objects for this record"},
   {"getRFsubsystems", _HDDM_getRFsubsystems, METH_NOARGS,
    "get complete list of RFsubsystem objects for this record"},
   {"getRFtimes", _HDDM_getRFtimes, METH_NOARGS,
    "get complete list of RFtime objects for this record"},
   {"getRICHs", _HDDM_getRICHs, METH_NOARGS,
    "get complete list of RICH objects for this record"},
   {"getRandoms", _HDDM_getRandoms, METH_NOARGS,
    "get complete list of random objects for this record"},
   {"getReactions", _HDDM_getReactions, METH_NOARGS,
    "get complete list of reaction objects for this record"},
   {"getReconViews", _HDDM_getReconViews, METH_NOARGS,
    "get complete list of reconView objects for this record"},
   {"getRichTruthHits", _HDDM_getRichTruthHits, METH_NOARGS,
    "get complete list of richTruthHit objects for this record"},
   {"getRichTruthPoints", _HDDM_getRichTruthPoints, METH_NOARGS,
    "get complete list of richTruthPoint objects for this record"},
   {"getStartCntrs", _HDDM_getStartCntrs, METH_NOARGS,
    "get complete list of startCntr objects for this record"},
   {"getStcDigihits", _HDDM_getStcDigihits, METH_NOARGS,
    "get complete list of stcDigihit objects for this record"},
   {"getStcHits", _HDDM_getStcHits, METH_NOARGS,
    "get complete list of stcHit objects for this record"},
   {"getStcPaddles", _HDDM_getStcPaddles, METH_NOARGS,
    "get complete list of stcPaddle objects for this record"},
   {"getStcTruthHits", _HDDM_getStcTruthHits, METH_NOARGS,
    "get complete list of stcTruthHit objects for this record"},
   {"getStcTruthPoints", _HDDM_getStcTruthPoints, METH_NOARGS,
    "get complete list of stcTruthPoint objects for this record"},
   {"getTaggerHits", _HDDM_getTaggerHits, METH_NOARGS,
    "get complete list of taggerHit objects for this record"},
   {"getTaggerTruthHits", _HDDM_getTaggerTruthHits, METH_NOARGS,
    "get complete list of taggerTruthHit objects for this record"},
   {"getTaggers", _HDDM_getTaggers, METH_NOARGS,
    "get complete list of tagger objects for this record"},
   {"getTargets", _HDDM_getTargets, METH_NOARGS,
    "get complete list of target objects for this record"},
   {"getTpolHits", _HDDM_getTpolHits, METH_NOARGS,
    "get complete list of tpolHit objects for this record"},
   {"getTpolSectors", _HDDM_getTpolSectors, METH_NOARGS,
    "get complete list of tpolSector objects for this record"},
   {"getTpolTruthHits", _HDDM_getTpolTruthHits, METH_NOARGS,
    "get complete list of tpolTruthHit objects for this record"},
   {"getTpolTruthPoints", _HDDM_getTpolTruthPoints, METH_NOARGS,
    "get complete list of tpolTruthPoint objects for this record"},
   {"getTrackIDs", _HDDM_getTrackIDs, METH_NOARGS,
    "get complete list of trackID objects for this record"},
   {"getTrackOrigins", _HDDM_getTrackOrigins, METH_NOARGS,
    "get complete list of trackOrigin objects for this record"},
   {"getTrackingErrorMatrixs", _HDDM_getTrackingErrorMatrixs, METH_NOARGS,
    "get complete list of TrackingErrorMatrix objects for this record"},
   {"getTracktimebaseds", _HDDM_getTracktimebaseds, METH_NOARGS,
    "get complete list of tracktimebased objects for this record"},
   {"getTripletPolarimeters", _HDDM_getTripletPolarimeters, METH_NOARGS,
    "get complete list of tripletPolarimeter objects for this record"},
   {"getUpstreamEMvetos", _HDDM_getUpstreamEMvetos, METH_NOARGS,
    "get complete list of upstreamEMveto objects for this record"},
   {"getUpvHits", _HDDM_getUpvHits, METH_NOARGS,
    "get complete list of upvHit objects for this record"},
   {"getUpvPaddles", _HDDM_getUpvPaddles, METH_NOARGS,
    "get complete list of upvPaddle objects for this record"},
   {"getUpvTruthHits", _HDDM_getUpvTruthHits, METH_NOARGS,
    "get complete list of upvTruthHit objects for this record"},
   {"getUpvTruthShowers", _HDDM_getUpvTruthShowers, METH_NOARGS,
    "get complete list of upvTruthShower objects for this record"},
   {"getUserDataFloats", _HDDM_getUserDataFloats, METH_NOARGS,
    "get complete list of userDataFloat objects for this record"},
   {"getUserDataInts", _HDDM_getUserDataInts, METH_NOARGS,
    "get complete list of userDataInt objects for this record"},
   {"getUserDatas", _HDDM_getUserDatas, METH_NOARGS,
    "get complete list of userData objects for this record"},
   {"getVertices", _HDDM_getVertices, METH_NOARGS,
    "get complete list of vertex objects for this record"},
   {"toString", _HDDM_toString, METH_NOARGS,
    "show element as a human-readable string"},
   {"toXML", _HDDM_toXML, METH_NOARGS,
    "show element as a XML fragment"},
#ifdef HDF5_SUPPORT
   {"hdf5FileWrite", _HDDM_hdf5FileWrite, METH_VARARGS,
    "random-access write this hddm record to an output hdf5 file"},
   {"hdf5FileRead", _HDDM_hdf5FileRead, METH_VARARGS,
    "random-access read this hddm record from an input hdf5 file"},
#endif
   {NULL}  /* Sentinel */
};

static PyTypeObject _HDDM_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.HDDM",         /*tp_name*/
    sizeof(_HDDM),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_HDDM_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_HDDM_toString,         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s HDDM element",  /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _HDDM_methods,          /* tp_methods */
    _HDDM_members,          /* tp_members */
    _HDDM_getsetters,       /* tp_getset */
    &_HDDM_Element_type,       /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_HDDM_init,   /* tp_init */
    0,                         /* tp_alloc */
    _HDDM_new,              /* tp_new */
};



// wrap class hddm_s::streamposition as hddm_s.streamposition

typedef struct {
   PyObject_HEAD
   streamposition *streampos;
} _streamposition;

static void
_streamposition_dealloc(_streamposition* self)
{
   if (self->streampos != 0)
      delete self->streampos;
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_streamposition_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _streamposition *self;
   self = (_streamposition*)type->tp_alloc(type, 0);
   if (self != NULL)
      self->streampos = 0;
   return (PyObject*)self;
}

static int
_streamposition_init(_streamposition *self, PyObject *args, PyObject *kwds)
{
   const char *kwlist[] = {"start", "offset", "status", NULL};
   uint64_t start = 0;
   uint32_t offset = 0;
   uint32_t status = 0;
   if (PyArg_ParseTuple(args, "") ||
       PyArg_ParseTupleAndKeywords(args, kwds, "kII", (char**)kwlist, 
                                   &start, &offset, &status))
   {
      PyErr_Clear();
      if (self->streampos != 0)
         delete self->streampos;
      self->streampos = new streamposition(start, offset, status);
      return 0;
   }
   return -1; 
}

static PyObject*
_streamposition_richcompare(PyObject *a, PyObject *b, int op)
{
   int res = 0;
   streamposition *apos = ((_streamposition*)a)->streampos;
   streamposition *bpos = ((_streamposition*)b)->streampos;
   if (op == Py_LT)
      res = (*apos < *bpos);
   else if (op == Py_LE)
      res = (*apos <= *bpos);
   else if (op == Py_EQ)
      res = (*apos == *bpos);
   else if (op == Py_NE)
      res = (*apos != *bpos);
   else if (op == Py_GT)
      res = (*apos > *bpos);
   else if (op == Py_GE)
      res = (*apos >= *bpos);
   if (res) {
      Py_INCREF(Py_True);
      return Py_True;
   }
   else {
      Py_INCREF(Py_False);
      return Py_False;
   }
}
static PyObject*
_streamposition_toString(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   ostr << "hddm_s.streamposition("
        << ((_streamposition*)self)->streampos->block_start << ","
        << ((_streamposition*)self)->streampos->block_offset << ","
        << ((_streamposition*)self)->streampos->block_status
        << ")";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyObject*
_streamposition_toRepr(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   ostr << "\'";
   ostr << "hddm_s.streamposition("
        << ((_streamposition*)self)->streampos->block_start << ","
        << ((_streamposition*)self)->streampos->block_offset << ","
        << ((_streamposition*)self)->streampos->block_status
        << ")";
   ostr << "\'";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyObject*
_streamposition_getstart(_streamposition *self, void *closure)
{
   return Py_BuildValue("k", self->streampos->block_start);
}

static int
_streamposition_setstart(_streamposition *self, PyObject *value, void *closure)
{
   if (value == NULL) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   long start = PyInt_AsLong(value);
   if (start < 0 && PyErr_Occurred()) {
      return -1;
   }
   self->streampos->block_start = start;
   return 0;
}

static PyObject*
_streamposition_getoffset(_streamposition *self, void *closure)
{
   return Py_BuildValue("I", self->streampos->block_offset);
}

static int
_streamposition_setoffset(_streamposition *self, PyObject *value, void *closure)
{
   if (value == NULL) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   long offset = PyInt_AsLong(value);
   if (offset < 0 && PyErr_Occurred()) {
      return -1;
   }
   self->streampos->block_offset = offset;
   return 0;
}

static PyObject*
_streamposition_getstatus(_streamposition *self, void *closure)
{
   return Py_BuildValue("I", self->streampos->block_status);
}

static int
_streamposition_setstatus(_streamposition *self, PyObject *value, void *closure)
{
   if (value == NULL) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   long status = PyInt_AsLong(value);
   if (status == -1 && PyErr_Occurred()) {
      return -1;
   }
   self->streampos->block_status = status;
   return 0;
}

static PyGetSetDef _streamposition_getsetters[] = {
   {(char*)"start", 
    (getter)_streamposition_getstart, (setter)_streamposition_setstart,
    (char*)"block start position",
    NULL},
   {(char*)"offset", 
    (getter)_streamposition_getoffset, (setter)_streamposition_setoffset,
    (char*)"block offset position",
    NULL},
   {(char*)"status", 
    (getter)_streamposition_getstatus, (setter)_streamposition_setstatus,
    (char*)"block status flags",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _streamposition_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _streamposition_methods[] = {
   {NULL}  /* Sentinel */
};

static PyTypeObject _streamposition_type = {
   PyVarObject_HEAD_INIT(NULL,0)
   "hddm_s.streamposition",   /*tp_name*/
   sizeof(_streamposition),   /*tp_basicsize*/
   0,                         /*tp_itemsize*/
   (destructor)_streamposition_dealloc, /*tp_dealloc*/
   0,                         /*tp_print*/
   0,                         /*tp_getattr*/
   0,                         /*tp_setattr*/
   0,                         /*tp_compare*/
   (reprfunc)_streamposition_toRepr, /*tp_repr*/
   0,                         /*tp_as_number*/
   0,                         /*tp_as_sequence*/
   0,                         /*tp_as_mapping*/
   0,                         /*tp_hash */
   0,                         /*tp_call*/
   (reprfunc)_streamposition_toString, /*tp_str*/
   0,                         /*tp_getattro*/
   0,                         /*tp_setattro*/
   0,                         /*tp_as_buffer*/
   Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
   "hddm_s streamposition objects", /* tp_doc */
   0,                         /* tp_traverse */
   0,                         /* tp_clear */
   _streamposition_richcompare, /* tp_richcompare */
   0,                         /* tp_weaklistoffset */
   0,                         /* tp_iter */
   0,                         /* tp_iternext */
   _streamposition_methods,   /* tp_methods */
   _streamposition_members,   /* tp_members */
   _streamposition_getsetters, /* tp_getset */
   0,                         /* tp_base */
   0,                         /* tp_dict */
   0,                         /* tp_descr_get */
   0,                         /* tp_descr_set */
   0,                         /* tp_dictoffset */
   (initproc)_streamposition_init, /* tp_init */
   0,                         /* tp_alloc */
   _streamposition_new,       /* tp_new */
};


// wrap class hddm_s::ostream as hddm_s.ostream

typedef struct {
   PyObject_HEAD
   std::string *fname;
   std::ofstream *fstr;
   ostream *ostr;
} _ostream;

static void
_ostream_dealloc(_ostream* self)
{
   if (self->fname != 0)
      delete self->fname;
   if (self->ostr != 0)
      delete self->ostr;
   if (self->fstr != 0)
      delete self->fstr;
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_ostream_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _ostream *self;
   self = (_ostream*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->fname = 0;
      self->fstr = 0;
      self->ostr = 0;
   }
   return (PyObject*)self;
}

static int
_ostream_init(_ostream *self, PyObject *args, PyObject *kwds)
{
   const char *kwlist[] = {"file", NULL};
   char *filename;
   if (PyArg_ParseTupleAndKeywords(args, kwds, "s", (char**)kwlist, &filename))
   {
      if (self->fname != 0)
         delete self->fname;
      if (self->ostr != 0)
         delete self->ostr;
      if (self->fstr != 0)
         delete self->fstr;
      self->fname = new std::string(filename);
      self->fstr = new std::ofstream(filename);
      if (! self->fstr->good()) {
         PyErr_Format(PyExc_IOError, "Cannot open output file %s", filename);
         return -1;
      }
      try {
         self->ostr = new ostream(*self->fstr);
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return -1;
      }
      return 0;
   }
   return -1; 
}

static PyObject*
_ostream_getCompression(_ostream *self, void *closure)
{
   return Py_BuildValue("i", self->ostr->getCompression());
}

static int
_ostream_setCompression(_ostream *self, PyObject *value, void *closure)
{
   if (value == NULL) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   long flags = PyInt_AsLong(value);
   if (flags == -1 && PyErr_Occurred()) {
      return -1;
   }
   try {
      self->ostr->setCompression(flags);
   }
   catch (std::exception& e) {
      PyErr_SetString(PyExc_RuntimeError, e.what());
      return -1;
   }
   return 0;
}

static PyObject*
_ostream_getIntegrityChecks(_ostream *self, void *closure)
{
   PyObject *flags = Py_BuildValue("i", self->ostr->getIntegrityChecks());
   return flags;
}

static int
_ostream_setIntegrityChecks(_ostream *self, PyObject *value, void *closure)
{
   if (value == NULL) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   long flags = PyInt_AsLong(value);
   if (flags == -1 && PyErr_Occurred()) {
      return -1;
   }
   try {
      self->ostr->setIntegrityChecks(flags);
   }
   catch (std::exception& e) {
      PyErr_SetString(PyExc_RuntimeError, e.what());
      return -1;
   }
   return 0;
}

static PyObject*
_ostream_getPosition(_ostream *self, void *closure)
{
   streamposition *pos = new streamposition();
   if (self->ostr != 0)
      *pos = self->ostr->getPosition();
   PyObject *pos_obj = _streamposition_new(&_streamposition_type, 0, 0);
   ((_streamposition*)pos_obj)->streampos = pos;
   return pos_obj;
}

static PyObject*
_ostream_getRecordsWritten(_ostream *self, void *closure)
{
   size_t records = 0;
   if (self->ostr != 0)
      try {
         records = self->ostr->getRecordsWritten();
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return NULL;
      }
   return PyLong_FromLongLong(records);
}

static PyObject*
_ostream_getBytesWritten(_ostream *self, void *closure)
{
   size_t bytes = 0;
   if (self->ostr != 0)
      try {
         bytes = self->ostr->getBytesWritten();
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return NULL;
      }
   return PyLong_FromLongLong(bytes);
}

static PyObject*
_ostream_write(PyObject *self, PyObject *args)
{
   _HDDM *record_obj;
   if (! PyArg_ParseTuple(args, "O!", &_HDDM_type, (PyObject*)&record_obj))
       return NULL;
   ostream *ostr = ((_ostream*)self)->ostr;
   try {
      Py_BEGIN_ALLOW_THREADS
      *ostr << *record_obj->elem;
      Py_END_ALLOW_THREADS
   }
   catch (std::exception& e) {
      PyErr_SetString(PyExc_RuntimeError, e.what());
      return NULL;
   }
   Py_INCREF(Py_None);
   return Py_None;
}

static PyObject*
_ostream_toString(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   if (((_ostream*)self)->fname != 0)
      ostr << "hddm_s.ostream(\""
           << *((_ostream*)self)->fname << "\")";
   else
      ostr << "hddm_s.ostream(NULL)";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyObject*
_ostream_toRepr(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   ostr << "\'";
   if (((_ostream*)self)->fname != 0)
      ostr << "hddm_s.ostream(\""
           << *((_ostream*)self)->fname << "\")";
   else
      ostr << "hddm_s.ostream()";
   ostr << "\'";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyGetSetDef _ostream_getsetters[] = {
   {(char*)"compression", 
    (getter)_ostream_getCompression, (setter)_ostream_setCompression,
    (char*)"ostream compression mode (k_no_compression, k_z_compression, ...)",
    NULL},
   {(char*)"integrityChecks", 
    (getter)_ostream_getIntegrityChecks, (setter)_ostream_setIntegrityChecks,
    (char*)"ostream data integrity checking mode (k_no_integrity, ...)",
    NULL},
   {(char*)"position", 
    (getter)_ostream_getPosition, 0,
    (char*)"output stream position",
    NULL},
   {(char*)"recordsWritten", 
    (getter)_ostream_getRecordsWritten, 0,
    (char*)"total records written to ostream",
    NULL},
   {(char*)"bytesWritten", 
    (getter)_ostream_getBytesWritten, 0,
    (char*)"total bytes written to ostream",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _ostream_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _ostream_methods[] = {
   {"write",  _ostream_write, METH_VARARGS,
    "write a HDDM record to the output stream."},
   {NULL}  /* Sentinel */
};

static PyTypeObject _ostream_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.ostream",          /*tp_name*/
    sizeof(_ostream),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_ostream_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    (reprfunc)_ostream_toRepr, /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_ostream_toString, /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s output stream",    /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    0,                         /* tp_iter */
    0,                         /* tp_iternext */
    _ostream_methods,          /* tp_methods */
    _ostream_members,          /* tp_members */
    _ostream_getsetters,       /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_ostream_init,   /* tp_init */
    0,                         /* tp_alloc */
    _ostream_new,              /* tp_new */
};


// wrap class hddm_s::istream as hddm_s.istream

typedef struct {
   PyObject_HEAD
   std::string *fname;
   std::ifstream *fstr;
#ifdef ISTREAM_OVER_HTTP
   httpIstream *tstr;
#endif
#ifdef ISTREAM_OVER_XROOTD
   xrootdIstream *rstr;
#endif
   istream *istr;
} _istream;

static void
_istream_dealloc(_istream* self)
{
   if (self->fname != 0)
      delete self->fname;
   if (self->istr != 0)
      delete self->istr;
   if (self->fstr != 0)
      delete self->fstr;
#ifdef ISTREAM_OVER_HTTP
   if (self->tstr != 0)
      delete self->tstr;
#endif
#ifdef ISTREAM_OVER_XROOTD
   if (self->rstr != 0)
      delete self->rstr;
#endif
   Py_TYPE(self)->tp_free((PyObject*)self);
}

static PyObject*
_istream_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   _istream *self;
   self = (_istream*)type->tp_alloc(type, 0);
   if (self != NULL) {
      self->fname = 0;
      self->fstr = 0;
#ifdef ISTREAM_OVER_HTTP
      self->tstr = 0;
#endif
#ifdef ISTREAM_OVER_XROOTD
      self->rstr = 0;
#endif
      self->istr = 0;
   }
   return (PyObject*)self;
}

static int
_istream_init(_istream *self, PyObject *args, PyObject *kwds)
{
   const char *kwlist[] = {"file", NULL};
   char *filename;
   if (PyArg_ParseTupleAndKeywords(args, kwds, "s", (char**)kwlist, &filename))
   {
      if (self->fname != 0)
         delete self->fname;
      if (self->istr != 0)
         delete self->istr;
      if (self->fstr != 0)
         delete self->fstr;
#ifdef ISTREAM_OVER_HTTP
      if (self->tstr != 0)
         delete self->tstr;
#endif
#ifdef ISTREAM_OVER_XROOTD
      if (self->rstr != 0)
         delete self->rstr;
#endif
      self->fname = new std::string(filename);
      if (strncmp(filename, "http://", 7) == 0 || strncmp(filename, "https://", 8) == 0) {
#ifdef ISTREAM_OVER_HTTP
         try {
            self->tstr = new httpIstream(filename);
         }
         catch (const std::exception& e) {
            PyErr_Format(PyExc_IOError, e.what());
            return -1;
         }
         if (! self->tstr->good()) {
            PyErr_Format(PyExc_IOError, "Cannot open input url %s", filename);
            return -1;
         }
#else
         PyErr_Format(PyExc_IOError, "Input streaming over http[s] disabled, see build options");
         return -1;
#endif
      }
      else if (strncmp(filename, "root://", 7) == 0 || strncmp(filename, "xrootd://", 9) == 0) {
#ifdef ISTREAM_OVER_XROOTD
         try {
            self->rstr = new xrootdIstream(filename);
         }
         catch (const std::exception& e) {
            PyErr_Format(PyExc_IOError, e.what());
            return -1;
         }
         if (! self->rstr->good()) {
            PyErr_Format(PyExc_IOError, "Cannot open input url %s", filename);
            return -1;
         }
#else
         PyErr_Format(PyExc_IOError, "Input streaming over xrootd disabled, see build options");
         return -1;
#endif
      }
      else {
         self->fstr = new std::ifstream(filename);
         if (! self->fstr->good()) {
            PyErr_Format(PyExc_IOError, "Cannot open input file %s", filename);
            return -1;
         }
      }
      try {
         if (self->fstr)
            self->istr = new istream(*self->fstr);
#ifdef ISTREAM_OVER_HTTP
         else if (self->tstr)
            self->istr = new istream(*self->tstr);
#endif
#ifdef ISTREAM_OVER_XROOTD
         else if (self->rstr)
            self->istr = new istream(*self->rstr);
#endif
         else
            PyErr_Format(PyExc_IOError, "Cannot access input file %s", filename);
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return -1;
      }
      return 0;
   }
   return -1; 
}

static PyObject*
_istream_getCompression(_istream *self, void *closure)
{
   return Py_BuildValue("i", self->istr->getCompression());
}

static PyObject*
_istream_getIntegrityChecks(_istream *self, void *closure)
{
   return Py_BuildValue("i", self->istr->getIntegrityChecks());
}

static PyObject*
_istream_getPosition(_istream *self, void *closure)
{
   streamposition *pos = new streamposition();
   if (self->istr != 0)
      try {
         *pos = self->istr->getPosition();
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return NULL;
      }
   PyObject *pos_obj = _streamposition_new(&_streamposition_type, 0, 0);
   ((_streamposition*)pos_obj)->streampos = pos;
   return pos_obj;
}

static int
_istream_setPosition(_istream *self, PyObject *value, void *closure)
{
   if (Py_TYPE(value) != &_streamposition_type)
   {
      PyErr_SetString(PyExc_TypeError, "unexpected argument type");
      return -1;
   }
   streamposition *pos = ((_streamposition*)value)->streampos;
   if (pos == 0) {
      PyErr_SetString(PyExc_TypeError, "unexpected null argument");
      return -1;
   }
   try {
      self->istr->setPosition(*pos);
   }
   catch (std::exception& e) {
      PyErr_SetString(PyExc_RuntimeError, e.what());
      return -1;
   }
   return 0;
}

static PyObject*
_istream_getRecordsRead(_istream *self, void *closure)
{
   size_t records = 0;
   if (self->istr != 0)
      try {
         records = self->istr->getRecordsRead();
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return NULL;
      }
   return PyLong_FromLongLong(records);
}

static PyObject*
_istream_getBytesRead(_istream *self, void *closure)
{
   size_t bytes = 0;
   if (self->istr != 0)
      try {
         bytes = self->istr->getBytesRead();
      }
      catch (std::exception& e) {
         PyErr_SetString(PyExc_RuntimeError, e.what());
         return NULL;
      }
   return PyLong_FromLongLong(bytes);
}

static PyObject*
_istream_skip(PyObject *self, PyObject *args)
{
   int count=0;
   if (! PyArg_ParseTuple(args, "I", &count)) {
      PyErr_SetString(PyExc_TypeError, "missing argument in skip");
      return NULL;
   }
   else if (count < 0) {
      PyErr_SetString(PyExc_TypeError, "skip count cannot be negative");
      return NULL;
   }
   istream *istr = ((_istream*)self)->istr;
   if (istr == 0) {
      PyErr_SetString(PyExc_TypeError, "unexpected null istream ptr");
      return NULL;
   }
   istr->skip(count);
   return PyLong_FromLong(0);
}

static PyObject*
_istream_read(PyObject *self, PyObject *args)
{
   istream *istr = ((_istream*)self)->istr;
   if (istr == 0) {
      PyErr_SetString(PyExc_TypeError, "unexpected null input stream");
      return NULL;
   }
   _HDDM *record_obj = (_HDDM*)_HDDM_new(&_HDDM_type, 0, 0);
   record_obj->elem = new HDDM();
   record_obj->host = (PyObject*)record_obj;
   try {
      Py_BEGIN_ALLOW_THREADS
      *istr >> *record_obj->elem;
      Py_END_ALLOW_THREADS
   }
   catch (std::exception& e) {
      PyErr_SetString(PyExc_RuntimeError, e.what());
      return NULL;
   }
   if (*istr) {
      LOG_NEW(Py_TYPE(record_obj), 0, 1);
      return (PyObject*)record_obj;
   }
   return NULL;
}

static PyObject*
_istream_toString(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   if (((_ostream*)self)->fname != 0)
      ostr << "hddm_s.istream(\""
           << *((_istream*)self)->fname << "\")";
   else
      ostr << "hddm_s.istream(NULL)";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyObject*
_istream_toRepr(PyObject *self, PyObject *args=0)
{
   std::stringstream ostr;
   ostr << "\'";
   if (((_ostream*)self)->fname != 0)
      ostr << "hddm_s.istream(\""
           << *((_istream*)self)->fname << "\")";
   else
      ostr << "hddm_s.istream()";
   ostr << "\'";
   return PyUnicode_FromString(ostr.str().c_str());
}

static PyObject*
_istream_iter(PyObject *self)
{
   Py_INCREF(self);
   return self;
}
static PyObject*
_istream_next(PyObject *self)
{
   PyObject *rec = _istream_read(self, 0);
   if (rec == NULL)
      PyErr_SetString(PyExc_StopIteration, "no more data on input stream");
   return rec;
}

static PyGetSetDef _istream_getsetters[] = {
   {(char*)"compression", 
    (getter)_istream_getCompression, 0,
    (char*)"istream compression mode (k_no_compression, k_z_compression, ...)",
    NULL},
   {(char*)"integrityChecks", 
    (getter)_istream_getIntegrityChecks, 0,
    (char*)"istream data integrity checking mode (k_no_integrity, ...)",
    NULL},
   {(char*)"position", 
    (getter)_istream_getPosition, (setter)_istream_setPosition,
    (char*)"input stream position",
    NULL},
   {(char*)"recordsRead", 
    (getter)_istream_getRecordsRead, 0,
    (char*)"total records read from istream",
    NULL},
   {(char*)"bytesRead", 
    (getter)_istream_getBytesRead, 0,
    (char*)"total bytes read from istream",
    NULL},
   {NULL}  /* Sentinel */
};

static PyMemberDef _istream_members[] = {
   {NULL}  /* Sentinel */
};

static PyMethodDef _istream_methods[] = {
   {"read",  _istream_read, METH_NOARGS,
    "read a HDDM record from the input stream."},
   {"skip",  _istream_skip, METH_VARARGS,
    "skip ahead given number of HDDM records in the input stream."},
   {NULL}  /* Sentinel */
};

static PyTypeObject _istream_type = {
    PyVarObject_HEAD_INIT(NULL,0)
    "hddm_s.istream",          /*tp_name*/
    sizeof(_istream),          /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)_istream_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    (reprfunc)_istream_toRepr, /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    (reprfunc)_istream_toString, /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "hddm_s input stream",    /* tp_doc */
    0,                         /* tp_traverse */
    0,                         /* tp_clear */
    0,                         /* tp_richcompare */
    0,                         /* tp_weaklistoffset */
    _istream_iter,             /* tp_iter */
    _istream_next,             /* tp_iternext */
    _istream_methods,          /* tp_methods */
    _istream_members,          /* tp_members */
    _istream_getsetters,       /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)_istream_init,   /* tp_init */
    0,                         /* tp_alloc */
    _istream_new,              /* tp_new */
};

#ifdef HDF5_SUPPORT
static PyObject*
_HDDM_hdf5FileCreate(PyObject *self, PyObject *args)
{
   char *name;
   int flags = 0;
   if (! PyArg_ParseTuple(args, "s|I", &name, &flags)) {
      return NULL;
   }
   flags = (flags == 0)? H5F_ACC_TRUNC : flags;
   hid_t result = hddm_s::HDDM::hdf5FileCreate(std::string(name), flags);
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5FileOpen(PyObject *self, PyObject *args)
{
   char *name;
   int flags = 0;
   if (! PyArg_ParseTuple(args, "s|I", &name, &flags)) {
      return NULL;
   }
   flags = (flags == 0)? H5F_ACC_RDONLY : flags;
   hid_t result=0;
   try {
      result = hddm_s::HDDM::hdf5FileOpen(std::string(name), flags);
   }
   catch (...) {
      result = -1;
   }
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5FileStamp(PyObject *self, PyObject *args)
{
   hid_t file_id;
   PyObject *ptags = 0;
   if (! PyArg_ParseTuple(args, "k|O!", &file_id, &PyList_Type, &ptags)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5FileStamp");
      return NULL;
   }
   std::vector<PyObject*> tags_unicode;
   std::vector<PyObject*> tags_ascii;
   std::vector<char*> tags;
   if (ptags != 0) {
      int ntags = PyList_Size(ptags);
      for (int i=0; i < ntags; i++) {
         PyObject *pitem = PyList_GetItem(ptags, i);
         PyObject *pitem_str = PyObject_Str(pitem);
         tags_unicode.push_back(pitem_str);
         PyObject *pitem_ascii = pitem_str;
         if (PyUnicode_Check(pitem_str)) {
            pitem_ascii = PyUnicode_AsEncodedString(pitem_str, "ASCII", "strict");
            tags_ascii.push_back(pitem_ascii);
         }
#if PY_MAJOR_VERSION < 3
         tags.push_back(PyString_AsString(pitem_ascii));
#else
         tags.push_back(PyBytes_AsString(pitem_ascii));
#endif
      }
   }
   tags.push_back(0);
   herr_t result = hddm_s::HDDM::hdf5FileStamp(file_id, &tags[0]);
   for (auto p : tags_unicode) {
      Py_XDECREF(p);
   }
   for (auto p : tags_ascii) {
      Py_XDECREF(p);
   }
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5FileCheck(PyObject *self, PyObject *args)
{
   hid_t file_id;
   PyObject *ptags = 0;
   if (! PyArg_ParseTuple(args, "k|O!", &file_id, &PyList_Type, &ptags)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5FileCheck");
      return NULL;
   }
   std::vector<PyObject*> tags_unicode;
   std::vector<PyObject*> tags_ascii;
   std::vector<char*> tags;
   if (ptags != 0) {
      int ntags = PyList_Size(ptags);
      for (int i=0; i < ntags; i++) {
         PyObject *pitem = PyList_GetItem(ptags, i);
         PyObject *pitem_str = PyObject_Str(pitem);
         tags_unicode.push_back(pitem_str);
         PyObject *pitem_ascii = pitem_str;
         if (PyUnicode_Check(pitem_str)) {
            pitem_ascii = PyUnicode_AsEncodedString(pitem_str, "ASCII", "strict");
            tags_ascii.push_back(pitem_ascii);
         }
#if PY_MAJOR_VERSION < 3
         tags.push_back(PyString_AsString(pitem_ascii));
#else
         tags.push_back(PyBytes_AsString(pitem_ascii));
#endif
      }
   }
   tags.push_back(0);
   herr_t result=0;
   try {
      result = hddm_s::HDDM::hdf5FileCheck(file_id, &tags[0]);
   }
   catch (...) {
      result = -1;
   }
   for (auto p : tags_unicode) {
      Py_XDECREF(p);
   }
   for (auto p : tags_ascii) {
      Py_XDECREF(p);
   }
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5GetEntries(PyObject *self, PyObject *args)
{
   hid_t file_id;
   if (! PyArg_ParseTuple(args, "k", &file_id)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5GetEntries");
      return NULL;
   }
   long int entries = hddm_s::HDDM::hdf5GetEntries(file_id);
   return PyLong_FromLong(entries);
}
static PyObject*
_HDDM_hdf5FileClose(PyObject *self, PyObject *args)
{
   hid_t file_id;
   if (! PyArg_ParseTuple(args, "k", &file_id)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5FileClose");
      return NULL;
   }
   herr_t result = hddm_s::HDDM::hdf5FileClose(file_id);
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5DocumentString(PyObject *self, PyObject *args)
{
   hid_t file_id;
   if (! PyArg_ParseTuple(args, "k", &file_id)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5DocumentString");
      return NULL;
   }
   std::string docstring = hddm_s::HDDM::hdf5DocumentString(file_id);
   return PyUnicode_FromString(docstring.c_str());
}
static PyObject*
_HDDM_hdf5GetChunksize(PyObject *self, PyObject *args)
{
   hid_t file_id;
   if (! PyArg_ParseTuple(args, "k", &file_id)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5GetChunksize");
      return NULL;
   }
   hsize_t result = hddm_s::HDDM::hdf5GetChunksize(file_id);
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5SetChunksize(PyObject *self, PyObject *args)
{
   hid_t file_id;
   hsize_t chunksize;
   if (! PyArg_ParseTuple(args, "kk", &file_id, &chunksize)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5SetChunksize");
      return NULL;
   }
   herr_t result = hddm_s::HDDM::hdf5SetChunksize(file_id, chunksize);
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5GetFilters(PyObject *self, PyObject *args)
{
   hid_t file_id;
   PyObject *pfilters;
   if (! PyArg_ParseTuple(args, "kO!", &file_id, &PyList_Type, &pfilters)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5GetFilters");
      return NULL;
   }
   std::vector<H5Z_filter_t> filters;
   herr_t result = hddm_s::HDDM::hdf5GetFilters(file_id, filters);
   PyList_SetSlice(pfilters, 0, PyList_Size(pfilters), 0);
   int nfilters = filters.size();
   for (int i=0; i < nfilters; i++) {
      PyList_Append(pfilters, PyLong_FromLong(filters[i]));
   }
   return PyLong_FromLong(result);
}
static PyObject*
_HDDM_hdf5SetFilters(PyObject *self, PyObject *args)
{
   hid_t file_id;
   PyObject *pfilters;
   if (! PyArg_ParseTuple(args, "kO!", &file_id, &PyList_Type, &pfilters)) {
      PyErr_SetString(PyExc_TypeError, "invalid argument in hdf5SetFilters");
      return NULL;
   }
   std::vector<H5Z_filter_t> filters;
   int nfilters = PyList_Size(pfilters);
   for (int i=0; i < nfilters; i++) {
      PyObject *pitem = PyList_GetItem(pfilters, i);
      filters.push_back(PyLong_AsLong(pitem));
   }
   herr_t result = hddm_s::HDDM::hdf5SetFilters(file_id, filters);
   return PyLong_FromLong(result);
}
#endif


// module declarations

static PyMethodDef hddm_s_methods[] = {
#ifdef HDF5_SUPPORT
   {"hdf5DocumentString", _HDDM_hdf5DocumentString, METH_VARARGS,
    "read the hddm document string from this hdf5 file"},
   {"hdf5FileCreate", _HDDM_hdf5FileCreate, METH_VARARGS,
    "create a new hdf5 and open for writing hddm records"},
   {"hdf5FileOpen", _HDDM_hdf5FileOpen, METH_VARARGS,
    "open an existing hdf5 file for reading hddm records"},
   {"hdf5FileClose", _HDDM_hdf5FileClose, METH_VARARGS,
    "close an open hdf5 file and free its hdf5 resources"},
   {"hdf5FileStamp", _HDDM_hdf5FileStamp, METH_VARARGS,
    "this is implicitly called by hdf5FileCreate"},
   {"hdf5FileCheck", _HDDM_hdf5FileCheck, METH_VARARGS,
    "this is implicitly called by hdf5FileOpen"},
   {"hdf5GetEntries", _HDDM_hdf5GetEntries, METH_VARARGS,
    "returns the number of hddm records in a hdf5 file"},
   {"hdf5GetFilters", _HDDM_hdf5GetFilters, METH_VARARGS,
    "gets the list of filters active on a hdf5 file"},
   {"hdf5SetFilters", _HDDM_hdf5SetFilters, METH_VARARGS,
    "sets the list of filters active on a hdf5 file"},
   {"hdf5GetChunksize", _HDDM_hdf5GetChunksize, METH_VARARGS,
    "gets the hddm dataset chunksize on an open hdf5 file"},
   {"hdf5SetChunksize", _HDDM_hdf5SetChunksize, METH_VARARGS,
    "sets the hddm dataset chunksize on an open hdf5 file"},
#endif
   {NULL}  /* Sentinel */
};

char hddm_s_doc[] = "Python module for hddm_s i/o package";

#if PY_MAJOR_VERSION >= 3
  static struct PyModuleDef moduledef = {
    PyModuleDef_HEAD_INIT,
    "hddm_s",            /* m_name */
    hddm_s_doc,          /* m_doc */
    -1,                  /* m_size */
    hddm_s_methods,      /* m_methods */
    NULL,                /* m_reload */
    NULL,                /* m_traverse */
    NULL,                /* m_clear */
    NULL,                /* m_free */
  };
#endif

static PyObject *
hddm_s_init(void) 
{
   PyObject* m;

#if PY_MAJOR_VERSION >= 3
   m = PyModule_Create(&moduledef);
#else
   m = Py_InitModule3("hddm_s", hddm_s_methods, hddm_s_doc);
#endif

   if (m == NULL)
      return NULL;

   if (PyType_Ready(&_Cerenkov_type) < 0)
      return NULL;
   Py_INCREF(&_Cerenkov_type);
   PyModule_AddObject(m, "Cerenkov", (PyObject*)&_Cerenkov_type);
   if (PyType_Ready(&_ComptonEMcal_type) < 0)
      return NULL;
   Py_INCREF(&_ComptonEMcal_type);
   PyModule_AddObject(m, "ComptonEMcal", (PyObject*)&_ComptonEMcal_type);
   if (PyType_Ready(&_CrystalEcal_type) < 0)
      return NULL;
   Py_INCREF(&_CrystalEcal_type);
   PyModule_AddObject(m, "CrystalEcal", (PyObject*)&_CrystalEcal_type);
   if (PyType_Ready(&_DIRC_type) < 0)
      return NULL;
   Py_INCREF(&_DIRC_type);
   PyModule_AddObject(m, "DIRC", (PyObject*)&_DIRC_type);
   if (PyType_Ready(&_HDDM_type) < 0)
      return NULL;
   Py_INCREF(&_HDDM_type);
   PyModule_AddObject(m, "HDDM", (PyObject*)&_HDDM_type);
   if (PyType_Ready(&_HDDM_Element_type) < 0)
      return NULL;
   Py_INCREF(&_HDDM_Element_type);
   PyModule_AddObject(m, "HDDM_Element", (PyObject*)&_HDDM_Element_type);
   if (PyType_Ready(&_HDDM_ElementList_type) < 0)
      return NULL;
   Py_INCREF(&_HDDM_ElementList_type);
   PyModule_AddObject(m, "HDDM_ElementList", (PyObject*)&_HDDM_ElementList_type);
   if (PyType_Ready(&_RFsubsystem_type) < 0)
      return NULL;
   Py_INCREF(&_RFsubsystem_type);
   PyModule_AddObject(m, "RFsubsystem", (PyObject*)&_RFsubsystem_type);
   if (PyType_Ready(&_RFtime_type) < 0)
      return NULL;
   Py_INCREF(&_RFtime_type);
   PyModule_AddObject(m, "RFtime", (PyObject*)&_RFtime_type);
   if (PyType_Ready(&_RICH_type) < 0)
      return NULL;
   Py_INCREF(&_RICH_type);
   PyModule_AddObject(m, "RICH", (PyObject*)&_RICH_type);
   if (PyType_Ready(&_TrackingErrorMatrix_type) < 0)
      return NULL;
   Py_INCREF(&_TrackingErrorMatrix_type);
   PyModule_AddObject(m, "TrackingErrorMatrix", (PyObject*)&_TrackingErrorMatrix_type);
   if (PyType_Ready(&_BarrelEMcal_type) < 0)
      return NULL;
   Py_INCREF(&_BarrelEMcal_type);
   PyModule_AddObject(m, "barrelEMcal", (PyObject*)&_BarrelEMcal_type);
   if (PyType_Ready(&_BcalCell_type) < 0)
      return NULL;
   Py_INCREF(&_BcalCell_type);
   PyModule_AddObject(m, "bcalCell", (PyObject*)&_BcalCell_type);
   if (PyType_Ready(&_BcalSiPMDownHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalSiPMDownHit_type);
   PyModule_AddObject(m, "bcalSiPMDownHit", (PyObject*)&_BcalSiPMDownHit_type);
   if (PyType_Ready(&_BcalSiPMSpectrum_type) < 0)
      return NULL;
   Py_INCREF(&_BcalSiPMSpectrum_type);
   PyModule_AddObject(m, "bcalSiPMSpectrum", (PyObject*)&_BcalSiPMSpectrum_type);
   if (PyType_Ready(&_BcalSiPMTruth_type) < 0)
      return NULL;
   Py_INCREF(&_BcalSiPMTruth_type);
   PyModule_AddObject(m, "bcalSiPMTruth", (PyObject*)&_BcalSiPMTruth_type);
   if (PyType_Ready(&_BcalSiPMUpHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalSiPMUpHit_type);
   PyModule_AddObject(m, "bcalSiPMUpHit", (PyObject*)&_BcalSiPMUpHit_type);
   if (PyType_Ready(&_BcalTDCDigiHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalTDCDigiHit_type);
   PyModule_AddObject(m, "bcalTDCDigiHit", (PyObject*)&_BcalTDCDigiHit_type);
   if (PyType_Ready(&_BcalTDCHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalTDCHit_type);
   PyModule_AddObject(m, "bcalTDCHit", (PyObject*)&_BcalTDCHit_type);
   if (PyType_Ready(&_BcalTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalTruthHit_type);
   PyModule_AddObject(m, "bcalTruthHit", (PyObject*)&_BcalTruthHit_type);
   if (PyType_Ready(&_BcalTruthIncidentParticle_type) < 0)
      return NULL;
   Py_INCREF(&_BcalTruthIncidentParticle_type);
   PyModule_AddObject(m, "bcalTruthIncidentParticle", (PyObject*)&_BcalTruthIncidentParticle_type);
   if (PyType_Ready(&_BcalTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_BcalTruthShower_type);
   PyModule_AddObject(m, "bcalTruthShower", (PyObject*)&_BcalTruthShower_type);
   if (PyType_Ready(&_BcalfADCDigiHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalfADCDigiHit_type);
   PyModule_AddObject(m, "bcalfADCDigiHit", (PyObject*)&_BcalfADCDigiHit_type);
   if (PyType_Ready(&_BcalfADCHit_type) < 0)
      return NULL;
   Py_INCREF(&_BcalfADCHit_type);
   PyModule_AddObject(m, "bcalfADCHit", (PyObject*)&_BcalfADCHit_type);
   if (PyType_Ready(&_BcalfADCPeak_type) < 0)
      return NULL;
   Py_INCREF(&_BcalfADCPeak_type);
   PyModule_AddObject(m, "bcalfADCPeak", (PyObject*)&_BcalfADCPeak_type);
   if (PyType_Ready(&_Beam_type) < 0)
      return NULL;
   Py_INCREF(&_Beam_type);
   PyModule_AddObject(m, "beam", (PyObject*)&_Beam_type);
   if (PyType_Ready(&_CcalBlock_type) < 0)
      return NULL;
   Py_INCREF(&_CcalBlock_type);
   PyModule_AddObject(m, "ccalBlock", (PyObject*)&_CcalBlock_type);
   if (PyType_Ready(&_CcalHit_type) < 0)
      return NULL;
   Py_INCREF(&_CcalHit_type);
   PyModule_AddObject(m, "ccalHit", (PyObject*)&_CcalHit_type);
   if (PyType_Ready(&_CcalTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_CcalTruthHit_type);
   PyModule_AddObject(m, "ccalTruthHit", (PyObject*)&_CcalTruthHit_type);
   if (PyType_Ready(&_CcalTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_CcalTruthShower_type);
   PyModule_AddObject(m, "ccalTruthShower", (PyObject*)&_CcalTruthShower_type);
   if (PyType_Ready(&_CcdbContext_type) < 0)
      return NULL;
   Py_INCREF(&_CcdbContext_type);
   PyModule_AddObject(m, "ccdbContext", (PyObject*)&_CcdbContext_type);
   if (PyType_Ready(&_CdcDigihit_type) < 0)
      return NULL;
   Py_INCREF(&_CdcDigihit_type);
   PyModule_AddObject(m, "cdcDigihit", (PyObject*)&_CdcDigihit_type);
   if (PyType_Ready(&_CdcHitQF_type) < 0)
      return NULL;
   Py_INCREF(&_CdcHitQF_type);
   PyModule_AddObject(m, "cdcHitQF", (PyObject*)&_CdcHitQF_type);
   if (PyType_Ready(&_CdcStraw_type) < 0)
      return NULL;
   Py_INCREF(&_CdcStraw_type);
   PyModule_AddObject(m, "cdcStraw", (PyObject*)&_CdcStraw_type);
   if (PyType_Ready(&_CdcStrawHit_type) < 0)
      return NULL;
   Py_INCREF(&_CdcStrawHit_type);
   PyModule_AddObject(m, "cdcStrawHit", (PyObject*)&_CdcStrawHit_type);
   if (PyType_Ready(&_CdcStrawTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_CdcStrawTruthHit_type);
   PyModule_AddObject(m, "cdcStrawTruthHit", (PyObject*)&_CdcStrawTruthHit_type);
   if (PyType_Ready(&_CdcTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_CdcTruthPoint_type);
   PyModule_AddObject(m, "cdcTruthPoint", (PyObject*)&_CdcTruthPoint_type);
   if (PyType_Ready(&_CentralDC_type) < 0)
      return NULL;
   Py_INCREF(&_CentralDC_type);
   PyModule_AddObject(m, "centralDC", (PyObject*)&_CentralDC_type);
   if (PyType_Ready(&_CereHit_type) < 0)
      return NULL;
   Py_INCREF(&_CereHit_type);
   PyModule_AddObject(m, "cereHit", (PyObject*)&_CereHit_type);
   if (PyType_Ready(&_CereSection_type) < 0)
      return NULL;
   Py_INCREF(&_CereSection_type);
   PyModule_AddObject(m, "cereSection", (PyObject*)&_CereSection_type);
   if (PyType_Ready(&_CereTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_CereTruthHit_type);
   PyModule_AddObject(m, "cereTruthHit", (PyObject*)&_CereTruthHit_type);
   if (PyType_Ready(&_CereTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_CereTruthPoint_type);
   PyModule_AddObject(m, "cereTruthPoint", (PyObject*)&_CereTruthPoint_type);
   if (PyType_Ready(&_CppTOF_type) < 0)
      return NULL;
   Py_INCREF(&_CppTOF_type);
   PyModule_AddObject(m, "cppTOF", (PyObject*)&_CppTOF_type);
   if (PyType_Ready(&_CtofCounter_type) < 0)
      return NULL;
   Py_INCREF(&_CtofCounter_type);
   PyModule_AddObject(m, "ctofCounter", (PyObject*)&_CtofCounter_type);
   if (PyType_Ready(&_CtofHit_type) < 0)
      return NULL;
   Py_INCREF(&_CtofHit_type);
   PyModule_AddObject(m, "ctofHit", (PyObject*)&_CtofHit_type);
   if (PyType_Ready(&_CtofTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_CtofTruthHit_type);
   PyModule_AddObject(m, "ctofTruthHit", (PyObject*)&_CtofTruthHit_type);
   if (PyType_Ready(&_CtofTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_CtofTruthPoint_type);
   PyModule_AddObject(m, "ctofTruthPoint", (PyObject*)&_CtofTruthPoint_type);
   if (PyType_Ready(&_DataVersionString_type) < 0)
      return NULL;
   Py_INCREF(&_DataVersionString_type);
   PyModule_AddObject(m, "dataVersionString", (PyObject*)&_DataVersionString_type);
   if (PyType_Ready(&_DircPmtHit_type) < 0)
      return NULL;
   Py_INCREF(&_DircPmtHit_type);
   PyModule_AddObject(m, "dircPmtHit", (PyObject*)&_DircPmtHit_type);
   if (PyType_Ready(&_DircTruthBarHit_type) < 0)
      return NULL;
   Py_INCREF(&_DircTruthBarHit_type);
   PyModule_AddObject(m, "dircTruthBarHit", (PyObject*)&_DircTruthBarHit_type);
   if (PyType_Ready(&_DircTruthPmtHit_type) < 0)
      return NULL;
   Py_INCREF(&_DircTruthPmtHit_type);
   PyModule_AddObject(m, "dircTruthPmtHit", (PyObject*)&_DircTruthPmtHit_type);
   if (PyType_Ready(&_DircTruthPmtHitExtra_type) < 0)
      return NULL;
   Py_INCREF(&_DircTruthPmtHitExtra_type);
   PyModule_AddObject(m, "dircTruthPmtHitExtra", (PyObject*)&_DircTruthPmtHitExtra_type);
   if (PyType_Ready(&_EcalBlock_type) < 0)
      return NULL;
   Py_INCREF(&_EcalBlock_type);
   PyModule_AddObject(m, "ecalBlock", (PyObject*)&_EcalBlock_type);
   if (PyType_Ready(&_EcalHit_type) < 0)
      return NULL;
   Py_INCREF(&_EcalHit_type);
   PyModule_AddObject(m, "ecalHit", (PyObject*)&_EcalHit_type);
   if (PyType_Ready(&_EcalTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_EcalTruthHit_type);
   PyModule_AddObject(m, "ecalTruthHit", (PyObject*)&_EcalTruthHit_type);
   if (PyType_Ready(&_EcalTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_EcalTruthShower_type);
   PyModule_AddObject(m, "ecalTruthShower", (PyObject*)&_EcalTruthShower_type);
   if (PyType_Ready(&_ErrorMatrix_type) < 0)
      return NULL;
   Py_INCREF(&_ErrorMatrix_type);
   PyModule_AddObject(m, "errorMatrix", (PyObject*)&_ErrorMatrix_type);
   if (PyType_Ready(&_FcalBlock_type) < 0)
      return NULL;
   Py_INCREF(&_FcalBlock_type);
   PyModule_AddObject(m, "fcalBlock", (PyObject*)&_FcalBlock_type);
   if (PyType_Ready(&_FcalDigihit_type) < 0)
      return NULL;
   Py_INCREF(&_FcalDigihit_type);
   PyModule_AddObject(m, "fcalDigihit", (PyObject*)&_FcalDigihit_type);
   if (PyType_Ready(&_FcalHit_type) < 0)
      return NULL;
   Py_INCREF(&_FcalHit_type);
   PyModule_AddObject(m, "fcalHit", (PyObject*)&_FcalHit_type);
   if (PyType_Ready(&_FcalTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_FcalTruthHit_type);
   PyModule_AddObject(m, "fcalTruthHit", (PyObject*)&_FcalTruthHit_type);
   if (PyType_Ready(&_FcalTruthLightGuide_type) < 0)
      return NULL;
   Py_INCREF(&_FcalTruthLightGuide_type);
   PyModule_AddObject(m, "fcalTruthLightGuide", (PyObject*)&_FcalTruthLightGuide_type);
   if (PyType_Ready(&_FcalTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_FcalTruthShower_type);
   PyModule_AddObject(m, "fcalTruthShower", (PyObject*)&_FcalTruthShower_type);
   if (PyType_Ready(&_FdcAnodeHit_type) < 0)
      return NULL;
   Py_INCREF(&_FdcAnodeHit_type);
   PyModule_AddObject(m, "fdcAnodeHit", (PyObject*)&_FdcAnodeHit_type);
   if (PyType_Ready(&_FdcAnodeTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_FdcAnodeTruthHit_type);
   PyModule_AddObject(m, "fdcAnodeTruthHit", (PyObject*)&_FdcAnodeTruthHit_type);
   if (PyType_Ready(&_FdcAnodeWire_type) < 0)
      return NULL;
   Py_INCREF(&_FdcAnodeWire_type);
   PyModule_AddObject(m, "fdcAnodeWire", (PyObject*)&_FdcAnodeWire_type);
   if (PyType_Ready(&_FdcCathodeHit_type) < 0)
      return NULL;
   Py_INCREF(&_FdcCathodeHit_type);
   PyModule_AddObject(m, "fdcCathodeHit", (PyObject*)&_FdcCathodeHit_type);
   if (PyType_Ready(&_FdcCathodeStrip_type) < 0)
      return NULL;
   Py_INCREF(&_FdcCathodeStrip_type);
   PyModule_AddObject(m, "fdcCathodeStrip", (PyObject*)&_FdcCathodeStrip_type);
   if (PyType_Ready(&_FdcCathodeTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_FdcCathodeTruthHit_type);
   PyModule_AddObject(m, "fdcCathodeTruthHit", (PyObject*)&_FdcCathodeTruthHit_type);
   if (PyType_Ready(&_FdcChamber_type) < 0)
      return NULL;
   Py_INCREF(&_FdcChamber_type);
   PyModule_AddObject(m, "fdcChamber", (PyObject*)&_FdcChamber_type);
   if (PyType_Ready(&_FdcDigihit_type) < 0)
      return NULL;
   Py_INCREF(&_FdcDigihit_type);
   PyModule_AddObject(m, "fdcDigihit", (PyObject*)&_FdcDigihit_type);
   if (PyType_Ready(&_FdcTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_FdcTruthPoint_type);
   PyModule_AddObject(m, "fdcTruthPoint", (PyObject*)&_FdcTruthPoint_type);
   if (PyType_Ready(&_FmwpcChamber_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcChamber_type);
   PyModule_AddObject(m, "fmwpcChamber", (PyObject*)&_FmwpcChamber_type);
   if (PyType_Ready(&_FmwpcHit_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcHit_type);
   PyModule_AddObject(m, "fmwpcHit", (PyObject*)&_FmwpcHit_type);
   if (PyType_Ready(&_FmwpcHitQ_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcHitQ_type);
   PyModule_AddObject(m, "fmwpcHitQ", (PyObject*)&_FmwpcHitQ_type);
   if (PyType_Ready(&_FmwpcTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcTruthHit_type);
   PyModule_AddObject(m, "fmwpcTruthHit", (PyObject*)&_FmwpcTruthHit_type);
   if (PyType_Ready(&_FmwpcTruthHitQ_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcTruthHitQ_type);
   PyModule_AddObject(m, "fmwpcTruthHitQ", (PyObject*)&_FmwpcTruthHitQ_type);
   if (PyType_Ready(&_FmwpcTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_FmwpcTruthPoint_type);
   PyModule_AddObject(m, "fmwpcTruthPoint", (PyObject*)&_FmwpcTruthPoint_type);
   if (PyType_Ready(&_ForwardDC_type) < 0)
      return NULL;
   Py_INCREF(&_ForwardDC_type);
   PyModule_AddObject(m, "forwardDC", (PyObject*)&_ForwardDC_type);
   if (PyType_Ready(&_ForwardEMcal_type) < 0)
      return NULL;
   Py_INCREF(&_ForwardEMcal_type);
   PyModule_AddObject(m, "forwardEMcal", (PyObject*)&_ForwardEMcal_type);
   if (PyType_Ready(&_ForwardMWPC_type) < 0)
      return NULL;
   Py_INCREF(&_ForwardMWPC_type);
   PyModule_AddObject(m, "forwardMWPC", (PyObject*)&_ForwardMWPC_type);
   if (PyType_Ready(&_ForwardTOF_type) < 0)
      return NULL;
   Py_INCREF(&_ForwardTOF_type);
   PyModule_AddObject(m, "forwardTOF", (PyObject*)&_ForwardTOF_type);
   if (PyType_Ready(&_FtofCounter_type) < 0)
      return NULL;
   Py_INCREF(&_FtofCounter_type);
   PyModule_AddObject(m, "ftofCounter", (PyObject*)&_FtofCounter_type);
   if (PyType_Ready(&_FtofDigihit_type) < 0)
      return NULL;
   Py_INCREF(&_FtofDigihit_type);
   PyModule_AddObject(m, "ftofDigihit", (PyObject*)&_FtofDigihit_type);
   if (PyType_Ready(&_FtofHit_type) < 0)
      return NULL;
   Py_INCREF(&_FtofHit_type);
   PyModule_AddObject(m, "ftofHit", (PyObject*)&_FtofHit_type);
   if (PyType_Ready(&_FtofTruthExtra_type) < 0)
      return NULL;
   Py_INCREF(&_FtofTruthExtra_type);
   PyModule_AddObject(m, "ftofTruthExtra", (PyObject*)&_FtofTruthExtra_type);
   if (PyType_Ready(&_FtofTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_FtofTruthHit_type);
   PyModule_AddObject(m, "ftofTruthHit", (PyObject*)&_FtofTruthHit_type);
   if (PyType_Ready(&_FtofTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_FtofTruthPoint_type);
   PyModule_AddObject(m, "ftofTruthPoint", (PyObject*)&_FtofTruthPoint_type);
   if (PyType_Ready(&_GapEMcal_type) < 0)
      return NULL;
   Py_INCREF(&_GapEMcal_type);
   PyModule_AddObject(m, "gapEMcal", (PyObject*)&_GapEMcal_type);
   if (PyType_Ready(&_GcalCell_type) < 0)
      return NULL;
   Py_INCREF(&_GcalCell_type);
   PyModule_AddObject(m, "gcalCell", (PyObject*)&_GcalCell_type);
   if (PyType_Ready(&_GcalHit_type) < 0)
      return NULL;
   Py_INCREF(&_GcalHit_type);
   PyModule_AddObject(m, "gcalHit", (PyObject*)&_GcalHit_type);
   if (PyType_Ready(&_GcalTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_GcalTruthHit_type);
   PyModule_AddObject(m, "gcalTruthHit", (PyObject*)&_GcalTruthHit_type);
   if (PyType_Ready(&_GcalTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_GcalTruthShower_type);
   PyModule_AddObject(m, "gcalTruthShower", (PyObject*)&_GcalTruthShower_type);
   if (PyType_Ready(&_Geometry_type) < 0)
      return NULL;
   Py_INCREF(&_Geometry_type);
   PyModule_AddObject(m, "geometry", (PyObject*)&_Geometry_type);
   if (PyType_Ready(&_HitView_type) < 0)
      return NULL;
   Py_INCREF(&_HitView_type);
   PyModule_AddObject(m, "hitView", (PyObject*)&_HitView_type);
   if (PyType_Ready(&_HodoChannel_type) < 0)
      return NULL;
   Py_INCREF(&_HodoChannel_type);
   PyModule_AddObject(m, "hodoChannel", (PyObject*)&_HodoChannel_type);
   if (PyType_Ready(&_istream_type) < 0)
      return NULL;
   Py_INCREF(&_istream_type);
   PyModule_AddObject(m, "istream", (PyObject*)&_istream_type);
   if (PyType_Ready(&_McTrajectory_type) < 0)
      return NULL;
   Py_INCREF(&_McTrajectory_type);
   PyModule_AddObject(m, "mcTrajectory", (PyObject*)&_McTrajectory_type);
   if (PyType_Ready(&_McTrajectoryPoint_type) < 0)
      return NULL;
   Py_INCREF(&_McTrajectoryPoint_type);
   PyModule_AddObject(m, "mcTrajectoryPoint", (PyObject*)&_McTrajectoryPoint_type);
   if (PyType_Ready(&_MicroChannel_type) < 0)
      return NULL;
   Py_INCREF(&_MicroChannel_type);
   PyModule_AddObject(m, "microChannel", (PyObject*)&_MicroChannel_type);
   if (PyType_Ready(&_Momentum_type) < 0)
      return NULL;
   Py_INCREF(&_Momentum_type);
   PyModule_AddObject(m, "momentum", (PyObject*)&_Momentum_type);
   if (PyType_Ready(&_Origin_type) < 0)
      return NULL;
   Py_INCREF(&_Origin_type);
   PyModule_AddObject(m, "origin", (PyObject*)&_Origin_type);
   if (PyType_Ready(&_ostream_type) < 0)
      return NULL;
   Py_INCREF(&_ostream_type);
   PyModule_AddObject(m, "ostream", (PyObject*)&_ostream_type);
   if (PyType_Ready(&_PairSpectrometerCoarse_type) < 0)
      return NULL;
   Py_INCREF(&_PairSpectrometerCoarse_type);
   PyModule_AddObject(m, "pairSpectrometerCoarse", (PyObject*)&_PairSpectrometerCoarse_type);
   if (PyType_Ready(&_PairSpectrometerFine_type) < 0)
      return NULL;
   Py_INCREF(&_PairSpectrometerFine_type);
   PyModule_AddObject(m, "pairSpectrometerFine", (PyObject*)&_PairSpectrometerFine_type);
   if (PyType_Ready(&_PhysicsEvent_type) < 0)
      return NULL;
   Py_INCREF(&_PhysicsEvent_type);
   PyModule_AddObject(m, "physicsEvent", (PyObject*)&_PhysicsEvent_type);
   if (PyType_Ready(&_Polarization_type) < 0)
      return NULL;
   Py_INCREF(&_Polarization_type);
   PyModule_AddObject(m, "polarization", (PyObject*)&_Polarization_type);
   if (PyType_Ready(&_Product_type) < 0)
      return NULL;
   Py_INCREF(&_Product_type);
   PyModule_AddObject(m, "product", (PyObject*)&_Product_type);
   if (PyType_Ready(&_Properties_type) < 0)
      return NULL;
   Py_INCREF(&_Properties_type);
   PyModule_AddObject(m, "properties", (PyObject*)&_Properties_type);
   if (PyType_Ready(&_PsHit_type) < 0)
      return NULL;
   Py_INCREF(&_PsHit_type);
   PyModule_AddObject(m, "psHit", (PyObject*)&_PsHit_type);
   if (PyType_Ready(&_PsTile_type) < 0)
      return NULL;
   Py_INCREF(&_PsTile_type);
   PyModule_AddObject(m, "psTile", (PyObject*)&_PsTile_type);
   if (PyType_Ready(&_PsTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_PsTruthHit_type);
   PyModule_AddObject(m, "psTruthHit", (PyObject*)&_PsTruthHit_type);
   if (PyType_Ready(&_PsTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_PsTruthPoint_type);
   PyModule_AddObject(m, "psTruthPoint", (PyObject*)&_PsTruthPoint_type);
   if (PyType_Ready(&_PscHit_type) < 0)
      return NULL;
   Py_INCREF(&_PscHit_type);
   PyModule_AddObject(m, "pscHit", (PyObject*)&_PscHit_type);
   if (PyType_Ready(&_PscPaddle_type) < 0)
      return NULL;
   Py_INCREF(&_PscPaddle_type);
   PyModule_AddObject(m, "pscPaddle", (PyObject*)&_PscPaddle_type);
   if (PyType_Ready(&_PscTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_PscTruthHit_type);
   PyModule_AddObject(m, "pscTruthHit", (PyObject*)&_PscTruthHit_type);
   if (PyType_Ready(&_PscTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_PscTruthPoint_type);
   PyModule_AddObject(m, "pscTruthPoint", (PyObject*)&_PscTruthPoint_type);
   if (PyType_Ready(&_Random_type) < 0)
      return NULL;
   Py_INCREF(&_Random_type);
   PyModule_AddObject(m, "random", (PyObject*)&_Random_type);
   if (PyType_Ready(&_Reaction_type) < 0)
      return NULL;
   Py_INCREF(&_Reaction_type);
   PyModule_AddObject(m, "reaction", (PyObject*)&_Reaction_type);
   if (PyType_Ready(&_ReconView_type) < 0)
      return NULL;
   Py_INCREF(&_ReconView_type);
   PyModule_AddObject(m, "reconView", (PyObject*)&_ReconView_type);
   if (PyType_Ready(&_RichTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_RichTruthHit_type);
   PyModule_AddObject(m, "richTruthHit", (PyObject*)&_RichTruthHit_type);
   if (PyType_Ready(&_RichTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_RichTruthPoint_type);
   PyModule_AddObject(m, "richTruthPoint", (PyObject*)&_RichTruthPoint_type);
   if (PyType_Ready(&_StartCntr_type) < 0)
      return NULL;
   Py_INCREF(&_StartCntr_type);
   PyModule_AddObject(m, "startCntr", (PyObject*)&_StartCntr_type);
   if (PyType_Ready(&_StcDigihit_type) < 0)
      return NULL;
   Py_INCREF(&_StcDigihit_type);
   PyModule_AddObject(m, "stcDigihit", (PyObject*)&_StcDigihit_type);
   if (PyType_Ready(&_StcHit_type) < 0)
      return NULL;
   Py_INCREF(&_StcHit_type);
   PyModule_AddObject(m, "stcHit", (PyObject*)&_StcHit_type);
   if (PyType_Ready(&_StcPaddle_type) < 0)
      return NULL;
   Py_INCREF(&_StcPaddle_type);
   PyModule_AddObject(m, "stcPaddle", (PyObject*)&_StcPaddle_type);
   if (PyType_Ready(&_StcTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_StcTruthHit_type);
   PyModule_AddObject(m, "stcTruthHit", (PyObject*)&_StcTruthHit_type);
   if (PyType_Ready(&_StcTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_StcTruthPoint_type);
   PyModule_AddObject(m, "stcTruthPoint", (PyObject*)&_StcTruthPoint_type);
   if (PyType_Ready(&_streamposition_type) < 0)
      return NULL;
   Py_INCREF(&_streamposition_type);
   PyModule_AddObject(m, "streamposition", (PyObject*)&_streamposition_type);
   if (PyType_Ready(&_Tagger_type) < 0)
      return NULL;
   Py_INCREF(&_Tagger_type);
   PyModule_AddObject(m, "tagger", (PyObject*)&_Tagger_type);
   if (PyType_Ready(&_TaggerHit_type) < 0)
      return NULL;
   Py_INCREF(&_TaggerHit_type);
   PyModule_AddObject(m, "taggerHit", (PyObject*)&_TaggerHit_type);
   if (PyType_Ready(&_TaggerTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_TaggerTruthHit_type);
   PyModule_AddObject(m, "taggerTruthHit", (PyObject*)&_TaggerTruthHit_type);
   if (PyType_Ready(&_Target_type) < 0)
      return NULL;
   Py_INCREF(&_Target_type);
   PyModule_AddObject(m, "target", (PyObject*)&_Target_type);
   if (PyType_Ready(&_TpolHit_type) < 0)
      return NULL;
   Py_INCREF(&_TpolHit_type);
   PyModule_AddObject(m, "tpolHit", (PyObject*)&_TpolHit_type);
   if (PyType_Ready(&_TpolSector_type) < 0)
      return NULL;
   Py_INCREF(&_TpolSector_type);
   PyModule_AddObject(m, "tpolSector", (PyObject*)&_TpolSector_type);
   if (PyType_Ready(&_TpolTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_TpolTruthHit_type);
   PyModule_AddObject(m, "tpolTruthHit", (PyObject*)&_TpolTruthHit_type);
   if (PyType_Ready(&_TpolTruthPoint_type) < 0)
      return NULL;
   Py_INCREF(&_TpolTruthPoint_type);
   PyModule_AddObject(m, "tpolTruthPoint", (PyObject*)&_TpolTruthPoint_type);
   if (PyType_Ready(&_TrackID_type) < 0)
      return NULL;
   Py_INCREF(&_TrackID_type);
   PyModule_AddObject(m, "trackID", (PyObject*)&_TrackID_type);
   if (PyType_Ready(&_TrackOrigin_type) < 0)
      return NULL;
   Py_INCREF(&_TrackOrigin_type);
   PyModule_AddObject(m, "trackOrigin", (PyObject*)&_TrackOrigin_type);
   if (PyType_Ready(&_Tracktimebased_type) < 0)
      return NULL;
   Py_INCREF(&_Tracktimebased_type);
   PyModule_AddObject(m, "tracktimebased", (PyObject*)&_Tracktimebased_type);
   if (PyType_Ready(&_TripletPolarimeter_type) < 0)
      return NULL;
   Py_INCREF(&_TripletPolarimeter_type);
   PyModule_AddObject(m, "tripletPolarimeter", (PyObject*)&_TripletPolarimeter_type);
   if (PyType_Ready(&_UpstreamEMveto_type) < 0)
      return NULL;
   Py_INCREF(&_UpstreamEMveto_type);
   PyModule_AddObject(m, "upstreamEMveto", (PyObject*)&_UpstreamEMveto_type);
   if (PyType_Ready(&_UpvHit_type) < 0)
      return NULL;
   Py_INCREF(&_UpvHit_type);
   PyModule_AddObject(m, "upvHit", (PyObject*)&_UpvHit_type);
   if (PyType_Ready(&_UpvPaddle_type) < 0)
      return NULL;
   Py_INCREF(&_UpvPaddle_type);
   PyModule_AddObject(m, "upvPaddle", (PyObject*)&_UpvPaddle_type);
   if (PyType_Ready(&_UpvTruthHit_type) < 0)
      return NULL;
   Py_INCREF(&_UpvTruthHit_type);
   PyModule_AddObject(m, "upvTruthHit", (PyObject*)&_UpvTruthHit_type);
   if (PyType_Ready(&_UpvTruthShower_type) < 0)
      return NULL;
   Py_INCREF(&_UpvTruthShower_type);
   PyModule_AddObject(m, "upvTruthShower", (PyObject*)&_UpvTruthShower_type);
   if (PyType_Ready(&_UserData_type) < 0)
      return NULL;
   Py_INCREF(&_UserData_type);
   PyModule_AddObject(m, "userData", (PyObject*)&_UserData_type);
   if (PyType_Ready(&_UserDataFloat_type) < 0)
      return NULL;
   Py_INCREF(&_UserDataFloat_type);
   PyModule_AddObject(m, "userDataFloat", (PyObject*)&_UserDataFloat_type);
   if (PyType_Ready(&_UserDataInt_type) < 0)
      return NULL;
   Py_INCREF(&_UserDataInt_type);
   PyModule_AddObject(m, "userDataInt", (PyObject*)&_UserDataInt_type);
   if (PyType_Ready(&_Vertex_type) < 0)
      return NULL;
   Py_INCREF(&_Vertex_type);
   PyModule_AddObject(m, "vertex", (PyObject*)&_Vertex_type);

   PyModule_AddIntConstant(m, "k_default_status", k_default_status);
   PyModule_AddIntConstant(m, "k_bits_compression", k_bits_compression);
   PyModule_AddIntConstant(m, "k_no_compression", k_no_compression);
   PyModule_AddIntConstant(m, "k_z_compression", k_z_compression);
   PyModule_AddIntConstant(m, "k_bz2_compression", k_bz2_compression);
   PyModule_AddIntConstant(m, "k_bits_integrity", k_bits_integrity);
   PyModule_AddIntConstant(m, "k_no_integrity", k_no_integrity);
   PyModule_AddIntConstant(m, "k_crc32_integrity", k_crc32_integrity);
   PyModule_AddIntConstant(m, "k_bits_randomaccess", k_bits_randomaccess);
   PyModule_AddIntConstant(m, "k_can_reposition", k_can_reposition);
   PyModule_AddIntConstant(m, "k_hddm_unknown", k_hddm_unknown);
   PyModule_AddIntConstant(m, "k_hddm_int", k_hddm_int);
   PyModule_AddIntConstant(m, "k_hddm_long", k_hddm_long);
   PyModule_AddIntConstant(m, "k_hddm_float", k_hddm_float);
   PyModule_AddIntConstant(m, "k_hddm_double", k_hddm_double);
   PyModule_AddIntConstant(m, "k_hddm_boolean", k_hddm_boolean);
   PyModule_AddIntConstant(m, "k_hddm_string", k_hddm_string);
   PyModule_AddIntConstant(m, "k_hddm_anyURI", k_hddm_anyURI);
   PyModule_AddIntConstant(m, "k_hddm_Particle_t", k_hddm_Particle_t);
   std::string docstring = HDDM::DocumentString();
   PyModule_AddStringConstant(m, "DocumentString", docstring.c_str());

#ifdef HDF5_SUPPORT
   PyModule_AddIntConstant(m, "k_hdf5_gzip_filter", k_hdf5_gzip_filter);
   PyModule_AddIntConstant(m, "k_hdf5_szip_filter", k_hdf5_szip_filter);
   PyModule_AddIntConstant(m, "k_hdf5_bzip2_plugin", k_hdf5_bzip2_plugin);
   PyModule_AddIntConstant(m, "k_hdf5_blosc_plugin", k_hdf5_blosc_plugin);
   PyModule_AddIntConstant(m, "k_hdf5_bshuf_plugin", k_hdf5_bshuf_plugin);
   PyModule_AddIntConstant(m, "k_hdf5_jpeg_plugin", k_hdf5_jpeg_plugin);
   PyModule_AddIntConstant(m, "k_hdf5_lz4_plugin", k_hdf5_lz4_plugin);
   PyModule_AddIntConstant(m, "k_hdf5_lzf_plugin", k_hdf5_lzf_plugin);
#endif

   return m;
}

#if PY_MAJOR_VERSION < 3
   PyMODINIT_FUNC
   inithddm_s(void)
   {
      hddm_s_init();
   }
#else
   PyMODINIT_FUNC
   PyInit_hddm_s(void)
   {
      return hddm_s_init();
   }
#endif
